/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(J){for(var e=[],D=0,A=J.length;D<A;D++)e[D]=te[J[D]];return e};define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(A,R){if(!A)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function A(I){const C=[];for(let d in I)D.call(I,d)&&C.push(I[d]);return C}e.values=A;function R(I,C){for(let d in I)if(D.call(I,d)&&C({key:d,value:I[d]},function(){delete I[d]})===!1)return}e.forEach=R;function T(I,C){const d=Object.create(null);for(const p of I){const h=C(p);let E=d[h];E||(E=d[h]=[]),E.push(p)}return d}e.groupBy=T;function i(I){const C=Object.create(null);return I&&I.forEach((d,p)=>{C[p]=d}),C}e.fromMap=i;function P(I,C){const d=[],p=[];for(let h of I)C.has(h)||d.push(h);for(let h of C)I.has(h)||p.push(h);return{removed:d,added:p}}e.diffSets=P;function S(I,C){const d=[],p=[];for(let[h,E]of I)C.has(h)||d.push(E);for(let[h,E]of C)I.has(h)||p.push(E);return{removed:d,added:p}}e.diffMaps=S;class b{constructor(){this.map=new Map}add(C,d){let p=this.map.get(C);p||(p=new Set,this.map.set(C,p)),p.add(d)}delete(C,d){const p=this.map.get(C);!p||(p.delete(d),p.size===0&&this.map.delete(C))}forEach(C,d){const p=this.map.get(C);!p||p.forEach(d)}}e.SetMap=b}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(i){return(P,S,b)=>{let I=null,C=null;if(typeof b.value=="function"?(I="value",C=b.value):typeof b.get=="function"&&(I="get",C=b.get),!C)throw new Error("not supported");b[I]=i(C,S)}}e.createDecorator=D;function A(i,P,S){let b=null,I=null;if(typeof S.value=="function"?(b="value",I=S.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(b="get",I=S.get),!I)throw new Error("not supported");const C=`$memoize$${P}`;S[b]=function(...d){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[C]}}e.memoize=A;function R(i,P,S){return D((b,I)=>{const C=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...p){this[d]||(this[d]=S?S():void 0),clearTimeout(this[C]),P&&(this[d]=P(this[d],...p),p=[this[d]]),this[C]=setTimeout(()=>{b.apply(this,p),this[d]=S?S():void 0},i)}})}e.debounce=R;function T(i,P,S){return D((b,I)=>{const C=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,p=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...E){if(this[d]||(this[d]=S?S():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...E)),this[h])return;const v=this[p]+i;v<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[d]]),this[d]=S?S():void 0):(this[h]=!0,this[C]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),b.apply(this,[this[d]]),this[d]=S?S():void 0},v-Date.now()))}})}e.throttle=T}),define(te[9],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=D,e.errorHandler=new D;function A(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=A;function R(l){S(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=R;function T(l){S(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=T;function i(l){if(l instanceof Error){let{name:r,message:o}=l;const n=l.stacktrace||l.stack;return{$isError:!0,name:r,message:o,stack:n}}return l}e.transformErrorForSerialization=i;const P="Canceled";function S(l){return l instanceof Error&&l.name===P&&l.message===P}e.isPromiseCanceledError=S;class b extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=b;function I(){const l=new Error(P);return l.name=l.message,l}e.canceled=I;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function d(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=d;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function E(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=E;class v extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=v;class m extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function f(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=f;function c(l,r=Object.create(null)){const o=new Error(l);return r.actions&&(o.actions=r.actions),o}e.createErrorWithActions=c}),define(te[17],ne([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(U,N=0){return U[U.length-(1+N)]}e.tail=A;function R(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=R;function T(U,N,z=(x,K)=>x===K){if(U===N)return!0;if(!U||!N||U.length!==N.length)return!1;for(let x=0,K=U.length;x<K;x++)if(!z(U[x],N[x]))return!1;return!0}e.equals=T;function i(U,N,z){let x=0,K=U.length-1;for(;x<=K;){const ee=(x+K)/2|0,V=z(U[ee],N);if(V<0)x=ee+1;else if(V>0)K=ee-1;else return ee}return-(x+1)}e.binarySearch=i;function P(U,N){let z=0,x=U.length;if(x===0)return 0;for(;z<x;){const K=Math.floor((z+x)/2);N(U[K])?x=K:z=K+1}return z}e.findFirstInSorted=P;function S(U,N,z){if(U=U|0,U>=N.length)throw new TypeError("invalid index");let x=N[Math.floor(N.length*Math.random())],K=[],ee=[],V=[];for(let X of N){const se=z(X,x);se<0?K.push(X):se>0?ee.push(X):V.push(X)}return U<K.length?S(U,K,z):U<K.length+V.length?V[0]:S(U-(K.length+V.length),ee,z)}e.quickSelect=S;function b(U,N){const z=[];let x;for(const K of U.slice(0).sort(N))!x||N(x[0],K)!==0?(x=[K],z.push(x)):x.push(K);return z}e.groupBy=b;function I(U,N,z){const x=[];function K(X,se,oe){if(se===0&&oe.length===0)return;const le=x[x.length-1];le&&le.start+le.deleteCount===X?(le.deleteCount+=se,le.toInsert.push(...oe)):x.push({start:X,deleteCount:se,toInsert:oe})}let ee=0,V=0;for(;;){if(ee===U.length){K(ee,0,N.slice(V));break}if(V===N.length){K(ee,U.length-ee,[]);break}const X=U[ee],se=N[V],oe=z(X,se);oe===0?(ee+=1,V+=1):oe<0?(K(ee,1,[]),ee+=1):oe>0&&(K(ee,0,[se]),V+=1)}return x}e.sortedDiff=I;function C(U,N,z){const x=I(U,N,z),K=[],ee=[];for(const V of x)K.push(...U.slice(V.start,V.start+V.deleteCount)),ee.push(...V.toInsert);return{removed:K,added:ee}}e.delta=C;function d(U,N,z){if(z===0)return[];const x=U.slice(0,z).sort(N);return h(U,N,x,z,U.length),x}e.top=d;function p(U,N,z,x,K){return z===0?Promise.resolve([]):new Promise((ee,V)=>{(async()=>{const X=U.length,se=U.slice(0,z).sort(N);for(let oe=z,le=Math.min(z+x,X);oe<X;oe=le,le=Math.min(le+x,X)){if(oe>z&&await new Promise(he=>setTimeout(he)),K&&K.isCancellationRequested)throw(0,D.canceled)();h(U,N,se,oe,le)}return se})().then(ee,V)})}e.topAsync=p;function h(U,N,z,x,K){for(const ee=z.length;x<K;x++){const V=U[x];if(N(V,z[ee-1])<0){z.pop();const X=P(z,se=>N(V,se)<0);z.splice(X,0,V)}}}function E(U){return U.filter(N=>!!N)}e.coalesce=E;function v(U){let N=0;for(let z=0;z<U.length;z++)U[z]&&(U[N]=U[z],N+=1);U.length=N}e.coalesceInPlace=v;function m(U,N,z){U.splice(z,0,U.splice(N,1)[0])}e.move=m;function w(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=w;function f(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=f;function c(U,N=z=>z){const z=new Set;return U.filter(x=>{const K=N(x);return z.has(K)?!1:(z.add(K),!0)})}e.distinct=c;function l(U){const N=Object.create(null);return z=>{const x=U(z);return N[x]?!1:(N[x]=!0,!0)}}e.uniqueFilter=l;function r(U,N){const z=o(U,N);if(z!==-1)return U[z]}e.findLast=r;function o(U,N){for(let z=U.length-1;z>=0;z--){const x=U[z];if(N(x))return z}return-1}e.lastIndex=o;function n(U,N){return U.length>0?U[0]:N}e.firstOrDefault=n;function t(U,N,z=(x,K)=>x===K){let x=0;for(let K=0,ee=Math.min(U.length,N.length);K<ee&&z(U[K],N[K]);K++)x++;return x}e.commonPrefixLength=t;function s(U){return[].concat(...U)}e.flatten=s;function a(U,N){let z=typeof N=="number"?U:0;typeof N=="number"?z=U:(z=0,N=U);const x=[];if(z<=N)for(let K=z;K<N;K++)x.push(K);else for(let K=z;K>N;K--)x.push(K);return x}e.range=a;function u(U,N,z){return U.reduce((x,K)=>(x[N(K)]=z?z(K):K,x),Object.create(null))}e.index=u;function g(U,N){return U.push(N),()=>y(U,N)}e.insert=g;function y(U,N){const z=U.indexOf(N);if(z>-1)return U.splice(z,1),N}e.remove=y;function k(U,N,z){const x=U.slice(0,N),K=U.slice(N);return x.concat(z,K)}e.arrayInsert=k;function O(U,N){let z;if(typeof N=="number"){let x=N;z=()=>{const K=Math.sin(x++)*179426549;return K-Math.floor(K)}}else z=Math.random;for(let x=U.length-1;x>0;x-=1){const K=Math.floor(z()*(x+1)),ee=U[x];U[x]=U[K],U[K]=ee}}e.shuffle=O;function M(U,N){const z=U.indexOf(N);z>-1&&(U.splice(z,1),U.unshift(N))}e.pushToStart=M;function W(U,N){const z=U.indexOf(N);z>-1&&(U.splice(z,1),U.push(N))}e.pushToEnd=W;function q(U,N){return Array.isArray(U)?U.map(N):N(U)}e.mapArrayOrNot=q;function L(U){return Array.isArray(U)?U:[U]}e.asArray=L;function $(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=$;function _(U,N){for(const z of U){const x=N(z);if(x!==void 0)return x}}e.mapFind=_;function F(U,N,z){const x=Z(U,N),K=U.length,ee=z.length;U.length=K+ee;for(let V=K-1;V>=x;V--)U[V+ee]=U[V];for(let V=0;V<ee;V++)U[V+x]=z[V]}e.insertInto=F;function B(U,N,z,x){const K=Z(U,N),ee=U.splice(K,z);return F(U,K,x),ee}e.splice=B;function Z(U,N){return N<0?Math.max(N+U.length,0):Math.min(N,U.length)}function H(U,N){let z=Number.MAX_SAFE_INTEGER,x=0;return U.forEach((K,ee)=>{const V=N(K);V<z&&(z=V,x=ee)}),x}e.minIndex=H;function j(U,N){let z=Number.MIN_SAFE_INTEGER,x=0;return U.forEach((K,ee)=>{const V=N(K);V>z&&(z=V,x=ee)}),x}e.maxIndex=j;class Q{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let z=this.firstIdx;for(;z<this.items.length&&N(this.items[z]);)z++;const x=z===this.firstIdx?null:this.items.slice(this.firstIdx,z);return this.firstIdx=z,x}takeFromEndWhile(N){let z=this.lastIdx;for(;z>=0&&N(this.items[z]);)z--;const x=z===this.lastIdx?null:this.items.slice(z+1,this.lastIdx+1);return this.lastIdx=z,x}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const z=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,z}}e.ArrayQueue=Q}),define(te[68],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(A){const R=this;let T=!1,i;return function(){return T||(T=!0,i=A.apply(R,arguments)),i}}e.once=D}),define(te[56],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(A){function R(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}A.is=R;const T=Object.freeze([]);function i(){return T}A.empty=i;function*P(l){yield l}A.single=P;function S(l){return l||T}A.from=S;function b(l){return!l||l[Symbol.iterator]().next().done===!0}A.isEmpty=b;function I(l){return l[Symbol.iterator]().next().value}A.first=I;function C(l,r){for(const o of l)if(r(o))return!0;return!1}A.some=C;function d(l,r){for(const o of l)if(r(o))return o}A.find=d;function*p(l,r){for(const o of l)r(o)&&(yield o)}A.filter=p;function*h(l,r){let o=0;for(const n of l)yield r(n,o++)}A.map=h;function*E(...l){for(const r of l)for(const o of r)yield o}A.concat=E;function*v(l){for(const r of l)for(const o of r)yield o}A.concatNested=v;function m(l,r,o){let n=o;for(const t of l)n=r(n,t);return n}A.reduce=m;function*w(l,r,o=l.length){for(r<0&&(r+=l.length),o<0?o+=l.length:o>l.length&&(o=l.length);r<o;r++)yield l[r]}A.slice=w;function f(l,r=Number.POSITIVE_INFINITY){const o=[];if(r===0)return[o,l];const n=l[Symbol.iterator]();for(let t=0;t<r;t++){const s=n.next();if(s.done)return[o,A.empty()];o.push(s.value)}return[o,{[Symbol.iterator](){return n}}]}A.consume=f;function c(l,r,o=(n,t)=>n===t){const n=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=n.next(),a=t.next();if(s.done!==a.done)return!1;if(s.done)return!0;if(!o(s.value,a.value))return!1}}A.equals=c})(D=e.Iterable||(e.Iterable={}))}),define(te[31],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var A;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(r){r.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function i(r,o=!1){let n=0,t=r.length,s="",a=0,u=16,g=0;function y($){let _=0,F=0;for(;_<$;){const B=r.charCodeAt(n);if(B>=48&&B<=57)F=F*16+B-48;else if(B>=65&&B<=70)F=F*16+B-65+10;else if(B>=97&&B<=102)F=F*16+B-97+10;else break;n++,_++}return _<$&&(F=-1),F}function k($){n=$,s="",a=0,u=16,g=0}function O(){const $=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&b(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&b(r.charCodeAt(n)))for(n++;n<r.length&&b(r.charCodeAt(n));)n++;else return g=3,r.substring($,n);let _=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&b(r.charCodeAt(n))){for(n++;n<r.length&&b(r.charCodeAt(n));)n++;_=n}else g=3;return r.substring($,_)}function M(){let $="",_=n;for(;;){if(n>=t){$+=r.substring(_,n),g=2;break}const F=r.charCodeAt(n);if(F===34){$+=r.substring(_,n),n++;break}if(F===92){if($+=r.substring(_,n),n++,n>=t){g=2;break}switch(r.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const Z=y(4);Z>=0?$+=String.fromCharCode(Z):g=4;break;default:g=5}_=n;continue}if(F>=0&&F<=31)if(S(F)){$+=r.substring(_,n),g=2;break}else g=6;n++}return $}function W(){if(s="",g=0,a=n,n>=t)return a=t,u=17;let $=r.charCodeAt(n);if(P($)){do n++,s+=String.fromCharCode($),$=r.charCodeAt(n);while(P($));return u=15}if(S($))return n++,s+=String.fromCharCode($),$===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),u=14;switch($){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,s=M(),u=10;case 47:const _=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<t&&!S(r.charCodeAt(n));)n++;return s=r.substring(_,n),u=12}if(r.charCodeAt(n+1)===42){n+=2;const F=t-1;let B=!1;for(;n<F;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,g=1),s=r.substring(_,n),u=13}return s+=String.fromCharCode($),n++,u=16;case 45:if(s+=String.fromCharCode($),n++,n===t||!b(r.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),u=11;default:for(;n<t&&q($);)n++,$=r.charCodeAt(n);if(a!==n){switch(s=r.substring(a,n),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode($),n++,u=16}}function q($){if(P($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let $;do $=W();while($>=12&&$<=15);return $}return{setPosition:k,getPosition:()=>n,scan:o?L:W,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>g}}e.createScanner=i;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function S(r){return r===10||r===13||r===8232||r===8233}function b(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function C(r,o){const n=[],t=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function g(y,k,O,M){a.value=y,a.offset=k,a.length=O,a.type=M,a.colonOffset=void 0,s=a}try{f(r,{onObjectBegin:(y,k)=>{if(o<=y)throw t;s=void 0,u=o>y,n.push("")},onObjectProperty:(y,k,O)=>{if(o<k||(g(y,k,O,"property"),n[n.length-1]=y,o<=k+O))throw t},onObjectEnd:(y,k)=>{if(o<=y)throw t;s=void 0,n.pop()},onArrayBegin:(y,k)=>{if(o<=y)throw t;s=void 0,n.push(0)},onArrayEnd:(y,k)=>{if(o<=y)throw t;s=void 0,n.pop()},onLiteralValue:(y,k,O)=>{if(o<k||(g(y,k,O,l(y)),o<=k+O))throw t},onSeparator:(y,k,O)=>{if(o<=k)throw t;if(y===":"&&s&&s.type==="property")s.colonOffset=k,u=!1,s=void 0;else if(y===","){const M=n[n.length-1];typeof M=="number"?n[n.length-1]=M+1:(u=!0,n[n.length-1]=""),s=void 0}}})}catch(y){if(y!==t)throw y}return{path:n,previousNode:s,isAtPropertyKey:u,matches:y=>{let k=0;for(let O=0;k<y.length&&O<n.length;O++)if(y[k]===n[O]||y[k]==="*")k++;else if(y[k]!=="**")return!1;return k===y.length}}}e.getLocation=C;function d(r,o=[],n=T.DEFAULT){let t=null,s=[];const a=[];function u(y){Array.isArray(s)?s.push(y):t!==null&&(s[t]=y)}return f(r,{onObjectBegin:()=>{const y={};u(y),a.push(s),s=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const y=[];u(y),a.push(s),s=y,t=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:u,onError:(y,k,O)=>{o.push({error:y,offset:k,length:O})}},n),s[0]}e.parse=d;function p(r,o=[],n=T.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){t.type==="property"&&(t.length=y-t.offset,t=t.parent)}function a(y){return t.children.push(y),y}f(r,{onObjectBegin:y=>{t=a({type:"object",offset:y,length:-1,parent:t,children:[]})},onObjectProperty:(y,k,O)=>{t=a({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:y,offset:k,length:O,parent:t})},onObjectEnd:(y,k)=>{t.length=y+k-t.offset,t=t.parent,s(y+k)},onArrayBegin:(y,k)=>{t=a({type:"array",offset:y,length:-1,parent:t,children:[]})},onArrayEnd:(y,k)=>{t.length=y+k-t.offset,t=t.parent,s(y+k)},onLiteralValue:(y,k,O)=>{a({type:l(y),offset:k,length:O,parent:t,value:y}),s(k+O)},onSeparator:(y,k,O)=>{t.type==="property"&&(y===":"?t.colonOffset=k:y===","&&s(k))},onError:(y,k,O)=>{o.push({error:y,offset:k,length:O})}},n);const g=t.children[0];return g&&delete g.parent,g}e.parseTree=p;function h(r,o){if(!r)return;let n=r;for(let t of o)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===t){n=a.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function E(r){if(!r.parent||!r.parent.children)return[];const o=E(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;o.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&o.push(n)}return o}e.getNodePath=E;function v(r){switch(r.type){case"array":return r.children.map(v);case"object":const o=Object.create(null);for(let n of r.children){const t=n.children[1];t&&(o[n.children[0].value]=v(t))}return o;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=v;function m(r,o,n=!1){return o>=r.offset&&o<r.offset+r.length||n&&o===r.offset+r.length}e.contains=m;function w(r,o,n=!1){if(m(r,o,n)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=o;s++){const a=w(t[s],o,n);if(a)return a}return r}}e.findNodeAtOffset=w;function f(r,o,n=T.DEFAULT){const t=i(r,!1);function s(z){return z?()=>z(t.getTokenOffset(),t.getTokenLength()):()=>!0}function a(z){return z?x=>z(x,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=s(o.onObjectBegin),g=a(o.onObjectProperty),y=s(o.onObjectEnd),k=s(o.onArrayBegin),O=s(o.onArrayEnd),M=a(o.onLiteralValue),W=a(o.onSeparator),q=s(o.onComment),L=a(o.onError),$=n&&n.disallowComments,_=n&&n.allowTrailingComma;function F(){for(;;){const z=t.scan();switch(t.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:$||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(z){case 12:case 13:$?B(10):q();break;case 16:B(1);break;case 15:case 14:break;default:return z}}}function B(z,x=[],K=[]){if(L(z),x.length+K.length>0){let ee=t.getToken();for(;ee!==17;){if(x.indexOf(ee)!==-1){F();break}else if(K.indexOf(ee)!==-1)break;ee=F()}}}function Z(z){const x=t.getTokenValue();return z?M(x):g(x),F(),!0}function H(){switch(t.getToken()){case 11:let z=0;try{z=JSON.parse(t.getTokenValue()),typeof z!="number"&&(B(2),z=0)}catch(x){B(2)}M(z);break;case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return F(),!0}function j(){return t.getToken()!==10?(B(3,[],[2,5]),!1):(Z(!1),t.getToken()===6?(W(":"),F(),N()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Q(){u(),F();let z=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(z||B(4,[],[]),W(","),F(),t.getToken()===2&&_)break}else z&&B(6,[],[]);j()||B(4,[],[2,5]),z=!0}return y(),t.getToken()!==2?B(7,[2],[]):F(),!0}function U(){k(),F();let z=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(z||B(4,[],[]),W(","),F(),t.getToken()===4&&_)break}else z&&B(6,[],[]);N()||B(4,[],[4,5]),z=!0}return O(),t.getToken()!==4?B(8,[4],[]):F(),!0}function N(){switch(t.getToken()){case 3:return U();case 1:return Q();case 10:return Z(!0);default:return H()}}return F(),t.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):N()?(t.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=f;function c(r,o){let n=i(r),t=[],s,a=0,u;do switch(u=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:a!==u&&t.push(r.substring(a,u)),o!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,o)),a=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=c;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[48],ne([0,1,31]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(S,b,I){let C,d,p,h,E;if(b){for(h=b.offset,E=h+b.length,p=h;p>0&&!P(S,p-1);)p--;let a=E;for(;a<S.length&&!P(S,a);)a++;d=S.substring(p,a),C=T(d,I)}else d=S,C=0,p=0,h=0,E=S.length;const v=i(I,S);let m=!1,w=0,f;I.insertSpaces?f=R(" ",I.tabSize||4):f="	";const c=(0,D.createScanner)(d,!1);let l=!1;function r(){return v+R(f,C+w)}function o(){let a=c.scan();for(m=!1;a===15||a===14;)m=m||a===14,a=c.scan();return l=a===16||c.getTokenError()!==0,a}const n=[];function t(a,u,g){!l&&u<E&&g>h&&S.substring(u,g)!==a&&n.push({offset:u,length:g-u,content:a})}let s=o();if(s!==17){const a=c.getTokenOffset()+p,u=R(f,C);t(u,p,a)}for(;s!==17;){let a=c.getTokenOffset()+c.getTokenLength()+p,u=o(),g="";for(;!m&&(u===12||u===13);){const k=c.getTokenOffset()+p;t(" ",a,k),a=c.getTokenOffset()+c.getTokenLength()+p,g=u===12?r():"",u=o()}if(u===2)s!==1&&(w--,g=r());else if(u===4)s!==3&&(w--,g=r());else{switch(s){case 3:case 1:w++,g=r();break;case 5:case 12:g=r();break;case 13:m?g=r():g=" ";break;case 6:g=" ";break;case 10:if(u===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?g=" ":u!==5&&u!==17&&(l=!0);break;case 16:l=!0;break}m&&(u===12||u===13)&&(g=r())}const y=c.getTokenOffset()+p;t(g,a,y),s=u}return n}e.format=A;function R(S,b){let I="";for(let C=0;C<b;C++)I+=S;return I}function T(S,b){let I=0,C=0;const d=b.tabSize||4;for(;I<S.length;){const p=S.charAt(I);if(p===" ")C++;else if(p==="	")C+=d;else break;I++}return Math.floor(C/d)}function i(S,b){for(let I=0;I<b.length;I++){const C=b.charAt(I);if(C==="\r")return I+1<b.length&&b.charAt(I+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=i;function P(S,b){return`\r
`.indexOf(S.charAt(b))!==-1}e.isEOL=P}),define(te[39],ne([0,1,31,48]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(b,I,C){return T(b,I,void 0,C)}e.removeProperty=R;function T(b,I,C,d,p){const h=I.slice(),E=[],v=(0,D.parseTree)(b,E);let m,w;for(;h.length>0&&(w=h.pop(),m=(0,D.findNodeAtLocation)(v,h),m===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const f=(0,D.findNodeAtLocation)(m,[w]);if(f!==void 0)if(C===void 0){if(!f.parent)throw new Error("Malformed AST");const c=m.children.indexOf(f.parent);let l,r=f.parent.offset+f.parent.length;if(c>0){const o=m.children[c-1];l=o.offset+o.length}else l=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return i(b,{offset:l,length:r-l,content:""},d)}else return i(b,{offset:f.offset,length:f.length,content:JSON.stringify(C)},d);else{if(C===void 0)return[];const c=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,l=p?p(m.children.map(o=>o.children[0].value)):m.children.length;let r;if(l>0){const o=m.children[l-1];r={offset:o.offset+o.length,length:0,content:","+c}}else m.children.length===0?r={offset:m.offset+1,length:0,content:c}:r={offset:m.offset+1,length:0,content:c+","};return i(b,r,d)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(C!==void 0){const f=`${JSON.stringify(C)}`;let c;if(m.children.length===0||w===0)c={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const l=w===-1||w>m.children.length?m.children.length:w,r=m.children[l-1];c={offset:r.offset+r.length,length:0,content:","+f}}return i(b,c,d)}else{const f=w,c=m.children[f];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const r=m.children[f-1],o=r.offset+r.length,n=m.offset+m.length;l={offset:o,length:n-2-o,content:""}}else l={offset:c.offset,length:m.children[f+1].offset-c.offset,content:""};return i(b,l,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return i(b,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(C)},d)}}e.setProperty=T;function i(b,I,C){let d=P(b,I),p=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;p>0&&!(0,A.isEOL)(d,p-1);)p--;for(;h<d.length&&!(0,A.isEOL)(d,h);)h++}const E=(0,A.format)(d,{offset:p,length:h-p},C);for(let m=E.length-1;m>=0;m--){const w=E[m];d=P(d,w),p=Math.min(p,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const v=b.length-(d.length-h)-p;return[{offset:p,length:v,content:d.substring(p,h)}]}e.withFormatting=i;function P(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}e.applyEdit=P;function S(b,I){let C=I.slice(0).sort((p,h)=>{const E=p.offset-h.offset;return E===0?p.length-h.length:E}),d=b.length;for(let p=C.length-1;p>=0;p--){let h=C[p];if(h.offset+h.length<=d)b=P(b,h);else throw new Error("Overlapping edit");d=h.offset}return b}e.applyEdits=S}),define(te[2],ne([0,1,68,56]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let T=null;function i(t){T=t}if(e.setDisposableTracker=i,R){const t="__is_disposable_tracked__";i(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function P(t){return T?.trackDisposable(t),t}function S(t){T?.markAsDisposed(t)}function b(t,s){T?.setParent(t,s)}function I(t,s){if(!!T)for(const a of t)T.setParent(a,s)}function C(t){return T?.markAsSingleton(t),t}e.markAsSingleton=C;class d extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=d;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(A.Iterable.is(t)){let s=[];for(const a of t)if(a)try{a.dispose()}catch(u){s.push(u)}if(s.length===1)throw s[0];if(s.length>1)throw new d(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function E(...t){const s=v(()=>h(t));return I(t,s),s}e.combinedDisposable=E;function v(t){const s=P({dispose:(0,D.once)(()=>{S(s),t()})});return s}e.toDisposable=v;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return b(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,P(this),b(this._store,this)}dispose(){S(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&b(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&b(s,null),s}}e.MutableDisposable=f;class c{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class l{constructor(){this.references=new Map}acquire(s,...a){let u=this.references.get(s);u||(u={counter:0,object:this.createReferencedObject(s,...a)},this.references.set(s,u));const{object:g}=u,y=(0,D.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(s,u.object),this.references.delete(s))});return u.counter++,{object:g,dispose:y}}}e.ReferenceCollection=l;class r{constructor(s){this.referenceCollection=s}async acquire(s,...a){const u=this.referenceCollection.acquire(s,...a);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(g){throw u.dispose(),g}}}e.AsyncReferenceCollection=r;class o{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=o;function n(t){const s=new m;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class A{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const i=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=i}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,i){const P=new D(T);if(this._first===D.Undefined)this._first=P,this._last=P;else if(i){const b=this._last;this._last=P,P.prev=b,b.next=P}else{const b=this._first;this._first=P,P.next=b,b.prev=P}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const i=T.prev;i.next=T.next,T.next.prev=i}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=A}),function(){function J(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function i(S){T.push(S,Date.now())}function P(){const S=[];for(let b=0;b<T.length;b+=2)S.push({name:T[b],startTime:T[b+1]});return S}return{mark:i,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const i of performance.getEntriesByType("mark"))T.push({name:i.name,startTime:Math.round(R+i.startTime)});return T}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=D(A))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let A=!1,R=!1,T=!1,i=!1,P=!1,S=!1,b=!1,I,C=D,d,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const E=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=E&&h?.sandboxed,typeof navigator=="object"&&!E)p=navigator.userAgent,A=p.indexOf("Windows")>=0,R=p.indexOf("Macintosh")>=0,b=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=p.indexOf("Linux")>=0,S=!0,I=navigator.language,C=I;else if(typeof h=="object"){A=h.platform==="win32",R=h.platform==="darwin",T=h.platform==="linux",i=T&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,I=D,C=D;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),s=t.availableLanguages["*"];I=t.locale,C=s||D,d=t._translationsConfigFile}catch(t){}P=!0}else console.error("Unable to resolve platform.");var v;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function m(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let w=0;R?w=1:A?w=3:T&&(w=2),e.isWindows=A,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=i,e.isNative=P,e.isWeb=S,e.isIOS=b,e.platform=w,e.userAgent=p,e.language=C;var f;(function(n){function t(){return e.language}n.value=t;function s(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=s;function a(){return e.language==="en"}n.isDefault=a})(f=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=d,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",s=>{if(s.data&&s.data.vscodeScheduleAsyncWork)for(let a=0,u=n.length;a<u;a++){const g=n[a];if(g.id===s.data.vscodeScheduleAsyncWork){n.splice(a,1),g.callback();return}}});let t=0;return s=>{const a=++t;n.push({id:a,callback:s}),e.globals.postMessage({vscodeScheduleAsyncWork:a},"*")}}return n=>setTimeout(n)})();var c;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:A?1:3;let l=!0,r=!1;function o(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,l=new Uint16Array(n.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=o}),define(te[32],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;A={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process!="undefined"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(te[10],ne([0,1,32]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,R=97,T=90,i=122,P=46,S=47,b=92,I=58,C=63;class d extends Error{constructor(c,l,r){let o;typeof l=="string"&&l.indexOf("not ")===0?(o="must not be",l=l.replace(/^not /,"")):o="must be";const n=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${n} ${o} of type ${l}`;t+=`. Received type ${typeof r}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(f,c){if(typeof f!="string")throw new d(c,"string",f)}function h(f){return f===S||f===b}function E(f){return f===S}function v(f){return f>=A&&f<=T||f>=R&&f<=i}function m(f,c,l,r){let o="",n=0,t=-1,s=0,a=0;for(let u=0;u<=f.length;++u){if(u<f.length)a=f.charCodeAt(u);else{if(r(a))break;a=S}if(r(a)){if(!(t===u-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const g=o.lastIndexOf(l);g===-1?(o="",n=0):(o=o.slice(0,g),n=o.length-1-o.lastIndexOf(l)),t=u,s=0;continue}else if(o.length!==0){o="",n=0,t=u,s=0;continue}}c&&(o+=o.length>0?`${l}..`:"..",n=2)}else o.length>0?o+=`${l}${f.slice(t+1,u)}`:o=f.slice(t+1,u),n=u-t-1;t=u,s=0}else a===P&&s!==-1?++s:s=-1}return o}function w(f,c){if(c===null||typeof c!="object")throw new d("pathObject","Object",c);const l=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${r}`:`${l}${f}${r}`:r}e.win32={resolve(...f){let c="",l="",r=!1;for(let o=f.length-1;o>=-1;o--){let n;if(o>=0){if(n=f[o],p(n,"path"),n.length===0)continue}else c.length===0?n=D.cwd():(n=D.env[`=${c}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${c}\\`));const t=n.length;let s=0,a="",u=!1;const g=n.charCodeAt(0);if(t===1)h(g)&&(s=1,u=!0);else if(h(g))if(u=!0,h(n.charCodeAt(1))){let y=2,k=y;for(;y<t&&!h(n.charCodeAt(y));)y++;if(y<t&&y!==k){const O=n.slice(k,y);for(k=y;y<t&&h(n.charCodeAt(y));)y++;if(y<t&&y!==k){for(k=y;y<t&&!h(n.charCodeAt(y));)y++;(y===t||y!==k)&&(a=`\\\\${O}\\${n.slice(k,y)}`,s=y)}}}else s=1;else v(g)&&n.charCodeAt(1)===I&&(a=n.slice(0,2),s=2,t>2&&h(n.charCodeAt(2))&&(u=!0,s=3));if(a.length>0)if(c.length>0){if(a.toLowerCase()!==c.toLowerCase())continue}else c=a;if(r){if(c.length>0)break}else if(l=`${n.slice(s)}\\${l}`,r=u,u&&c.length>0)break}return l=m(l,!r,"\\",h),r?`${c}\\${l}`:`${c}${l}`||"."},normalize(f){p(f,"path");const c=f.length;if(c===0)return".";let l=0,r,o=!1;const n=f.charCodeAt(0);if(c===1)return E(n)?"\\":f;if(h(n))if(o=!0,h(f.charCodeAt(1))){let s=2,a=s;for(;s<c&&!h(f.charCodeAt(s));)s++;if(s<c&&s!==a){const u=f.slice(a,s);for(a=s;s<c&&h(f.charCodeAt(s));)s++;if(s<c&&s!==a){for(a=s;s<c&&!h(f.charCodeAt(s));)s++;if(s===c)return`\\\\${u}\\${f.slice(a)}\\`;s!==a&&(r=`\\\\${u}\\${f.slice(a,s)}`,l=s)}}}else l=1;else v(n)&&f.charCodeAt(1)===I&&(r=f.slice(0,2),l=2,c>2&&h(f.charCodeAt(2))&&(o=!0,l=3));let t=l<c?m(f.slice(l),!o,"\\",h):"";return t.length===0&&!o&&(t="."),t.length>0&&h(f.charCodeAt(c-1))&&(t+="\\"),r===void 0?o?`\\${t}`:t:o?`${r}\\${t}`:`${r}${t}`},isAbsolute(f){p(f,"path");const c=f.length;if(c===0)return!1;const l=f.charCodeAt(0);return h(l)||c>2&&v(l)&&f.charCodeAt(1)===I&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,l;for(let n=0;n<f.length;++n){const t=f[n];p(t,"path"),t.length>0&&(c===void 0?c=l=t:c+=`\\${t}`)}if(c===void 0)return".";let r=!0,o=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++o;const n=l.length;n>1&&h(l.charCodeAt(1))&&(++o,n>2&&(h(l.charCodeAt(2))?++o:r=!1))}if(r){for(;o<c.length&&h(c.charCodeAt(o));)o++;o>=2&&(c=`\\${c.slice(o)}`)}return e.win32.normalize(c)},relative(f,c){if(p(f,"from"),p(c,"to"),f===c)return"";const l=e.win32.resolve(f),r=e.win32.resolve(c);if(l===r||(f=l.toLowerCase(),c=r.toLowerCase(),f===c))return"";let o=0;for(;o<f.length&&f.charCodeAt(o)===b;)o++;let n=f.length;for(;n-1>o&&f.charCodeAt(n-1)===b;)n--;const t=n-o;let s=0;for(;s<c.length&&c.charCodeAt(s)===b;)s++;let a=c.length;for(;a-1>s&&c.charCodeAt(a-1)===b;)a--;const u=a-s,g=t<u?t:u;let y=-1,k=0;for(;k<g;k++){const M=f.charCodeAt(o+k);if(M!==c.charCodeAt(s+k))break;M===b&&(y=k)}if(k!==g){if(y===-1)return r}else{if(u>g){if(c.charCodeAt(s+k)===b)return r.slice(s+k+1);if(k===2)return r.slice(s+k)}t>g&&(f.charCodeAt(o+k)===b?y=k:k===2&&(y=3)),y===-1&&(y=0)}let O="";for(k=o+y+1;k<=n;++k)(k===n||f.charCodeAt(k)===b)&&(O+=O.length===0?"..":"\\..");return s+=y,O.length>0?`${O}${r.slice(s,a)}`:(r.charCodeAt(s)===b&&++s,r.slice(s,a))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const l=c.charCodeAt(2);if(l!==C&&l!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(v(c.charCodeAt(0))&&c.charCodeAt(1)===I&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return f},dirname(f){p(f,"path");const c=f.length;if(c===0)return".";let l=-1,r=0;const o=f.charCodeAt(0);if(c===1)return h(o)?f:".";if(h(o)){if(l=r=1,h(f.charCodeAt(1))){let s=2,a=s;for(;s<c&&!h(f.charCodeAt(s));)s++;if(s<c&&s!==a){for(a=s;s<c&&h(f.charCodeAt(s));)s++;if(s<c&&s!==a){for(a=s;s<c&&!h(f.charCodeAt(s));)s++;if(s===c)return f;s!==a&&(l=r=s+1)}}}}else v(o)&&f.charCodeAt(1)===I&&(l=c>2&&h(f.charCodeAt(2))?3:2,r=l);let n=-1,t=!0;for(let s=c-1;s>=r;--s)if(h(f.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(l===-1)return".";n=l}return f.slice(0,n)},basename(f,c){c!==void 0&&p(c,"ext"),p(f,"path");let l=0,r=-1,o=!0,n;if(f.length>=2&&v(f.charCodeAt(0))&&f.charCodeAt(1)===I&&(l=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let t=c.length-1,s=-1;for(n=f.length-1;n>=l;--n){const a=f.charCodeAt(n);if(h(a)){if(!o){l=n+1;break}}else s===-1&&(o=!1,s=n+1),t>=0&&(a===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=f.length),f.slice(l,r)}for(n=f.length-1;n>=l;--n)if(h(f.charCodeAt(n))){if(!o){l=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":f.slice(l,r)},extname(f){p(f,"path");let c=0,l=-1,r=0,o=-1,n=!0,t=0;f.length>=2&&f.charCodeAt(1)===I&&v(f.charCodeAt(0))&&(c=r=2);for(let s=f.length-1;s>=c;--s){const a=f.charCodeAt(s);if(h(a)){if(!n){r=s+1;break}continue}o===-1&&(n=!1,o=s+1),a===P?l===-1?l=s:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||o===-1||t===0||t===1&&l===o-1&&l===r+1?"":f.slice(l,o)},format:w.bind(null,"\\"),parse(f){p(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const l=f.length;let r=0,o=f.charCodeAt(0);if(l===1)return h(o)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(h(o)){if(r=1,h(f.charCodeAt(1))){let y=2,k=y;for(;y<l&&!h(f.charCodeAt(y));)y++;if(y<l&&y!==k){for(k=y;y<l&&h(f.charCodeAt(y));)y++;if(y<l&&y!==k){for(k=y;y<l&&!h(f.charCodeAt(y));)y++;y===l?r=y:y!==k&&(r=y+1)}}}}else if(v(o)&&f.charCodeAt(1)===I){if(l<=2)return c.root=c.dir=f,c;if(r=2,h(f.charCodeAt(2))){if(l===3)return c.root=c.dir=f,c;r=3}}r>0&&(c.root=f.slice(0,r));let n=-1,t=r,s=-1,a=!0,u=f.length-1,g=0;for(;u>=r;--u){if(o=f.charCodeAt(u),h(o)){if(!a){t=u+1;break}continue}s===-1&&(a=!1,s=u+1),o===P?n===-1?n=u:g!==1&&(g=1):n!==-1&&(g=-1)}return s!==-1&&(n===-1||g===0||g===1&&n===s-1&&n===t+1?c.base=c.name=f.slice(t,s):(c.name=f.slice(t,n),c.base=f.slice(t,s),c.ext=f.slice(n,s))),t>0&&t!==r?c.dir=f.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",l=!1;for(let r=f.length-1;r>=-1&&!l;r--){const o=r>=0?f[r]:D.cwd();p(o,"path"),o.length!==0&&(c=`${o}/${c}`,l=o.charCodeAt(0)===S)}return c=m(c,!l,"/",E),l?`/${c}`:c.length>0?c:"."},normalize(f){if(p(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===S,l=f.charCodeAt(f.length-1)===S;return f=m(f,!c,"/",E),f.length===0?c?"/":l?"./":".":(l&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return p(f,"path"),f.length>0&&f.charCodeAt(0)===S},join(...f){if(f.length===0)return".";let c;for(let l=0;l<f.length;++l){const r=f[l];p(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(p(f,"from"),p(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const l=1,r=f.length,o=r-l,n=1,t=c.length-n,s=o<t?o:t;let a=-1,u=0;for(;u<s;u++){const y=f.charCodeAt(l+u);if(y!==c.charCodeAt(n+u))break;y===S&&(a=u)}if(u===s)if(t>s){if(c.charCodeAt(n+u)===S)return c.slice(n+u+1);if(u===0)return c.slice(n+u)}else o>s&&(f.charCodeAt(l+u)===S?a=u:u===0&&(a=0));let g="";for(u=l+a+1;u<=r;++u)(u===r||f.charCodeAt(u)===S)&&(g+=g.length===0?"..":"/..");return`${g}${c.slice(n+a)}`},toNamespacedPath(f){return f},dirname(f){if(p(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===S;let l=-1,r=!0;for(let o=f.length-1;o>=1;--o)if(f.charCodeAt(o)===S){if(!r){l=o;break}}else r=!1;return l===-1?c?"/":".":c&&l===1?"//":f.slice(0,l)},basename(f,c){c!==void 0&&p(c,"ext"),p(f,"path");let l=0,r=-1,o=!0,n;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let t=c.length-1,s=-1;for(n=f.length-1;n>=0;--n){const a=f.charCodeAt(n);if(a===S){if(!o){l=n+1;break}}else s===-1&&(o=!1,s=n+1),t>=0&&(a===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=f.length),f.slice(l,r)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===S){if(!o){l=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":f.slice(l,r)},extname(f){p(f,"path");let c=-1,l=0,r=-1,o=!0,n=0;for(let t=f.length-1;t>=0;--t){const s=f.charCodeAt(t);if(s===S){if(!o){l=t+1;break}continue}r===-1&&(o=!1,r=t+1),s===P?c===-1?c=t:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===l+1?"":f.slice(c,r)},format:w.bind(null,"/"),parse(f){p(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const l=f.charCodeAt(0)===S;let r;l?(c.root="/",r=1):r=0;let o=-1,n=0,t=-1,s=!0,a=f.length-1,u=0;for(;a>=r;--a){const g=f.charCodeAt(a);if(g===S){if(!s){n=a+1;break}continue}t===-1&&(s=!1,t=a+1),g===P?o===-1?o=a:u!==1&&(u=1):o!==-1&&(u=-1)}if(t!==-1){const g=n===0&&l?1:n;o===-1||u===0||u===1&&o===t-1&&o===n+1?c.base=c.name=f.slice(g,t):(c.name=f.slice(g,o),c.base=f.slice(g,t),c.ext=f.slice(o,t))}return n>0?c.dir=f.slice(0,n-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[102],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var A;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(A=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(T,...i){const P=i.reduce((I,C)=>(I[C]=!0,I),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(I=>!P[I]).forEach(I=>{for(let C=0;C<S.length;C++)if(I.search(S[C])!==-1){delete T[I];break}})}e.sanitizeProcessEnvironment=R}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var A in D)(typeof exports=="object"?exports:J)[A]=D[A]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function D(A){if(e[A])return e[A].exports;var R=e[A]={i:A,l:!1,exports:{}};return J[A].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=J,D.c=e,D.d=function(A,R,T){D.o(A,R)||Object.defineProperty(A,R,{enumerable:!0,get:T})},D.r=function(A){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},D.t=function(A,R){if(1&R&&(A=D(A)),8&R||4&R&&typeof A=="object"&&A&&A.__esModule)return A;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:A}),2&R&&typeof A!="string")for(var i in A)D.d(T,i,function(P){return A[P]}.bind(null,i));return T},D.n=function(A){var R=A&&A.__esModule?function(){return A.default}:function(){return A};return D.d(R,"a",R),R},D.o=function(A,R){return Object.prototype.hasOwnProperty.call(A,R)},D.p="",D(D.s=0)}([function(J,e,D){(function(A){var R;e=J.exports=K,R=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,i=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],b=0,I=b++;S[I]="0|[1-9]\\d*";var C=b++;S[C]="[0-9]+";var d=b++;S[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=b++;S[p]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var h=b++;S[h]="("+S[C]+")\\.("+S[C]+")\\.("+S[C]+")";var E=b++;S[E]="(?:"+S[I]+"|"+S[d]+")";var v=b++;S[v]="(?:"+S[C]+"|"+S[d]+")";var m=b++;S[m]="(?:-("+S[E]+"(?:\\."+S[E]+")*))";var w=b++;S[w]="(?:-?("+S[v]+"(?:\\."+S[v]+")*))";var f=b++;S[f]="[0-9A-Za-z-]+";var c=b++;S[c]="(?:\\+("+S[f]+"(?:\\."+S[f]+")*))";var l=b++,r="v?"+S[p]+S[m]+"?"+S[c]+"?";S[l]="^"+r+"$";var o="[v=\\s]*"+S[h]+S[w]+"?"+S[c]+"?",n=b++;S[n]="^"+o+"$";var t=b++;S[t]="((?:<|>)?=?)";var s=b++;S[s]=S[C]+"|x|X|\\*";var a=b++;S[a]=S[I]+"|x|X|\\*";var u=b++;S[u]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[m]+")?"+S[c]+"?)?)?";var g=b++;S[g]="[v=\\s]*("+S[s]+")(?:\\.("+S[s]+")(?:\\.("+S[s]+")(?:"+S[w]+")?"+S[c]+"?)?)?";var y=b++;S[y]="^"+S[t]+"\\s*"+S[u]+"$";var k=b++;S[k]="^"+S[t]+"\\s*"+S[g]+"$";var O=b++;S[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=b++;S[M]="(?:~>?)";var W=b++;S[W]="(\\s*)"+S[M]+"\\s+",P[W]=new RegExp(S[W],"g");var q=b++;S[q]="^"+S[M]+S[u]+"$";var L=b++;S[L]="^"+S[M]+S[g]+"$";var $=b++;S[$]="(?:\\^)";var _=b++;S[_]="(\\s*)"+S[$]+"\\s+",P[_]=new RegExp(S[_],"g");var F=b++;S[F]="^"+S[$]+S[u]+"$";var B=b++;S[B]="^"+S[$]+S[g]+"$";var Z=b++;S[Z]="^"+S[t]+"\\s*("+o+")$|^$";var H=b++;S[H]="^"+S[t]+"\\s*("+r+")$|^$";var j=b++;S[j]="(\\s*)"+S[t]+"\\s*("+o+"|"+S[u]+")",P[j]=new RegExp(S[j],"g");var Q=b++;S[Q]="^\\s*("+S[u]+")\\s+-\\s+("+S[u]+")\\s*$";var U=b++;S[U]="^\\s*("+S[g]+")\\s+-\\s+("+S[g]+")\\s*$";var N=b++;S[N]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)R(z,S[z]),P[z]||(P[z]=new RegExp(S[z]));function x(ie,ae){if(ie instanceof K)return ie;if(typeof ie!="string"||ie.length>T||!(ae?P[n]:P[l]).test(ie))return null;try{return new K(ie,ae)}catch(ce){return null}}function K(ie,ae){if(ie instanceof K){if(ie.loose===ae)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof K))return new K(ie,ae);R("SemVer",ie,ae),this.loose=ae;var ce=ie.trim().match(ae?P[n]:P[l]);if(!ce)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Pe=+ye;if(Pe>=0&&Pe<i)return Pe}return ye}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=x,e.valid=function(ie,ae){var ce=x(ie,ae);return ce?ce.version:null},e.clean=function(ie,ae){var ce=x(ie.trim().replace(/^[=v]+/,""),ae);return ce?ce.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ie){return R("SemVer.compare",this.version,this.loose,ie),ie instanceof K||(ie=new K(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},K.prototype.compareMain=function(ie){return ie instanceof K||(ie=new K(ie,this.loose)),V(this.major,ie.major)||V(this.minor,ie.minor)||V(this.patch,ie.patch)},K.prototype.comparePre=function(ie){if(ie instanceof K||(ie=new K(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ae=0;do{var ce=this.prerelease[ae],ye=ie.prerelease[ae];if(R("prerelease compare",ae,ce,ye),ce===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ce===void 0)return-1;if(ce!==ye)return V(ce,ye)}while(++ae)},K.prototype.inc=function(ie,ae){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ae,ce,ye){typeof ce=="string"&&(ye=ce,ce=void 0);try{return new K(ie,ce).inc(ae,ye).version}catch(Pe){return null}},e.diff=function(ie,ae){if(le(ie,ae))return null;var ce=x(ie),ye=x(ae);if(ce.prerelease.length||ye.prerelease.length){for(var Pe in ce)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ce[Pe]!==ye[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ce)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ce[Pe]!==ye[Pe])return Pe},e.compareIdentifiers=V;var ee=/^[0-9]+$/;function V(ie,ae){var ce=ee.test(ie),ye=ee.test(ae);return ce&&ye&&(ie=+ie,ae=+ae),ce&&!ye?-1:ye&&!ce?1:ie<ae?-1:ie>ae?1:0}function X(ie,ae,ce){return new K(ie,ce).compare(new K(ae,ce))}function se(ie,ae,ce){return X(ie,ae,ce)>0}function oe(ie,ae,ce){return X(ie,ae,ce)<0}function le(ie,ae,ce){return X(ie,ae,ce)===0}function he(ie,ae,ce){return X(ie,ae,ce)!==0}function be(ie,ae,ce){return X(ie,ae,ce)>=0}function Ce(ie,ae,ce){return X(ie,ae,ce)<=0}function we(ie,ae,ce,ye){var Pe;switch(ae){case"===":typeof ie=="object"&&(ie=ie.version),typeof ce=="object"&&(ce=ce.version),Pe=ie===ce;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof ce=="object"&&(ce=ce.version),Pe=ie!==ce;break;case"":case"=":case"==":Pe=le(ie,ce,ye);break;case"!=":Pe=he(ie,ce,ye);break;case">":Pe=se(ie,ce,ye);break;case">=":Pe=be(ie,ce,ye);break;case"<":Pe=oe(ie,ce,ye);break;case"<=":Pe=Ce(ie,ce,ye);break;default:throw new TypeError("Invalid operator: "+ae)}return Pe}function ve(ie,ae){if(ie instanceof ve){if(ie.loose===ae)return ie;ie=ie.value}if(!(this instanceof ve))return new ve(ie,ae);R("comparator",ie,ae),this.loose=ae,this.parse(ie),this.semver===De?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ie,ae){return V(ae,ie)},e.major=function(ie,ae){return new K(ie,ae).major},e.minor=function(ie,ae){return new K(ie,ae).minor},e.patch=function(ie,ae){return new K(ie,ae).patch},e.compare=X,e.compareLoose=function(ie,ae){return X(ie,ae,!0)},e.rcompare=function(ie,ae,ce){return X(ae,ie,ce)},e.sort=function(ie,ae){return ie.sort(function(ce,ye){return e.compare(ce,ye,ae)})},e.rsort=function(ie,ae){return ie.sort(function(ce,ye){return e.rcompare(ce,ye,ae)})},e.gt=se,e.lt=oe,e.eq=le,e.neq=he,e.gte=be,e.lte=Ce,e.cmp=we,e.Comparator=ve;var De={};function Se(ie,ae){if(ie instanceof Se)return ie.loose===ae?ie:new Se(ie.raw,ae);if(ie instanceof ve)return new Se(ie.value,ae);if(!(this instanceof Se))return new Se(ie,ae);if(this.loose=ae,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function Ie(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function Me(ie,ae,ce,ye,Pe,_e,Te,Fe,Ae,Ue,Y,re,ue){return((ae=Ie(ce)?"":Ie(ye)?">="+ce+".0.0":Ie(Pe)?">="+ce+"."+ye+".0":">="+ae)+" "+(Fe=Ie(Ae)?"":Ie(Ue)?"<"+(+Ae+1)+".0.0":Ie(Y)?"<"+Ae+"."+(+Ue+1)+".0":re?"<="+Ae+"."+Ue+"."+Y+"-"+re:"<="+Fe)).trim()}function je(ie,ae){for(var ce=0;ce<ie.length;ce++)if(!ie[ce].test(ae))return!1;if(ae.prerelease.length){for(ce=0;ce<ie.length;ce++)if(R(ie[ce].semver),ie[ce].semver!==De&&ie[ce].semver.prerelease.length>0){var ye=ie[ce].semver;if(ye.major===ae.major&&ye.minor===ae.minor&&ye.patch===ae.patch)return!0}return!1}return!0}function Ne(ie,ae,ce){try{ae=new Se(ae,ce)}catch(ye){return!1}return ae.test(ie)}function We(ie,ae,ce,ye){var Pe,_e,Te,Fe,Ae;switch(ie=new K(ie,ye),ae=new Se(ae,ye),ce){case">":Pe=se,_e=Ce,Te=oe,Fe=">",Ae=">=";break;case"<":Pe=oe,_e=be,Te=se,Fe="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ie,ae,ye))return!1;for(var Ue=0;Ue<ae.set.length;++Ue){var Y=ae.set[Ue],re=null,ue=null;if(Y.forEach(function(fe){fe.semver===De&&(fe=new ve(">=0.0.0")),re=re||fe,ue=ue||fe,Pe(fe.semver,re.semver,ye)?re=fe:Te(fe.semver,ue.semver,ye)&&(ue=fe)}),re.operator===Fe||re.operator===Ae||(!ue.operator||ue.operator===Fe)&&_e(ie,ue.semver)||ue.operator===Ae&&Te(ie,ue.semver))return!1}return!0}ve.prototype.parse=function(ie){var ae=this.loose?P[Z]:P[H],ce=ie.match(ae);if(!ce)throw new TypeError("Invalid comparator: "+ie);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new K(ce[2],this.loose):this.semver=De},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ie){return R("Comparator.test",ie,this.loose),this.semver===De||(typeof ie=="string"&&(ie=new K(ie,this.loose)),we(ie,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ie,ae){if(!(ie instanceof ve))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new Se(ie.value,ae),Ne(this.value,ce,ae);if(ie.operator==="")return ce=new Se(this.value,ae),Ne(ie.semver,ce,ae);var ye=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),_e=this.semver.version===ie.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Fe=we(this.semver,"<",ie.semver,ae)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Ae=we(this.semver,">",ie.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return ye||Pe||_e&&Te||Fe||Ae},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(ie){var ae=this.loose;ie=ie.trim(),R("range",ie,ae);var ce=ae?P[U]:P[Q];ie=ie.replace(ce,Me),R("hyphen replace",ie),ie=ie.replace(P[j],"$1$2$3"),R("comparator trim",ie,P[j]),ie=(ie=(ie=ie.replace(P[W],"$1~")).replace(P[_],"$1^")).split(/\s+/).join(" ");var ye=ae?P[Z]:P[H],Pe=ie.split(" ").map(function(_e){return function(Te,Fe){return R("comp",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(Y){return function(re,ue){R("caret",re,ue);var fe=ue?P[B]:P[F];return re.replace(fe,function(pe,ge,Ee,Re,ke){var Le;return R("caret",re,pe,ge,Ee,Re,ke),Ie(ge)?Le="":Ie(Ee)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(Re)?Le=ge==="0"?">="+ge+"."+Ee+".0 <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+".0 <"+(+ge+1)+".0.0":ke?(R("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=ge==="0"?Ee==="0"?">="+ge+"."+Ee+"."+Re+ke+" <"+ge+"."+Ee+"."+(+Re+1):">="+ge+"."+Ee+"."+Re+ke+" <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+"."+Re+ke+" <"+(+ge+1)+".0.0"):(R("no pr"),Le=ge==="0"?Ee==="0"?">="+ge+"."+Ee+"."+Re+" <"+ge+"."+Ee+"."+(+Re+1):">="+ge+"."+Ee+"."+Re+" <"+ge+"."+(+Ee+1)+".0":">="+ge+"."+Ee+"."+Re+" <"+(+ge+1)+".0.0"),R("caret return",Le),Le})}(Y,Ue)}).join(" ")}(Te,Fe),R("caret",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(Y){return function(re,ue){var fe=ue?P[L]:P[q];return re.replace(fe,function(pe,ge,Ee,Re,ke){var Le;return R("tilde",re,pe,ge,Ee,Re,ke),Ie(ge)?Le="":Ie(Ee)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ie(Re)?Le=">="+ge+"."+Ee+".0 <"+ge+"."+(+Ee+1)+".0":ke?(R("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+ge+"."+Ee+"."+Re+ke+" <"+ge+"."+(+Ee+1)+".0"):Le=">="+ge+"."+Ee+"."+Re+" <"+ge+"."+(+Ee+1)+".0",R("tilde return",Le),Le})}(Y,Ue)}).join(" ")}(Te,Fe),R("tildes",Te),Te=function(Ae,Ue){return R("replaceXRanges",Ae,Ue),Ae.split(/\s+/).map(function(Y){return function(re,ue){re=re.trim();var fe=ue?P[k]:P[y];return re.replace(fe,function(pe,ge,Ee,Re,ke,Le){R("xRange",re,pe,ge,Ee,Re,ke,Le);var $e=Ie(Ee),Ye=$e||Ie(Re),He=Ye||Ie(ke);return ge==="="&&He&&(ge=""),$e?pe=ge===">"||ge==="<"?"<0.0.0":"*":ge&&He?(Ye&&(Re=0),He&&(ke=0),ge===">"?(ge=">=",Ye?(Ee=+Ee+1,Re=0,ke=0):He&&(Re=+Re+1,ke=0)):ge==="<="&&(ge="<",Ye?Ee=+Ee+1:Re=+Re+1),pe=ge+Ee+"."+Re+"."+ke):Ye?pe=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":He&&(pe=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),R("xRange return",pe),pe})}(Y,Ue)}).join(" ")}(Te,Fe),R("xrange",Te),Te=function(Ae,Ue){return R("replaceStars",Ae,Ue),Ae.trim().replace(P[N],"")}(Te,Fe),R("stars",Te),Te}(_e,ae)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(_e){return!!_e.match(ye)})),Pe=Pe.map(function(_e){return new ve(_e,ae)})},Se.prototype.intersects=function(ie,ae){if(!(ie instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ye){return ie.set.some(function(Pe){return Pe.every(function(_e){return ye.intersects(_e,ae)})})})})},e.toComparators=function(ie,ae){return new Se(ie,ae).set.map(function(ce){return ce.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new K(ie,this.loose));for(var ae=0;ae<this.set.length;ae++)if(je(this.set[ae],ie))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ie,ae,ce){var ye=null,Pe=null;try{var _e=new Se(ae,ce)}catch(Te){return null}return ie.forEach(function(Te){_e.test(Te)&&(ye&&Pe.compare(Te)!==-1||(Pe=new K(ye=Te,ce)))}),ye},e.minSatisfying=function(ie,ae,ce){var ye=null,Pe=null;try{var _e=new Se(ae,ce)}catch(Te){return null}return ie.forEach(function(Te){_e.test(Te)&&(ye&&Pe.compare(Te)!==1||(Pe=new K(ye=Te,ce)))}),ye},e.validRange=function(ie,ae){try{return new Se(ie,ae).range||"*"}catch(ce){return null}},e.ltr=function(ie,ae,ce){return We(ie,ae,"<",ce)},e.gtr=function(ie,ae,ce){return We(ie,ae,">",ce)},e.outside=We,e.prerelease=function(ie,ae){var ce=x(ie,ae);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(ie,ae,ce){return ie=new Se(ie,ce),ae=new Se(ae,ce),ie.intersects(ae)},e.coerce=function(ie){if(ie instanceof K)return ie;if(typeof ie!="string")return null;var ae=ie.match(P[O]);return ae==null?null:x((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(J,e){var D,A,R=J.exports={};function T(){throw new Error("setTimeout has not been defined")}function i(){throw new Error("clearTimeout has not been defined")}function P(v){if(D===setTimeout)return setTimeout(v,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(v,0);try{return D(v,0)}catch(m){try{return D.call(null,v,0)}catch(w){return D.call(this,v,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch(v){D=T}try{A=typeof clearTimeout=="function"?clearTimeout:i}catch(v){A=i}})();var S,b=[],I=!1,C=-1;function d(){I&&S&&(I=!1,S.length?b=S.concat(b):C=-1,b.length&&p())}function p(){if(!I){var v=P(d);I=!0;for(var m=b.length;m;){for(S=b,b=[];++C<m;)S&&S[C].run();C=-1,m=b.length}S=null,I=!1,function(w){if(A===clearTimeout)return clearTimeout(w);if((A===i||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(w);try{A(w)}catch(f){try{return A.call(null,w)}catch(c){return A.call(this,w)}}}(v)}}function h(v,m){this.fun=v,this.array=m}function E(){}R.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];b.push(new h(v,m)),b.length!==1||I||P(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=E,R.addListener=E,R.once=E,R.off=E,R.removeListener=E,R.removeAllListeners=E,R.emit=E,R.prependListener=E,R.prependOnceListener=E,R.listeners=function(v){return[]},R.binding=function(v){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(v){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[103],ne([0,1]),function(J,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(P,S,b){this.level=P,this.key=S,this.value=b,this.forward=[]}}const R=void 0;class T{constructor(P,S=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new A(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new A(this._maxLevel,R,R)}has(P){return Boolean(T._search(this,P,this.comparator))}get(P){return T._search(this,P,this.comparator)?.value}set(P,S){return T._insert(this,P,S,this.comparator)&&(this._size+=1),this}delete(P){const S=T._delete(this,P,this.comparator);return S&&(this._size-=1),S}forEach(P,S){let b=this._header.forward[0];for(;b;)P.call(S,b.value,b.key,this),b=b.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",S=this._header.forward[0];for(;S;)P+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return P}static _search(P,S,b){let I=P._header;for(let C=P._level-1;C>=0;C--)for(;I.forward[C]&&b(I.forward[C].key,S)<0;)I=I.forward[C];if(I=I.forward[0],I&&b(I.key,S)===0)return I}static _insert(P,S,b,I){let C=[],d=P._header;for(let p=P._level-1;p>=0;p--){for(;d.forward[p]&&I(d.forward[p].key,S)<0;)d=d.forward[p];C[p]=d}if(d=d.forward[0],d&&I(d.key,S)===0)return d.value=b,!1;{let p=T._randomLevel(P);if(p>P._level){for(let h=P._level;h<p;h++)C[h]=P._header;P._level=p}d=new A(p,S,b);for(let h=0;h<p;h++)d.forward[h]=C[h].forward[h],C[h].forward[h]=d;return!0}}static _randomLevel(P,S=.5){let b=1;for(;Math.random()<S&&b<P._maxLevel;)b+=1;return b}static _delete(P,S,b){let I=[],C=P._header;for(let d=P._level-1;d>=0;d--){for(;C.forward[d]&&b(C.forward[d].key,S)<0;)C=C.forward[d];I[d]=C}if(C=C.forward[0],!C||b(C.key,S)!==0)return!1;for(let d=0;d<P._level&&I[d].forward[d]===C;d++)I[d].forward[d]=C.forward[d];for(;P._level>0&&P._header.forward[P._level-1]===R;)P._level-=1;return!0}}e.SkipList=T}),define(te[104],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(i){this._highResolution=A&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new R(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(te[3],ne([0,1,9,68,2,101,104]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(c){c.None=()=>R.Disposable.None;function l(_){return(F,B=null,Z)=>{let H=!1,j;return j=_(Q=>{if(!H)return j?j.dispose():H=!0,F.call(B,Q)},null,Z),H&&j.dispose(),j}}c.once=l;function r(_,F){return u((B,Z=null,H)=>_(j=>B.call(Z,F(j)),null,H))}c.map=r;function o(_,F){return u((B,Z=null,H)=>_(j=>{F(j),B.call(Z,j)},null,H))}c.forEach=o;function n(_,F){return u((B,Z=null,H)=>_(j=>F(j)&&B.call(Z,j),null,H))}c.filter=n;function t(_){return _}c.signal=t;function s(..._){return(F,B=null,Z)=>(0,R.combinedDisposable)(..._.map(H=>H(j=>F.call(B,j),null,Z)))}c.any=s;function a(_,F,B){let Z=B;return r(_,H=>(Z=F(Z,H),Z))}c.reduce=a;function u(_){let F;const B=new d({onFirstListenerAdd(){F=_(B.fire,B)},onLastListenerRemove(){F.dispose()}});return B.event}function g(_,F,B=100,Z=!1,H){let j,Q,U,N=0;const z=new d({leakWarningThreshold:H,onFirstListenerAdd(){j=_(x=>{N++,Q=F(Q,x),Z&&!U&&(z.fire(Q),Q=void 0),clearTimeout(U),U=setTimeout(()=>{const K=Q;Q=void 0,U=void 0,(!Z||N>1)&&z.fire(K),N=0},B)})},onLastListenerRemove(){j.dispose()}});return z.event}c.debounce=g;function y(_,F=(B,Z)=>B===Z){let B=!0,Z;return n(_,H=>{const j=B||!F(H,Z);return B=!1,Z=H,j})}c.latch=y;function k(_,F){return[c.filter(_,F),c.filter(_,B=>!F(B))]}c.split=k;function O(_,F=!1,B=[]){let Z=B.slice(),H=_(U=>{Z?Z.push(U):Q.fire(U)});const j=()=>{Z&&Z.forEach(U=>Q.fire(U)),Z=null},Q=new d({onFirstListenerAdd(){H||(H=_(U=>Q.fire(U)))},onFirstListenerDidAdd(){Z&&(F?setTimeout(j):j())},onLastListenerRemove(){H&&H.dispose(),H=null}});return Q.event}c.buffer=O;class M{constructor(F){this.event=F}map(F){return new M(r(this.event,F))}forEach(F){return new M(o(this.event,F))}filter(F){return new M(n(this.event,F))}reduce(F,B){return new M(a(this.event,F,B))}latch(){return new M(y(this.event))}debounce(F,B=100,Z=!1,H){return new M(g(this.event,F,B,Z,H))}on(F,B,Z){return this.event(F,B,Z)}once(F,B,Z){return l(this.event)(F,B,Z)}}function W(_){return new M(_)}c.chain=W;function q(_,F,B=Z=>Z){const Z=(...U)=>Q.fire(B(...U)),H=()=>_.on(F,Z),j=()=>_.removeListener(F,Z),Q=new d({onFirstListenerAdd:H,onLastListenerRemove:j});return Q.event}c.fromNodeEventEmitter=q;function L(_,F,B=Z=>Z){const Z=(...U)=>Q.fire(B(...U)),H=()=>_.addEventListener(F,Z),j=()=>_.removeEventListener(F,Z),Q=new d({onFirstListenerAdd:H,onLastListenerRemove:j});return Q.event}c.fromDOMEventEmitter=L;function $(_){return new Promise(F=>l(_)(F))}c.toPromise=$})(P=e.Event||(e.Event={}));class S{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${S._idPool++}`}start(l){this._stopWatch=new i.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let b=-1;function I(c){const l=b;return b=c,{dispose(){b=l}}}e.setGlobalLeakWarningThreshold=I;class C{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=b;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(o)||0;if(this._stacks.set(o,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[a,u]of this._stacks)(!t||s<u)&&(t=a,s=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=b>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,o)=>{this._listeners||(this._listeners=new T.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const s=this._leakageMon?.check(this._listeners.size),a=(0,R.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof R.DisposableStore?o.add(a):Array.isArray(o)&&o.push(a),a}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,o]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(n){(0,D.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class p extends d{async fireAsync(l,r,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],a={...t,waitUntil:u=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");o&&(u=o(u,typeof n=="function"?n:n[0])),s.push(u)}};try{typeof n=="function"?n.call(void 0,a):n[0].call(n[1],a)}catch(u){(0,D.onUnexpectedError)(u);continue}Object.freeze(s),await Promise.allSettled(s).then(u=>{for(const g of u)g.status==="rejected"&&(0,D.onUnexpectedError)(g.reason)})}}}}e.AsyncEmitter=p;class h extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class E extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=E;class v extends d{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const o=()=>{this.hasListeners&&this.unhook(r);const n=this.events.indexOf(r);this.events.splice(n,1)};return(0,R.toDisposable)((0,A.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,o,n)=>l(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(o,t)):r.call(o,t)},void 0,n)}bufferEvents(l){const r=[];this.buffers.push(r);const o=l();return this.buffers.pop(),r.forEach(n=>n()),o}}e.EventBufferer=w;class f{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(te[27],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,S){const b=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(b)}}});var R;(function(P){function S(b){return b===P.None||b===P.Cancelled||b instanceof T?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=i}),define(te[49],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(I){const C=this._icons.get(I.id);C?I.description?C.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new A;e.iconRegistry=R;function T(b){return b?b.replace(/\$\((.*?)\)/g,(I,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=T;class i{constructor(I,C,d){this.id=I,this.definition=C,this.description=d,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function P(b,I){const C=["codicon","codicon-"+b];return I&&C.push("codicon-modifier-"+I),C}e.getClassNamesArray=P;var S;(function(b){b.iconNameSegment="[A-Za-z0-9]+",b.iconNameExpression="[A-Za-z0-9-]+",b.iconModifierExpression="~[A-Za-z]+",b.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${b.iconNameExpression})(${b.iconModifierExpression})?$`);function C(h){if(h instanceof i)return["codicon","codicon-"+h.id];const E=I.exec(h.id);if(!E)return C(i.error);let[,v,m]=E;const w=["codicon","codicon-"+v];return m&&w.push("codicon-modifier-"+m.substr(1)),w}b.asClassNameArray=C;function d(h){return C(h).join(" ")}b.asClassName=d;function p(h){return"."+C(h).join(".")}b.asCSSSelector=p})(S=e.CSSIcon||(e.CSSIcon={}))}),define(te[50],ne([0,1,9,2]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=R;function T(f){const c=f;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function i(f,c){return new P(f,c)}e.newWriteableStream=i;class P{constructor(c,l){this.reducer=c,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(l=>l(c))}emitError(c){this.listeners.error.length===0?(0,D.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(l=>l(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,l){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(c,l){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const o=r.indexOf(l);o>=0&&r.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(f,c){const l=[];let r;for(;(r=f.read())!==null;)l.push(r);return c(l)}e.consumeReadable=S;function b(f,c,l){const r=[];let o;for(;(o=f.read())!==null&&r.length<l;)r.push(o);return o===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof o!="undefined"){const n=o;return o=void 0,n}return f.read()}}}e.peekReadable=b;function I(f,c){return new Promise((l,r)=>{const o=[];C(f,{onData:n=>{c&&o.push(n)},onError:n=>{c?r(n):l(void 0)},onEnd:()=>{l(c?c(o):void 0)}})})}e.consumeStream=I;function C(f,c){f.on("error",l=>c.onError(l)),f.on("end",()=>c.onEnd()),f.on("data",l=>c.onData(l))}e.listenStream=C;function d(f,c){return new Promise((l,r)=>{const o=new A.DisposableStore,n=[],t=u=>{if(n.push(u),n.length>c)return o.dispose(),f.pause(),l({stream:f,buffer:n,ended:!1})},s=u=>r(u),a=()=>l({stream:f,buffer:n,ended:!0});o.add((0,A.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),o.add((0,A.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),o.add((0,A.toDisposable)(()=>f.removeListener("data",t))),f.on("data",t)})}e.peekStream=d;function p(f,c){const l=i(c);return l.end(f),l}e.toStream=p;function h(){const f=i(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function E(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=E;function v(f,c,l){const r=i(l);return C(f,{onData:o=>r.write(c.data(o)),onError:o=>r.error(c.error?c.error(o):o),onEnd:()=>r.end()}),r}e.transform=v;function m(f,c,l){let r=!1;return{read:()=>{const o=c.read();return r?o:(r=!0,o!==null?l([f,o]):f)}}}e.prefixedReadable=m;function w(f,c,l){let r=!1;const o=i(l);return C(c,{onData:n=>r?o.write(n):(r=!0,o.write(l([f,n]))),onError:n=>o.error(n),onEnd:()=>{r||(r=!0,o.write(f)),o.end()}}),o}e.prefixedStream=w}),define(te[19],ne([0,1,50]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined";let R,T;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return A?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return A&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&A?new i(Buffer.from(t)):(R||(R=new TextEncoder),new i(R.encode(t)))}static concat(t,s){if(typeof s=="undefined"){s=0;for(let g=0,y=t.length;g<y;g++)s+=t[g].byteLength}const a=i.alloc(s);let u=0;for(let g=0,y=t.length;g<y;g++){const k=t[g];a.set(k,u),u+=k.byteLength}return a}toString(){return A?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(t,s){return new i(this.buffer.subarray(t,s))}set(t,s){t instanceof i?this.buffer.set(t.buffer,s):this.buffer.set(t,s)}readUInt32BE(t){return b(this.buffer,t)}writeUInt32BE(t,s){I(this.buffer,t,s)}readUInt32LE(t){return C(this.buffer,t)}writeUInt32LE(t,s){d(this.buffer,t,s)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,s){h(this.buffer,t,s)}}e.VSBuffer=i;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=P;function S(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=S;function b(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=b;function I(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=I;function C(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=C;function d(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=d;function p(n,t){return n[t]}e.readUInt8=p;function h(n,t,s){n[s]=t}e.writeUInt8=h;function E(n){return D.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=E;function v(n){return D.toReadable(n)}e.bufferToReadable=v;function m(n){return D.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=m;async function w(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=w;function f(n){return D.toStream(n,t=>i.concat(t))}e.bufferToStream=f;function c(n){return D.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=c;function l(n){return D.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=l;function r(n,t){return D.prefixedReadable(n,t,s=>i.concat(s))}e.prefixedBufferReadable=r;function o(n,t){return D.prefixedStream(n,t,s=>i.concat(s))}e.prefixedBufferStream=o}),define(te[25],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=A;const R=/{(\d+)}/g;function T(Y,...re){return re.length===0?Y:Y.replace(R,function(ue,fe){const pe=parseInt(fe,10);return isNaN(pe)||pe<0||pe>=re.length?ue:re[pe]})}e.format=T;const i=/{([^}]+)}/g;function P(Y,re){return Y.replace(i,(ue,fe)=>re[fe]??ue)}e.format2=P;function S(Y){return Y.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=S;function b(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function I(Y,re){let ue=0;const fe=re.charCodeAt(0);for(let pe=Y.length-1;pe>=0;pe--)Y.charCodeAt(pe)===fe&&ue++;return ue}e.count=I;function C(Y,re,ue="\u2026"){return Y.length<=re?Y:`${Y.substr(0,re)}${ue}`}e.truncate=C;function d(Y,re=" "){const ue=p(Y,re);return h(ue,re)}e.trim=d;function p(Y,re){if(!Y||!re)return Y;const ue=re.length;if(ue===0||Y.length===0)return Y;let fe=0;for(;Y.indexOf(re,fe)===fe;)fe=fe+ue;return Y.substring(fe)}e.ltrim=p;function h(Y,re){if(!Y||!re)return Y;const ue=re.length,fe=Y.length;if(ue===0||fe===0)return Y;let pe=fe,ge=-1;for(;ge=Y.lastIndexOf(re,pe-1),!(ge===-1||ge+ue!==pe);){if(ge===0)return"";pe=ge}return Y.substring(0,pe)}e.rtrim=h;function E(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function v(Y){return Y.replace(/\*/g,"")}e.stripWildcards=v;function m(Y,re,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");re||(Y=b(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let fe="";return ue.global&&(fe+="g"),ue.matchCase||(fe+="i"),ue.multiline&&(fe+="m"),ue.unicode&&(fe+="u"),new RegExp(Y,fe)}e.createRegExp=m;function w(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function f(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function c(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=c;function l(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=l;function r(Y){for(let re=0,ue=Y.length;re<ue;re++){const fe=Y.charCodeAt(re);if(fe!==32&&fe!==9)return re}return-1}e.firstNonWhitespaceIndex=r;function o(Y,re=0,ue=Y.length){for(let fe=re;fe<ue;fe++){const pe=Y.charCodeAt(fe);if(pe!==32&&pe!==9)return Y.substring(re,fe)}return Y.substring(re,ue)}e.getLeadingWhitespace=o;function n(Y,re=Y.length-1){for(let ue=re;ue>=0;ue--){const fe=Y.charCodeAt(ue);if(fe!==32&&fe!==9)return ue}return-1}e.lastNonWhitespaceIndex=n;function t(Y,re){return Y<re?-1:Y>re?1:0}e.compare=t;function s(Y,re,ue=0,fe=Y.length,pe=0,ge=re.length){for(;ue<fe&&pe<ge;ue++,pe++){let ke=Y.charCodeAt(ue),Le=re.charCodeAt(pe);if(ke<Le)return-1;if(ke>Le)return 1}const Ee=fe-ue,Re=ge-pe;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstring=s;function a(Y,re){return u(Y,re,0,Y.length,0,re.length)}e.compareIgnoreCase=a;function u(Y,re,ue=0,fe=Y.length,pe=0,ge=re.length){for(;ue<fe&&pe<ge;ue++,pe++){let ke=Y.charCodeAt(ue),Le=re.charCodeAt(pe);if(ke===Le)continue;if(ke>=128||Le>=128)return s(Y.toLowerCase(),re.toLowerCase(),ue,fe,pe,ge);g(ke)&&(ke-=32),g(Le)&&(Le-=32);const $e=ke-Le;if($e!==0)return $e}const Ee=fe-ue,Re=ge-pe;return Ee<Re?-1:Ee>Re?1:0}e.compareSubstringIgnoreCase=u;function g(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=g;function y(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=y;function k(Y,re){return Y.length===re.length&&u(Y,re)===0}e.equalsIgnoreCase=k;function O(Y,re){const ue=re.length;return re.length>Y.length?!1:u(Y,re,0,ue)===0}e.startsWithIgnoreCase=O;function M(Y,re){let ue,fe=Math.min(Y.length,re.length);for(ue=0;ue<fe;ue++)if(Y.charCodeAt(ue)!==re.charCodeAt(ue))return ue;return fe}e.commonPrefixLength=M;function W(Y,re){let ue,fe=Math.min(Y.length,re.length);const pe=Y.length-1,ge=re.length-1;for(ue=0;ue<fe;ue++)if(Y.charCodeAt(pe-ue)!==re.charCodeAt(ge-ue))return ue;return fe}e.commonSuffixLength=W;function q(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=q;function L(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=L;function $(Y,re){return(Y-55296<<10)+(re-56320)+65536}e.computeCodePoint=$;function _(Y,re,ue){const fe=Y.charCodeAt(ue);if(q(fe)&&ue+1<re){const pe=Y.charCodeAt(ue+1);if(L(pe))return $(fe,pe)}return fe}e.getNextCodePoint=_;function F(Y,re){const ue=Y.charCodeAt(re-1);if(L(ue)&&re>1){const fe=Y.charCodeAt(re-2);if(q(fe))return $(fe,ue)}return ue}function B(Y,re){const ue=ae.getInstance(),fe=re,pe=Y.length,ge=_(Y,pe,re);re+=ge>=65536?2:1;let Ee=ue.getGraphemeBreakType(ge);for(;re<pe;){const Re=_(Y,pe,re),ke=ue.getGraphemeBreakType(Re);if(We(Ee,ke))break;re+=Re>=65536?2:1,Ee=ke}return re-fe}e.nextCharLength=B;function Z(Y,re){const ue=ae.getInstance(),fe=re,pe=F(Y,re);re-=pe>=65536?2:1;let ge=ue.getGraphemeBreakType(pe);for(;re>0;){const Ee=F(Y,re),Re=ue.getGraphemeBreakType(Ee);if(We(Re,ge))break;re-=Ee>=65536?2:1,ge=Re}return fe-re}e.prevCharLength=Z;function H(Y,re){const ue=ae.getInstance(),fe=Y.length,pe=re,ge=_(Y,fe,re),Ee=ue.getGraphemeBreakType(ge);re+=ge>=65536?2:1;let Re=Ee;for(;re<fe;){const Le=_(Y,fe,re),$e=ue.getGraphemeBreakType(Le);if(We(Re,$e))break;re+=Le>=65536?2:1,Re=$e}const ke=re;for(re=pe,Re=Ee;re>0;){const Le=F(Y,re),$e=ue.getGraphemeBreakType(Le);if(We($e,Re))break;re-=Le>=65536?2:1,Re=$e}return[re,ke]}function j(Y,re){return re>0&&L(Y.charCodeAt(re))?H(Y,re-1):H(Y,re)}e.getCharContainingOffset=j;const Q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function U(Y){return Q.test(Y)}e.containsRTL=U;const N=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function z(Y){return N.test(Y)}e.containsEmoji=z;const x=/^[\t\n\r\x20-\x7E]*$/;function K(Y){return x.test(Y)}e.isBasicASCII=K,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=ee;function V(Y){for(let re=0,ue=Y.length;re<ue;re++)if(X(Y.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=V;function X(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=X;function se(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=se;function oe(Y,re){if(Y.length<re)return Y;const ue=/\b/g;let fe=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<re);)fe=ue.lastIndex,ue.lastIndex+=1;return Y.substring(fe).replace(/^\s/,"")}e.lcut=oe;const le=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,be=/\x1b\[0?m/g;function Ce(Y){return Y&&(Y=Y.replace(le,""),Y=Y.replace(he,""),Y=Y.replace(be,"")),Y}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function ve(Y){return we(Y)?Y.substr(1):Y}e.stripUTF8BOM=ve;function De(Y,re){if(!Y||!re||Y.length<re.length)return!1;const ue=re.length,fe=Y.toLowerCase();let pe=0,ge=-1;for(;pe<ue;){const Ee=fe.indexOf(re[pe],ge+1);if(Ee<0)return!1;ge=Ee,pe++}return!0}e.fuzzyContains=De;function Se(Y,re=!1){return Y?(re&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Se;function Ie(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Ie;function Me(Y,re=1){if(re===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),re--;while(re>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Me;function je(Y){const re=90-65+1;return Y=Y%(2*re),Y<re?String.fromCharCode(97+Y):String.fromCharCode(65+Y-re)}e.singleLetterHash=je;function Ne(Y){return ae.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function We(Y,re){return Y===0?re!==5&&re!==7:Y===2&&re===3?!1:Y===4||Y===2||Y===3||re===4||re===2||re===3?!0:!(Y===8&&(re===8||re===9||re===11||re===12)||(Y===11||Y===9)&&(re===9||re===10)||(Y===12||Y===10)&&re===10||re===5||re===13||re===7||Y===1||Y===13&&re===14||Y===6&&re===6)}e.breakBetweenGraphemeBreakType=We;var ie;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ce()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const ue=this._data,fe=ue.length/3;let pe=1;for(;pe<=fe;)if(re<ue[3*pe])pe=2*pe;else if(re>ue[3*pe+1])pe=2*pe+1;else return ue[3*pe+2];return 0}}ae._INSTANCE=null;function ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ye(Y,re){if(Y===0)return 0;const ue=Pe(Y,re);if(ue!==void 0)return ue;const fe=F(re,Y);return Y-=_e(fe),Y}e.getLeftDeleteOffset=ye;function Pe(Y,re){let ue=F(re,Y);for(Y-=_e(ue);Te(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=F(re,Y),Y-=_e(ue)}if(!!se(ue)){if(Y>=0){const fe=F(re,Y);fe===8205&&(Y-=_e(fe))}return Y}}function _e(Y){return Y>=65536?2:1}function Te(Y){return 127995<=Y&&Y<=127999}var Fe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class Ae{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ae.map){let fe=function(Ee){const Re=new Map;for(let ke=0;ke<Ee.length;ke+=2)Re.set(Ee[ke],Ee[ke+1]);return Re};const re=Ae.getData();let ue=D.locale;(!ue||!(ue in re))&&(ue=D.language),(!ue||!(ue in re))&&(ue="_default");const pe=fe(re._common),ge=fe(re[ue]);for(const[Ee,Re]of ge)pe.set(Ee,Re);Ae.map=pe}return Ae.map}static isAmbiguous(re){return Ae.getConfusablesForCurrentLocale().has(re)}static getPrimaryConfusable(re){return Ae.getConfusablesForCurrentLocale().get(re)}static getPrimaryConfusableCodePoints(){return new Set(Ae.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ae;class Ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ue.getRawData())),this._data}static isInvisibleCharacter(re){return Ue.getData().has(re)}static get codePoints(){return Ue.getData()}}e.InvisibleCharacters=Ue,Ue._data=void 0}),define(te[105],ne([0,1,25]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(m){return R(m,0)}e.hash=A;function R(m,w){switch(typeof m){case"object":return m===null?T(349,w):Array.isArray(m)?S(m,w):b(m,w);case"string":return P(m,w);case"boolean":return i(m,w);case"number":return T(m,w);case"undefined":return T(937,w);default:return T(617,w)}}e.doHash=R;function T(m,w){return(w<<5)-w+m|0}e.numberHash=T;function i(m,w){return T(m?433:863,w)}function P(m,w){w=T(149417,w);for(let f=0,c=m.length;f<c;f++)w=T(m.charCodeAt(f),w);return w}e.stringHash=P;function S(m,w){return w=T(104579,w),m.reduce((f,c)=>R(c,f),w)}function b(m,w){return w=T(181387,w),Object.keys(m).sort().reduce((f,c)=>(f=P(c,f),R(m[c],f)),w)}class I{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=R(w,this._value),this._value}}e.Hasher=I;var C;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function d(m,w,f=32){const c=f-w,l=~((1<<c)-1);return(m<<w|(l&m)>>>c)>>>0}function p(m,w=0,f=m.byteLength,c=0){for(let l=0;l<f;l++)m[w+l]=c}function h(m,w,f="0"){for(;m.length<w;)m=f+m;return m}function E(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),w/4)}e.toHexString=E;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const f=w.length;if(f===0)return;const c=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,o,n;for(r!==0?(o=r,n=-1,r=0):(o=w.charCodeAt(0),n=0);;){let t=o;if(D.isHighSurrogate(o))if(n+1<f){const s=w.charCodeAt(n+1);D.isLowSurrogate(s)?(n++,t=D.computeCodePoint(o,s)):t=65533}else{r=o;break}else D.isLowSurrogate(o)&&(t=65533);if(l=this._push(c,l,t),n++,n<f)o=w.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,f,c){return c<128?w[f++]=c:c<2048?(w[f++]=192|(c&1984)>>>6,w[f++]=128|(c&63)>>>0):c<65536?(w[f++]=224|(c&61440)>>>12,w[f++]=128|(c&4032)>>>6,w[f++]=128|(c&63)>>>0):(w[f++]=240|(c&1835008)>>>18,w[f++]=128|(c&258048)>>>12,w[f++]=128|(c&4032)>>>6,w[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,f=this._buffDV;for(let u=0;u<64;u+=4)w.setUint32(u,f.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)w.setUint32(u,d(w.getUint32(u-12,!1)^w.getUint32(u-32,!1)^w.getUint32(u-56,!1)^w.getUint32(u-64,!1),1),!1);let c=this._h0,l=this._h1,r=this._h2,o=this._h3,n=this._h4,t,s,a;for(let u=0;u<80;u++)u<20?(t=l&r|~l&o,s=1518500249):u<40?(t=l^r^o,s=1859775393):u<60?(t=l&r|l&o|r&o,s=2400959708):(t=l^r^o,s=3395469782),a=d(c,5)+t+n+s+w.getUint32(u*4,!1)&4294967295,n=o,o=r,r=d(l,30),l=c,c=a;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var bt=this&&this.__classPrivateFieldSet||function(J,e,D,A,R){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?R.call(J,D):R?R.value=D:e.set(J,D),D},Ve=this&&this.__classPrivateFieldGet||function(J,e,D,A){if(D==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?A:D==="a"?A.call(J):A?A.value:e.get(J)};define(te[40],ne([0,1,17,25]),function(J,e,D,A){"use strict";var R,T,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(n,t,s){let a=n.get(t);return a===void 0&&(a=s,n.set(t,a)),a}e.getOrSet=P;function S(n){const t=[];return n.forEach((s,a)=>{t.push(`${a} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=S;function b(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=b;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=I;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,A.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class d{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,A.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var p;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,A.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(v||(v={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(){return new m(new d)}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new C)}clear(){this._root=void 0}fill(t,s){if(s){const a=s.slice(0);(0,D.shuffle)(a);for(let u of a)this.set(u,t)}else{const a=t.slice(0);(0,D.shuffle)(a);for(let u of a)this.set(u[0],u[1])}}set(t,s){const a=this._iter.reset(t);let u;this._root||(this._root=new E,this._root.segment=a.value());const g=[];for(u=this._root;;){const k=a.cmp(u.segment);if(k>0)u.left||(u.left=new E,u.left.segment=a.value()),g.push([-1,u]),u=u.left;else if(k<0)u.right||(u.right=new E,u.right.segment=a.value()),g.push([1,u]),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new E,u.mid.segment=a.value()),g.push([0,u]),u=u.mid;else break}const y=u.value;u.value=s,u.key=t;for(let k=g.length-1;k>=0;k--){const O=g[k][1];O.updateHeight();const M=O.balanceFactor();if(M<-1||M>1){const W=g[k][0],q=g[k+1][0];if(W===1&&q===1)g[k][1]=O.rotateLeft();else if(W===-1&&q===-1)g[k][1]=O.rotateRight();else if(W===1&&q===-1)O.right=g[k+1][1]=g[k+1][1].rotateRight(),g[k][1]=O.rotateLeft();else if(W===-1&&q===1)O.left=g[k+1][1]=g[k+1][1].rotateLeft(),g[k][1]=O.rotateRight();else throw new Error;if(k>0)switch(g[k-1][0]){case-1:g[k-1][1].left=g[k][1];break;case 1:g[k-1][1].right=g[k][1];break;case 0:g[k-1][1].mid=g[k][1];break}else this._root=g[0][1]}}return y}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const a=this._iter.reset(t),u=[];let g=this._root;for(;g;){const y=a.cmp(g.segment);if(y>0)u.push([-1,g]),g=g.left;else if(y<0)u.push([1,g]),g=g.right;else if(a.hasNext())a.next(),u.push([0,g]),g=g.mid;else break}if(!!g){if(s?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const y=this._min(g.right),{key:k,value:O,segment:M}=y;this._delete(y.key,!1),g.key=k,g.value=O,g.segment=M}else{const y=g.left??g.right;if(u.length>0){const[k,O]=u[u.length-1];switch(k){case-1:O.left=y;break;case 0:O.mid=y;break;case 1:O.right=y;break}}else this._root=y}for(let y=u.length-1;y>=0;y--){const k=u[y][1];k.updateHeight();const O=k.balanceFactor();if(O>1?(k.right.balanceFactor()>=0||(k.right=u[y+1][1]=u[y+1][1].rotateRight()),u[y][1]=k.rotateLeft()):O<-1&&(k.left.balanceFactor()<=0||(k.left=u[y+1][1]=u[y+1][1].rotateLeft()),u[y][1]=k.rotateRight()),y>0)switch(u[y-1][0]){case-1:u[y-1][1].left=u[y][1];break;case 1:u[y-1][1].right=u[y][1];break;case 0:u[y-1][1].mid=u[y][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let a=this._root,u;for(;a;){const g=s.cmp(a.segment);if(g>0)a=a.left;else if(g<0)a=a.right;else if(s.hasNext())s.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(t){const s=this._iter.reset(t);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(t){for(const[s,a]of this)t(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=m;class w{constructor(t,s){this.uri=t,this.value=s}}class f{constructor(t,s){this[R]="ResourceMap",t instanceof f?(this.map=new Map(t.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=t??f.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new w(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[a,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=f,f.defaultToKey=n=>n.toString();var c;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const a=this._map.get(t);if(!!a)return s!==0&&this.touch(a,s),a.value}set(t,s,a=0){let u=this._map.get(t);if(u)u.value=s,a!==0&&this.touch(u,a);else{switch(u={key:t,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const a=this._state;let u=this._head;for(;u;){if(s?t.bind(s)(u.value,u.key,this):t(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:a.key,done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return u}values(){const t=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:a.value,done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return u}entries(){const t=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:[a.key,a.value],done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>t;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,a=t.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const a=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const a=t.next,u=t.previous;t===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,a)=>{t.push([a,s])}),t}fromJSON(t){this.clear();for(const[s,a]of t)this.set(s,a)}}e.LinkedMap=l;class r extends l{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class o{constructor(t){i.set(this,void 0),bt(this,i,t,"f")}get size(){return Ve(this,i,"f").size}forEach(t,s){Ve(this,i,"f").forEach(t,s)}get(t){return Ve(this,i,"f").get(t)}has(t){return Ve(this,i,"f").has(t)}entries(){return Ve(this,i,"f").entries()}keys(){return Ve(this,i,"f").keys()}values(){return Ve(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Ve(this,i,"f").entries()}}e.ReadonlyMapView=o}),define(te[69],ne([0,1,40]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new D.LRUCache(1e4);function R(b){return S(b,"NFC",A)}e.normalizeNFC=R;const T=new D.LRUCache(1e4);function i(b){return S(b,"NFD",T)}e.normalizeNFD=i;const P=/[^\u0000-\u0080]/;function S(b,I,C){if(!b)return b;const d=C.get(b);if(d)return d;let p;return P.test(b)?p=b.normalize(I):p=b,C.set(b,p),p}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(I){return i(I).replace(b,"")}}()}),define(te[15],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(g){return Array.isArray(g)}e.isArray=D;function A(g){return typeof g=="string"}e.isString=A;function R(g){return Array.isArray(g)&&g.every(y=>A(y))}e.isStringArray=R;function T(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=T;function i(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=i;function P(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=P;function S(g){return g===!0||g===!1}e.isBoolean=S;function b(g){return typeof g=="undefined"}e.isUndefined=b;function I(g){return!C(g)}e.isDefined=I;function C(g){return b(g)||g===null}e.isUndefinedOrNull=C;function d(g,y){if(!g)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}e.assertType=d;function p(g){if(C(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=p;function h(...g){const y=[];for(let k=0;k<g.length;k++){const O=g[k];if(C(O))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);y.push(O)}return y}e.assertAllDefined=h;const E=Object.prototype.hasOwnProperty;function v(g){if(!T(g))return!1;for(let y in g)if(E.call(g,y))return!1;return!0}e.isEmptyObject=v;function m(g){return typeof g=="function"}e.isFunction=m;function w(...g){return g.length>0&&g.every(m)}e.areFunctions=w;function f(g,y){const k=Math.min(g.length,y.length);for(let O=0;O<k;O++)c(g[O],y[O])}e.validateConstraints=f;function c(g,y){if(A(y)){if(typeof g!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(m(y)){try{if(g instanceof y)return}catch{}if(!C(g)&&g.constructor===y||y.length===1&&y.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(g){let y=[],k=Object.getPrototypeOf(g);for(;Object.prototype!==k;)y=y.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return y}e.getAllPropertyNames=l;function r(g){const y=[];for(const k of l(g))typeof g[k]=="function"&&y.push(k);return y}e.getAllMethodNames=r;function o(g,y){const k=M=>function(){const W=Array.prototype.slice.call(arguments,0);return y(M,W)};let O={};for(const M of g)O[M]=k(M);return O}e.createProxyObject=o;function n(g){return g===null?void 0:g}e.withNullAsUndefined=n;function t(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=t;function s(g){return class{constructor(){return new Proxy({},{get(y,k){if(y[k])return y[k];throw new Error(`Not Implemented: ${g}->${String(k)}`)}})}}}e.NotImplementedProxy=s;function a(g,y="Unreachable"){throw new Error(y)}e.assertNever=a;function u(g){return!!g&&typeof g.then=="function"&&typeof g.catch=="function"}e.isPromise=u}),define(te[41],ne([0,1,10,4,25,15]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function S(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=S;function b(n,t=D.posix.sep){if(!n)return"";const s=n.length,a=n.charCodeAt(0);if(i(a)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let g=3;const y=g;for(;g<s&&!i(n.charCodeAt(g));g++);if(y!==g&&!i(n.charCodeAt(g+1))){for(g+=1;g<s;g++)if(i(n.charCodeAt(g)))return n.slice(0,g+1).replace(/[\\/]/g,t)}}return t}else if(m(a)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let u=n.indexOf("://");if(u!==-1){for(u+=3;u<s;u++)if(i(n.charCodeAt(u)))return n.slice(0,u+1)}return""}e.getRoot=b;function I(n){if(!A.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let s=2;const a=s;for(;s<n.length&&(t=n.charCodeAt(s),t!==92);s++);return!(a===s||(t=n.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=A.isWindows){const s=t?C:d;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||t&&p.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function E(n,t,s){const a=n===t;return!s||a?a:!n||!t?!1:(0,R.equalsIgnoreCase)(n,t)}e.isEqual=E;function v(n,t,s,a=D.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(s){if(!(0,R.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let g=t.length;return t.charAt(t.length-1)===a&&g--,n.charAt(g)===a}return t.charAt(t.length-1)!==a&&(t+=a),n.indexOf(t)===0}e.isEqualOrParent=v;function m(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=m;function w(n,t){return A.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(t,n)),n=(0,D.normalize)(n),A.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=w;function f(n){const t=(0,D.normalize)(n);return A.isWindows?n.length>3?!1:c(t)&&(n.length===2||t.charCodeAt(2)===92):t===D.posix.sep}e.isRootOrDriveLetter=f;function c(n,t){return(t!==void 0?t:A.isWindows)?m(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(n){return c(n)?n[0]:void 0}e.getDriveLetter=l;function r(n,t,s){return t.length>n.length?-1:n===t?0:(s&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function o(n){const t=n.split(":");let s,a,u;if(t.forEach(g=>{const y=Number(g);(0,T.isNumber)(y)?a===void 0?a=y:u===void 0&&(u=y):s=s?[s,g].join(":"):g}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:a!==void 0?a:void 0,column:u!==void 0?u:a!==void 0?1:void 0}}e.parseLineAndColumnAware=o}),define(te[28],ne([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const v=Array.isArray(E)?[]:{};return Object.keys(E).forEach(m=>{E[m]&&typeof E[m]=="object"?v[m]=A(E[m]):v[m]=E[m]}),v}e.deepClone=A;function R(E){if(!E||typeof E!="object")return E;const v=[E];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const w in m)if(T.call(m,w)){const f=m[w];typeof f=="object"&&!Object.isFrozen(f)&&v.push(f)}}return E}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function i(E,v){return P(E,v,new Set)}e.cloneAndChange=i;function P(E,v,m){if((0,D.isUndefinedOrNull)(E))return E;const w=v(E);if(typeof w!="undefined")return w;if((0,D.isArray)(E)){const f=[];for(const c of E)f.push(P(c,v,m));return f}if((0,D.isObject)(E)){if(m.has(E))throw new Error("Cannot clone recursive data-structure");m.add(E);const f={};for(let c in E)T.call(E,c)&&(f[c]=P(E[c],v,m));return m.delete(E),f}return E}function S(E,v,m=!0){return(0,D.isObject)(E)?((0,D.isObject)(v)&&Object.keys(v).forEach(w=>{w in E?m&&((0,D.isObject)(E[w])&&(0,D.isObject)(v[w])?S(E[w],v[w],m):E[w]=v[w]):E[w]=v[w]}),E):v}e.mixin=S;function b(E,v){if(E===v)return!0;if(E==null||v===null||v===void 0||typeof E!=typeof v||typeof E!="object"||Array.isArray(E)!==Array.isArray(v))return!1;let m,w;if(Array.isArray(E)){if(E.length!==v.length)return!1;for(m=0;m<E.length;m++)if(!b(E[m],v[m]))return!1}else{const f=[];for(w in E)f.push(w);f.sort();const c=[];for(w in v)c.push(w);if(c.sort(),!b(f,c))return!1;for(m=0;m<f.length;m++)if(!b(E[f[m]],v[f[m]]))return!1}return!0}e.equals=b;function I(E){const v=new Set;return JSON.stringify(E,(m,w)=>{if((0,D.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=I;function C(E,v,m){const w=v(E);return typeof w=="undefined"?m:w}e.getOrDefault=C;function d(E,v){const m=Object.create(null);return!E||!v||Object.keys(v).forEach(f=>{const c=E[f],l=v[f];b(c,l)||(m[f]=l)}),m}e.distinct=d;function p(E,v){const m=v.toLowerCase(),w=Object.keys(E).find(f=>f.toLowerCase()===m);return w?E[w]:E[v]}e.getCaseInsensitive=p;function h(E,v){const m=Object.create(null);for(const[w,f]of Object.entries(E))v(w,f)&&(m[w]=f);return m}e.filter=h}),define(te[7],ne([0,1,10,4]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,i=/^\/\//;function P(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!T.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,t){return!n&&!t?"file":n}function b(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==C&&(t=C+t):t=C;break}return t}const I="",C="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,s,a,u,g,y=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=S(t,y),this.authority=s||I,this.path=b(this.scheme,a||I),this.query=u||I,this.fragment=g||I,P(this,y))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return f(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:a,path:u,query:g,fragment:y}=t;return s===void 0?s=this.scheme:s===null&&(s=I),a===void 0?a=this.authority:a===null&&(a=I),u===void 0?u=this.path:u===null&&(u=I),g===void 0?g=this.query:g===null&&(g=I),y===void 0?y=this.fragment:y===null&&(y=I),s===this.scheme&&a===this.authority&&u===this.path&&g===this.query&&y===this.fragment?this:new E(s,a,u,g,y)}static parse(t,s=!1){const a=d.exec(t);return a?new E(a[2]||I,o(a[4]||I),o(a[5]||I),o(a[7]||I),o(a[9]||I),s):new E(I,I,I,I,I)}static file(t){let s=I;if(A.isWindows&&(t=t.replace(/\\/g,C)),t[0]===C&&t[1]===C){const a=t.indexOf(C,2);a===-1?(s=t.substring(2),t=C):(s=t.substring(2,a),t=t.substring(a)||C)}return new E("file",s,t,I,I)}static from(t){const s=new E(t.scheme,t.authority,t.path,t.query,t.fragment);return P(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return A.isWindows&&t.scheme==="file"?a=p.file(D.win32.join(f(t,!0),...s)).path:a=D.posix.join(t.path,...s),t.with({path:a})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const s=new E(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=p;const h=A.isWindows?1:void 0;class E extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,t){let s,a=-1;for(let u=0;u<n.length;u++){const g=n.charCodeAt(u);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||t&&g===47)a!==-1&&(s+=encodeURIComponent(n.substring(a,u)),a=-1),s!==void 0&&(s+=n.charAt(u));else{s===void 0&&(s=n.substr(0,u));const y=v[g];y!==void 0?(a!==-1&&(s+=encodeURIComponent(n.substring(a,u)),a=-1),s+=y):a===-1&&(a=u)}}return a!==-1&&(s+=encodeURIComponent(n.substring(a))),s!==void 0?s:n}function w(n){let t;for(let s=0;s<n.length;s++){const a=n.charCodeAt(s);a===35||a===63?(t===void 0&&(t=n.substr(0,s)),t+=v[a]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function f(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,A.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function c(n,t){const s=t?w:m;let a="",{scheme:u,authority:g,path:y,query:k,fragment:O}=n;if(u&&(a+=u,a+=":"),(g||u==="file")&&(a+=C,a+=C),g){let M=g.indexOf("@");if(M!==-1){const W=g.substr(0,M);g=g.substr(M+1),M=W.indexOf(":"),M===-1?a+=s(W,!1):(a+=s(W.substr(0,M),!1),a+=":",a+=s(W.substr(M+1),!1)),a+="@"}g=g.toLowerCase(),M=g.indexOf(":"),M===-1?a+=s(g,!1):(a+=s(g.substr(0,M),!1),a+=g.substr(M))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const M=y.charCodeAt(1);M>=65&&M<=90&&(y=`/${String.fromCharCode(M+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const M=y.charCodeAt(0);M>=65&&M<=90&&(y=`${String.fromCharCode(M+32)}:${y.substr(2)}`)}a+=s(y,!0)}return k&&(a+="?",a+=s(k,!1)),O&&(a+="#",a+=t?O:m(O,!1)),a}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(r)?n.replace(r,t=>l(t)):n}}),define(te[106],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=A;function R(b){const I=[];let C;try{const d=JSON.parse(b.arguments),p=d[d.length-1];p&&p.__$stack&&(d.pop(),C=p.__$stack),I.push(...d)}catch(d){I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:C}}e.parse=R;function T(b){if(typeof b!="string")return T(R(b).stack);const I=b;if(I){const C=i(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=T;function i(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function P(b,I){const{args:C,stack:d}=R(b),p=typeof C[0]=="string"&&C.length===1;let h=i(d);h&&(h=`(${h.trim()})`);let E=[];if(typeof C[0]=="string"?h&&p?E=[`%c[${I}] %c${C[0]} %c${h}`,S("blue"),S(""),S("grey")]:E=[`%c[${I}] %c${C[0]}`,S("blue"),S(""),...C.slice(1)]:E=[`%c[${I}]%`,S("blue"),...C],h&&!p&&E.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,E)}e.log=P;function S(b){return`color: ${b}`}}),define(te[107],ne([0,1,19,25,7]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,S)}e.stringify=T;function i(I){let C=JSON.parse(I);return C=b(C),C}e.parse=i;var P;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function S(I,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,A.regExpFlags)(C)}:C}function b(I,C=0){if(!I||C>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return R.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof D.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let d=0;d<I.length;++d)I[d]=b(I[d],C+1);else for(const d in I)Object.hasOwnProperty.call(I,d)&&(I[d]=b(I[d],C+1))}return I}e.revive=b}),define(te[16],ne([0,1,4,7]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(R=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,b,I){this._hosts[S]=b,this._ports[S]=I}setConnectionToken(S,b){this._connectionTokens[S]=b}rewrite(S){if(this._delegate)return this._delegate(S);const b=S.authority;let I=this._hosts[b];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const C=this._ports[b],d=this._connectionTokens[b];let p=`path=${encodeURIComponent(S.path)}`;return typeof d=="string"&&(p+=`&tkn=${encodeURIComponent(d)}`),A.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${I}:${C}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new T;class i{asBrowserUri(S,b){const I=this.toUri(S,b);return I.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?I.with({scheme:R.vscodeFileResource,authority:I.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(S,b){const I=this.toUri(S,b);return I.scheme===R.vscodeFileResource?I.with({scheme:R.file,authority:I.authority!==i.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(S,b){return A.URI.isUri(S)?S:A.URI.parse(b.toUrl(S))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(te[18],ne([0,1,41,16,10,4,25,7]),function(J,e,D,A,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=S;class b{constructor(h){this._ignorePathCasing=h}compare(h,E,v=!1){return h===E?0:(0,i.compare)(this.getComparisonKey(h,v),this.getComparisonKey(E,v))}isEqual(h,E,v=!1){return h===E?!0:!h||!E?!1:this.getComparisonKey(h,v)===this.getComparisonKey(E,v)}getComparisonKey(h,E=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,E,v=!1){if(h.scheme===E.scheme){if(h.scheme===A.Schemas.file)return D.isEqualOrParent(S(h),S(E),this._ignorePathCasing(h))&&h.query===E.query&&(v||h.fragment===E.fragment);if((0,e.isEqualAuthority)(h.authority,E.authority))return D.isEqualOrParent(h.path,E.path,this._ignorePathCasing(h),"/")&&h.query===E.query&&(v||h.fragment===E.fragment)}return!1}joinPath(h,...E){return P.URI.joinPath(h,...E)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return R.posix.basename(h.path)}extname(h){return R.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let E;return h.scheme===A.Schemas.file?E=P.URI.file(R.dirname(S(h))).path:(E=R.posix.dirname(h.path),h.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),E="/")),h.with({path:E})}normalizePath(h){if(!h.path.length)return h;let E;return h.scheme===A.Schemas.file?E=P.URI.file(R.normalize(S(h))).path:E=R.posix.normalize(h.path),h.with({path:E})}relativePath(h,E){if(h.scheme!==E.scheme||!(0,e.isEqualAuthority)(h.authority,E.authority))return;if(h.scheme===A.Schemas.file){const w=R.relative(S(h),S(E));return T.isWindows?D.toSlashes(w):w}let v=h.path||"/",m=E.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const f=Math.min(v.length,m.length);w<f&&!(v.charCodeAt(w)!==m.charCodeAt(w)&&v.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);v=m.substr(0,w)+v.substr(w)}return R.posix.relative(v,m)}resolvePath(h,E){if(h.scheme===A.Schemas.file){const v=P.URI.file(R.resolve(S(h),E));return h.with({authority:v.authority,path:v.path})}return E=D.toPosixPath(E),h.with({path:R.posix.resolve(h.path,E)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,E){return h===E||h!==void 0&&E!==void 0&&(0,i.equalsIgnoreCase)(h,E)}hasTrailingPathSeparator(h,E=R.sep){if(h.scheme===A.Schemas.file){const v=S(h);return v.length>D.getRoot(v).length&&v[v.length-1]===E}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,E=R.sep){return(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,E=R.sep){let v=!1;if(h.scheme===A.Schemas.file){const m=S(h);v=m!==void 0&&m.length===D.getRoot(m).length&&m[m.length-1]===E}else{E="/";const m=h.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(p=>p.scheme===A.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new b(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(p,h){const E=[];for(let v=0;v<p.length;v++){const m=h(p[v]);p.some((w,f)=>f===v?!1:(0,e.isEqualOrParent)(m,h(w)))||E.push(p[v])}return E}e.distinctParents=I;var C;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(E){const v=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,l]=f.split(":");c&&l&&v.set(c,l)});const w=E.path.substring(0,E.path.indexOf(";"));return w&&v.set(p.META_DATA_MIME,w),v}p.parseMetaData=h})(C=e.DataUri||(e.DataUri={}));function d(p,h,E){if(h){let v=p.path;return v&&v[0]!==R.posix.sep&&(v=R.posix.sep+v),p.with({scheme:E,authority:h,path:v})}return p.with({scheme:E})}e.toLocalResource=d}),define(te[5],ne([0,1,27,9,3,2,18,4]),function(J,e,D,A,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(U){return!!U&&typeof U.then=="function"}e.isThenable=S;function b(U){const N=new D.CancellationTokenSource,z=U(N.token),x=new Promise((K,ee)=>{const V=N.token.onCancellationRequested(()=>{V.dispose(),N.dispose(),ee((0,A.canceled)())});Promise.resolve(z).then(X=>{V.dispose(),N.dispose(),K(X)},X=>{V.dispose(),N.dispose(),ee(X)})});return new class{cancel(){N.cancel()}then(K,ee){return x.then(K,ee)}catch(K){return this.then(void 0,K)}finally(K){return x.finally(K)}}}e.createCancelablePromise=b;function I(U,N,z){return Promise.race([U,new Promise(x=>N.onCancellationRequested(()=>x(z)))])}e.raceCancellation=I;async function C(U){let N=-1;const z=U.map((K,ee)=>K.then(V=>(N=ee,V))),x=await Promise.race(z);return U.forEach((K,ee)=>{ee!==N&&K.cancel()}),x}e.raceCancellablePromises=C;function d(U,N,z){let x;const K=setTimeout(()=>{x?.(void 0),z?.()},N);return Promise.race([U.finally(()=>clearTimeout(K)),new Promise(ee=>x=ee)])}e.raceTimeout=d;function p(U){return new Promise((N,z)=>{const x=U();S(x)?x.then(N,z):N(x)})}e.asPromise=p;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(z,z).then(x)})}return new Promise((z,x)=>{this.queuedPromise.then(z,x)})}return this.activePromise=N(),new Promise((z,x)=>{this.activePromise.then(K=>{this.activePromise=null,z(K)},K=>{this.activePromise=null,x(K)})})}}e.Throttler=h;class E{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=E;class v{constructor(){this.promiseMap=new Map}queue(N,z){const K=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(N)===K&&this.promiseMap.delete(N)});return this.promiseMap.set(N,K),K}}e.SequencerByKey=v;class m{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,z=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,K)=>{this.doResolve=x,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=m;class w{constructor(N){this.delayer=new m(N),this.throttler=new h}trigger(N,z){return this.delayer.trigger(()=>this.throttler.queue(N),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class f{constructor(){this._isOpen=!1,this._promise=new Promise((N,z)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class c extends f{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function l(U,N){return N?new Promise((z,x)=>{const K=setTimeout(()=>{ee.dispose(),z()},U),ee=N.onCancellationRequested(()=>{clearTimeout(K),ee.dispose(),x((0,A.canceled)())})}):b(z=>l(U,z))}e.timeout=l;function r(U,N=0){const z=setTimeout(U,N);return(0,T.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=r;function o(U){const N=[];let z=0;const x=U.length;function K(){return z<x?U[z++]():null}function ee(V){V!=null&&N.push(V);const X=K();return X?X.then(ee):Promise.resolve(N)}return Promise.resolve(null).then(ee)}e.sequence=o;function n(U,N=x=>!!x,z=null){let x=0;const K=U.length,ee=()=>{if(x>=K)return Promise.resolve(z);const V=U[x++];return Promise.resolve(V()).then(se=>N(se)?Promise.resolve(se):ee())};return ee()}e.first=n;function t(U,N=x=>!!x,z=null){if(U.length===0)return Promise.resolve(z);let x=U.length;const K=()=>{x=-1;for(const ee of U)ee.cancel?.()};return new Promise((ee,V)=>{for(const X of U)X.then(se=>{--x>=0&&N(se)?(K(),ee(se)):x===0&&ee(z)}).catch(se=>{--x>=0&&(K(),V(se))})})}e.firstParallel=t;class s{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((z,x)=>{this.outstandingPromises.push({factory:N,c:z,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const z=N.factory();z.then(N.c,N.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class a extends s{constructor(){super(1)}}e.Queue=a;class u{constructor(){this.queues=new Map}queueFor(N,z=i.extUri){const x=z.getComparisonKey(N);let K=this.queues.get(x);return K||(K=new a,R.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(x)}),this.queues.set(x,K)),K}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=u;class g{constructor(N,z){this._token=-1,typeof N=="function"&&typeof z=="number"&&this.setIfNotSet(N,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},z)}setIfNotSet(N,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},z))}}e.TimeoutTimer=g;class y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,z){this.cancel(),this._token=setInterval(()=>{N()},z)}}e.IntervalTimer=y;class k{constructor(N,z){this.timeoutToken=-1,this.runner=N,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=k;class O{constructor(N,z){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=O;class M extends k{constructor(N,z){super(N,z);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class W extends T.Disposable{constructor(N,z,x,K){super();this.maxWorkChunkSize=N,this.maxPendingWork=z,this.throttleDelay=x,this.handler=K,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new k(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{(0,P.setTimeout0)(()=>{if(N)return;const z=Date.now()+3;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(U,N)=>{const z=requestIdleCallback(U,typeof N=="number"?{timeout:N}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(z))}}}}();class q{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function L(U,N,z){let x;for(let K=0;K<z;K++)try{return await U()}catch(ee){x=ee,await l(N)}throw x}e.retry=L;class ${hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,z,x){return this._pending={taskId:N,cancel:()=>x?.(),promise:z},z.then(()=>this.donePending(N),()=>this.donePending(N)),z}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let z,x;const K=new Promise((ee,V)=>{z=ee,x=V});this._next={run:N,promise:K,promiseResolve:z,promiseReject:x}}return this._next.promise}}e.TaskSequentializer=$;class _{constructor(N,z=()=>Date.now()){this.interval=N,this.nowFn=z,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=_;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,z)=>{this.completeCallback=N,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(z=>{this.completeCallback(N),this.resolved=!0,z()})}error(N){return new Promise(z=>{this.errorCallback(N),this.rejected=!0,z()})}cancel(){new Promise(N=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=F;var B;(function(U){async function N(x){let K;const ee=await Promise.all(x.map(V=>V.then(X=>X,X=>{K||(K=X)})));if(typeof K!="undefined")throw K;return ee}U.settled=N;function z(x){return new Promise(async(K,ee)=>{try{await x(K,ee)}catch(V){ee(V)}})}U.withAsyncBody=z})(B=e.Promises||(e.Promises={}));var Z;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(Z||(Z={}));class H{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const z={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(N(z)),this.resolve()}catch(x){this.reject(x)}finally{z.emitOne=void 0,z.emitMany=void 0,z.reject=void 0}})}static fromArray(N){return new H(z=>{z.emitMany(N)})}static fromPromise(N){return new H(async z=>{z.emitMany(await N)})}static fromPromises(N){return new H(async z=>{await Promise.all(N.map(async x=>z.emitOne(await x)))})}static merge(N){return new H(async z=>{await Promise.all(N.map(async x=>{for await(const K of x)z.emitOne(K)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,z){return new H(async x=>{for await(const K of N)x.emitOne(z(K))})}map(N){return H.map(this,N)}static filter(N,z){return new H(async x=>{for await(const K of N)z(K)&&x.emitOne(K)})}filter(N){return H.filter(this,N)}static coalesce(N){return H.filter(N,z=>!!z)}coalesce(){return H.coalesce(this)}static async toPromise(N){const z=[];for await(const x of N)z.push(x);return z}toPromise(){return H.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class j extends H{constructor(N,z){super(z);this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=j;function Q(U){const N=new D.CancellationTokenSource,z=U(N.token);return new j(N,async x=>{const K=N.token.onCancellationRequested(()=>{K.dispose(),N.dispose(),x.reject((0,A.canceled)())});try{for await(const ee of z){if(N.token.isCancellationRequested)return;x.emitOne(ee)}K.dispose(),N.dispose()}catch(ee){K.dispose(),N.dispose(),x.reject(ee)}})}e.createCancelableAsyncIterable=Q}),define(te[108],ne([0,1,5,41,40,10,25]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const S="**",b="/",I="[/\\\\]",C="[^/\\\\]",d=/\//g;function p(j){switch(j){case 0:return"";case 1:return`${C}*?`;default:return`(?:${I}|${C}+${I}|${I}${C}+)*?`}}function h(j,Q){if(!j)return[];const U=[];let N=!1,z=!1,x="";for(const K of j){switch(K){case Q:if(!N&&!z){U.push(x),x="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":z=!0;break;case"]":z=!1;break}x+=K}return x&&U.push(x),U}e.splitGlobAware=h;function E(j){if(!j)return"";let Q="";const U=h(j,b);if(U.every(N=>N===S))Q=".*";else{let N=!1;U.forEach((z,x)=>{if(z===S){N||(Q+=p(2),N=!0);return}let K=!1,ee="",V=!1,X="";for(const se of z){if(se!=="}"&&K){ee+=se;continue}if(V&&(se!=="]"||!X)){let oe;se==="-"?oe=se:(se==="^"||se==="!")&&!X?oe="^":se===b?oe="":oe=i.escapeRegExpCharacters(se),X+=oe;continue}switch(se){case"{":K=!0;continue;case"[":V=!0;continue;case"}":Q+=`(?:${h(ee,",").map(he=>E(he)).join("|")})`,K=!1,ee="";break;case"]":Q+="["+X+"]",V=!1,X="";break;case"?":Q+=C;continue;case"*":Q+=p(1);continue;default:Q+=i.escapeRegExpCharacters(se)}}x<U.length-1&&(U[x+1]!==S||x+2<U.length)&&(Q+=I),N=!1})}return Q}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new R.LRUCache(1e4),o=function(){return!1},n=function(){return null};function t(j,Q){if(!j)return n;let U;typeof j!="string"?U=j.pattern:U=j,U=U.trim();const N=`${U}_${!!Q.trimForExclusions}`;let z=r.get(N);if(z)return s(z,j);let x;if(v.test(U)){const K=U.substr(4);z=function(ee,V){return typeof ee=="string"&&ee.endsWith(K)?U:null}}else(x=m.exec(a(U,Q)))?z=u(x[1],U):(Q.trimForExclusions?f:w).test(U)?z=g(U,Q):(x=c.exec(a(U,Q)))?z=y(x[1].substr(1),U,!0):(x=l.exec(a(U,Q)))?z=y(x[1],U,!1):z=k(U);return r.set(N,z),s(z,j)}function s(j,Q){return typeof Q=="string"?j:function(U,N){return A.isEqualOrParent(U,Q.base)?j(T.relative(Q.base,U),N):null}}function a(j,Q){return Q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function u(j,Q){const U=`/${j}`,N=`\\${j}`,z=function(K,ee){return typeof K!="string"?null:ee?ee===j?Q:null:K===j||K.endsWith(U)||K.endsWith(N)?Q:null},x=[j];return z.basenames=x,z.patterns=[Q],z.allBasenames=x,z}function g(j,Q){const U=H(j.slice(1,-1).split(",").map(ee=>t(ee,Q)).filter(ee=>ee!==n),j),N=U.length;if(!N)return n;if(N===1)return U[0];const z=function(ee,V){for(let X=0,se=U.length;X<se;X++)if(U[X](ee,V))return j;return null},x=U.find(ee=>!!ee.allBasenames);x&&(z.allBasenames=x.allBasenames);const K=U.reduce((ee,V)=>V.allPaths?ee.concat(V.allPaths):ee,[]);return K.length&&(z.allPaths=K),z}function y(j,Q,U){const N=T.sep===T.posix.sep,z=N?j:j.replace(d,T.sep),x=T.sep+z,K=T.posix.sep+j,ee=U?function(V,X){return typeof V=="string"&&(V===z||V.endsWith(x)||!N&&(V===j||V.endsWith(K)))?Q:null}:function(V,X){return typeof V=="string"&&(V===z||!N&&V===j)?Q:null};return ee.allPaths=[(U?"*/":"./")+j],ee}function k(j){try{const Q=new RegExp(`^${E(j)}$`);return function(U){return Q.lastIndex=0,typeof U=="string"&&Q.test(U)?j:null}}catch(Q){return n}}function O(j,Q,U){return!j||typeof Q!="string"?!1:M(j)(Q,void 0,U)}e.match=O;function M(j,Q={}){if(!j)return o;if(typeof j=="string"||$(j)){const U=t(j,Q);if(U===n)return o;const N=function(z,x){return!!U(z,x)};return U.allBasenames&&(N.allBasenames=U.allBasenames),U.allPaths&&(N.allPaths=U.allPaths),N}return B(j,Q)}e.parse=M;function W(j){if(!j)return;let Q;return U=>(Q||(Q=(j()||Promise.resolve([])).then(N=>N?L(N):{})),Q.then(N=>!!N[U]))}e.hasSiblingPromiseFn=W;function q(j){if(!j)return;let Q;return U=>{if(!Q){const N=j();Q=N?L(N):{}}return!!Q[U]}}e.hasSiblingFn=q;function L(j){const Q={};for(const U of j)Q[U]=!0;return Q}function $(j){const Q=j;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=$;function _(j){return j.allBasenames||[]}e.getBasenameTerms=_;function F(j){return j.allPaths||[]}e.getPathTerms=F;function B(j,Q){const U=H(Object.getOwnPropertyNames(j).map(ee=>Z(ee,j[ee],Q)).filter(ee=>ee!==n)),N=U.length;if(!N)return n;if(!U.some(ee=>!!ee.requiresSiblings)){if(N===1)return U[0];const ee=function(se,oe){for(let le=0,he=U.length;le<he;le++){const be=U[le](se,oe);if(be)return be}return null},V=U.find(se=>!!se.allBasenames);V&&(ee.allBasenames=V.allBasenames);const X=U.reduce((se,oe)=>oe.allPaths?se.concat(oe.allPaths):se,[]);return X.length&&(ee.allPaths=X),ee}const z=function(ee,V,X){let se;for(let oe=0,le=U.length;oe<le;oe++){const he=U[oe];he.requiresSiblings&&X&&(V||(V=T.basename(ee)),se||(se=V.substr(0,V.length-T.extname(ee).length)));const be=he(ee,V,se,X);if(be)return be}return null},x=U.find(ee=>!!ee.allBasenames);x&&(z.allBasenames=x.allBasenames);const K=U.reduce((ee,V)=>V.allPaths?ee.concat(V.allPaths):ee,[]);return K.length&&(z.allPaths=K),z}function Z(j,Q,U){if(Q===!1)return n;const N=t(j,U);if(N===n)return n;if(typeof Q=="boolean")return N;if(Q){const z=Q.when;if(typeof z=="string"){const x=(K,ee,V,X)=>{if(!X||!N(K,ee))return null;const se=z.replace("$(basename)",V),oe=X(se);return(0,D.isThenable)(oe)?oe.then(le=>le?j:null):oe?j:null};return x.requiresSiblings=!0,x}}return N}function H(j,Q){const U=j.filter(ee=>!!ee.basenames);if(U.length<2)return j;const N=U.reduce((ee,V)=>{const X=V.basenames;return X?ee.concat(X):ee},[]);let z;if(Q){z=[];for(let ee=0,V=N.length;ee<V;ee++)z.push(Q)}else z=U.reduce((ee,V)=>{const X=V.patterns;return X?ee.concat(X):ee},[]);const x=function(ee,V){if(typeof ee!="string")return null;if(!V){let se;for(se=ee.length;se>0;se--){const oe=ee.charCodeAt(se-1);if(oe===47||oe===92)break}V=ee.substr(se)}const X=N.indexOf(V);return X!==-1?z[X]:null};x.basenames=N,x.patterns=z,x.allBasenames=N;const K=j.filter(ee=>!ee.basenames);return K.push(x),K}}),define(te[109],ne([0,1,108,16,10,18,25]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let S=[],b=[],I=[];function C(t,s=!1){const a=d(t);S.push(a),a.userConfigured?I.push(a):b.push(a),s&&!a.userConfigured&&S.forEach(u=>{u.mime===a.mime||u.userConfigured||(a.extension&&u.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&u.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&u.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&u.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=C;function d(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,D.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(R.posix.sep)>=0:!1}}function p(t){t?(S=S.filter(s=>!s.userConfigured),I=[]):(S=[],b=[],I=[])}e.clearTextMimes=p;function h(t,s){let a;if(t)switch(t.scheme){case A.Schemas.file:a=t.fsPath;break;case A.Schemas.data:a=T.DataUri.parseMetaData(t).get(T.DataUri.META_DATA_LABEL);break;default:a=t.path}if(!a)return[P.unknown];a=a.toLowerCase();const u=(0,R.basename)(a),g=E(a,u,I);if(g)return[g,P.text];const y=E(a,u,b);if(y)return[y,P.text];if(s){const k=v(s);if(k)return[k,P.text]}return[P.unknown]}e.guessMimeTypes=h;function E(t,s,a){let u=null,g=null,y=null;for(let k=a.length-1;k>=0;k--){const O=a[k];if(s===O.filenameLowercase){u=O;break}if(O.filepattern&&(!g||O.filepattern.length>g.filepattern.length)){const M=O.filepatternOnPath?t:s;O.filepatternLowercase?.(M)&&(g=O)}O.extension&&(!y||O.extension.length>y.extension.length)&&s.endsWith(O.extensionLowercase)&&(y=O)}return u?u.mime:g?g.mime:y?y.mime:null}function v(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let s=S.length-1;s>=0;s--){const a=S[s];if(!a.firstline)continue;const u=t.match(a.firstline);if(u&&u.length>0)return a.mime}return null}function m(t){return t?typeof t=="string"?t===P.binary||t===P.text||t===P.unknown:t.length===1&&m(t[0]):!0}e.isUnspecific=m;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(t){const s=(0,R.extname)(t),a=w[s.toLowerCase()];return a!==void 0?a:l(t)}e.getMediaOrTextMime=c;function l(t){const s=(0,R.extname)(t);return f[s.toLowerCase()]}e.getMediaMime=l;function r(t){for(const s in f)if(f[s]===t)return s}e.getExtensionForMimeType=r;const o=/^(.+)\/(.+?)(;.+)?$/;function n(t,s){const a=o.exec(t);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:s?void 0:t}e.normalizeMimeType=n}),define(te[110],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(I){return I.toJSON()}class R{constructor(C){this._uriTransformer=C}transformIncoming(C){const d=this._uriTransformer.transformIncoming(C);return d===C?C:A(D.URI.from(d))}transformOutgoing(C){const d=this._uriTransformer.transformOutgoing(C);return d===C?C:A(D.URI.from(d))}transformOutgoingURI(C){const d=this._uriTransformer.transformOutgoing(C);return d===C?C:D.URI.from(d)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function T(I,C,d){if(!I||d>200)return null;if(typeof I=="object"){if(I instanceof D.URI)return C.transformOutgoing(I);for(let p in I)if(Object.hasOwnProperty.call(I,p)){const h=T(I[p],C,d+1);h!==null&&(I[p]=h)}}return null}function i(I,C){const d=T(I,C,0);return d===null?I:d}e.transformOutgoingURIs=i;function P(I,C,d,p){if(!I||p>200)return null;if(typeof I=="object"){if(I.$mid===1)return d?D.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(let h in I)if(Object.hasOwnProperty.call(I,h)){const E=P(I[h],C,d,p+1);E!==null&&(I[h]=E)}}return null}function S(I,C){const d=P(I,C,!1,0);return d===null?I:d}e.transformIncomingURIs=S;function b(I,C){const d=P(I,C,!0,0);return d===null?I:d}e.transformAndReviveIncomingURIs=b}),define(te[29],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(S){return D.test(S)}e.isUUID=A;const R=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(S){for(let b=0;b<S.length;b++)S[b]=Math.floor(Math.random()*256);return S};function P(){i(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,b="";return b+=T[R[S++]],b+=T[R[S++]],b+=T[R[S++]],b+=T[R[S++]],b+="-",b+=T[R[S++]],b+=T[R[S++]],b+="-",b+=T[R[S++]],b+=T[R[S++]],b+="-",b+=T[R[S++]],b+=T[R[S++]],b+="-",b+=T[R[S++]],b+=T[R[S++]],b+=T[R[S++]],b+=T[R[S++]],b+=T[R[S++]],b+=T[R[S++]],b}e.generateUuid=P}),define(te[111],ne([0,1,243]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const i=[],P=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(P.length<1)return i;let S=0,b,I=S;for(;I<P.length;)if(b=P.charCodeAt(I),b===13||b===10){if(i.push(P.substring(S,I)),I++,I<P.length){const C=b;b=P.charCodeAt(I),(C===13&&b===10||C===10&&b===13)&&I++}S=I}else I++;return this.remaining=S<P.length?P.substr(S):null,i}end(){return this.remaining}}e.LineDecoder=A}),define(te[112],ne([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(i){const P=i.replace(/\-/g,":").toLowerCase();return!A.has(P)}function T(){const i=(0,D.networkInterfaces)();for(let P in i){const S=i[P];if(S){for(const{mac:b}of S)if(R(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(te[113],ne([0,1,33,9,40,29,112]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,C=0;const d=(0,D.networkInterfaces)();for(let p in d){const h=d[p];if(h)for(const{mac:E,internal:v}of h)v||(C+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(I+=1))}this._value=C>0?I/C:0}return this._value}};let P;async function S(){return P||(P=(async()=>await b()||T.generateUuid())()),P}e.getMachineId=S;async function b(){try{const I=await new Promise((d,p)=>{J(["crypto"],d,p)}),C=(0,i.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){A.onUnexpectedError(I);return}}}),define(te[20],ne([0,1,51,33,244,5,41,69,10,4,18,7,29]),function(J,e,D,A,R,T,i,P,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(_,F=p.UNLINK){if((0,i.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return F===p.UNLINK?v(_):E(_)}async function E(_){try{const F=(0,S.join)((0,A.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(_,F)}catch(B){return v(_)}v(F).catch(B=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function v(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function m(_){if((0,i.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(_,{recursive:!0})}e.rimrafSync=m;async function w(_,F){return l(await(F?f(_):(0,R.promisify)(D.readdir)(_)))}async function f(_){try{return await(0,R.promisify)(D.readdir)(_,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const F=[],B=await w(_);for(const Z of B){let H=!1,j=!1,Q=!1;try{const U=await e.Promises.lstat((0,S.join)(_,Z));H=U.isFile(),j=U.isDirectory(),Q=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}F.push({name:Z,isFile:()=>H,isDirectory:()=>j,isSymbolicLink:()=>Q})}return F}function c(_){return l(D.readdirSync(_))}e.readdirSync=c;function l(_){return _.map(F=>typeof F=="string"?b.isMacintosh?(0,P.normalizeNFC)(F):F:(F.name=b.isMacintosh?(0,P.normalizeNFC)(F.name):F.name,F))}async function r(_){const F=await w(_),B=[];for(const Z of F)await n.existsDirectory((0,S.join)(_,Z))&&B.push(Z);return B}function o(_,F=1e3){return new Promise(B=>{let Z=!1;const H=setInterval(()=>{Z||(Z=!0,D.access(_,j=>{Z=!1,j&&(clearInterval(H),B(void 0))}))},F)})}e.whenDeleted=o;var n;(function(_){async function F(H){let j;try{if(j=await e.Promises.lstat(H),!j.isSymbolicLink())return{stat:j}}catch(Q){}try{return{stat:await e.Promises.stat(H),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(b.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw U}throw Q}}_.stat=F;async function B(H){try{const{stat:j,symbolicLink:Q}=await _.stat(H);return j.isFile()&&Q?.dangling!==!0}catch(j){}return!1}_.existsFile=B;async function Z(H){try{const{stat:j,symbolicLink:Q}=await _.stat(H);return j.isDirectory()&&Q?.dangling!==!0}catch(j){}return!1}_.existsDirectory=Z})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new T.ResourceQueue;function s(_,F,B){return t.queueFor(C.URI.file(_),I.extUriBiasedIgnorePathCase).queue(()=>{const Z=y(B);return new Promise((H,j)=>u(_,F,Z,Q=>Q?j(Q):H()))})}let a=!0;function u(_,F,B,Z){if(!a)return D.writeFile(_,F,{mode:B.mode,flag:B.flag},Z);D.open(_,B.flag,B.mode,(H,j)=>{if(H)return Z(H);D.writeFile(j,F,Q=>{if(Q)return D.close(j,()=>Z(Q));D.fdatasync(j,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),a=!1),D.close(j,N=>Z(N))))})})}function g(_,F,B){const Z=y(B);if(!a)return D.writeFileSync(_,F,{mode:Z.mode,flag:Z.flag});const H=D.openSync(_,Z.flag,Z.mode);try{D.writeFileSync(H,F);try{D.fdatasyncSync(H)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),a=!1}}finally{D.closeSync(H)}}e.writeFileSync=g;function y(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function k(_,F){if(_===F)return;async function B(Z){try{const H=await e.Promises.lstat(Z);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes(Z,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(_,F),await B(F)}catch(Z){if(_.toLowerCase()!==F.toLowerCase()&&Z.code==="EXDEV"||_.endsWith("."))await O(_,F,{preserveSymlinks:!1}),await h(_,p.MOVE),await B(F);else throw Z}}async function O(_,F,B){return W(_,F,{root:{source:_,target:F},options:B,handledSourcePaths:new Set})}const M=511;async function W(_,F,B){if(B.handledSourcePaths.has(_))return;B.handledSourcePaths.add(_);const{stat:Z,symbolicLink:H}=await n.stat(_);if(H){if(B.options.preserveSymlinks)try{return await $(_,F,B)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(H.dangling)return}return Z.isDirectory()?q(_,F,Z.mode&M,B):L(_,F,Z.mode&M)}async function q(_,F,B,Z){await e.Promises.mkdir(F,{recursive:!0,mode:B});const H=await w(_);for(const j of H)await W((0,S.join)(_,j),(0,S.join)(F,j),Z)}async function L(_,F,B){await e.Promises.copyFile(_,F),await e.Promises.chmod(F,B)}async function $(_,F,B){let Z=await e.Promises.readlink(_);(0,i.isEqualOrParent)(Z,B.root.source,!b.isLinux)&&(Z=(0,S.join)(B.root.target,Z.substr(B.root.source.length+1))),await e.Promises.symlink(Z,F)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return r}get writeFile(){return s}get rm(){return h}get move(){return k}get copy(){return O}}}),define(te[114],ne([0,1,51,10,25,20]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(I){const C=(0,A.dirname)(I);if(I===C)return I;const d=((0,A.basename)(I)||I).toLowerCase();try{const h=(0,T.readdirSync)(C).filter(E=>E.toLowerCase()===d);if(h.length===1){const E=i(C);if(E)return(0,A.join)(E,h[0])}else if(h.length>1){const E=h.indexOf(d);if(E>=0){const v=i(C);if(v)return(0,A.join)(v,h[E])}}}catch(p){}return null}e.realcaseSync=i;async function P(I){try{return await T.Promises.realpath(I)}catch(C){const d=b(I);return await T.Promises.access(d,D.constants.R_OK),d}}e.realpath=P;function S(I){try{return D.realpathSync(I)}catch(C){const d=b(I);return D.accessSync(d,D.constants.R_OK),d}}e.realpathSync=S;function b(I){return(0,R.rtrim)((0,A.normalize)(I),A.sep)}}),define(te[115],ne([0,1,57]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function A(P,S,b,I=1){let C=!1;return new Promise(d=>{const p=setTimeout(()=>{if(!C)return C=!0,d(0)},b);R(P,S,I,h=>{if(!C)return C=!0,clearTimeout(p),d(h)})})}e.findFreePort=A;function R(P,S,b,I){if(S===0)return I(0);const C=new D.Socket;C.once("connect",()=>(i(C),R(P+b,S-1,b,I))),C.once("data",()=>{}),C.once("error",d=>(i(C),d.code!=="ECONNREFUSED"?R(P+b,S-1,b,I):I(P))),C.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(P,S,b){let I=!1,C,d=1;const p=D.createServer({pauseOnConnect:!0});function h(E,v){I||(I=!0,p.removeAllListeners(),p.close(),C&&clearTimeout(C),v(E))}return new Promise(E=>{C=setTimeout(()=>{h(0,E)},b),p.on("listening",()=>{h(P,E)}),p.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&d<S?(P++,d++,p.listen(P,"127.0.0.1")):h(0,E)}),p.on("close",()=>{h(0,E)}),p.listen(P,"127.0.0.1")})}e.findFreePortFaster=T;function i(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(S){console.error(S)}}}),define(te[70],ne([0,1,33,10,20]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,i=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var S;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(S||(S={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(l,r,o){this.exePath=l,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:c=!1,findPreview:l=!1}={}){const r=d({useAlternateBitness:c});if(!r)return null;const o=A.join(r,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let n=-1,t=null;for(const u of await R.Promises.readdir(o)){let g=-1;if(l){const k=u.indexOf("-");if(k<0)continue;const O=u.substring(0,k);if(!T.test(O)||u.substring(k+1)!=="preview")continue;g=parseInt(O,10)}else{if(!T.test(u))continue;g=parseInt(u,10)}if(g<=n)continue;const y=A.join(o,u,"pwsh.exe");!await R.SymlinkSupport.existsFile(y)||(t=y,n=g)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",a=l?" Preview":"";return new C(t,`PowerShell${a}${s}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:i,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(l))if(r.test(n)){const t=A.join(l,n,"pwsh.exe");return new C(t,o)}return null}function E(){const c=A.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(c,".NET Core PowerShell Global Tool")}function v(){const c=A.join(process.env.windir,b===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(c,"Windows PowerShell",!0)}async function*m(){let c=await p();c&&(yield c),c=await p({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=E(),c&&(yield c),c=await p({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await p({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=v(),c&&(yield c)}async function*w(){for await(const c of m())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=w;async function f(){for await(const c of w())return c;return null}e.getFirstAvailablePowerShellInstallation=f}),define(te[116],ne([0,1,45,16]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(i){return new Promise((P,S)=>{let b;const I=new Map;function C(p,h,E,v,m){const w=I.get(h);if(p===i||w){const f={name:d(E),cmd:E,pid:p,ppid:h,load:v,mem:m};I.set(p,f),p===i&&(b=f),w&&(w.children||(w.children=[]),w.children.push(f),w.children.length>1&&(w.children=w.children.sort((c,l)=>c.pid-l.pid)))}}function d(p){const h=/--vscode-window-kind=shared-process/,E=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,f=/\\pipe\\winpty-control/,c=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(p))return"electron-crash-reporter";if(f.exec(p))return"winpty-process";if(c.exec(p))return"console-window-host (Windows internal process)";let r=l.exec(p);if(r&&r.length===2)return r[1]==="renderer"?h.exec(p)?"shared-process":E.exec(p)?"issue-reporter":v.exec(p)?"process-explorer":"window":r[1]==="utility"&&m.exec(p)?"utility-network-service":r[1];const o=/[a-zA-Z-]+\.js/g;let n="";do r=o.exec(p),r&&(n+=r+" ");while(r);return n&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${n}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,E)=>{J(["windows-process-tree"],h,E)}).then(h=>{h.getProcessList(i,E=>{h.getProcessCpuUsage(E,v=>{const m=new Map;v.forEach(w=>{const f=p(w.commandLine||"");m.set(w.pid,{name:d(f),cmd:f,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),b=m.get(i),b?(m.forEach(w=>{const f=m.get(w.ppid);f&&(f.children||(f.children=[]),f.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((f,c)=>f.pid-c.pid))}),P(b)):S(new Error(`Root process ${i} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[b];const E=[];for(;h.length;){const m=h.shift();m&&(E.push(m.pid),m.children&&(h=h.concat(m.children)))}let v=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);v+=" "+E.join(" "),(0,D.exec)(v,{},(m,w,f)=>{if(m||f)S(m||new Error(f.toString()));else{const c=w.toString().split(`
`);for(let l=0;l<E.length;l++){const r=I.get(E[l]);r.load=parseFloat(c[l])}if(!b){S(new Error(`Root process ${i} not found`));return}P(b)}})};(0,D.exec)("which ps",{},(h,E,v)=>{if(h||v)if(process.platform!=="linux")S(h||new Error(v.toString()));else{const m=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,D.exec)(m,{},(w,f,c)=>{w||c?S(w||new Error(c.toString())):(T(f,C),p())})}else{const m=E.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,c,l)=>{f||l&&!l.includes("screen size is bogus")?S(f||new Error(l.toString())):(T(c,C),process.platform==="linux"?p():b?P(b):S(new Error(`Root process ${i} not found`)))})}})}})}e.listProcesses=R;function T(i,P){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=i.toString().split(`
`);for(const I of b){const C=S.exec(I.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(te[117],ne([0,1,51,27,41,2,69,10,4,20]),function(J,e,D,A,R,T,i,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function I(h,E,v){return d({path:h,isDirectory:!1},E,v)}e.watchFile=I;function C(h,E,v){return d({path:h,isDirectory:!0},E,v)}e.watchFolder=C,e.CHANGE_BUFFER_DELAY=100;function d(h,E,v){if(S.isMacintosh&&(0,R.isEqualOrParent)(h.path,"/Volumes/"))return v(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const m=(0,P.basename)(h.path),w=new Map;let f=!1,c=[(0,T.toDisposable)(()=>{w.forEach(l=>(0,T.dispose)(l)),w.clear()})];try{const l=(0,D.watch)(h.path);c.push((0,T.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const r=new Set;h.isDirectory&&b.Promises.readdir(h.path).then(o=>o.forEach(n=>r.add(n))),l.on("error",(o,n)=>{f||v(`Failed to watch ${h.path} for changes using fs.watch() (${o}, ${n})`)}),l.on("change",(o,n)=>{if(f)return;let t="";if(n&&(t=n.toString(),S.isMacintosh&&(t=(0,i.normalizeNFC)(t))),!t||o!=="change"&&o!=="rename")return;const s=h.isDirectory?(0,P.join)(h.path,t):h.path;if(h.isDirectory)if(o==="rename"){const a=w.get(s);a&&(0,T.dispose)(a);const u=setTimeout(async()=>{w.delete(s);const g=await b.Promises.exists(s);if(f)return;let y;g?r.has(t)?y="changed":(y="added",r.add(t)):(r.delete(t),y="deleted"),E(y,s)},e.CHANGE_BUFFER_DELAY);w.set(s,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let a;r.has(t)?a="changed":(a="added",r.add(t)),E(a,s)}else if(o==="rename"||t!==m){const a=setTimeout(async()=>{const u=await b.Promises.exists(s);f||(u?(E("changed",s),c=[d(h,E,v)]):E("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(c),c=[(0,T.toDisposable)(()=>clearTimeout(a))]}else E("changed",s)})}catch(l){b.Promises.exists(h.path).then(r=>{r&&!f&&v(`Failed to watch ${h.path} for changes using fs.watch() (${l.toString()})`)})}return(0,T.toDisposable)(()=>{f=!0,c=(0,T.dispose)(c)})}async function p(h,E,v,m=512){const w=await b.Promises.open(h,"r"),f=Buffer.allocUnsafe(m),c=new A.CancellationTokenSource(v);let l,r=!1;const o=I(h,async n=>{if(n==="changed"){if(r)return;r=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:t}=await b.Promises.read(w,f,0,m,null);if(!t||c.token.isCancellationRequested)break;E(f.slice(0,t))}}catch(t){l=new Error(t),c.dispose(!0)}finally{r=!1}}},n=>{l=new Error(n),c.dispose(!0)});return new Promise((n,t)=>{c.token.onCancellationRequested(async()=>{o.dispose(),await b.Promises.close(w),l?t(l):n()})})}e.watchFileContents=p});var de=this&&this.__decorate||function(J,e,D,A){var R=arguments.length,T=R<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,D):A,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,D,A);else for(var P=J.length-1;P>=0;P--)(i=J[P])&&(T=(R<3?i(T):R>3?i(e,D,T):i(e,D))||T);return R>3&&T&&Object.defineProperty(e,D,T),T};define(te[34],ne([0,1,17,5,19,27,67,9,3,2,107,25,15]),function(J,e,D,A,R,T,i,P,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function v(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(m||(m={}));class w{constructor(j){this.buffer=j,this.pos=0}read(j){const Q=this.buffer.slice(this.pos,this.pos+j);return this.pos+=Q.byteLength,Q}}class f{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var c;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(c||(c={}));function l(H){const j=R.VSBuffer.alloc(4);return j.writeUInt32BE(H,0),j}function r(H){return H.read(4).readUInt32BE(0)}function o(H){const j=R.VSBuffer.alloc(1);return j.writeUInt8(H,0),j}const n={Undefined:o(c.Undefined),String:o(c.String),Buffer:o(c.Buffer),VSBuffer:o(c.VSBuffer),Array:o(c.Array),Object:o(c.Object)},t=typeof Buffer!="undefined";function s(H,j){if(typeof j=="undefined")H.write(n.Undefined);else if(typeof j=="string"){const Q=R.VSBuffer.fromString(j);H.write(n.String),H.write(l(Q.byteLength)),H.write(Q)}else if(t&&Buffer.isBuffer(j)){const Q=R.VSBuffer.wrap(j);H.write(n.Buffer),H.write(l(Q.byteLength)),H.write(Q)}else if(j instanceof R.VSBuffer)H.write(n.VSBuffer),H.write(l(j.byteLength)),H.write(j);else if(Array.isArray(j)){H.write(n.Array),H.write(l(j.length));for(const Q of j)s(H,Q)}else{const Q=R.VSBuffer.fromString(JSON.stringify(j));H.write(n.Object),H.write(l(Q.byteLength)),H.write(Q)}}function a(H){switch(H.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return H.read(r(H)).toString();case c.Buffer:return H.read(r(H)).buffer;case c.VSBuffer:return H.read(r(H));case c.Array:{const Q=r(H),U=[];for(let N=0;N<Q;N++)U.push(a(H));return U}case c.Object:return JSON.parse(H.read(r(H)).toString())}}class u{constructor(j,Q,U=null,N=1e3){this.protocol=j,this.ctx=Q,this.logger=U,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(j,Q){this.channels.set(j,Q),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const Q=this.send([j.type]);this.logger&&this.logger.logOutgoing(Q,0,1,v(j.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([j.type,j.id],j.data);this.logger&&this.logger.logOutgoing(Q,j.id,1,v(j.type),j.data);return}}}send(j,Q=void 0){const U=new f;return s(U,j),s(U,Q),this.sendBuffer(U.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(Q){return 0}}onRawMessage(j){const Q=new w(j),U=a(Q),N=a(Q),z=U[0];switch(z){case 100:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${h(z)}: ${U[2]}.${U[3]}`,N),this.onPromise({type:z,id:U[1],channelName:U[2],name:U[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${h(z)}: ${U[2]}.${U[3]}`,N),this.onEventListen({type:z,id:U[1],channelName:U[2],name:U[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:U[1]})}}onPromise(j){const Q=this.channels.get(j.channelName);if(!Q){this.collectPendingRequest(j);return}const U=new T.CancellationTokenSource;let N;try{N=Q.call(this.ctx,j.name,j.arg,U.token)}catch(K){N=Promise.reject(K)}const z=j.id;N.then(K=>{this.sendResponse({id:z,data:K,type:201}),this.activeRequests.delete(j.id)},K=>{K instanceof Error?this.sendResponse({id:z,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:z,data:K,type:203}),this.activeRequests.delete(j.id)});const x=(0,b.toDisposable)(()=>U.cancel());this.activeRequests.set(j.id,x)}onEventListen(j){const Q=this.channels.get(j.channelName);if(!Q){this.collectPendingRequest(j);return}const U=j.id,z=Q.listen(this.ctx,j.name,j.arg)(x=>this.sendResponse({id:U,data:x,type:204}));this.activeRequests.set(j.id,z)}disposeActiveRequest(j){const Q=this.activeRequests.get(j.id);Q&&(Q.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let Q=this.pendingRequests.get(j.channelName);Q||(Q=[],this.pendingRequests.set(j.channelName,Q));const U=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:j,timeoutTimer:U})}flushPendingRequests(j){const Q=this.pendingRequests.get(j);if(Q){for(const U of Q)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var g;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(j,Q=null){this.protocol=j,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=Q}getChannel(j){const Q=this;return{call(U,N,z){return Q.isDisposed?Promise.reject(P.canceled()):Q.requestPromise(j,U,N,z)},listen(U,N){return Q.isDisposed?Promise.reject(P.canceled()):Q.requestEvent(j,U,N)}}}requestPromise(j,Q,U,N=T.CancellationToken.None){const z=this.lastRequestId++,K={id:z,type:100,channelName:j,name:Q,arg:U};if(N.isCancellationRequested)return Promise.reject(P.canceled());let ee;return new Promise((X,se)=>{if(N.isCancellationRequested)return se(P.canceled());const oe=()=>{const Ce=we=>{switch(we.type){case 201:this.handlers.delete(z),X(we.data);break;case 202:this.handlers.delete(z);const ve=new Error(we.data.message);ve.stack=we.data.stack,ve.name=we.data.name,se(ve);break;case 203:this.handlers.delete(z),se(we.data);break}};this.handlers.set(z,Ce),this.sendRequest(K)};let le=null;this.state===m.Idle?oe():(le=(0,A.createCancelablePromise)(Ce=>this.whenInitialized()),le.then(()=>{le=null,oe()}));const he=()=>{le?(le.cancel(),le=null):this.sendRequest({id:z,type:101}),se(P.canceled())},be=N.onCancellationRequested(he);ee=(0,b.combinedDisposable)((0,b.toDisposable)(he),be),this.activeRequests.add(ee)}).finally(()=>{this.activeRequests.delete(ee)})}requestEvent(j,Q,U){const N=this.lastRequestId++,x={id:N,type:102,channelName:j,name:Q,arg:U};let K=null;const ee=new S.Emitter({onFirstListenerAdd:()=>{K=(0,A.createCancelablePromise)(X=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(ee),this.sendRequest(x)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(ee),this.sendRequest({id:N,type:103}))}}),V=X=>ee.fire(X.data);return this.handlers.set(N,V),ee.event}sendRequest(j){switch(j.type){case 100:case 102:{const Q=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(Q,j.id,0,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Q=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(Q,j.id,0,h(j.type));return}}}send(j,Q=void 0){const U=new f;return s(U,j),s(U,Q),this.sendBuffer(U.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(Q){return 0}}onBuffer(j){const Q=new w(j),U=a(Q),N=a(Q),z=U[0];switch(z){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,v(z)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,U[1],0,v(z),N),this.onResponse({type:U[0],id:U[1],data:N})}}onResponse(j){if(j.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const Q=this.handlers.get(j.id);Q&&Q(j)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}de([i.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class k{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:Q,onDidClientDisconnect:U})=>{S.Event.once(Q.onMessage)(z=>{const x=new w(z),K=a(x),ee=new u(Q,K),V=new y(Q);this.channels.forEach((se,oe)=>ee.registerChannel(oe,se));const X={channelServer:ee,channelClient:V,ctx:K};this._connections.add(X),this._onDidAddConnection.fire(X),U(()=>{ee.dispose(),V.dispose(),this._connections.delete(X),this._onDidRemoveConnection.fire(X)})})})}get connections(){const j=[];return this._connections.forEach(Q=>j.push(Q)),j}getChannel(j,Q){const U=this;return{call(N,z,x){let K;if((0,d.isFunction)(Q)){let V=(0,D.getRandomElement)(U.connections.filter(Q));K=V?Promise.resolve(V):S.Event.toPromise(S.Event.filter(U.onDidAddConnection,Q))}else K=Q.routeCall(U,N,z);const ee=K.then(V=>V.channelClient.getChannel(j));return M(ee).call(N,z,x)},listen(N,z){if((0,d.isFunction)(Q))return U.getMulticastEvent(j,Q,N,z);const x=Q.routeEvent(U,N,z).then(K=>K.channelClient.getChannel(j));return M(x).listen(N,z)}}}getMulticastEvent(j,Q,U,N){const z=this;let x=new b.DisposableStore;const K=new S.Emitter({onFirstListenerAdd:()=>{x=new b.DisposableStore;const ee=new S.EventMultiplexer,V=new Map,X=oe=>{const he=oe.channelClient.getChannel(j).listen(U,N),be=ee.add(he);V.set(oe,be)},se=oe=>{const le=V.get(oe);!le||(le.dispose(),V.delete(oe))};z.connections.filter(Q).forEach(X),S.Event.filter(z.onDidAddConnection,Q)(X,void 0,x),z.onDidRemoveConnection(se,void 0,x),ee.event(K.fire,K,x),x.add(ee)},onLastListenerRemove:()=>{x.dispose()}});return K.event}registerChannel(j,Q){this.channels.set(j,Q),this._connections.forEach(U=>{U.channelServer.registerChannel(j,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=k;class O{constructor(j,Q,U=null){const N=new f;s(N,Q),j.send(N.buffer),this.channelClient=new y(j,U),this.channelServer=new u(j,Q,U)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,Q){this.channelServer.registerChannel(j,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function M(H){return{call(j,Q,U){return H.then(N=>N.call(j,Q,U))},listen(j,Q){const U=new S.Relay;return H.then(N=>U.input=N.listen(j,Q)),U.event}}}e.getDelayedChannel=M;function W(H){let j=!1;return{call(Q,U,N){return j?H.call(Q,U,N):(0,A.timeout)(0).then(()=>j=!0).then(()=>H.call(Q,U,N))},listen(Q,U){if(j)return H.listen(Q,U);const N=new S.Relay;return(0,A.timeout)(0).then(()=>j=!0).then(()=>N.input=H.listen(Q,U)),N.event}}}e.getNextTickChannel=W;class q{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const Q of j.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=q;var L;(function(H){function j(z,x){const K=z,ee=x&&x.disableMarshalling,V=new Map;for(const X in K)U(X)&&V.set(X,S.Event.buffer(K[X],!0));return new class{listen(X,se,oe){const le=V.get(se);if(le)return le;if(N(se)){const he=K[se];if(typeof he=="function")return he.call(K,oe)}throw new Error(`Event not found: ${se}`)}call(X,se,oe){const le=K[se];if(typeof le=="function"){if(!ee&&Array.isArray(oe))for(let he=0;he<oe.length;he++)oe[he]=(0,I.revive)(oe[he]);return le.apply(K,oe)}throw new Error(`Method not found: ${se}`)}}}H.fromService=j;function Q(z,x){const K=x&&x.disableMarshalling;return new Proxy({},{get(ee,V){if(typeof V=="string")return x?.properties?.has(V)?x.properties.get(V):N(V)?function(X){return z.listen(V,X)}:U(V)?z.listen(V):async function(...X){let se;x&&!(0,d.isUndefinedOrNull)(x.context)?se=[x.context,...X]:se=X;const oe=await z.call(V,se);return K?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(V)}`)}})}H.toService=Q;function U(z){return z[0]==="o"&&z[1]==="n"&&C.isUpperAsciiLetter(z.charCodeAt(2))}function N(z){return/^onDynamic/.test(z)&&C.isUpperAsciiLetter(z.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let j=H.toString();if(j!=="[object Object]")return j}return H}function F(H){return Array.isArray(H)?H.map(_):_(H)}function B(H,j,Q,U,N,z,x){x=F(x);const K=$[N],ee=K[U%K.length];let V=[`%c[${H}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(z)?(V=V.concat(x),V.push(")")):V.push(x),console.log.apply(console,V)}e.logWithColors=B;class Z{constructor(j,Q){this._outgoingPrefix=j,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,Q,U,N,z){this._totalOutgoing+=j,B(this._outgoingPrefix,this._totalOutgoing,j,Q,U,N,z)}logIncoming(j,Q,U,N,z){this._totalIncoming+=j,B(this._incomingPrefix,this._totalIncoming,j,Q,U,N,z)}}e.IPCLogger=Z}),define(te[118],ne([0,1,19,3,34]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(S){this.port=S,this.onMessage=A.Event.fromDOMEventEmitter(this.port,"message",b=>D.VSBuffer.wrap(b.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class i extends R.IPCClient{constructor(S,b){const I=new T(S);super(I,b);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=i}),define(te[71],ne([0,1,19,3,2,34]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var i;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(i=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function S(){return P||(P=D.VSBuffer.alloc(0)),P}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,n){if(o===0)return S();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const u=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=o),u}if(this._chunks[0].byteLength>o){const u=this._chunks[0].slice(0,o);return n&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),u}let t=D.VSBuffer.alloc(o),s=0,a=0;for(;o>0;){const u=this._chunks[a];if(u.byteLength>o){const g=u.slice(0,o);t.set(g,s),s+=o,n&&(this._chunks[a]=u.slice(o),this._totalLength-=o),o-=o}else t.set(u,s),s+=u.byteLength,n?(this._chunks.shift(),this._totalLength-=u.byteLength):a++,o-=u.byteLength}return t}}e.ChunkStream=b;var I;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var C;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(C=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(o,n,t,s){this.type=o,this.id=n,this.ack=t,this.data=s,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends R.Disposable{constructor(o){super();this._onMessage=this._register(new A.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5);else{const t=this._state.messageType,s=this._state.id,a=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(t,s,a,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=D.VSBuffer.alloc(13);n.writeUInt8(o.type,0),n.writeUInt32BE(o.id,1),n.writeUInt32BE(o.ack,5),n.writeUInt32BE(o.data.byteLength,9),this._writeSoon(n,o.data)}_bufferAdd(o,n){const t=this._totalLength===0;return this._data.push(o,n),this._totalLength+=o.byteLength+n.byteLength,t}_bufferTake(){const o=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,n){this._bufferAdd(o,n)&&setTimeout(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends R.Disposable{constructor(o){super();this._onMessage=new A.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new A.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new d(1,0,0,o))}}e.Protocol=E;class v extends T.IPCClient{constructor(o,n,t=null){super(o,n,t);this.protocol=o}static fromSocket(o,n){return new v(new E(o),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=v;class m{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new A.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=m;class w{constructor(o){this.data=o,this.next=null}}class f{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],n=0,t=this._first;for(;t;)o[n++]=t.data,t=t.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const n=new w(o);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class c{constructor(){this.lastRuns=[];const o=Date.now();for(let n=0;n<c._HISTORY_LENGTH;n++)this.lastRuns[n]=o-1e3*n;setInterval(()=>{for(let n=c._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const o=Date.now(),n=(1+c._HISTORY_LENGTH)*1e3;let t=0;for(let s=0;s<c._HISTORY_LENGTH;s++)o-this.lastRuns[s]<=n&&t++;return 1-t/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class l{constructor(o,n=null,t=c.getInstance()){this._onControlMessage=new m,this.onControlMessage=this._onControlMessage.event,this._onMessage=new m,this.onMessage=this._onMessage.event,this._onDidDispose=new m,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new m,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new m,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=t,this._isReconnecting=!1,this._outgoingUnackMsg=new f,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(s=>this._receiveMessage(s))),this._socketDisposables.push(this._socket.onClose(s=>this._onSocketClose.fire(s))),n&&this._socketReader.acceptChunk(n),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new d(5,0,0,S());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const n=new d(4,0,0,S());this._socketWriter.write(n),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,n){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(t=>this._receiveMessage(t))),this._socketDisposables.push(this._socket.onClose(t=>this._onSocketClose.fire(t))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let n=0,t=o.length;n<t;n++)this._socketWriter.write(o[n]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new d(6,0,0,S())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const n=this._outgoingUnackMsg.toArray();for(let t=0,s=n.length;t<s;t++)this._socketWriter.write(n[t]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const t=new d(1,n,this._incomingAckId,o);this._outgoingUnackMsg.push(t),this._isReconnecting||(this._socketWriter.write(t),this._recvAckCheck())}sendControl(o){const n=new d(2,0,0,o);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),n=Date.now()-o.writtenTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-n,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new d(3,0,this._incomingAckId,S());this._socketWriter.write(o)}}e.PersistentProtocol=l}),define(te[119],ne([0,1,72,3,34,118]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class i extends R.IPCServer{static getOnDidClientConnect(){const S=A.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(b,I)=>I);return A.Event.map(S,b=>{const{port1:I,port2:C}=new MessageChannel,p={protocol:new T.Protocol(I),onDidClientDisconnect:A.Event.fromDOMEventEmitter(I,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[C]),p})}constructor(){super(i.getOnDidClientConnect())}}e.Server=i}),define(te[120],ne([0,1,19,9]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,S){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((I,C)=>{b.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(b,P),b.responseType="arraybuffer",b.onerror=d=>C(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=d=>{I({res:{statusCode:b.status,headers:i(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=d=>C(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(b.timeout=P.timeout),b.send(P.data),S.onCancellationRequested(()=>{b.abort(),C((0,A.canceled)())})})}e.request=R;function T(P,S){if(S.headers){e:for(let b in S.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(b,S.headers[b])}}}function i(P){const S=Object.create(null);for(const b of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const I=b.indexOf(":");S[b.substr(0,I).trim().toLowerCase()]=b.substr(I+1).trim()}return S}}),define(te[73],ne([0,1,5,3,2,15]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var i;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(i=e.StorageHint||(e.StorageHint={}));function P(C){const d=C;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var S;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(S||(S={}));class b extends R.Disposable{constructor(d,p=Object.create(null)){super();this.database=d,this.options=p,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((p,h)=>this.accept(h,p)),d.deleted?.forEach(p=>this.accept(p,void 0))}accept(d,p){if(this.state===S.Closed)return;let h=!1;(0,T.isUndefinedOrNull)(p)?h=this.cache.delete(d):this.cache.get(d)!==p&&(this.cache.set(d,p),h=!0),h&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==i.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,p){const h=this.cache.get(d);return(0,T.isUndefinedOrNull)(h)?p:h}getBoolean(d,p){const h=this.get(d);return(0,T.isUndefinedOrNull)(h)?p:h==="true"}getNumber(d,p){const h=this.get(d);return(0,T.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(d,p){if(this.state===S.Closed)return;if((0,T.isUndefinedOrNull)(p))return this.delete(d);const h=String(p);if(this.cache.get(d)!==h)return this.cache.set(d,h),this.pendingInserts.set(d,h),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===S.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.doFlush(0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((p,h)=>this.items.set(h,p)),d.delete&&d.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[121],ne([12,13]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[58],ne([0,1,121]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,R=A*60,T=R*24,i=T*7,P=T*30,S=T*365;function b(C,d){typeof C!="number"&&(C=C.getTime());const p=Math.round((new Date().getTime()-C)/1e3);if(p<-30)return(0,D.localize)(0,null,b(new Date().getTime()+p*1e3,!1));if(p<30)return(0,D.localize)(1,null);let h;return p<A?(h=p,d?h===1?(0,D.localize)(2,null,h):(0,D.localize)(3,null,h):h===1?(0,D.localize)(4,null,h):(0,D.localize)(5,null,h)):p<R?(h=Math.floor(p/A),d?h===1?(0,D.localize)(6,null,h):(0,D.localize)(7,null,h):h===1?(0,D.localize)(8,null,h):(0,D.localize)(9,null,h)):p<T?(h=Math.floor(p/R),d?h===1?(0,D.localize)(10,null,h):(0,D.localize)(11,null,h):h===1?(0,D.localize)(12,null,h):(0,D.localize)(13,null,h)):p<i?(h=Math.floor(p/T),d?h===1?(0,D.localize)(14,null,h):(0,D.localize)(15,null,h):h===1?(0,D.localize)(16,null,h):(0,D.localize)(17,null,h)):p<P?(h=Math.floor(p/i),d?h===1?(0,D.localize)(18,null,h):(0,D.localize)(19,null,h):h===1?(0,D.localize)(20,null,h):(0,D.localize)(21,null,h)):p<S?(h=Math.floor(p/P),d?h===1?(0,D.localize)(22,null,h):(0,D.localize)(23,null,h):h===1?(0,D.localize)(24,null,h):(0,D.localize)(25,null,h)):(h=Math.floor(p/S),d?h===1?(0,D.localize)(26,null,h):(0,D.localize)(27,null,h):h===1?(0,D.localize)(28,null,h):(0,D.localize)(29,null,h))}e.fromNow=b;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[122],ne([12,13]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,17,15,122]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(b,I){return I&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),i(b.stack)||i(b.stacktrace)):P(b)}function i(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function S(b=null,I=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const C=D.coalesce(b),d=S(C[0],I);return C.length>1?R.localize(4,null,d,C.length):d}if(A.isString(b))return b;if(b.detail){const C=b.detail;if(C.error)return T(C.error,I);if(C.exception)return T(C.exception,I)}return b.stack?T(b,I):b.message?b.message:R.localize(5,null)}e.toErrorMessage=S}),define(te[123],ne([12,13]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,45,41,16,28,10,4,32,102,15,111,20,123]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function E(r,o){if(P.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};o&&(n.cwd=o);const t=D.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],n);return new Promise(s=>{t.once("error",a=>{s({success:!1,error:a})}),t.once("exit",(a,u)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(P.isLinux||P.isMacintosh)try{const n=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{D.execFile(n,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,a,u)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function v(r){!r||(delete r.DEBUG,P.isMacintosh&&delete r.DYLD_LIBRARY_PATH,P.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function m(r=S.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(o,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=o,this.args=n,this.shell=t,this.options=s;else{const a=o;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(S.env).forEach(u=>{a[u]=S.env[u]}),Object.keys(this.options.env).forEach(u=>{a[u]=this.options.env[u]}),this.options.env=a}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const n=o.lastIndexOf(i.sep);return n!==-1&&(o=o.substring(n+1)),w.WellKnowCommands[o]?o:"other"}start(o){return P.isWindows&&(this.options&&this.options.cwd&&A.isUNC(this.options.cwd)||!this.options&&A.isUNC(S.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(n=>{let t,s;const a=new Promise((u,g)=>{t=u,s=g});if(n){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(g,y,k)=>{this.childProcess=null;const O=g;O&&O.killed?s({killed:this.terminateRequested,stdout:y.toString(),stderr:k.toString()}):this.handleExec(t,o,g,y,k)})}else{let u=null;const g=y=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(y,t,o,s);const k={terminated:this.terminateRequested};I.isNumber(y)&&(k.cmdCode=y),t(k)};if(this.shell&&P.isWindows){const y=T.deepClone(this.options);y.windowsVerbatimArguments=!0,y.detached=!1;let k=!1,O=!1;const M=[];let W=this.ensureQuotes(this.cmd);M.push(W.value),k=W.quoted,this.args&&this.args.forEach(L=>{W=this.ensureQuotes(L),M.push(W.value),O=O&&W.quoted});const q=["/s","/c"];k?O?q.push('"'+M.join(" ")+'"'):M.length>1?q.push('"'+M[0]+'" '+M.slice(1).join(" ")):q.push('"'+M[0]+'"'):q.push(M.join(" ")),u=D.spawn(m(),q,y)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(I.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",y=>{this.childProcess=null,s({terminated:this.terminateRequested,error:y})}),u.pid&&(this.childProcess.on("close",g),this.handleSpawn(u,t,o,s,!0)))}return a})}handleClose(o,n,t,s){}ensureQuotes(o){return w.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,E(o,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!P.isWindows)return o(!1);const n=D.spawn(m(),["/s","/c"]);n.on("error",t=>o(!0)),n.on("exit",t=>o(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class f extends w{constructor(o,n,t,s){super(o,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,n,t,s,a){[s,a].forEach((u,g)=>{const y=new C.LineDecoder;y.write(u).forEach(M=>{n({line:M,source:g===0?0:1})});const O=y.end();O&&n({line:O,source:g===0?0:1})}),o({terminated:this.terminateRequested,error:t})}handleSpawn(o,n,t,s,a){const u=new C.LineDecoder,g=new C.LineDecoder;o.stdout.on("data",y=>{u.write(y).forEach(O=>t({line:O,source:0}))}),o.stderr.on("data",y=>{g.write(y).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=g}handleClose(o,n,t,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&t({line:a,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=f;function c(r){let o=[],n=!1;const t=function(s){if(n){o.push(s);return}(!r.send(s,u=>{if(u&&console.error(u),n=!1,o.length>0){const g=o.slice(0);o=[],g.forEach(y=>t(y))}})||P.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=c;var l;(function(r){async function o(n,t,s){if(i.isAbsolute(n))return n;if(t===void 0&&(t=S.cwd()),i.dirname(n)!=="."||(s===void 0&&I.isString(S.env.PATH)&&(s=S.env.PATH.split(i.delimiter)),s===void 0||s.length===0))return i.join(t,n);async function u(g){if(await d.Promises.exists(g)){let y;try{y=await d.Promises.stat(g)}catch(k){k.message.startsWith("EACCES")&&(y=await d.Promises.lstat(g))}return y?!y.isDirectory():!1}return!1}for(let g of s){let y;if(i.isAbsolute(g)?y=i.join(g,n):y=i.join(t,g,n),await u(y))return y;let k=y+".com";if(await u(k)||(k=y+".exe",await u(k)))return k}return i.join(t,n)}r.findExecutable=o})(l=e.win32||(e.win32={}))}),define(te[124],ne([0,1,33,4,70,74]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function i(p,h){return p===1?A.isWindows?C():T.getWindowsShell(h):b(p,h)}e.getSystemShell=i;function P(p,h){return p===1?A.isWindows?d(h):T.getWindowsShell(h):b(p,h)}e.getSystemShellSync=P;let S=null;function b(p,h){if(A.isLinux&&p===2||A.isMacintosh&&p===3)return"/bin/bash";if(!S){let E;if(A.isWindows)E="/bin/bash";else{if(E=h.SHELL,!E)try{E=(0,D.userInfo)().shell}catch(v){}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}S=E}return S}let I=null;async function C(){return I||(I=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),I}function d(p){if(I)return I;const h=A.isWindows&&parseFloat((0,D.release)())>=10,E=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${p.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?v:T.getWindowsShell(p)}}),define(te[52],ne([0,1,45,5,19,27,106,9,3,2,28,74,34]),function(J,e,D,A,R,T,i,P,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends d.ChannelServer{constructor(v){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(w){}},onMessage:S.Event.fromNodeEventEmitter(process,"message",m=>R.VSBuffer.wrap(Buffer.from(m,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(v,m){this.modulePath=v,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new S.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new A.Delayer(w),this.child=null,this._client=null}getChannel(v){const m=this;return{call(w,f,c){return m.requestPromise(v,w,f,c)},listen(w,f){return m.requestEvent(v,w,f)}}}requestPromise(v,m,w,f=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(v),l=(0,A.createCancelablePromise)(n=>c.call(m,w,n)),r=f.onCancellationRequested(()=>l.cancel()),o=(0,b.toDisposable)(()=>l.cancel());return this.activeRequests.add(o),l.finally(()=>{r.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(v,m,w){if(!this.disposeDelayer)return S.Event.None;this.disposeDelayer.cancel();let f;const c=new S.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(v).listen(m,w)(c.fire,c),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(m.env),this.child=(0,D.fork)(this.modulePath,v,m);const w=new S.Emitter;S.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,i.isRemoteConsoleLog)(t)){(0,i.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(R.VSBuffer.wrap(Buffer.from(t,"base64")))});const c=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&c.send(t.buffer.toString("base64")),r=w.event,o={send:l,onMessage:r};this._client=new d.ChannelClient(o);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(a=>(0,b.dispose)(a)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(v){let m=this.channels.get(v);return m||(m=this.client.getChannel(v),this.channels.set(v,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[125],ne([12,13]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[126],ne([12,13]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[127],ne([12,13]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[128],ne([12,13]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[129],ne([12,13]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[130],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[131],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[132],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[133],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[134],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[135],ne([12,13]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[136],ne([12,13]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[137],ne([12,13]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[138],ne([12,13]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[139],ne([12,13]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[140],ne([12,13]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[141],ne([12,13]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[142],ne([12,13]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[143],ne([12,13]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[144],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[145],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[146],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[147],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[148],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[149],ne([12,13]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[150],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var A;(function(i){i.Team="team",i.Internal="internal",i.Insiders="insider",i.Public="public"})(A=e.TargetPopulation||(e.TargetPopulation={}));var R;(function(i){i.Market="X-MSEdge-Market",i.CorpNet="X-FD-Corpnet",i.ApplicationVersion="X-VSCode-AppVersion",i.Build="X-VSCode-Build",i.ClientId="X-MSEdge-ClientId",i.ExtensionName="X-VSCode-ExtensionName",i.Language="X-VSCode-Language",i.TargetPopulation="X-VSCode-TargetPopulation"})(R=e.Filters||(e.Filters={}));class T{constructor(P,S,b,I){this.version=P,this.appName=S,this.machineId=b,this.targetPopulation=I}getFilterValue(P){switch(P){case R.ApplicationVersion:return this.version;case R.Build:return this.appName;case R.ClientId:return this.machineId;case R.Language:return D.language;case R.ExtensionName:return"vscode-core";case R.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let P=new Map,S=Object.values(R);for(let b of S)P.set(b,this.getFilterValue(b));return P}}e.AssignmentFilterProvider=T}),define(te[75],ne([0,1,58,67,16,10,32,18,7]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(E,v,m){this._args=E,this.paths=v,this.productService=m}get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("",J).fsPath)}get userHome(){return S.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return S.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.paths.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return S.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(S.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return S.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return S.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=i.env.VSCODE_PORTABLE;return E?S.URI.file((0,T.join)(E,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,T.resolve)(E):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=this.args["extensions-download-dir"];return E?(0,T.resolve)(E):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,T.resolve)(E);const v=i.env.VSCODE_EXTENSIONS;if(v)return v;const m=i.env.VSCODE_PORTABLE;return m?(0,T.join)(m,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(v=>/^[^:/?#]+?:\/\//.test(v)?S.URI.parse(v):S.URI.file((0,T.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?S.URI.parse(E):S.URI.file((0,T.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!i.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return S.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([A.memoize],b.prototype,"appRoot",null),de([A.memoize],b.prototype,"userHome",null),de([A.memoize],b.prototype,"userDataPath",null),de([A.memoize],b.prototype,"appSettingsHome",null),de([A.memoize],b.prototype,"tmpDir",null),de([A.memoize],b.prototype,"cacheHome",null),de([A.memoize],b.prototype,"userRoamingDataHome",null),de([A.memoize],b.prototype,"settingsResource",null),de([A.memoize],b.prototype,"userDataSyncHome",null),de([A.memoize],b.prototype,"userDataSyncLogResource",null),de([A.memoize],b.prototype,"sync",null),de([A.memoize],b.prototype,"machineSettingsResource",null),de([A.memoize],b.prototype,"globalStorageHome",null),de([A.memoize],b.prototype,"workspaceStorageHome",null),de([A.memoize],b.prototype,"keybindingsResource",null),de([A.memoize],b.prototype,"keyboardLayoutResource",null),de([A.memoize],b.prototype,"argvResource",null),de([A.memoize],b.prototype,"snippetsHome",null),de([A.memoize],b.prototype,"isExtensionDevelopment",null),de([A.memoize],b.prototype,"untitledWorkspacesHome",null),de([A.memoize],b.prototype,"installSourcePath",null),de([A.memoize],b.prototype,"builtinExtensionsPath",null),de([A.memoize],b.prototype,"extensionsPath",null),de([A.memoize],b.prototype,"extensionDevelopmentLocationURI",null),de([A.memoize],b.prototype,"extensionDevelopmentKind",null),de([A.memoize],b.prototype,"extensionTestsLocationURI",null),de([A.memoize],b.prototype,"debugExtensionHost",null),de([A.memoize],b.prototype,"serviceMachineIdResource",null),de([A.memoize],b.prototype,"telemetryLogResource",null),de([A.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function I(h,E){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,E,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function C(h,E){return p(h["inspect-search"],h["inspect-brk-search"],5876,E,h.extensionEnvironment)}e.parseSearchPort=C;function d(h,E){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,E,h.extensionEnvironment)}e.parsePtyHostPort=d;function p(h,E,v,m,w,f){const l=Number(E||h)||(m?null:v),r=l?Boolean(!!E):!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:l,break:r,debugId:w,env:o}}}),define(te[151],ne([0,1,245,4,127]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const i={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(h,E,v=i){const m={},w=[],f=[];for(let o in E){const n=E[o];n.alias&&(m[o]=n.alias),n.type==="string"||n.type==="string[]"?(w.push(o),n.deprecates&&w.push(n.deprecates)):n.type==="boolean"&&(f.push(o),n.deprecates&&f.push(n.deprecates))}const c=D(h,{string:w,boolean:f,alias:m}),l={},r=c;l._=c._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(let o in E){const n=E[o];n.alias&&delete r[n.alias];let t=r[o];n.deprecates&&r.hasOwnProperty(n.deprecates)&&(t||(t=r[n.deprecates]),delete r[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),v.onMultipleValues(o,t)),l[o]=t),delete r[o]}for(let o in r)v.onUnknownOption(o);return l}e.parseArgs=P;function S(h,E){let v="";return E.args&&(Array.isArray(E.args)?v=` <${E.args.join("> <")}>`:v=` <${E.args}>`),E.alias?`-${E.alias} --${h}${v}`:`--${h}${v}`}function b(h,E){let v=0,m=[];for(const l in h){const r=h[l],o=S(l,r);v=Math.max(v,o.length),m.push([o,r.description])}let w=v+2+1;if(E-w<25)return m.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let f=E-w-1,c=[];for(const l of m){let r=l[0],o=C(l[1],f),n=I(w-r.length-2);c.push("  "+r+n+o[0]);for(let t=1;t<o.length;t++)c.push(I(w)+o[t])}return c}e.formatOptions=b;function I(h){return" ".repeat(h)}function C(h,E){let v=[];for(;h.length;){let m=h.length<E?h.length:h.lastIndexOf(" ",E),w=h.slice(0,m).trim();h=h.slice(m),v.push(w)}return v}function d(h,E,v,m,w){const f=process.stdout.isTTY&&process.stdout.columns||80,c=w?.noInputFiles!==!0?`[${(0,R.localize)(32,null)}...]`:"",l=[`${h} ${v}`];l.push(""),l.push(`${(0,R.localize)(33,null)}: ${E} [${(0,R.localize)(34,null)}]${c}`),l.push(""),w?.noPipe!==!0&&(A.isWindows?l.push((0,R.localize)(35,null,E)):l.push((0,R.localize)(36,null,E)),l.push(""));const r={};for(const o in m){const n=m[o];if(n.description&&n.cat){let t=r[n.cat];t||(r[n.cat]=t={}),t[o]=n}}for(let o in r){const n=o;let t=r[n];t&&(l.push(T[n]),l.push(...b(t,f)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=d;function p(h,E){return`${h||(0,R.localize)(37,null)}
${E||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function J(e,D,A,R){function T(P){const S=i(P),b=[S];return e.isAbsolute(S)||b.unshift(R),e.resolve(...b)}function i(P){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,A);const I=P["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(C,"AppData","Roaming")}break;case"darwin":b=e.join(D.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,A)}return{getUserDataPath:T}}if(typeof define=="function")define(te[152],ne([0,153,33,16,18,32]),function(e,D,A,R,T,i){const P=T.dirname(R.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(T.joinPath(P,"package.json").fsPath);return J(D,A,S.name,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),A=require("os");module.exports=J(D,A,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[154],ne([0,1,33,75,152]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends A.AbstractNativeEnvironmentService{constructor(P,S){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},S)}}e.NativeEnvironmentService=T}),define(te[155],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const A=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,i=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(v){const m=v.match(i);return m?m[1]:null}function I(v){if(v.indexOf("://")===-1){const m=v.match(A);return m?b(m[2]):null}try{const m=D.URI.parse(v);if(m.authority)return b(m.authority)}catch(m){}return null}function C(v,m){const w=new Set;let f;for(;f=P.exec(v);){const l=I(f[1]);l&&w.add(l)}const c=new Set(m);return Array.from(w).map(l=>c.has(l)?l:l.replace(S,"a"))}e.getDomainsOfRemotes=C;function d(v){const m=v.match(T);return m?m[2]:null}function p(v,m,w){return v&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${v}${m}`:`${v}/${m}`):null}function h(v,m){if(v.indexOf("://")===-1){const w=v.match(R);if(w)return p(w[2],w[3],m)}try{const w=D.URI.parse(v);if(w.authority)return p(d(w.authority),w.path,m)}catch(w){}return null}function E(v,m=!1){const w=[];let f;for(;f=P.exec(v);){const c=h(f[1],m);c&&w.push(c)}return w}e.getRemotes=E}),define(te[156],ne([0,1,28]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const A=/^%([\w\d.-]+)%$/i;function R(T,i){const P=S=>{if(typeof S!="string")return;const b=A.exec(S);if(!b)return;const I=i[b[1]]??S;return typeof I=="string"?I:typeof I.message=="string"?I.message:S};return(0,D.cloneAndChange)(T,P)}e.localizeManifest=R}),define(te[157],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,i,P,S){return this.channel.call("promptImportantExtensionsInstallNotification",[T,i,P,S])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class A{constructor(T){this.service=T}listen(T,i){throw new Error(`Event not found: ${i}`)}call(T,i,P){switch(i){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${i}`)}}e.ExtensionRecommendationNotificationServiceChannel=A}),define(te[76],ne([0,1,136]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function T(d){return d=d.trim(),d==="*"||A.test(d)}e.isValidVersionStr=T;function i(d){if(!T(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=d.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=i;function P(d){if(!d)return null;let p=d.majorBase,h=d.majorMustEqual,E=d.minorBase,v=d.minorMustEqual,m=d.patchBase,w=d.patchMustEqual;d.hasCaret&&(p===0||(v=!1),w=!1);let f=0;if(d.preRelease){const c=R.exec(d.preRelease);if(c){const[,l,r,o]=c;f=Date.UTC(Number(l),Number(r)-1,Number(o))}}return{majorBase:p,majorMustEqual:h,minorBase:E,minorMustEqual:v,patchBase:m,patchMustEqual:w,isMinimum:d.hasGreaterEquals,notBefore:f}}e.normalizeVersion=P;function S(d,p,h){let E;typeof d=="string"?E=P(i(d)):E=d;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let m;if(typeof h=="string"?m=P(i(h)):m=h,!E||!m)return!1;let w=E.majorBase,f=E.minorBase,c=E.patchBase,l=m.majorBase,r=m.minorBase,o=m.patchBase,n=m.notBefore,t=m.majorMustEqual,s=m.minorMustEqual,a=m.patchMustEqual;return m.isMinimum?w>l?!0:w<l?!1:f>r?!0:f<r||v&&v<n?!1:c>=o:(w===1&&l===0&&(!t||!s||!a)&&(l=1,r=0,o=0,t=!0,s=!1,a=!1),w<l?!1:w>l?!t:f<r?!1:f>r?!s:c<o?!1:c>o?!a:!(v&&v<n))}e.isValidVersion=S;function b(d,p,h,E){return h.isBuiltin||typeof h.main=="undefined"?!0:C(d,p,h.engines.vscode,E)}e.isValidExtensionVersion=b;function I(d,p,h){return d==="*"||C(p,h,d)}e.isEngineValid=I;function C(d,p,h,E=[]){let v=P(i(h));if(!v)return E.push(D.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return E.push(D.localize(1,null,h)),!1}else if(!v.majorMustEqual)return E.push(D.localize(2,null,h)),!1;return S(d,p,v)?!0:(E.push(D.localize(3,null,d,h)),!1)}}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,T=[],i=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=D}),define(te[77],ne([0,1,53]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const A=[];function R(i,P,S){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],S)),A.push([i,P])}e.registerSingleton=R;function T(){return A}e.getSingletonServiceDescriptors=T}),define(te[158],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class A{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let i of this._nodes.values())i.outgoing.size===0&&T.push(i);return T}insertEdge(T,i){const P=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(i);P.outgoing.set(this._hashFn(i),S),S.incoming.set(this._hashFn(T),P)}removeNode(T){const i=this._hashFn(T);this._nodes.delete(i);for(let P of this._nodes.values())P.outgoing.delete(i),P.incoming.delete(i)}lookupOrInsertNode(T){const i=this._hashFn(T);let P=this._nodes.get(i);return P||(P=new D(T),this._nodes.set(i,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[i,P]of this._nodes)T.push(`${i}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,i]of this._nodes){const P=new Set([T]),S=this._findCycle(i,P);if(S)return S}}_findCycle(T,i){for(let[P,S]of T.outgoing){if(i.has(P))return[...i,P].join(" -> ");i.add(P);const b=this._findCycle(S,i);if(b)return b;i.delete(P)}}}e.Graph=A}),define(te[6],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function P(S){return S[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function A(i,P,S,b){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:i,index:S,optional:b}):(P[D.DI_DEPENDENCIES]=[{id:i,index:S,optional:b}],P[D.DI_TARGET]=P)}function R(i){if(D.serviceIds.has(i))return D.serviceIds.get(i);const P=function(S,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,S,I,!1)};return P.toString=()=>i,D.serviceIds.set(i,P),P}e.createDecorator=R;function T(i){return i}e.refineServiceDecorator=T}),define(te[159],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[21],ne([0,1,15,7,6]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function T(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof A.URI)}e.isConfigurationOverrides=T;function i(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||D.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=i;var P;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function b(v,m){const w=Object.create(null);for(let f in v)I(w,f,v[f],m);return w}e.toValuesTree=b;function I(v,m,w,f){const c=m.split("."),l=c.pop();let r=v;for(let o=0;o<c.length;o++){let n=c[o],t=r[n];switch(typeof t){case"undefined":t=r[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${m} as ${c.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=w}catch(o){f(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function C(v,m){const w=m.split(".");d(v,w)}e.removeFromValueTree=C;function d(v,m){const w=m.shift();if(m.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const f=v[w];typeof f=="object"&&!Array.isArray(f)&&(d(f,m),Object.keys(f).length===0&&delete v[w])}}function p(v,m,w){function f(r,o){let n=r;for(const t of o){if(typeof n!="object"||n===null)return;n=n[t]}return n}const c=m.split("."),l=f(v,c);return typeof l=="undefined"?w:l}e.getConfigurationValue=p;function h(v,m,w){Object.keys(m).forEach(f=>{f!=="__proto__"&&(f in v?D.isObject(v[f])&&D.isObject(m[f])?h(v[f],m[f],w):w&&(v[f]=m[f]):v[f]=m[f])})}e.merge=h;function E(v,m,w){const f=v.inspect(m),c=v.inspect(w);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:f.defaultValue}e.getMigratedSettingValue=E}),define(te[160],ne([0,1,4,25,6]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",D.isMacintosh),i.set("isLinux",D.isLinux),i.set("isWindows",D.isWindows),i.set("isWeb",D.isWeb),i.set("isMacNative",D.isMacintosh&&!D.isWeb),i.set("isEdge",T.indexOf("Edg/")>=0),i.set("isFirefox",T.indexOf("Firefox")>=0),i.set("isChrome",T.indexOf("Chrome")>=0),i.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var S;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return d.INSTANCE}static true(){return p.INSTANCE}static has(L){return h.create(L)}static equals(L,$){return E.create(L,$)}static notEquals(L,$){return w.create(L,$)}static regex(L,$){return t.create(L,$)}static in(L,$){return v.create(L,$)}static not(L){return f.create(L)}static and(...L){return u.create(L,null)}static or(...L){return g.create(L,null,!0)}static greater(L,$){return l.create(L,$)}static greaterEquals(L,$){return r.create(L,$)}static smaller(L,$){return o.create(L,$)}static smallerEquals(L,$){return n.create(L,$)}static deserialize(L,$=!1){if(!!L)return this._deserializeOrExpression(L,$)}static _deserializeOrExpression(L,$){let _=L.split("||");return g.create(_.map(F=>this._deserializeAndExpression(F,$)),null,!0)}static _deserializeAndExpression(L,$){let _=L.split("&&");return u.create(_.map(F=>this._deserializeOne(F,$)),null)}static _deserializeOne(L,$){if(L=L.trim(),L.indexOf("!=")>=0){let _=L.split("!=");return w.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("==")>=0){let _=L.split("==");return E.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("=~")>=0){let _=L.split("=~");return t.create(_[0].trim(),this._deserializeRegexValue(_[1],$))}if(L.indexOf(" in ")>=0){let _=L.split(" in ");return v.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const _=L.split(">=");return r.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const _=L.split(">");return l.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const _=L.split("<=");return n.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const _=L.split("<");return o.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(L)?f.create(L.substr(1).trim()):h.create(L)}static _deserializeValue(L,$){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;let _=/^'([^']*)'$/.exec(L);return _?_[1].trim():L}static _deserializeRegexValue(L,$){if((0,A.isFalsyOrWhitespace)(L)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=L.indexOf("/"),F=L.lastIndexOf("/");if(_===F||_<0){if($)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}let B=L.slice(_+1,F),Z=L[F+1]==="i"?"i":"";try{return new RegExp(B,Z)}catch(H){if($)throw new Error(`bad regexp-value '${L}', parse error: ${H}`);return console.warn(`bad regexp-value '${L}', parse error: ${H}`),null}}}e.ContextKeyExpr=b;function I(q,L){const $=q?q.substituteConstants():void 0,_=L?L.substituteConstants():void 0;return!$&&!_?!0:!$||!_?!1:$.equals(_)}e.expressionsAreEqualWithConstantSubstitution=I;function C(q,L){return q.cmp(L)}class d{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class p{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(L,$){this.key=L,this.negated=$,this.type=2}static create(L,$=null){const _=i.get(L);return typeof _=="boolean"?_?p.INSTANCE:d.INSTANCE:new h(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:k(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=i.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:d.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class E{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=4}static create(L,$,_=null){if(typeof $=="boolean")return $?h.create(L,_):f.create(L,_);const F=i.get(L);return typeof F=="boolean"?$===(F?"true":"false")?p.INSTANCE:d.INSTANCE:new E(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=i.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?p.INSTANCE:d.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=E;class v{constructor(L,$){this.key=L,this.valueKey=$,this.type=10,this.negated=null}static create(L,$){return new v(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.valueKey),_=L.getValue(this.key);return Array.isArray($)?$.indexOf(_)>=0:typeof _=="string"&&typeof $=="object"&&$!==null?P.call($,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=v;class m{constructor(L){this._actual=L,this.type=11}static create(L){return new m(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new m(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class w{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=5}static create(L,$,_=null){if(typeof $=="boolean")return $?f.create(L,_):h.create(L,_);const F=i.get(L);return typeof F=="boolean"?$===(F?"true":"false")?d.INSTANCE:p.INSTANCE:new w(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=i.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?d.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class f{constructor(L,$){this.key=L,this.negated=$,this.type=3}static create(L,$=null){const _=i.get(L);return typeof _=="boolean"?_?d.INSTANCE:p.INSTANCE:new f(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:k(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=i.get(this.key);return typeof L=="boolean"?L?d.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function c(q,L){if(typeof q=="string"){const $=parseFloat(q);isNaN($)||(q=$)}return typeof q=="string"||typeof q=="number"?L(q):d.INSTANCE}class l{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=12}static create(L,$,_=null){return c($,F=>new l(L,F,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=13}static create(L,$,_=null){return c($,F=>new r(L,F,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class o{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=14}static create(L,$,_=null){return c($,F=>new o(L,F,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class n{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=15}static create(L,$,_=null){return c($,F=>new n(L,F,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(L,$){this.key=L,this.regexp=$,this.type=7,this.negated=null}static create(L,$){return new t(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return $<_?-1:$>_?1:0}equals(L){if(L.type===this.type){const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return this.key===L.key&&$===_}return!1}substituteConstants(){return this}evaluate(L){let $=L.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(L){this._actual=L,this.type=8}static create(L){return new s(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new s(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function a(q){let L=null;for(let $=0,_=q.length;$<_;$++){const F=q[$].substituteConstants();if(q[$]!==F&&L===null){L=[];for(let B=0;B<$;B++)L[B]=q[B]}L!==null&&(L[$]=F)}return L===null?q:L}class u{constructor(L,$){this.expr=L,this.negated=$,this.type=6}static create(L,$){return u._normalizeArr(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const F=C(this.expr[$],L.expr[$]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:u.create(L,this.negated)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].evaluate(L))return!1;return!0}static _normalizeArr(L,$){const _=[];let F=!1;for(const B of L)if(!!B){if(B.type===1){F=!0;continue}if(B.type===0)return d.INSTANCE;if(B.type===6){_.push(...B.expr);continue}_.push(B)}if(_.length===0&&F)return p.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(C);for(let B=1;B<_.length;B++)_[B-1].equals(_[B])&&(_.splice(B,1),B--);if(_.length===1)return _[0];for(;_.length>1;){const B=_[_.length-1];if(B.type!==9)break;_.pop();const Z=_.pop(),H=_.length===0,j=g.create(B.expr.map(Q=>u.create([Q,Z],null)),null,H);j&&(_.push(j),_.sort(C))}return _.length===1?_[0]:new u(_,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new u(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){const L=[];for(let $ of this.expr)L.push($.negate());this.negated=g.create(L,this,!0)}return this.negated}}class g{constructor(L,$){this.expr=L,this.negated=$,this.type=9}static create(L,$,_){return g._normalizeArr(L,$,_)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const F=C(this.expr[$],L.expr[$]);if(F!==0)return F}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:g.create(L,this.negated,!1)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(this.expr[$].evaluate(L))return!0;return!1}static _normalizeArr(L,$,_){let F=[],B=!1;if(L){for(let Z=0,H=L.length;Z<H;Z++){const j=L[Z];if(!!j){if(j.type===0){B=!0;continue}if(j.type===1)return p.INSTANCE;if(j.type===9){F=F.concat(j.expr);continue}F.push(j)}}if(F.length===0&&B)return d.INSTANCE;F.sort(C)}if(F.length!==0){if(F.length===1)return F[0];for(let Z=1;Z<F.length;Z++)F[Z-1].equals(F[Z])&&(F.splice(Z,1),Z--);if(F.length===1)return F[0];if(_){for(let Z=0;Z<F.length;Z++)for(let H=Z+1;H<F.length;H++)M(F[Z],F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0]}return new g(F,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new g(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){let L=[];for(let $ of this.expr)L.push($.negate());for(;L.length>1;){const $=L.shift(),_=L.shift(),F=[];for(const Z of W($))for(const H of W(_))F.push(u.create([Z,H],null));const B=L.length===0;L.unshift(g.create(F,null,B))}this.negated=L[0]}return this.negated}}class y extends h{constructor(L,$,_){super(L,null);this._defaultValue=$,typeof _=="object"?y._info.push({..._,key:L}):_!==!0&&y._info.push({key:L,description:_,type:$!=null?typeof $:void 0})}static all(){return y._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return E.create(this.key,L)}notEqualsTo(L){return w.create(this.key,L)}}e.RawContextKey=y,y._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function k(q,L){return q<L?-1:q>L?1:0}function O(q,L,$,_){return q<$?-1:q>$?1:L<_?-1:L>_?1:0}function M(q,L){if(L.type===6&&q.type!==9&&q.type!==6){for(const F of L.expr)if(q.equals(F))return!0}const $=q.negate(),_=W($).concat(W(L));_.sort(C);for(let F=0;F<_.length;F++){const Z=_[F].negate();for(let H=F+1;H<_.length;H++){const j=_[H];if(Z.equals(j))return!0}}return!1}e.implies=M;function W(q){return q.type===9?q.expr:[q]}}),define(te[78],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function A(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=A}),define(te[79],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,16,131,6]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var T;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));function i(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function S(f,c){switch(f){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function b(f,c){return c==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function I(f,c,l){return b(c,l)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===l?!0:C(l).includes(f)}e.isTargetPlatformCompatible=I;function C(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function d(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=d;var p;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var E;(function(f){f.Install="install",f.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(c,l){super(c);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,A.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,A.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var G=this&&this.__param||function(J,e){return function(D,A){e(D,A,J)}};define(te[161],ne([0,1,2,30]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(i){super();this.extensionManagementService=i,this._register(i),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=de([G(0,A.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(te[162],ne([0,1,3,2,28,7,110,30]),function(J,e,D,A,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(E,v){return T.URI.revive(v?v.transformIncoming(E):E)}function b(E,v){return v?v.transformOutgoingURI(E):E}function I(E,v){v=v||i.DefaultURITransformer;const m=E.manifest;return{...(0,i.transformAndReviveIncomingURIs)({...E,manifest:void 0},v),manifest:m}}function C(E,v){return v?(0,R.cloneAndChange)(E,m=>m instanceof T.URI?v.transformOutgoingURI(m):void 0):E}class d{constructor(v,m){this.service=v,this.getUriTransformer=m,this.onInstallExtension=D.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,m){const w=this.getUriTransformer(v);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,f=>f.map(c=>({...c,local:c.local?C(c.local,w):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,m,w){const f=this.getUriTransformer(v);switch(m){case"zip":return this.service.zip(I(w[0],f)).then(c=>b(c,f));case"unzip":return this.service.unzip(S(w[0],f));case"install":return this.service.install(S(w[0],f),w[1]);case"getManifest":return this.service.getManifest(S(w[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(I(w[0],f),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(w[0],f));case"getInstalled":return this.service.getInstalled(w[0]).then(c=>c.map(l=>C(l,f)));case"updateMetadata":return this.service.updateMetadata(I(w[0],f),w[1]).then(c=>C(c,f));case"updateExtensionScope":return this.service.updateExtensionScope(I(w[0],f),w[1]).then(c=>C(c,f));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class p extends A.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?T.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?I(w.local,null):w.local,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const m=await this.getTargetPlatform();return v.allTargetPlatforms.some(w=>(0,P.isTargetPlatformCompatible)(w,v.allTargetPlatforms,m))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(m=>T.URI.revive(m)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v,m){return Promise.resolve(this.channel.call("install",[v,m])).then(w=>I(w,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,m){return Promise.resolve(this.channel.call("installFromGallery",[v,m])).then(w=>I(w,null))}uninstall(v,m){return Promise.resolve(this.channel.call("uninstall",[v,m]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(m=>m.map(w=>I(w,null)))}updateMetadata(v,m){return Promise.resolve(this.channel.call("updateMetadata",[v,m])).then(w=>I(w,null))}updateExtensionScope(v,m){return Promise.resolve(this.channel.call("updateExtensionScope",[v,m])).then(w=>I(w,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(v){this.service=v}listen(v,m){throw new Error("Invalid listen")}call(v,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var A;(function(i){i[i.FILE=1]="FILE",i[i.WORKSPACE=2]="WORKSPACE",i[i.EXE=3]="EXE"})(A=e.RecommendationSource||(e.RecommendationSource={}));function R(i){switch(i){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var T;(function(i){i.Ignored="ignored",i.Cancelled="cancelled",i.TooMany="toomany",i.IncompatibleWindow="incompatibleWindow",i.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[14],ne([0,1,40,10,25,15,7,138,6]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function b(_){return _.create===!0}e.isFileOpenForWriteOptions=b;var I;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function(_){_[_.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var d;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=p;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function E(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function v(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=v;var m;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(F,B){super(F);this.code=B}}e.FileSystemProviderError=w;function f(_,F){const B=new w(_.toString(),F);return l(B,F),B}e.createFileSystemProviderError=f;function c(_){return _||f((0,P.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=c;function l(_,F){return _.name=F?`${F} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=l;function r(_){if(!_)return m.Unknown;if(_ instanceof w)return _.code;const F=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!F)return m.Unknown;switch(F[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=r;function o(_){if(_ instanceof g)return _.fileOperationResult;switch(r(_)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var n;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(F,B,Z){this.resource=F,this.operation=B,this.target=Z}isOperation(F){return this.operation===F}}e.FileOperationEvent=t;var s;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class a{constructor(F,B){this.added=void 0,this.updated=void 0,this.deleted=void 0;const Z=new Map;for(const H of F){const j=Z.get(H.type);j?j.push([H.resource,H]):Z.set(H.type,[[H.resource,H]])}for(const[H,j]of Z)switch(H){case 1:this.added=D.TernarySearchTree.forUris(()=>B),this.added.fill(j);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>B),this.updated.fill(j);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>B),this.deleted.fill(j);break}}contains(F,...B){return this.doContains(F,{includeChildren:!1},...B)}affects(F,...B){return this.doContains(F,{includeChildren:!0},...B)}doContains(F,B,...Z){if(!F)return!1;const H=Z.length>0;return!!((!H||Z.includes(1))&&(this.added?.get(F)||B.includeChildren&&this.added?.findSuperstr(F))||(!H||Z.includes(0))&&(this.updated?.get(F)||B.includeChildren&&this.updated?.findSuperstr(F))||(!H||Z.includes(2))&&(this.deleted?.findSubstr(F)||B.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=a;function u(_,F,B){return!_||!F||_===F||F.length>_.length?!1:(F.charAt(F.length-1)!==A.sep&&(F+=A.sep),B?(0,R.startsWithIgnoreCase)(_,F):_.indexOf(F)===0)}e.isParent=u;class g extends Error{constructor(F,B,Z){super(F);this.fileOperationResult=B,this.options=Z}}e.FileOperationError=g;class y extends g{constructor(F,B,Z){super(F,2,Z);this.stat=B}}e.NotModifiedSinceFileOperationError=y;var k;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=M;async function W(_,F){if(!F.hasProvider(i.URI.from({scheme:_.scheme})))return new Promise(B=>{const Z=F.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===_.scheme&&H.added&&(Z.dispose(),B())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class q{static formatSize(F){return(0,T.isNumber)(F)||(F=0),F<q.KB?(0,P.localize)(1,null,F.toFixed(0)):F<q.MB?(0,P.localize)(2,null,(F/q.KB).toFixed(2)):F<q.GB?(0,P.localize)(3,null,(F/q.MB).toFixed(2)):F<q.TB?(0,P.localize)(4,null,(F/q.GB).toFixed(2)):(0,P.localize)(5,null,(F/q.TB).toFixed(2))}}e.ByteSize=q,q.KB=1024,q.MB=q.KB*q.KB,q.GB=q.MB*q.KB,q.TB=q.GB*q.KB;var L;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function $(_){return{maxFileSize:_===0?300*q.MB:16*q.GB,maxHeapSize:_===0?700*q.MB:2*700*q.MB}}e.getPlatformLimits=$}),define(te[163],ne([0,1,81,50,14]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}async checksum(P){const S=(await this.fileService.readFileStream(P)).value;return new Promise((b,I)=>{const C=(0,D.createHash)("md5");(0,A.listenStream)(S,{onData:d=>C.update(d.buffer),onError:d=>I(d),onEnd:()=>b(C.digest("base64").replace(/=+$/,""))})})}};T=de([G(0,R.IFileService)],T),e.ChecksumService=T}),define(te[164],ne([0,1,246,128,151,14]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function i(d,p){const h={onUnknownOption:v=>{console.warn((0,A.localize)(0,null,v))},onMultipleValues:(v,m)=>{console.warn((0,A.localize)(1,null,v,m))}},E=(0,R.parseArgs)(d,R.OPTIONS,p?h:void 0);return E.goto&&E._.forEach(v=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,A.localize)(2,null))),E["max-memory"]&&D(parseInt(E["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),E}function P(d){const p=d.findIndex(h=>!/^-/.test(h));if(p>-1)return[...d.slice(0,p),...d.slice(p+1)]}function S(d){let[,...p]=d;process.env.VSCODE_DEV&&(p=P(p)||[]);const h=!C(process.env);return i(p,h)}e.parseMainProcessArgv=S;function b(d){const[,,...p]=d;return i(p,!0)}e.parseCLIProcessArgv=b;function I(d,...p){const h=d.indexOf("--");return h===-1?d.push(...p):d.splice(h,0,...p),d}e.addArg=I;function C(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(te[165],ne([0,1,45,10,129,27,38,9,4,29,124,164,5]),function(J,e,D,A,R,T,i,P,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let h;async function E(m,w,f){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(f)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(f)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=d.Promises.withAsyncBody(async(c,l)=>{const r=new T.CancellationTokenSource,o=setTimeout(()=>{r.dispose(!0),l(new Error((0,R.localize)(0,null)))},p);try{c(await v(m,r.token))}catch(n){!(0,P.isPromiseCanceledError)(n)&&!r.token.isCancellationRequested?l(new Error((0,R.localize)(1,null,(0,i.toErrorMessage)(n)))):c({})}finally{clearTimeout(o),r.dispose()}})),h)}e.resolveShellEnv=E;async function v(m,w){const f=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",f);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",c);const l=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",o);const n=await(0,I.getSystemShell)(S.OS,o);return m.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(w.isCancellationRequested)return s((0,P.canceled)());const a=(0,A.basename)(n);let u,g;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(u=`& '${process.execPath}' ${y} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,g=["-Login","-Command"]):(u=`'${process.execPath}' ${y} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"?g=["-ic"]:g=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),u);const k=(0,D.spawn)(n,[...g,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});w.onCancellationRequested(()=>(k.kill(),s((0,P.canceled)()))),k.on("error",W=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(W)),s(W)});const O=[];k.stdout.on("data",W=>O.push(W));const M=[];k.stderr.on("data",W=>M.push(W)),k.on("close",(W,q)=>{const L=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",L);const $=Buffer.concat(M).toString("utf8");if($.trim()&&m.trace("getUnixShellEnvironment#stderr",$),W||q)return s(new Error((0,R.localize)(2,null,W,q)));const _=r.exec(L),F=_?_[1]:"{}";try{const B=JSON.parse(F);f?B.ELECTRON_RUN_AS_NODE=f:delete B.ELECTRON_RUN_AS_NODE,c?B.ELECTRON_NO_ATTACH_CONSOLE=c:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",B),t(B)}catch(B){m.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(B)),s(B)}})})}}),define(te[82],ne([0,1,19,9,139,14]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(I,C,d,p,h,E){let v;try{await P(I,C,d,p,h,E)}catch(m){v=m}finally{v&&h.errorTransformer&&(v=h.errorTransformer(v)),typeof v!="undefined"&&d.error(v),d.end()}}e.readFileIntoStream=i;async function P(I,C,d,p,h,E){S(E);const v=await I.open(C,{create:!1});try{S(E);let m=0,w=0,f=h&&typeof h.length=="number"?h.length:void 0,c=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,r=0;do w=await I.read(v,l,c.buffer,r,c.byteLength-r),l+=w,r+=w,m+=w,typeof f=="number"&&(f-=w),r===c.byteLength&&(await d.write(p(c)),c=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),r=0);while(w>0&&(typeof f!="number"||f>0)&&S(E)&&b(m,h));if(r>0){let o=r;typeof f=="number"&&(o=Math.min(r,f)),d.write(p(c.slice(0,o)))}}catch(m){throw(0,T.ensureFileSystemProviderError)(m)}finally{await I.close(v)}}function S(I){if(I.isCancellationRequested)throw(0,A.canceled)();return!0}function b(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[54],ne([0,1,2,4,7,14]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class i extends D.Disposable{constructor(d,p,h){super();this.onFileChanges=d,this.onLogMessage=p,this.verboseLogging=h,this.serviceDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new D.DisposableStore;this.serviceDisposables.value=d,this.service=this.createService(d),this.service.setVerboseLogging(this.verboseLogging),d.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),d.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),d.add(this.service.onDidError(p=>this.onError(p)))}onError(d){this.restartCounter<i.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.service?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=i,i.MAX_RESTARTS=5;class P extends D.Disposable{}e.WatcherService=P;function S(C){return C.map(d=>({type:d.type,resource:R.URI.file(d.path)}))}e.toFileChanges=S;function b(C){const d=new I;for(const p of C)d.processEvent(p);return d.coalesce()}e.coalesceEvents=b;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return A.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const p=this.mapPathToChange.get(this.toKey(d));let h=!1;if(p){const E=p.type,v=d.type;p.path!==d.path&&d.type===2?h=!0:E===1&&v===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(p)):E===2&&v===1?p.type=0:E===1&&v===0||(p.type=v)}else h=!0;h&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],p=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(d.push(h),!1):!0).sort((h,E)=>h.path.length-E.path.length).filter(h=>p.some(E=>(0,T.isParent)(h.path,E,!A.isLinux))?!1:(p.push(h.path),!0)).concat(d)}}}),define(te[166],ne([0,1,5,2,10,114,20,117,54]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends A.Disposable{constructor(C,d,p,h){super();this.path=C,this.onDidFilesChange=d,this.onLogMessage=p,this.verboseLogging=h,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:d}=await i.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(d)try{p=await(0,T.realpath)(p)}catch(h){if(this.onError(h),d.dangling)return}C.isDirectory()?this._register((0,P.watchFolder)(p,(h,E)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(E))})},h=>this.onError(h))):this._register((0,P.watchFile)(p,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,S.coalesceEvents)(d);if(this.verboseLogging)for(const h of p)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(te[167],ne([0,1,16,34,52,54]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends T.WatcherService{constructor(S,b,I){super();this.onDidFilesChange=S,this.onLogMessage=b,this.verboseLogging=I,this.isDisposed=!1,this.startWatching()}startWatching(){const S=this._register(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=A.ProxyChannel.toService((0,A.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b)))}async setVerboseLogging(S){this.verboseLogging=S,this.isDisposed||await this.service?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}async watch(S){this.isDisposed||await this.service?.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(te[168],ne([0,1,16,34,52,54]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends T.AbstractWatcherService{constructor(S,b,I){super(S,b,I);this.init()}createService(S){const b=S.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(b.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(b.getChannel("watcher")))}}e.FileWatcher=i}),define(te[83],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[T,i]of R)this.set(T,i)}set(R,T){const i=this._entries.get(R);return this._entries.set(R,T),i}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(te[169],ne([0,1,5,9,53,158,6,83]),function(J,e,D,A,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new P.ServiceCollection,E=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=E,this._parent=v,this._services.set(i.IInstantiationService,this)}createChild(h){return new I(h,this._strict,this)}invokeFunction(h,...E){let v=d.traceInvocation(h),m=!1;try{return h({get:f=>{if(m)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(f,v);if(!c)throw new Error(`[invokeFunction] unknown service '${f}'`);return c}},...E)}finally{m=!0,v.stop()}}createInstance(h,...E){let v,m;return h instanceof R.SyncDescriptor?(v=d.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(E),v)):(v=d.traceCreation(h),m=this._createInstance(h,E,v)),v.stop(),m}_createInstance(h,E=[],v){let m=i._util.getServiceDependencies(h).sort((c,l)=>c.index-l.index),w=[];for(const c of m){let l=this._getOrCreateServiceInstance(c.id,v);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);w.push(l)}let f=m.length>0?m[0].index:E.length;if(E.length!==f){console.warn(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${E.length} static arguments`);let c=f-E.length;c>0?E=E.concat(new Array(c)):E=E.slice(0,f)}return new h(...[...E,...w])}_setServiceInstance(h,E){if(this._services.get(h)instanceof R.SyncDescriptor)this._services.set(h,E);else if(this._parent)this._parent._setServiceInstance(h,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let E=this._services.get(h);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):E}_getOrCreateServiceInstance(h,E){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,E.branch(h,!0)):(E.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,E,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,E,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,E,v){const m=new T.Graph(c=>c.id.toString());let w=0;const f=[{id:h,desc:E,_trace:v}];for(;f.length;){const c=f.pop();if(m.lookupOrInsertNode(c),w++>1e3)throw new b(m);for(let l of i._util.getServiceDependencies(c.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),r instanceof R.SyncDescriptor){const o={id:l.id,desc:r,_trace:c._trace.branch(l.id,!0)};m.insertEdge(c,o),f.push(o)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new b(m);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof R.SyncDescriptor){const o=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,o)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,E,v=[],m,w){if(this._services.get(h)instanceof R.SyncDescriptor)return this._createServiceInstance(E,v,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,E,v,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(h,E=[],v,m){if(v){const w=new D.IdleValue(()=>this._createInstance(h,E,m));return new Proxy(Object.create(null),{get(f,c){if(c in f)return f[c];let l=w.value,r=l[c];return typeof r!="function"||(r=r.bind(l),f[c]=r),r},set(f,c,l){return w.value[c]=l,!0}})}else return this._createInstance(h,E,m)}}e.InstantiationService=I;var C;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(C||(C={}));class d{constructor(h,E){this.type=h,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return S?new d(0,h.name):d._None}branch(h,E){let v=new d(2,h.toString());return this._dep.push([h,E,v]),v}stop(){let h=Date.now()-this._start;d._totals+=h;let E=!1;function v(w,f){let c=[],l=new Array(w+1).join("	");for(const[r,o,n]of f._dep)if(o&&n){E=!0,c.push(`${l}CREATES -> ${r}`);let t=v(w+1,n);t&&c.push(t)}else c.push(`${l}uses -> ${r}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||E)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(te[170],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,T){this.server=R,this.router=T}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,T){this.server.registerChannel(R,T)}}e.MessagePortMainProcessService=D}),define(te[171],ne([0,1,34,53,77,6]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class i{constructor(p,h,E){const v=E.getChannel(p);return P(h)?new h.channelClientCtor(v):D.ProxyChannel.toService(v,h?.proxyOptions)}}function P(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let S=class extends i{constructor(p,h,E){super(p,h,E)}};S=de([G(2,e.IMainProcessService)],S);function b(d,p,h){(0,R.registerSingleton)(d,new A.SyncDescriptor(S,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let I=class extends i{constructor(p,h,E){super(p,h,E)}};I=de([G(2,e.ISharedProcessService)],I);function C(d,p,h){(0,R.registerSingleton)(d,new A.SyncDescriptor(I,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(te[59],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function A(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const T of R.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=A}),define(te[172],ne([0,1,2,59]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(i){super();this.localizationsService=i,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=de([G(0,A.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(te[8],ne([0,1,38,3,2,4,6]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function P(){return new Date().toISOString()}var S;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function b(o,n,t){switch(n){case S.Trace:o.trace(t);break;case S.Debug:o.debug(t);break;case S.Info:o.info(t);break;case S.Warning:o.warn(t);break;case S.Error:o.error(t);break;case S.Critical:o.critical(t);break;default:throw new Error("Invalid log level")}}e.log=b;function I(o){let n="";for(let t=0;t<o.length;t++){let s=o[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}n+=(t>0?" ":"")+s}return n}e.format=I;class C extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class d extends C{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(S.Trace)&&this.log(S.Trace,I([n,...t]))}debug(n,...t){this.checkLogLevel(S.Debug)&&this.log(S.Debug,I([n,...t]))}info(n,...t){this.checkLogLevel(S.Info)&&this.log(S.Info,I([n,...t]))}warn(n,...t){this.checkLogLevel(S.Warning)&&this.log(S.Warning,I([n,...t]))}error(n,...t){if(this.checkLogLevel(S.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(S.Error,I(s))}else this.log(S.Error,I([n,...t]))}critical(n,...t){this.checkLogLevel(S.Critical)&&this.log(S.Critical,I([n,...t]))}flush(){}}e.AbstractMessageLogger=d;class p extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!T.isWindows}trace(n,...t){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}debug(n,...t){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}info(n,...t){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}warn(n,...t){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,n,...t):console.warn(`[main ${P()}]`,n,...t))}error(n,...t){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,n,...t):console.error(`[main ${P()}]`,n,...t))}critical(n,...t){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,n,...t):console.error(`[main ${P()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class E extends C{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,D.toErrorMessage)(n,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class v extends C{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class m extends R.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=m;class w extends R.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?S.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class f{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(n){}getLevel(){return S.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=f;function c(o){if(o.verbose)return S.Trace;if(typeof o.logLevel=="string"){const n=l(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function l(o){switch(o){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function r(o){switch(o){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=r}),define(te[173],ne([0,1,5,9,2,10,20,11,8]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends R.Disposable{constructor(C,d){super();this.environmentService=C,this.logService=d,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsPath),d=(0,T.dirname)(this.environmentService.logsPath),E=(await i.Promises.readdir(d)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==C),v=E.slice(0,Math.max(0,E.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(m=>i.Promises.rm((0,T.join)(d,m)))))}catch(C){(0,A.onUnexpectedError)(C)}}};b=de([G(0,P.IEnvironmentService),G(1,S.ILogService)],b),e.LogsDataCleaner=b}),define(te[174],ne([0,1,5,9,2,10,20,11,8]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class gt extends R.Disposable{constructor(C,d,p){super();this.backupWorkspacesPath=C,this.environmentService=d,this.logService=p,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const C=await i.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(C).emptyWorkspaceInfos.map(E=>E.backupFolder),h=await i.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async E=>{E.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||E===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(E)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${E}.`),await i.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,E)))}))}catch(C){(0,A.onUnexpectedError)(C)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",b=de([G(1,P.INativeEnvironmentService),G(2,S.ILogService)],b),e.StorageDataCleaner=b}),define(te[84],ne([0,1,5,19,31,39,11,14,6,8]),function(J,e,D,A,R,T,i,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var I;(function(d){d.ERROR_INVALID_FILE="ERROR_INVALID_FILE",d.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(I=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,S.createDecorator)(e.UserConfigurationFileServiceId);let C=class{constructor(p,h,E){this.environmentService=p,this.fileService=h,this.logService=E,this.queue=new D.Queue}async updateSettings(p,h){return this.queue.queue(()=>this.doWrite(p,h))}async doWrite(p,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:E,mtime:v,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let w=E.toString();const f=[];if((0,R.parse)(w,f,{allowTrailingComma:!0,allowEmptyContent:!0}),f.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(p,w,h)[0];if(c){w=w.substring(0,c.offset)+c.content+w.substring(c.offset+c.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,A.VSBuffer.fromString(w),{etag:m,mtime:v})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,h)})}getEdits({value:p,path:h},E,v){return h.length?(0,T.setProperty)(E,h,p,v):[{content:JSON.stringify(p,null,v.insertSpaces&&v.tabSize?" ".repeat(v.tabSize):"	"),length:E.length,offset:0}]}};C=de([G(0,i.IEnvironmentService),G(1,P.IFileService),G(2,b.ILogService)],C),e.UserConfigurationFileService=C}),define(te[175],ne([0,1,45,5,38,3,2,16,10,20,11,8]),function(J,e,D,A,R,T,i,P,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends i.Disposable{constructor(h,E){super();this.environmentService=h,this.logService=E,this.processesLimiter=new A.Limiter(5)}async postUninstall(h){const E=this.parseScript(h,"uninstall");return E&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${v}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(h,E){const v=`vscode:${E}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[v]=="string"){const m=h.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${v} should be a node script`),null):{script:(0,S.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,E,v,m,w){return new Promise((f,c)=>{const l=this.start(h,E,v,w);let r;const o=n=>{r&&(clearTimeout(r),r=null),n?c(n):f(void 0)};l.on("error",n=>{o((0,R.toErrorMessage)(n)||"Unknown")}),l.on("exit",(n,t)=>{o(n?`post-${E} process exited with code ${n}`:void 0)}),m&&(r=setTimeout(()=>{r=null,l.kill(),c("timed out")},5e3))})}start(h,E,v,m){const w={silent:!0,execArgv:void 0},f=(0,D.fork)(h,[`--type=extension-post-${E}`,...v],w);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const c=T.Event.fromNodeEventEmitter(f.stdout,"data"),l=T.Event.fromNodeEventEmitter(f.stderr,"data");c(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${E}`,n)),l(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${E}`,n));const r=T.Event.any(T.Event.map(c,n=>({data:`%c${n}`,format:[""]})),T.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return T.Event.debounce(r,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(h){return(0,S.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=de([G(0,I.IEnvironmentService),G(1,C.ILogService)],d),e.ExtensionsLifecycle=d}),define(te[176],ne([0,1,17,5,9,3,2,10,54,8]),function(J,e,D,A,R,T,i,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends i.Disposable{constructor(d){super();this.logService=d,this._onDidErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new A.ThrottledDelayer(0))}watch(d,p){return p.recursive?this.watchRecursive(d,p):this.watchNonRecursive(d)}watchRecursive(d,p){const h={path:this.toFilePath(d),excludes:p.excludes},E=(0,D.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,i.toDisposable)(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,R.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,S.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,p){return d.watch(p)}watchNonRecursive(d){const p=this.createNonRecursiveWatcher(this.toFilePath(d),E=>this._onDidChangeFile.fire((0,S.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===b.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,i.combinedDisposable)(p,h)}onWatcherLogMessage(d){d.type==="error"&&this._onDidErrorOccur.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,P.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[177],ne([0,1,17,5,19,27,3,56,2,40,16,178,18,50,137,14,82,8]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class Ke extends S.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new i.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new i.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new i.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new i.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new i.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new i.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new A.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new E.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new A.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new E.FileChangesEvent(l,!0)))),this.watchedResources=b.TernarySearchTree.forUris(l=>{const r=this.getProvider(l.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new A.ResourceQueue)}registerProvider(c,l){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:l});const r=new S.DisposableStore;return r.add(l.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(l)))),r.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:c}))),typeof l.onDidErrorOccur=="function"&&r.add(l.onDidErrorOccur(o=>this._onError.fire(new Error(o)))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:l}),this.provider.delete(c),(0,S.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){l.push(r)}}),!this.provider.has(c)&&await A.Promises.settled(l)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,l){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return P.Iterable.map(this.provider,([c,l])=>({scheme:c,capabilities:l.capabilities}))}async withProvider(c){if(!(0,d.isAbsolutePath)(c))throw new E.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const l=this.provider.get(c.scheme);if(!l){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,c.toString()),r}return l}async withReadProvider(c){const l=await this.withProvider(c);if((0,E.hasOpenReadWriteCloseCapability)(l)||(0,E.hasReadWriteCapability)(l)||(0,E.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const l=await this.withProvider(c);if((0,E.hasOpenReadWriteCloseCapability)(l)||(0,E.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,l){try{return await this.doResolveFile(c,l)}catch(r){throw(0,E.toFileSystemProviderErrorCode)(r)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,E.ensureFileSystemProviderError)(r)}}async doResolveFile(c,l){const r=await this.withProvider(c),o=this.isPathCaseSensitive(r),n=l?.resolveTo,t=l?.resolveSingleChildDescendants,s=l?.resolveMetadata,a=await r.stat(c);let u;return this.toFileStat(r,c,a,void 0,!!s,(g,y)=>(u||(u=b.TernarySearchTree.forUris(()=>!o),u.set(c,!0),n&&u.fill(!0,n)),u.get(g.resource)||u.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&t?y===1:!1))}async toFileStat(c,l,r,o,n,t){const{providerExtUri:s}=this.getExtUri(c),a={resource:l,name:s.basename(l),isFile:(r.type&E.FileType.File)!=0,isDirectory:(r.type&E.FileType.Directory)!=0,isSymbolicLink:(r.type&E.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&E.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,E.etag)({mtime:r.mtime,size:r.size})};if(a.isDirectory&&t(a,o)){try{const u=await c.readdir(l),g=await A.Promises.settled(u.map(async([y,k])=>{try{const O=s.joinPath(l,y),M=n?await c.stat(O):{type:k};return await this.toFileStat(c,O,M,u.length,n,t)}catch(O){return this.logService.trace(O),null}}));a.children=(0,D.coalesce)(g)}catch(u){this.logService.trace(u),a.children=[]}return a}return a}async resolveAll(c){return A.Promises.settled(c.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(c){const l=await this.withProvider(c);try{return!!await l.stat(c)}catch(r){return!1}}async canCreateFile(c,l){try{await this.doValidateCreateFile(c,l)}catch(r){return r}return!0}async doValidateCreateFile(c,l){if(!l?.overwrite&&await this.exists(c))throw new E.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,l)}async createFile(c,l=R.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const o=await this.writeFile(c,l);return this._onDidRunOperation.fire(new E.FileOperationEvent(c,0,o)),o}async writeFile(c,l,r){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(o);try{await this.validateWriteFile(o,c,r)||await this.mkdirp(o,n.dirname(c));let s;if((0,E.hasReadWriteCapability)(o)&&!(l instanceof R.VSBuffer))if((0,p.isReadableStream)(l)){const a=await(0,p.peekStream)(l,3);a.ended?s=R.VSBuffer.concat(a.buffer):s=a}else s=(0,p.peekReadable)(l,a=>R.VSBuffer.concat(a),3);else s=l;!(0,E.hasOpenReadWriteCloseCapability)(o)||(0,E.hasReadWriteCapability)(o)&&s instanceof R.VSBuffer?await this.doWriteUnbuffered(o,c,r,s):await this.doWriteBuffered(o,c,r,s instanceof R.VSBuffer?(0,R.bufferToReadable)(s):s)}catch(t){throw new E.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,E.ensureFileSystemProviderError)(t).toString()),(0,E.toFileOperationResult)(t),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,l,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(l)));let n;try{n=await c.stat(l)}catch(t){return}if((n.type&E.FileType.Directory)!=0)throw new E.FileOperationError((0,h.localize)(6,null,this.resourceForError(l)),0,r);if(this.throwIfFileIsReadonly(l,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==E.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,E.etag)({mtime:r.mtime,size:n.size}))throw new E.FileOperationError((0,h.localize)(7,null),3,r);return n}async readFile(c,l){const r=await this.withReadProvider(c);return l?.atomic?this.doReadFileAtomic(r,c,l):this.doReadFile(r,c,l)}async doReadFileAtomic(c,l,r){return new Promise((o,n)=>{this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(c,l,r);o(t)}catch(t){n(t)}})})}async doReadFile(c,l,r){const o=await this.doReadFileStream(c,l,{...r,preferUnbuffered:!0});return{...o,value:await(0,R.streamToBuffer)(o.value)}}async readFileStream(c,l){const r=await this.withReadProvider(c);return this.doReadFileStream(r,c,l)}async doReadFileStream(c,l,r){const o=new T.CancellationTokenSource,n=this.validateReadFile(l,r).then(s=>s,s=>{throw o.cancel(),s});let t;try{return typeof r?.etag=="string"&&r.etag!==E.ETAG_DISABLED&&await n,!((0,E.hasOpenReadWriteCloseCapability)(c)||(0,E.hasFileReadStreamCapability)(c))||(0,E.hasReadWriteCapability)(c)&&r?.preferUnbuffered?t=this.readFileUnbuffered(c,l,r):(0,E.hasFileReadStreamCapability)(c)?t=this.readFileStreamed(c,l,o.token,r):t=this.readFileBuffered(c,l,o.token,r),{...await n,value:t}}catch(s){t&&await(0,p.consumeStream)(t);const a=(0,h.localize)(8,null,this.resourceForError(l),(0,E.ensureFileSystemProviderError)(s).toString());throw s instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(a,s.stat,r):new E.FileOperationError(a,(0,E.toFileOperationResult)(s),r)}}readFileStreamed(c,l,r,o=Object.create(null)){const n=c.readFileStream(l,o,r);return(0,p.transform)(n,{data:t=>t instanceof R.VSBuffer?t:R.VSBuffer.wrap(t),error:t=>new E.FileOperationError((0,h.localize)(9,null,this.resourceForError(l),(0,E.ensureFileSystemProviderError)(t).toString()),(0,E.toFileOperationResult)(t),o)},t=>R.VSBuffer.concat(t))}readFileBuffered(c,l,r,o=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,l,n,t=>t,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new E.FileOperationError((0,h.localize)(10,null,this.resourceForError(l),(0,E.ensureFileSystemProviderError)(t).toString()),(0,E.toFileOperationResult)(t),o)},r),n}readFileUnbuffered(c,l,r){const o=(0,p.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await c.readFile(l);typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(l,n.byteLength,r),o.end(R.VSBuffer.wrap(n))}catch(n){o.error(n),o.end()}})(),o}async validateReadFile(c,l){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new E.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,l);if(typeof l?.etag=="string"&&l.etag!==E.ETAG_DISABLED&&l.etag===r.etag)throw new E.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,l);return this.validateReadFileLimits(c,r.size,l),r}validateReadFileLimits(c,l,r){if(r?.limits){let o;if(typeof r.limits.memory=="number"&&l>r.limits.memory&&(o=9),typeof r.limits.size=="number"&&l>r.limits.size&&(o=7),typeof o=="number")throw new E.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),o)}}async canMove(c,l,r){return this.doCanMoveCopy(c,l,"move",r)}async canCopy(c,l,r){return this.doCanMoveCopy(c,l,"copy",r)}async doCanMoveCopy(c,l,r,o){if(c.toString()!==l.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,c,t,l,r,o)}catch(n){return n}return!0}async move(c,l,r){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(o,c,n,l,"move",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(c,t==="move"?2:3,s)),s}async copy(c,l,r){const o=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(o,c,n,l,"copy",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(c,t==="copy"?3:2,s)),s}async doMoveCopy(c,l,r,o,n,t){if(l.toString()===o.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,l,r,o,n,t);if(s&&!a&&t&&await this.del(o,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(o)),n==="copy"){if(c===r&&(0,E.hasFileFolderCopyCapability)(c))await c.copy(l,o,{overwrite:t});else{const u=await this.resolve(l);u.isDirectory?await this.doCopyFolder(c,u,r,o):await this.doCopyFile(c,l,r,o)}return n}else return c===r?(await c.rename(l,o,{overwrite:t}),n):(await this.doMoveCopy(c,l,r,o,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(c,l,r,o){if((0,E.hasOpenReadWriteCloseCapability)(c)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,l,r,o);if((0,E.hasOpenReadWriteCloseCapability)(c)&&(0,E.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,l,r,o);if((0,E.hasReadWriteCapability)(c)&&(0,E.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,l,r,o);if((0,E.hasReadWriteCapability)(c)&&(0,E.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,l,r,o)}async doCopyFolder(c,l,r,o){await r.mkdir(o),Array.isArray(l.children)&&await A.Promises.settled(l.children.map(async n=>{const t=this.getExtUri(r).providerExtUri.joinPath(o,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),r,t):this.doCopyFile(c,n.resource,r,t)}))}async doValidateMoveCopy(c,l,r,o,n,t){let s=!1;if(c===r){const{providerExtUri:u,isPathCaseSensitive:g}=this.getExtUri(c);if(g||(s=u.isEqual(l,o)),s&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(l),this.resourceForError(o)));if(!s&&u.isEqualOrParent(o,l))throw new Error((0,h.localize)(15,null,this.resourceForError(l),this.resourceForError(o)))}const a=await this.exists(o);if(a&&!s){if(!t)throw new E.FileOperationError((0,h.localize)(16,null,this.resourceForError(l),this.resourceForError(o)),4);if(c===r){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(l,o))throw new Error((0,h.localize)(17,null,this.resourceForError(l),this.resourceForError(o)))}}return{exists:a,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const l=this.isPathCaseSensitive(c);return{providerExtUri:l?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(l,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(c,0,r)),r}async mkdirp(c,l){const r=[],{providerExtUri:o}=this.getExtUri(c);for(;!o.isEqual(l,o.dirname(l));)try{if(((await c.stat(l)).type&E.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(l)));break}catch(n){if((0,E.toFileSystemProviderErrorCode)(n)!==E.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(o.basename(l)),l=o.dirname(l)}for(let n=r.length-1;n>=0;n--){l=o.joinPath(l,r[n]);try{await c.mkdir(l)}catch(t){if((0,E.toFileSystemProviderErrorCode)(t)!==E.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(c,l){try{await this.doValidateDelete(c,l)}catch(r){return r}return!0}async doValidateDelete(c,l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!l?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let n;try{n=await r.stat(c)}catch(s){}if(n)this.throwIfFileIsReadonly(c,n);else throw new E.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!l?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return r}async del(c,l){const r=await this.doValidateDelete(c,l),o=!!l?.useTrash,n=!!l?.recursive;await r.delete(c,{recursive:n,useTrash:o}),this._onDidRunOperation.fire(new E.FileOperationEvent(c,1))}onDidChangeFile(c,l){this._onDidChangeFilesRaw.fire({changes:c});let r,o;{for(const n of c)this.watchedResources.has(n.resource)?(r||(r=[]),r.push(n)):(o||(o=[]),o.push(n));r&&this._onDidFilesChange.fire(new E.FileChangesEvent(r,!l))}if(o){const n=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(o)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,l={recursive:!1,excludes:[]}){const r=new S.DisposableStore;let o=!1,n=()=>{o=!0};return r.add((0,S.toDisposable)(()=>n())),this.doWatch(c,l).then(t=>{o?(0,S.dispose)(t):n=()=>(0,S.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),r.add((0,S.toDisposable)(()=>{const t=this.watchedResources.get(c);typeof t=="number"&&(t<=1?this.watchedResources.delete(c):this.watchedResources.set(c,t-1))}))),r}async doWatch(c,l){const r=await this.withProvider(c),o=this.toWatchKey(r,c,l);let n=this.activeWatchers.get(o);return n||(n={count:0,disposable:r.watch(c,l)},this.activeWatchers.set(o,n)),n.count+=1,(0,S.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,S.dispose)(n.disposable),this.activeWatchers.delete(o)))})}toWatchKey(c,l,r){const{providerExtUri:o}=this.getExtUri(c);return[o.getComparisonKey(l),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,S.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,l,r,o){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(o)||(0,p.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(c,n,o):await this.doWriteReadableBufferedQueued(c,n,o)}catch(t){throw(0,E.ensureFileSystemProviderError)(t)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,l,r){let o=0,n;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=R.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,l,t,t.byteLength,o,0),o+=t.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((t,s)=>{(0,p.listenStream)(n,{onData:async a=>{n.pause();try{await this.doWriteBuffer(c,l,a,a.byteLength,o,0)}catch(u){return s(u)}o+=a.byteLength,setTimeout(()=>n.resume())},onError:a=>s(a),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(c,l,r){let o=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(c,l,n,n.byteLength,o,0),o+=n.byteLength}async doWriteBuffer(c,l,r,o,n,t){let s=0;for(;s<o;)s+=await c.write(l,n+s,r.buffer,t+s,o-s)}async doWriteUnbuffered(c,l,r,o){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,l,r,o))}async doWriteUnbufferedQueued(c,l,r,o){let n;o instanceof R.VSBuffer?n=o:(0,p.isReadableStream)(o)?n=await(0,R.streamToBuffer)(o):(0,p.isReadableBufferedStream)(o)?n=await(0,R.bufferedStreamToBuffer)(o):n=(0,R.readableToBuffer)(o),await c.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,l,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,l,r,o))}async doPipeBufferedQueued(c,l,r,o){let n,t;try{n=await c.open(l,{create:!1}),t=await r.open(o,{create:!0,unlock:!1});const s=R.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,u=0,g=0;do g=await c.read(n,a,s.buffer,u,s.byteLength-u),await this.doWriteBuffer(r,t,s,g,a,u),a+=g,u+=g,u===s.byteLength&&(u=0);while(g>0)}catch(s){throw(0,E.ensureFileSystemProviderError)(s)}finally{await A.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(c,l,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,l,r,o))}async doPipeUnbufferedQueued(c,l,r,o){return r.writeFile(o,await c.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,l,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,l,r,o))}async doPipeUnbufferedToBufferedQueued(c,l,r,o){const n=await r.open(o,{create:!0,unlock:!1});try{const t=await c.readFile(l);await this.doWriteBuffer(r,n,R.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,E.ensureFileSystemProviderError)(t)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(c,l,r,o){const n=await(0,R.streamToBuffer)(this.readFileBuffered(c,l,T.CancellationToken.None));await this.doWriteUnbuffered(r,o,void 0,n)}throwIfFileSystemIsReadonly(c,l){if(c.capabilities&2048)throw new E.FileOperationError((0,h.localize)(22,null,this.resourceForError(l)),6);return c}throwIfFileIsReadonly(c,l){if((l.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===I.Schemas.file?c.fsPath:c.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=de([G(0,m.ILogService)],w),e.FileService=w}),define(te[179],ne([0,1,51,247,5,19,3,41,10,4,18,50,20,140,14,82,166,167,168,176,38]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(r)}`)}})();class l extends f.AbstractDiskFileSystemProvider{constructor(o,n){super(o);this.options=n,this.onDidChangeCapabilities=i.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(o){try{const{stat:n,symbolicLink:t}=await d.SymlinkSupport.stat(this.toFilePath(o));return{type:this.toType(n,t),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(o){try{const n=await d.Promises.readdir(this.toFilePath(o),{withFileTypes:!0}),t=[];return await Promise.all(n.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,I.joinPath)(o,s.name))).type:a=this.toType(s),t.push([s.name,a])}catch(a){this.logService.trace(a)}})),t}catch(n){throw this.toFileSystemProviderError(n)}}toType(o,n){let t;return n?.dangling?t=h.FileType.Unknown:o.isFile()?t=h.FileType.File:o.isDirectory()?t=h.FileType.Directory:t=h.FileType.Unknown,n&&(t|=h.FileType.SymbolicLink),t}async readFile(o){try{const n=this.toFilePath(o);return await d.Promises.readFile(n)}catch(n){throw this.toFileSystemProviderError(n)}}readFileStream(o,n,t){const s=(0,C.newWriteableStream)(a=>T.VSBuffer.concat(a.map(u=>T.VSBuffer.wrap(u))).buffer);return(0,E.readFileIntoStream)(this,o,s,a=>a.buffer,{...n,bufferSize:256*1024},t),s}async writeFile(o,n,t){let s;try{const a=this.toFilePath(o);if(!t.create||!t.overwrite){if(await d.Promises.exists(a)){if(!t.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(o,{create:!0,unlock:t.unlock}),await this.write(s,0,n,0,n.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(o,a)}finally{typeof s=="number"&&await this.close(s)}}async open(o,n){try{const t=this.toFilePath(o);if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:u}=await d.SymlinkSupport.stat(t);u.mode&128||await d.Promises.chmod(t,u.mode|128)}catch(u){this.logService.trace(u)}let s;if((0,h.isFileOpenForWriteOptions)(n)){if(b.isWindows)try{await d.Promises.truncate(t,0),s="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}s||(s="w")}else s="r";const a=await d.Promises.open(t,s);return this.mapHandleToPos.set(a,0),(0,h.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(a,o),a}catch(t){throw(0,h.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(o,t):this.toFileSystemProviderError(t)}}async close(o){try{if(this.mapHandleToPos.delete(o),this.writeHandles.delete(o)&&this.canFlush)try{await d.Promises.fdatasync(o)}catch(n){this.canFlush=!1,this.logService.error(n)}return await d.Promises.close(o)}catch(n){throw this.toFileSystemProviderError(n)}}async read(o,n,t,s,a){const u=this.normalizePos(o,n);let g=null;try{const y=await d.Promises.read(o,t,s,a,u);return typeof y=="number"?g=y:g=y.bytesRead,g}catch(y){throw this.toFileSystemProviderError(y)}finally{this.updatePos(o,u,g)}}normalizePos(o,n){return n===this.mapHandleToPos.get(o)?null:n}updatePos(o,n,t){const s=this.mapHandleToPos.get(o);typeof s=="number"&&(typeof n=="number"||(typeof t=="number"?this.mapHandleToPos.set(o,s+t):this.mapHandleToPos.delete(o)))}async write(o,n,t,s,a){return(0,R.retry)(()=>this.doWrite(o,n,t,s,a),100,3)}async doWrite(o,n,t,s,a){const u=this.normalizePos(o,n);let g=null;try{const y=await d.Promises.write(o,t,s,a,u);return typeof y=="number"?g=y:g=y.bytesWritten,g}catch(y){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(o),y)}finally{this.updatePos(o,u,g)}}async mkdir(o){try{await d.Promises.mkdir(this.toFilePath(o))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(o,n){try{const t=this.toFilePath(o);await this.doDelete(t,n)}catch(t){throw this.toFileSystemProviderError(t)}}async doDelete(o,n){n.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}async rename(o,n,t){const s=this.toFilePath(o),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(o,n,"move",t.overwrite),await d.Promises.move(s,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(2,null,(0,S.basename)(s),(0,S.basename)((0,S.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(o,n,t){const s=this.toFilePath(o),a=this.toFilePath(n);if(s!==a)try{await this.validateTargetDeleted(o,n,"copy",t.overwrite),await d.Promises.copy(s,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(3,null,(0,S.basename)(s),(0,S.basename)((0,S.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(o,n,t,s){const a=this.toFilePath(o),u=this.toFilePath(n);let g=!1;if(!!(this.capabilities&1024)||(g=(0,P.isEqual)(a,u,!0)),g&&t==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!g&&await d.Promises.exists(u)){if(!s)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(o,n,t){let s,a=!1;return this.options?.watcher?.usePolling?a=!1:a=this.options?.legacyWatcher==="on",a?s=m.FileWatcher:s=w.FileWatcher,new s(u=>o(u),u=>n(u),t,this.options?.watcher)}doWatch(o,n){const t=this.options?.watcher?.usePolling;if(t===!0)for(const s of n)s.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const s of n)t.includes(s.path)&&(s.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(o,n)}createNonRecursiveWatcher(o,n,t,s){return new v.FileWatcher(o,a=>n(a),a=>t(a),s)}toFileSystemProviderError(o){if(o instanceof h.FileSystemProviderError)return o;let n;switch(o.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(o,n)}async toFileSystemProviderWriteError(o,n){let t=this.toFileSystemProviderError(n);if(o&&t.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await d.SymlinkSupport.stat(this.toFilePath(o));s.mode&128||(t=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return t}}e.DiskFileSystemProvider=l}),define(te[85],ne([0,1,3,7,8]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(d){this.service=d,this.onDidChangeLogLevel=D.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=T;class i{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){i.setLevel(this.channel,d)}static setLevel(d,p){return d.call("setLevel",p)}}e.LogLevelChannelClient=i;class P{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,p){throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"createLogger":this.createLogger(A.URI.revive(h[0]),h[1]);return;case"log":return this.log(A.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(d,p){this.loggers.set(d.toString(),this.loggerService.createLogger(d,p))}consoleLog(d,p){let h=console.log;switch(d){case R.LogLevel.Error:h=console.error;break;case R.LogLevel.Warning:h=console.warn;break;case R.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(d,p){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[E,v]of p)(0,R.log)(h,E,v)}}e.LoggerChannel=P;class S extends R.AbstractLoggerService{constructor(d,p,h){super(d,p);this.channel=h}createConsoleMainLogger(){return new R.AdapterLogger({log:(d,p)=>{this.channel.call("consoleLog",[d,p])}})}doCreateLogger(d,p,h){return new b(this.channel,d,p,h)}}e.LoggerChannelClient=S;class b extends R.AbstractMessageLogger{constructor(d,p,h,E){super(E?.always);this.channel=d,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,p){const h=[[d,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class I extends R.LogService{constructor(d,p){super(p);this.parent=d,this._register(d.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=I}),define(te[60],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[86],ne([0,1,16,4,32,18]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof A.globals.vscode!="undefined"&&typeof A.globals.vscode.context!="undefined"){const P=A.globals.vscode.context.configuration();if(P)i=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const P=(0,T.dirname)(D.FileAccess.asFileUri("",J));i=J.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath);const S=J.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:S.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i}),define(te[26],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(te[180],ne([0,1,5,9,2,10,20,8,26]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends R.Disposable{constructor(C,d,p){super();this.productService=d,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),p=(0,T.dirname)(C),h=(0,T.basename)(C),E=await i.Promises.readdir(p);await Promise.all(E.map(async v=>{if(v===h)return;const m=(0,T.join)(p,v),w=await i.Promises.stat(m);if(w.isDirectory()&&d-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),i.Promises.rm(m)}))}catch(d){(0,A.onUnexpectedError)(d)}}};b=de([G(1,S.IProductService),G(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(te[181],ne([0,1,5,9,2,10,20,11,8,26]),function(J,e,D,A,R,T,i,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends R.Disposable{constructor(d,p,h){super();this.environmentService=d,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),p=JSON.parse(await i.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(p)){const f=p[w];d[`${f.hash}.${w}`]=!0}const h=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await i.Promises.exists(h))return;const v=await i.Promises.readdir(h);for(const w of v){if(d[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await i.Promises.rm((0,T.join)(h,w))}const m=Date.now();for(const w of Object.keys(d)){const f=(0,T.join)(h,w),c=await i.Promises.readdir(f);for(const l of c){if(l==="tcf.json")continue;const r=(0,T.join)(f,l),o=await i.Promises.stat(r);o.isDirectory()&&m-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(w,l)}`),await i.Promises.rm(r))}}}catch(d){(0,A.onUnexpectedError)(d)}}};I=de([G(0,P.INativeEnvironmentService),G(1,S.ILogService),G(2,b.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(te[37],ne([0,1,100,15]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(i,P){D.ok(A.isString(i)),D.ok(A.isObject(P)),D.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,P)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new R}),define(te[87],ne([0,1,3,37]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,b){this.schemasById[R(S)]=b,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new T;A.Registry.add(e.Extensions.JSONContribution,i)}),define(te[42],ne([0,1,17,3,15,126,87,37]),function(J,e,D,A,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=P.Registry.as(i.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const o=this.doRegisterConfigurations(l,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const o=[];o.push(...this.doDeregisterConfigurations(r)),o.push(...this.doRegisterConfigurations(l,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(o)})}registerDefaultConfigurations(l){const r=[],o=[];for(const n of l)for(const t in n)if(r.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){this.configurationDefaultsOverrides[t]={...this.configurationDefaultsOverrides[t]||{},...n[t]};const s={type:"object",default:this.configurationDefaultsOverrides[t],description:T.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(...h(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.configurationDefaultsOverrides[t]=n[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const o of l)for(const n in o)if(r.push(n),delete this.configurationDefaultsOverrides[n],e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const t=this.configurationProperties[n];t&&(this.updatePropertyDefaultValue(n,t),this.updateSchema(n,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const o=[];return l.forEach(n=>{o.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),o}doDeregisterConfigurations(l){const r=[],o=n=>{if(n.properties)for(const t in n.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>o(t))};for(const n of l){o(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,o,n=3){n=R.isUndefinedOrNull(l.scope)?n:l.scope;let t=[],s=l.properties;if(s)for(let u in s){if(r&&w(u)){delete s[u];continue}const g=s[u];if(this.updatePropertyDefaultValue(u,g),e.OVERRIDE_PROPERTY_REGEX.test(u)?g.scope=void 0:(g.scope=R.isUndefinedOrNull(g.scope)?n:g.scope,g.restricted=R.isUndefinedOrNull(g.restricted)?!!o?.restrictedConfigurations?.includes(u):g.restricted),s[u].hasOwnProperty("included")&&!s[u].included){this.excludedConfigurationProperties[u]=s[u],delete s[u];continue}else this.configurationProperties[u]=s[u];!s[u].deprecationMessage&&s[u].markdownDeprecationMessage&&(s[u].deprecationMessage=s[u].markdownDeprecationMessage),t.push(u)}let a=l.allOf;if(a)for(let u of a)t.push(...this.validateAndRegisterProperties(u,r,o,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=o=>{let n=o.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=o.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,o={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,o),e.allSettings.properties[r]=o,e.applicationSettings.properties[r]=o,e.machineSettings.properties[r]=o,e.machineOverridableSettings.properties[r]=o,e.windowSettings.properties[r]=o,e.resourceSettings.properties[r]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){let o=this.configurationDefaultsOverrides[l];R.isUndefined(o)&&(o=r.default),R.isUndefined(o)&&(o=v(r.type)),r.default=o}}const d="\\[([^\\]]+)\\]",p=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=p.exec(c);for(;r?.length;){const o=r[1].trim();o&&l.push(o),r=p.exec(c)}}return(0,D.distinct)(l)}e.overrideIdentifiersFromKey=h;function E(c){return c.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=E;function v(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const m=new C;P.Registry.add(e.Extensions.Configuration,m);function w(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?T.localize(7,null,c):m.getConfigurationProperties()[c]!==void 0?T.localize(8,null,c):null:T.localize(6,null)}e.validateProperty=w;function f(){const c=[],l=m.getConfigurationProperties();for(const r of Object.keys(l))c.push([r,l[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=f}),define(te[88],ne([0,1,17,3,31,2,40,28,15,7,21,42,37]),function(J,e,D,A,R,T,i,P,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,I.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return D.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=P.deepClone(this.contents),s=P.deepClone(this.overrides),a=[...this.keys];for(const u of n){this.mergeContents(t,u.contents);for(const g of u.overrides){const[y]=s.filter(k=>D.equals(k.identifiers,g.identifiers));y?(this.mergeContents(y.contents,g.contents),y.keys.push(...g.keys),y.keys=D.distinct(y.keys)):s.push(P.deepClone(g))}for(const g of u.keys)a.indexOf(g)===-1&&a.push(g)}return new p(t,a,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const a of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[a],g=t[a];g&&(typeof u=="object"&&typeof g=="object"?(u=P.deepClone(u),this.mergeContents(u,g)):u=g),s[a]=u}return new p(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&S.isObject(n[s])&&S.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=P.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?P.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const a=u=>{u&&(s?this.mergeContents(s,u):s=P.deepClone(u))};for(const u of this.overrides)D.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&a(u.contents);return a(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,I.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(n={}){const t=d.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),a=Object.create(null),u=[];for(const g in t){const y=n[g],k=y!==void 0?y:t[g].default;(0,I.addToValueTree)(a,g,k,O=>console.error(`Conflict in default settings: ${O}`))}for(const g of Object.keys(a))C.OVERRIDE_PROPERTY_REGEX.test(g)&&u.push({identifiers:(0,C.overrideIdentifiersFromKey)(g),keys:Object.keys(a[g]),contents:(0,I.toValuesTree)(a[g],y=>console.error(`Conflict in default settings file: ${y}`))});super(a,s,u)}}e.DefaultConfigurationModel=h;class E{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!S.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:a,overrides:u,restricted:g}=this.doParseRaw(n,t);this._configurationModel=new p(s,a,u),this._restrictedConfigurations=g||[]}doParseContent(n){let t={},s=null,a=[],u=[],g=[];function y(O){Array.isArray(a)?a.push(O):s!==null&&(a[s]=O)}let k={onObjectBegin:()=>{let O={};y(O),u.push(a),a=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{let O=[];y(O),u.push(a),a=O,s=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:y,onError:(O,M,W)=>{g.push({error:O,offset:M,length:W})}};if(n)try{R.visit(n,k),t=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return t}doParseRaw(n,t){const s=d.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),a=this.filter(n,s,!0,t);n=a.raw;const u=(0,I.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),g=Object.keys(n),y=this.toOverrides(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:u,keys:g,overrides:y,restricted:a.restricted}}filter(n,t,s,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:n,restricted:[]};const u={},g=[];for(let y in n)if(C.OVERRIDE_PROPERTY_REGEX.test(y)&&s){const k=this.filter(n[y],t,!1,a);u[y]=k.raw,g.push(...k.restricted)}else{const k=t[y],O=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&g.push(y),(O===void 0||a.scopes===void 0||a.scopes.includes(O))&&(a.skipRestricted&&k?.restricted||(u[y]=n[y]))}return{raw:u,restricted:g}}toOverrides(n,t){const s=[];for(const a of Object.keys(n))if(C.OVERRIDE_PROPERTY_REGEX.test(a)){const u={};for(const g in n[a])u[g]=n[a][g];s.push({identifiers:(0,C.overrideIdentifiersFromKey)(a),keys:Object.keys(u),contents:(0,I.toValuesTree)(u,t)})}return s}}e.ConfigurationModelParser=E;class v extends T.Disposable{constructor(n,t,s,a){super();this.userSettingsResource=n,this.scopes=t,this.fileService=a,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(A.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class m{constructor(n,t,s=new p,a=new p,u=new i.ResourceMap,g=new p,y=new i.ResourceMap,k=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=u,this._memoryConfiguration=g,this._memoryConfigurationByResource=y,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new p,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,t===void 0?a.removeValue(n):a.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const a=this.getConsolidateConfigurationModel(t,s),u=this.getFolderConfigurationModelForResource(t.resource,s),g=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,y=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),k=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),M=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),W=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,q=u?t.overrideIdentifier?u.freeze().override(t.overrideIdentifier).getValue(n):u.freeze().getValue(n):void 0,L=t.overrideIdentifier?g.override(t.overrideIdentifier).getValue(n):g.getValue(n),$=a.getValue(n),_=D.distinct(D.flatten(a.overrides.map(F=>F.identifiers))).filter(F=>a.getOverrideValue(n,F)!==void 0);return{defaultValue:y,userValue:k,userLocalValue:O,userRemoteValue:M,workspaceValue:W,workspaceFolderValue:q,memoryValue:L,value:$,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:q!==void 0?{value:u?.freeze().getValue(n),override:t.overrideIdentifier?u?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:g.getValue(n),override:t.overrideIdentifier?g.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:_.length?_:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n){const{added:t,updated:s,removed:a,overrides:u}=l(this._defaultConfiguration,n),g=[...t,...s,...a];return g.length&&this.updateDefaultConfiguration(n),{keys:g,overrides:u}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:a,overrides:u}=l(this.localUserConfiguration,n),g=[...t,...s,...a];return g.length&&this.updateLocalUserConfiguration(n),{keys:g,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:a,overrides:u}=l(this.remoteUserConfiguration,n);let g=[...t,...s,...a];return g.length&&this.updateRemoteUserConfiguration(n),{keys:g,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:a,overrides:u}=l(this.workspaceConfiguration,n);let g=[...t,...s,...a];return g.length&&this.updateWorkspaceConfiguration(n),{keys:g,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:a,updated:u,removed:g,overrides:y}=l(s,t);let k=[...a,...u,...g];return(k.length||!s)&&this.updateFolderConfiguration(n,t),{keys:k,overrides:y}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:a,removed:u,overrides:g}=l(t,void 0);return{keys:[...s,...a,...u],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const a=t.getFolder(n);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const u=this._memoryConfigurationByResource.get(n);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(n);a?(t=s.merge(a),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:a,keys:u}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:a,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(a=>t.add(a))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),a=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((g,y)=>(g.set(b.URI.revive(y[0]),this.parseConfigurationModel(y[1])),g),new i.ResourceMap);return new m(t,s,new p,a,u,new p,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,t=new Map;for(const a of o)a.keys.forEach(u=>n.add(u)),a.overrides.forEach(([u,g])=>{const y=(0,i.getOrSet)(t,u,new Set);g.forEach(k=>y.add(k))});const s=[];return t.forEach((a,u)=>s.push([u,[...a.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=w;class f{constructor(n,t,s,a){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(y=>u.add(y)),n.overrides.forEach(([,y])=>y.forEach(k=>u.add(k))),this.affectedKeys=[...u.values()];const g=new p;this.affectedKeys.forEach(y=>g.setValue(y,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!P.equals(s,a)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,I.toValuesTree)({[t]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(n=n[a],!n)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=f;class c extends f{constructor(n,t,s,a){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=c;function l(o,n){const{added:t,removed:s,updated:a}=r(n,o),u=[],g=o?.getAllOverrideIdentifiers()||[],y=n?.getAllOverrideIdentifiers()||[];if(n){const k=y.filter(O=>!g.includes(O));for(const O of k)u.push([O,n.getKeysForOverrideIdentifier(O)])}if(o){const k=g.filter(O=>!y.includes(O));for(const O of k)u.push([O,o.getKeysForOverrideIdentifier(O)])}if(n&&o){for(const k of g)if(y.includes(k)){const O=r({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)});u.push([k,[...O.added,...O.removed,...O.updated]])}}return{added:t,removed:s,updated:a,overrides:u}}function r(o,n){const t=o?n?o.keys.filter(u=>n.keys.indexOf(u)===-1):[...o.keys]:[],s=n?o?n.keys.filter(u=>o.keys.indexOf(u)===-1):[...n.keys]:[],a=[];if(o&&n){for(const u of n.keys)if(o.keys.indexOf(u)!==-1){const g=(0,I.getConfigurationValue)(n.contents,u),y=(0,I.getConfigurationValue)(o.contents,u);P.equals(g,y)||a.push(u)}}return{added:t,removed:s,updated:a}}}),define(te[182],ne([0,1,5,3,2,18,21,88,42,37]),function(J,e,D,A,R,T,i,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends R.Disposable{constructor(d,p){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,p)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(()=>this.onDidDefaultConfigurationChange())),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,p){const h=typeof d=="string"?d:void 0,E=(0,i.isConfigurationOverrides)(d)?d:(0,i.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,E,void 0)}updateValue(d,p,h,E){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,p,1)}onDidDefaultConfigurationChange(){const d=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel);this.trigger(p,d,6)}trigger(d,p,h){const E=new P.ConfigurationChangeEvent(d,{data:p},this.configuration);E.source=h,E.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[183],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var A;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(i,P=A.Unknown,S){super(i);this._message=i,this._code=P,this._detail=S,this.isHandled=P===A.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(i){return i instanceof R&&i._code===A.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof R&&i._code===A.NoResolverFound}static isHandled(i){return i instanceof R&&i.isHandled}}e.RemoteAuthorityResolverError=R}),define(te[184],ne([0,1,5,19,27,9,3,2,29,71,183]),function(J,e,D,A,R,T,i,P,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var d;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function p(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(U){const N=new R.CancellationTokenSource;return setTimeout(()=>N.cancel(),U),N.token}function E(U,N){if(U.isCancellationRequested||N.isCancellationRequested)return R.CancellationToken.Cancelled;const z=new R.CancellationTokenSource;return U.onCancellationRequested(()=>z.cancel()),N.onCancellationRequested(()=>z.cancel()),z.token}class v{constructor(N){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((z,x)=>{this._resolvePromise=z,this._rejectPromise=x}),N.isCancellationRequested?this._timeout():this._disposables.add(N.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(N){this._state==="pending"?this._disposables.add(N):N.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(N))}reject(N){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(N))}}function m(U,N){const z=new v(N);return z.registerDisposable(U.onControlMessage(x=>{const K=JSON.parse(x.toString()),ee=B(K);ee?z.reject(ee):z.resolve(K)})),z.promise}function w(U,N,z,x,K,ee){const V=new v(ee);return N.connect(z,x,K,(X,se)=>{V.didTimeout?(X&&U.error(X),se?.dispose()):X||!se?V.reject(X):V.resolve(se)}),V.promise}function f(U,N){const z=new v(N);return U.then(x=>{z.didTimeout||z.resolve(x)},x=>{z.didTimeout||z.reject(x)}),z.promise}async function c(U,N,z,x){const K=j(U,N);U.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await w(U.logService,U.socketFactory,U.host,U.port,`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,x)}catch(le){throw U.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),U.logService.error(le),le}U.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let V,X;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(ee,null),V=U.reconnectionProtocol,X=!1):(V=new b.PersistentProtocol(ee,null),X=!0),U.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const se=await f(U.signService.createNewMessage((0,S.generateUuid)()),x),oe={type:"auth",auth:U.connectionToken||"00000000000000000000",data:se.data};V.sendControl(A.VSBuffer.fromString(JSON.stringify(oe)));try{const le=await m(V,E(x,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(U.logService.trace(`${K} 4/6. received SignRequest control message.`),!await f(U.signService.validate(se,le.signedData),x)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const be=await f(U.signService.sign(le.data),x),Ce={type:"connectionType",commit:U.commit,signedData:be,desiredConnectionType:N};return z&&(Ce.args=z),U.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(A.VSBuffer.fromString(JSON.stringify(Ce))),{protocol:V,ownsProtocol:X}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(U.logService.error(`${K} the handshake timed out. Error:`),U.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${K} received error control message when negotiating connection. Error:`),U.logService.error(le)),X&&F(V),le}}async function l(U,N,z,x){const K=Date.now(),ee=j(U,N),{protocol:V,ownsProtocol:X}=await c(U,N,z,x),se=new v(x);return se.registerDisposable(V.onControlMessage(oe=>{const le=JSON.parse(oe.toString()),he=B(le);he?(U.logService.error(`${ee} received error control message when negotiating connection. Error:`),U.logService.error(he),X&&F(V),se.reject(he)):(U.reconnectionProtocol&&U.reconnectionProtocol.endAcceptReconnection(),U.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${Q(K)}!`),se.resolve({protocol:V,firstMessage:le}))})),se.promise}async function r(U,N){const{protocol:z}=await l(U,1,void 0,N);return{protocol:z}}async function o(U,N,z){const{protocol:x,firstMessage:K}=await l(U,2,N,z),ee=K&&K.debugPort;return{protocol:x,debugPort:ee}}async function n(U,N,z){const x=Date.now(),K=j(U,3),{protocol:ee}=await c(U,3,N,z);return U.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${Q(x)}!`),ee}async function t(U,N,z){const{host:x,port:K,connectionToken:ee}=await U.addressProvider.getAddress();return{commit:U.commit,host:x,port:K,connectionToken:ee,reconnectionToken:N,reconnectionProtocol:z,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function s(U,N,z){try{const x=(0,S.generateUuid)(),K=await t(U,x,null),{protocol:ee}=await r(K,R.CancellationToken.None);return new $(U,N,z,x,ee)}catch(x){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(x),L.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(x)),x}}e.connectRemoteAgentManagement=s;async function a(U,N){try{const z=(0,S.generateUuid)(),x=await t(U,z,null),{protocol:K,debugPort:ee}=await o(x,N,R.CancellationToken.None);return new _(U,N,z,K,ee)}catch(z){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(z),L.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(z)),z}}e.connectRemoteAgentExtensionHost=a;async function u(U,N,z){const x=await t(U,(0,S.generateUuid)(),null);return await n(x,{host:N,port:z},R.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function g(U){return(0,D.createCancelablePromise)(N=>new Promise((z,x)=>{const K=setTimeout(z,U*1e3);N.onCancellationRequested(()=>{clearTimeout(K),z()})}))}var y;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(y=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class k{constructor(N,z){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=k;class O{constructor(N,z,x,K){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.durationSeconds=x,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class M{constructor(N,z,x){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.attempt=x,this.type=2}}e.ReconnectionRunningEvent=M;class W{constructor(N,z,x){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.attempt=x,this.type=4}}e.ConnectionGainEvent=W;class q{constructor(N,z,x,K){this.reconnectionToken=N,this.millisSinceLastIncomingData=z,this.attempt=x,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=q;class L extends P.Disposable{constructor(N,z,x,K){super();this._connectionType=N,this._onDidStateChange=this._register(new i.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=z,this.reconnectionToken=x,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new W(this.reconnectionToken,0,0)),this._register(K.onSocketClose(ee=>{const V=H(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${V} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${V} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${V} received socket close event.`),this._beginReconnecting()})),this._register(K.onSocketTimeout(()=>{const ee=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${ee} received socket timeout event.`),this._beginReconnecting()})),L._instances.push(this),L._permanentFailure&&this._gotoPermanentFailure(L._permanentFailureMillisSinceLastIncomingData,L._permanentFailureAttempt,L._permanentFailureHandled)}static triggerPermanentFailure(N,z,x){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=N,this._permanentFailureAttempt=z,this._permanentFailureHandled=x,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(L._permanentFailure)return;const N=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const K=x<z.length?z[x]:z[z.length-1];try{if(K>0){const V=g(K);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,V)),this._options.logService.info(`${N} waiting for ${K} seconds before reconnecting...`);try{await V}catch{}}if(L._permanentFailure){this._options.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this._options.logService.info(`${N} resolving connection...`);const ee=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${N} connecting to ${ee.host}:${ee.port}...`),await this._reconnect(ee,h(C)),this._options.logService.info(`${N} reconnected!`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this._options.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,T.isPromiseCanceledError)(ee)){this._options.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,I.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!L._permanentFailure)}_gotoPermanentFailure(N,z,x){this._onDidStateChange.fire(new q(this.reconnectionToken,N,z,x)),F(this.protocol)}}L._permanentFailure=!1,L._permanentFailureMillisSinceLastIncomingData=0,L._permanentFailureAttempt=0,L._permanentFailureHandled=!1,L._instances=[];class $ extends L{constructor(N,z,x,K,ee){super(1,N,K,ee);this.client=this._register(new b.Client(ee,{remoteAuthority:z,clientId:x},N.ipcLogger))}async _reconnect(N,z){await r(N,z)}}e.ManagementPersistentConnection=$;class _ extends L{constructor(N,z,x,K,ee){super(2,N,x,K);this._startArguments=z,this.debugPort=ee}async _reconnect(N,z){await o(N,this._startArguments,z)}}e.ExtensionHostPersistentConnection=_;function F(U){try{U.acceptDisconnect();const N=U.getSocket();U.dispose(),N.dispose()}catch(N){(0,T.onUnexpectedError)(N)}}function B(U){if(U&&U.type==="error"){const N=new Error(`Connection error: ${U.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function Z(U,N){for(;U.length<N;)U+=" ";return U}function H(U,N,z){return`[remote-connection][${Z(p(U),13)}][${N.substr(0,5)}\u2026][${z?"reconnect":"initial"}]`}function j(U,N){return`${H(N,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function Q(U){return`${Date.now()-U} ms`}}),define(te[185],ne([0,1,16]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function A(b){return b.scheme===D.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=A;function R(b){if(!b)return;const I=b.indexOf("+");return I<0?b:b.substr(0,I)}e.getRemoteName=R;function T(b){return b.scheme!==D.Schemas.file&&b.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=T;function i(b){if(b.folders.length)return b.folders.every(I=>T(I.uri))?b.folders[0].uri:void 0;if(b.configuration&&T(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=i;function P(b){return i(b)?.scheme}e.getVirtualWorkspaceScheme=P;function S(b){return i(b)!==void 0}e.isVirtualWorkspace=S}),define(te[89],ne([0,1,25,6,185]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=T;function i(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class S{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let E=typeof p=="string"?p:p.value,v=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(E,v)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=S;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function I(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function C(d,p){if(p){const h=`onResolveRemoteAuthority:${(0,R.getRemoteName)(p)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[35],ne([0,1,25,89]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(h,E){return h.uuid&&E.uuid?h.uuid===E.uuid:h.id===E.id?!0:(0,D.compareIgnoreCase)(h.id,E.id)===0}e.areSameExtensions=R;class T{constructor(E,v){this.version=v,this.id=E.id,this.uuid=E.uuid}key(){return`${this.id}-${this.version}`}equals(E){return E instanceof T?R(this,E)&&this.version===E.version:!1}}e.ExtensionIdentifierWithVersion=T;function i(h,E){return`${h}.${E}`}e.getExtensionId=i;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function S(h,E){return P(i(h,E))}e.getGalleryExtensionId=S;function b(h,E){const v=[],m=w=>{for(const f of v)if(f.some(c=>R(E(c),E(w))))return f;return null};for(const w of h){const f=m(w);f?f.push(w):v.push([w])}return v}e.groupByExtension=b;function I(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function C(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function d(h){const E=new Set;for(const v of h)v.malicious&&E.add(v.id.id);return E}e.getMaliciousExtensionsSet=d;function p(h,E){const v=[],m=E.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&v.every(f=>!R(f.identifier,{id:w}))){const f=h.filter(c=>R(c.identifier,{id:w}));f.length===1&&(v.push(f[0]),m.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=p}),define(te[186],ne([0,1,5,9,2,4,18,61,7,29,20,11,30,35,14,8]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends R.Disposable{constructor(f,c,l,r){super();this.fileService=c,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=S.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,c){await this.cleanUpPromise;const l=this.getName(f),r=(0,i.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const o=(0,i.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(f,o,c);try{await this.rename(o,r,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(o)}catch(t){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,A.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,o.path),n}}return r}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,c,l){try{await I.Promises.rename(f.fsPath,c.fsPath)}catch(r){if(T.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${f} to ${c} with 'EPERM' error. Trying again...`),this.rename(f,c,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const c=[],l=[];for(const n of f.children){const t=this.parse(n.name);t&&l.push([t,n])}const r=(0,p.groupByExtension)(l,([n])=>n),o=[];for(const n of r)n.sort((t,s)=>P.rcompare(t[0].version,s[0].version)),c.push(...n.slice(1).map(t=>t[1].resource)),o.push(n[0][1]);o.sort((n,t)=>n.mtime-t.mtime),c.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(c.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new p.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(f){const c=v.exec(f);return c&&c[1]&&c[2]?new p.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};m=de([G(0,C.INativeEnvironmentService),G(1,h.IFileService),G(2,d.IExtensionGalleryService),G(3,E.ILogService)],m),e.ExtensionsDownloader=m}),define(te[187],ne([0,1,2,10,20,89]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class i extends D.Disposable{constructor(S,b){super();this.environmentService=S,this.extensionsManifestCache=(0,A.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(b.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(S){S.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=i}),define(te[188],ne([0,1,81,17,5,2,16,10,20,11,30,35,59,8]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends T.Disposable{constructor(m,w,f){super();this.extensionManagementService=m,this.logService=f,this.cache=this._register(new E(w,f)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,A.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(f=>w[f]&&w[f].extensions.some(c=>(0,C.areSameExtensions)(c.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(w);return!(0,A.equals)(Object.keys(m),Object.keys(f))}};h=de([G(0,I.IExtensionManagementService),G(1,b.INativeEnvironmentService),G(2,p.ILogService)],h),e.LocalizationsService=h;let E=class extends T.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(f=>delete w[f]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const f of w)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,f);Object.keys(m).forEach(f=>this.updateHash(m[f]))}createLanguagePacksFromExtension(m,w){const f=w.identifier,c=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of c)if(w.location.scheme===i.Schemas.file&&(0,d.isValidLocalization)(l)){let r=m[l.languageId];r||(r={hash:"",extensions:[],translations:{}},m[l.languageId]=r);let o=r.extensions.filter(n=>(0,C.areSameExtensions)(n.extensionIdentifier,f))[0];o?o.version=w.manifest.version:r.extensions.push({extensionIdentifier:f,version:w.manifest.version});for(const n of l.translations)r.translations[n.id]=(0,P.join)(w.location.fsPath,n.path)}}updateHash(m){if(m){const w=(0,D.createHash)("md5");for(const f of m.extensions)w.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(c){return{}}}).then(f=>(w=m(f),f)).then(f=>{for(const l of Object.keys(f))f[l]||delete f[l];this.languagePacks=f,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),S.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>w,f=>this.logService.error(f))})}};E=de([G(0,b.INativeEnvironmentService),G(1,p.ILogService)],E)}),define(te[189],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,8]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var i;(function(h){h.Http="http",h.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const E=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!E)return{address:E[1],port:+E[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=C;function d(h,E){return E?E!==1&&h<1024:!A.isWindows&&h<1024}e.isPortPrivileged=d;let p=class{constructor(E){this.logService=E,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(E,v){return this._tunnelProvider=E,E?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const E=[],v=Array.from(this._tunnels.values());for(let m of v){const w=Array.from(m.values());for(let f of w){const c=await f.value;c&&E.push(c)}}return E}async dispose(){for(const E of this._tunnels.values()){for(const{value:v}of E.values())await v.then(m=>m?.dispose());E.clear()}this._tunnels.clear()}openTunnel(E,v,m,w,f=!1,c=P.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${m} on local port ${w}.`),!E)return;v||(v="localhost");const r=this.retainOrCreateTunnel(E,v,m,w,f,c,l);return r?r.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(o);return(o.tunnelRemoteHost!==v||o.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(E){return{tunnelRemotePort:E.tunnelRemotePort,tunnelRemoteHost:E.tunnelRemoteHost,tunnelLocalPort:E.tunnelLocalPort,localAddress:E.localAddress,privacy:E.privacy,protocol:E.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${E.tunnelRemoteHost}:${E.tunnelRemotePort} `);const v=this._tunnels.get(E.tunnelRemoteHost);if(v){const m=v.get(E.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(E.tunnelRemoteHost,E.tunnelRemotePort,m))}}}}async tryDisposeTunnel(E,v,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${E}:${v}.`);const w=m.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(E)&&this._tunnels.get(E).delete(v),w}}async closeTunnel(E,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${E}:${v} `);const m=this._tunnels.get(E);if(m&&m.has(v)){const w=m.get(v);w.refcount=0,await this.tryDisposeTunnel(E,v,w)}}addTunnelToMap(E,v,m){this._tunnels.has(E)||this._tunnels.set(E,new Map),this._tunnels.get(E).set(v,{refcount:1,value:m})}async removeEmptyTunnelFromMap(E,v){const m=this._tunnels.get(E);m&&(await m.get(v)||m.delete(v),m.size===0&&this._tunnels.delete(E))}getTunnelFromMap(E,v){let m=[E];I(E)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):C(E)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(f=>this._tunnels.get(f));for(const f of w){const c=f?.get(v);if(c)return c}}canTunnel(E){return!!b(E)}createWithProvider(E,v,m,w,f,c,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${m} on local port ${w}.`);const o={elevationRequired:f?d(w===void 0?m:w):!1},n={remoteAddress:{host:v,port:m},localAddressPort:w,privacy:c,public:c!==P.Private,protocol:l},t=E.forwardPort(n,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,m,t),t}};p=de([G(0,T.ILogService)],p),e.AbstractTunnelService=p}),define(te[190],ne([0,1,8,62,2,9,5]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new i.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let S=class Et extends R.Disposable{constructor(I,C){super();this._tunnelService=I,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Et._lastId)}}async startTunnel(I,C,d,p,h,E){const v=new P,m=await Promise.resolve(this._tunnelService.openTunnel(I,v,d,p,h,E));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${p} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),v.dispose(),await m.dispose(),(0,T.canceled)();return v.setTunnel(m),this._tunnels.set(C,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${m.localAddress} (local) to ${d}:${p} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,C){const d=this._tunnels.get(I);!d||d.setAddress(C)}async destroyTunnel(I){const C=this._tunnels.get(I);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await C.dispose();return}this._disposedTunnels.add(I)}};S._lastId=0,S=de([G(0,A.ISharedTunnelsService),G(1,D.ILogService)],S),e.SharedProcessTunnelService=S}),define(te[191],ne([0,1,120,21,8]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,S){this.configurationService=P,this.logService=S}request(P,S){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,S)}async resolveProxy(P){}};T=de([G(0,A.IConfigurationService),G(1,R.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,19,141,42,6,37]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function S(h){return h.res.statusCode===204}async function b(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,D.streamToBuffer)(h.stream)).toString()}e.asText=b;async function I(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const v=(await(0,D.streamToBuffer)(h.stream)).toString();try{return JSON.parse(v)}catch(m){throw m.message+=`:
`+v,m}}e.asJson=I;function C(h){p(h)}e.updateProxyConfigurationsScope=C;let d;function p(h){const E=i.Registry.as(R.Extensions.Configuration),v=d;d={id:"http",order:15,title:(0,A.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(4,null),(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null)],default:"override",description:(0,A.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[d],remove:v?[v]:[]})}p(2)}),define(te[192],ne([0,1,27,16,14,43]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let i=class{constructor(S,b){this.requestService=S,this.fileService=b}async download(S,b,I=D.CancellationToken.None){if(S.scheme===A.Schemas.file||S.scheme===A.Schemas.vscodeRemote){await this.fileService.copy(S,b);return}const C={type:"GET",url:S.toString()},d=await this.requestService.request(C,I);if(d.res.statusCode===200)await this.fileService.writeFile(b,d.stream);else{const p=await(0,T.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${p}`)}}};i=de([G(0,T.IRequestService),G(1,R.IFileService)],i),e.DownloadService=i}),define(te[193],ne([0,1,17,27,66,2,18,155,14,8,26,43]),function(J,e,D,A,R,T,i,P,S,b,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends T.Disposable{constructor(h,E,v,m){super();this.fileService=h,this.productService=E,this.requestService=v,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const E=[];for(const[v,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,i.joinPath)(h,v)),f=new Map;(0,R.forEach)(m.recommendations,({key:l,value:r})=>{if((0,D.isNonEmptyArray)(r.remotes))for(const o of r.remotes)f.set(o,{extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else E.push({extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const c=(0,P.getDomainsOfRemotes)(w.value.toString(),[...f.keys()]);for(const l of c){const r=f.get(l);r&&E.push(r)}}catch(w){}return E}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},A.CancellationToken.None);if(h.res.statusCode!==200)return[];const E=await(0,C.asJson)(h);return E?E.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=de([G(0,S.IFileService),G(1,I.IProductService),G(2,C.IRequestService),G(3,b.ILogService)],d),e.ExtensionTipsService=d}),define(te[46],ne([0,1,19,29]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,i,P){let S=P&&P.get("storage.serviceMachineId",0)||null;if(S)return S;try{const I=(await i.readFile(T.serviceMachineIdResource)).value.toString();S=(0,A.isUUID)(I)?I:null}catch(b){S=null}if(!S){S=(0,A.generateUuid)();try{await i.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(S))}catch(b){}}return P&&P.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=R}),define(te[90],ne([0,1,105,6]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,A.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[194],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(A){A.Spawn="vscode:shared-process->shared-process-worker=spawn",A.Terminate="vscode:shared-process->shared-process-worker=terminate",A.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",A.Ready="vscode:shared-process-worker->shared-process=ready",A.Ack="vscode:shared-process-worker->shared-process=ack",A.Trace="vscode:shared-process-worker->shared-process=trace",A.Info="vscode:shared-process-worker->shared-process=info",A.Warn="vscode:shared-process-worker->shared-process=warn",A.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[195],ne([0,1,72,153,5,27,3,2,16,4,29,11,8,26,90,194]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let v=class{constructor(f,c,l){this.logService=f,this.productService=c,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(f){const c=`window: ${f.reply.windowId}, moduleId: ${f.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${c})`);const l=(0,h.hash)(f);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${c})`),this.doDisposeWorker(f));const r=new T.CancellationTokenSource;let o,n,t;this.processeDisposables.set(l,g=>{r.dispose(!0),o?.terminate(f,T.CancellationToken.None),n?.close(),t?.close(),this.processeDisposables.delete(l);const y=this.processResolvers.get(l);y&&(this.processResolvers.delete(l),y({reason:g}))}),o=await this.getOrCreateWebWorker(f);const s=new Promise(g=>{this.processResolvers.set(l,g)});if(r.token.isCancellationRequested)return s;const{port1:a,port2:u}=new MessageChannel;return n=a,t=u,await o.spawn(f,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${c})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",f,[n])),s}getOrCreateWebWorker(f){let c=this.workers.get(f.process.moduleId);if(!c){this.logService.trace(`SharedProcess: creating new web worker (${f.process.moduleId})`);const l=new m(f.process.type,this.logService,this.productService,this.environmentService);c=l.init(),l.onDidProcessSelfTerminate(({configuration:r,reason:o})=>{this.doDisposeWorker(r,o)}),this.workers.set(f.process.moduleId,c)}return c}async disposeWorker(f){return this.doDisposeWorker(f)}doDisposeWorker(f,c){const l=this.processeDisposables.get((0,h.hash)(f));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${f.reply.windowId}, moduleId: ${f.process.moduleId})`),l(c))}};v=de([G(0,d.ILogService),G(1,p.IProductService),G(2,C.INativeEnvironmentService)],v),e.SharedProcessWorkerService=v;class m extends P.Disposable{constructor(f,c,l,r){super();this.type=f,this.logService=c,this.productService=l,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new i.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const f=new R.DeferredPromise,c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return c.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},c.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},c.onmessage=l=>{const{id:r,message:o,configuration:n,nonce:t}=l.data;switch(r){case E.SharedProcessWorkerMessages.Ready:f.complete(c);break;case E.SharedProcessWorkerMessages.Ack:if(t){const s=this.mapMessageNonceToPendingMessageResolve.get(t);s&&(this.mapMessageNonceToPendingMessageResolve.delete(t),s())}break;case E.SharedProcessWorkerMessages.SelfTerminated:n&&o&&this._onDidProcessSelfTerminate.fire({configuration:n,reason:JSON.parse(o)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,o);break;case E.SharedProcessWorkerMessages.Info:o&&this.logService.info(o);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,o);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,o);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),f.p}async send(f,c,l){const r=await this.workerReady;if(!c.isCancellationRequested)return new Promise(o=>{const n=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(n,o);const t={...f,nonce:n};l?r.postMessage(t,[l]):r.postMessage(t),c.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(n)&&o()})})}spawn(f,c,l){const r={id:E.SharedProcessWorkerMessages.Spawn,configuration:f,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,l,c)}getSharedProcessWorkerEnvironment(){const f={bootstrapPath:S.FileAccess.asFileUri("bootstrap-fork",J).fsPath,env:Object.create(null)};if(b.isLinux){const c={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&l&&(0,I.isUUID)(l)){const t=r["linux-x64"];c.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),c.uploadToServer=!0}const n=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;f.env.BREAKPAD_DUMP_LOCATION=(0,A.join)(n,this.type),f.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(c)}return f}terminate(f,c){const l={id:E.SharedProcessWorkerMessages.Terminate,configuration:f};return this.send(l,c)}}}),define(te[91],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[196],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,T)=>J(["vsda"],R,T))}async createNewMessage(R){try{const T=await this.vsda(),i=new T.validator;if(i){const P=String(D._nextId++);return this.validators.set(P,i),{id:P,data:i.createNewMessage(R)}}}catch(T){}return{id:"",data:R}}async validate(R,T){if(!R.id)return!0;const i=this.validators.get(R.id);if(!i)return!1;this.validators.delete(R.id);try{return i.validate(T)==="ok"}catch(P){return!1}}async sign(R){try{const T=await this.vsda(),i=new T.signer;if(i)return i.sign(R)}catch(T){}return R}}e.SignService=D,D._nextId=1}),define(te[23],ne([0,1,5,3,2,178,15,73,6]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var I;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var d;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class p extends R.Disposable{constructor(m={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===b?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,f){return this.getStorage(w)?.get(m,f)}getBoolean(m,w,f){return this.getStorage(w)?.getBoolean(m,f)}getNumber(m,w,f){return this.getStorage(w)?.getNumber(m,f)}store(m,w,f,c){if((0,i.isUndefinedOrNull)(w)){this.remove(m,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,c),this.getStorage(f)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const f=[],c=this.getKeyTargets(m);for(const l of Object.keys(c))c[l]===w&&f.push(l);return f}updateKeyTarget(m,w,f){const c=this.getKeyTargets(w);typeof f=="number"?c[m]!==f&&(c[m]=f,this.getStorage(w)?.set(b,JSON.stringify(c))):typeof c[m]=="number"&&(delete c[m],this.getStorage(w)?.set(b,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(b,m);if(w)try{return JSON.parse(w)}catch(f){}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=I.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),f=this.getStorage(1);switch(m){case I.NONE:await D.Promises.settled([w?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([w?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return E(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function E(v,m,w,f){const c=a=>{try{return JSON.parse(a)}catch(u){return a}},l=new Map,r=new Map;v.forEach((a,u)=>{l.set(u,a),r.set(u,c(a))});const o=new Map,n=new Map;m.forEach((a,u)=>{o.set(u,a),n.set(u,c(a))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((a,u)=>{t.push({key:u,value:a})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${f})`);let s=[];o.forEach((a,u)=>{s.push({key:u,value:a})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=E}),define(te[197],ne([0,1,3,2,15,30,35,23]),function(J,e,D,A,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends A.Disposable{constructor(C){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(C)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"})))}async enableExtension(C,d){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:d}),!0):!1}async disableExtension(C,d){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let d=this.getDisabledExtensions();return d.every(p=>!(0,i.areSameExtensions)(p,C))?(d.push(C),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(C){let d=this.getDisabledExtensions();for(let p=0;p<d.length;p++){const h=d[p];if((0,i.areSameExtensions)(h,C))return d.splice(p,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,d){this.storageManger.set(C,d,0)}};S=de([G(0,P.IStorageService)],S),e.GlobalExtensionEnablementService=S;class b extends A.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(C,d){let p;return d===0?((0,R.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,d)),p=this.storage[C]):p=this._get(C,d),JSON.parse(p)}set(C,d,p){let h=JSON.stringify(d.map(({id:v,uuid:m})=>({id:v,uuid:m})));this._get(C,p)!==h&&(p===0&&(d.length?this.storage[C]=h:delete this.storage[C]),this._set(C,d.length?h:void 0,p))}onDidStorageChange(C){if(C.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const p=this.get(C.key,C.scope);delete this.storage[C.key];const h=this.get(C.key,C.scope),E=p.filter(m=>!h.some(w=>(0,i.areSameExtensions)(m,w))),v=h.filter(m=>!p.some(w=>(0,i.areSameExtensions)(w,m)));(E.length||v.length)&&this._onDidChange.fire([...E,...v])}}_get(C,d){return this.storageService.get(C,d,"[]")}_set(C,d,p){d?this.storageService.store(C,d,p,1):this.storageService.remove(C,p)}}e.StorageManager=b}),define(te[198],ne([0,1,3,2]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends A.Disposable{constructor(b,I){super();this.channel=b,this.workspace=I}async getItems(){const b={workspace:this.workspace},I=await this.channel.call("getItems",b);return new Map(I)}updateItems(b){const I={workspace:this.workspace};return b.insert&&(I.insert=Array.from(b.insert.entries())),b.delete&&(I.delete=Array.from(b.delete.values())),this.channel.call("updateItems",I)}}class T extends R{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class i extends R{constructor(b,I){super(b,I);this.onDidChangeItemsExternal=D.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class P extends A.Disposable{constructor(b,I){super();this.channel=b,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new i(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[199],ne([0,1,5,2,18,73,23,198]),function(J,e,D,A,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends i.AbstractStorageService{constructor(I,C,d){super();this.mainProcessService=C,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new A.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),C=new T.Storage(I.globalStorage);return this._register(C.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),C}createWorkspaceStorage(I){const C=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(C.workspaceStorage){const d=new T.Storage(C.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=I?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(i.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const C=this.workspaceStorage,d=C?.items??new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[p,h]of d)this.workspaceStorage.set(p,h)}}e.NativeStorageService=S}),define(te[200],ne([0,1,4,32,7,29]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function i(b){if(D.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,I,C,d,p,h,E,v,m,w){const f=Object.create(null);f["common.machineId"]=E,f.sessionID=(0,T.generateUuid)()+Date.now(),f.commitHash=p,f.version=h,f["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,D.PlatformToString)(D.platform),f["common.nodePlatform"]=A.platform,f["common.nodeArch"]=d,f["common.product"]=w||"desktop";const c=S(v||[]);c&&(f["common.msftInternal"]=c);let l=0;const r=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(f["common.snap"]="true");const o=i(C);o&&(f["common.platformDetail"]=o);try{const n=await b.readFile(R.URI.file(m));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}e.resolveCommonProperties=P;function S(b){const I=A.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return b.some(d=>C===d)}e.verifyMicrosoftInternalDomain=S}),define(te[22],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[201],ne([0,1,33,56,5,31,16,10,4,7,113,20,116,78,14,26,22]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(r,o){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,s=new Map,a=2e4;function u(k,O,M,W){const q=O.substring(k.length+1);return R.Promises.withAsyncBody(async L=>{let $;try{$=await C.Promises.readdir(O,{withFileTypes:!0})}catch(B){L();return}if(W.count>=a){W.count+=$.length,W.maxReached=!0,L();return}let _=$.length;if(_===0){L();return}let F=$;W.count+$.length>a&&(W.maxReached=!0,_=a-W.count,F=$.slice(0,_)),W.count+=$.length;for(const B of F)if(B.isDirectory()){if(M.includes(B.name)||await u(k,(0,P.join)(O,B.name),M,W),--_==0){L();return}}else{const Z=B.name.lastIndexOf(".");if(Z>=0){const H=B.name.substring(Z+1);H&&t.set(H,(t.get(H)??0)+1)}for(const H of n)H.relativePathPattern?.test(q)!==!1&&H.filePattern.test(B.name)&&s.set(H.tag,(s.get(H.tag)??0)+1);if(--_==0){L();return}}})}const g={count:0,maxReached:!1};await u(r,r,o,g);const y=await c(r);return{configFiles:w(s),fileTypes:w(t),fileCount:g.count,maxFilesReached:g.maxReached,launchConfigFiles:y}}e.collectWorkspaceStats=m;function w(r){return[...A.Iterable.map(r.entries(),([o,n])=>({name:o,count:n}))].sort((o,n)=>n.count-o.count)}function f(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},o=D.cpus();return o&&o.length>0&&(r.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),r}e.getMachineInfo=f;async function c(r){try{const o=new Map,n=(0,P.join)(r,".vscode","launch.json"),t=await C.Promises.readFile(n),s=[],a=(0,T.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,T.getNodeType)(a)==="object"&&a.configurations)for(const u of a.configurations){const g=u.type;g&&(o.has(g)?o.set(g,o.get(g)+1):o.set(g,1))}return w(o)}catch(o){return[]}}e.collectLaunchConfigs=c;let l=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),S.isWindows||n.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,d.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async t=>{let[s,a]=t,u=this.formatProcessList(o,s);return n.forEach(g=>{if((0,p.isRemoteDiagnosticError)(g))u+=`
${g.errorMessage}`,a+=`
${g.errorMessage}`;else if(u+=`

Remote: ${g.hostName}`,g.processes&&(u+=`
${this.formatProcessList(o,g.processes)}`),g.workspaceMetadata){a+=`
|  Remote: ${g.hostName}`;for(const y of Object.keys(g.workspaceMetadata)){const k=g.workspaceMetadata[y];let O=`${k.fileCount} files`;k.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${y}): ${O}`,a+=this.formatWorkspaceStats(k)}}}),{processInfo:u,workspaceInfo:a}})}async getSystemInfo(o,n){const{memory:t,vmHint:s,os:a,cpus:u}=f(),g={os:a,memory:t,cpus:u,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return S.isWindows||(g.load=`${D.loadavg().map(y=>Math.round(y)).join(", ")}`),S.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(o,n){const t=[];return(0,d.listProcesses)(o.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(o)),t.push(""),t.push(this.formatProcessList(o,s)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(o))),n.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))t.push(`
${a.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${a.hostName}`),t.push(this.formatMachineInfo(a.machineInfo)),a.processes&&t.push(this.formatProcessList(o,a.processes)),a.workspaceMetadata)for(const u of Object.keys(a.workspaceMetadata)){const g=a.workspaceMetadata[u];let y=`${g.fileCount} files`;g.maxFilesReached&&(y=`more than ${y}`),t.push(`Folder (${u}): ${y}`),t.push(this.formatWorkspaceStats(g))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(o){const n=[],t=60;let s=0;const a=(k,O)=>{const M=` ${k}(${O})`;s+M.length>t?(n.push(u),u="|                 ",s=u.length):s+=M.length,u+=M};let u="|      File types:";const g=10;let y=o.fileTypes.length>g?g:o.fileTypes.length;for(let k=0;k<y;k++){const O=o.fileTypes[k];a(O.name,O.count)}if(n.push(u),o.configFiles.length>=0&&(u="|      Conf files:",s=0,o.configFiles.forEach(k=>{a(k.name,k.count)}),n.push(u)),o.launchConfigFiles.length>0){let k="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{k+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(k)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${o[t]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],t=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const u=b.URI.revive(a);if(u.scheme===i.Schemas.file){const g=u.fsPath;t.push(m(g,["node_modules",".git"]).then(y=>{let k=`${y.fileCount} files`;y.maxFilesReached&&(k=`more than ${k}`),n.push(`|    Folder (${(0,P.basename)(g)}): ${k}`),n.push(this.formatWorkspaceStats(y))}).catch(y=>{n.push(`|      Error: Unable to collect workspace stats for folder ${g} (${y.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(o,n){const t=new Map;o.windows.forEach(a=>t.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,t,s,n,0),s.join(`
`)}formatProcessItem(o,n,t,s,a){const u=a===0;let g;u?g=s.pid===o?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(g=`${g} (${n.get(s.pid)})`));const y=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(y/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(s.children)&&s.children.forEach(k=>this.formatProcessItem(o,n,t,k,a+1))}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const t=b.URI.revive(n);if(t.scheme!==i.Schemas.file)continue;const s=t.fsPath;try{const a=await m(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:u.name,count:u.count})}),a.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:u.name,count:u.count})}),a.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};l=de([G(0,v.ITelemetryService),G(1,E.IProductService)],l),e.DiagnosticsService=l}),define(te[202],ne([0,1,17,5,27,9,3,2,4,7,130,30,35,8,26,22]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let v=class extends P.Disposable{constructor(r,o,n,t){super();this.galleryService=r,this.telemetryService=o,this.logService=n,this.productService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new i.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new i.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new i.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new i.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(n=>(0,C.isTargetPlatformCompatible)(n,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{if(!this.galleryService.isEnabled())throw new C.ExtensionManagementError(I.localize(0,null),C.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(r,!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,o)}catch(n){throw f(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,n),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(n),w(n)}}async uninstall(r,o={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,o)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const o=await this.findGalleryExtension(r);if(!o)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsReport(){const r=new Date().getTime();return(!this.reportedExtensions||r-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=r),this.reportedExtensions}registerParticipant(r){this.participants.push(r)}async installExtension(r,o,n){if(!b.URI.isUri(o)){let g=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(o.identifier,o.version).key());if(g)return this.logService.info("Extensions is already requested to install",o.identifier.id),g.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],s=[],a=this.createInstallExtensionTask(r,o,n);b.URI.isUri(o)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(a.identifier,r.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:o}),this.logService.info("Installing extension:",a.identifier.id),t.push({task:a,manifest:r});let u=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const y=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:k,manifest:O}of y)if(u=u||!!O.extensionDependencies?.some(M=>(0,d.areSameExtensions)({id:M},a.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(k.identifier,k.version).key()))this.logService.info("Extension is already requested to install",k.identifier.id);else{const M=this.createInstallExtensionTask(O,k,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(M.identifier,O.version).key(),M),this._onInstallExtension.fire({identifier:M.identifier,source:k}),this.logService.info("Installing extension:",M.identifier.id),t.push({task:M,manifest:O})}}catch(y){if(b.URI.isUri(a.source))(0,D.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,y.message),(0,D.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,y.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),y}const g=t.reduce((y,{task:k,manifest:O})=>(y.set(k.identifier.id.toLowerCase(),{task:k,manifest:O}),y),new Map);for(;g.size;){let y;const k=[...g.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(M=>g.has(M.toLowerCase())));k.length?y=g.size===1?k:k.filter(({task:O})=>!(O===a&&!u)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:O})=>O.identifier.id)),y=[...g.values()]),await this.joinAllSettled(y.map(async({task:O})=>{const M=new Date().getTime();try{const W=await O.run();if(await this.joinAllSettled(this.participants.map(q=>q.postInstall(W,O.source,n,R.CancellationToken.None))),!b.URI.isUri(O.source)&&(f(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-M,void 0),S.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch(q){}s.push({local:W,identifier:O.identifier,operation:O.operation,source:O.source})}catch(W){throw b.URI.isUri(O.source)||f(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-M,W),this.logService.error("Error while installing the extension:",O.identifier.id),W}finally{g.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:y})=>this.logService.info("Extension installed successfully:",y.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:y})=>(0,d.areSameExtensions)(y,a.identifier))[0].local}catch(g){if(t.forEach(({task:y})=>y.cancel()),s.length)try{const y=await Promise.allSettled(s.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0}).run()));for(let k=0;k<y.length;k++){const O=y[k],{identifier:M}=s[k];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",M.id):this.logService.warn("Rollback: Error while uninstalling extension",M.id,(0,T.getErrorMessage)(O.reason))}}catch(y){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(y),s.map(({identifier:k})=>k.id))}throw this._onDidInstallExtensions.fire(t.map(({task:y})=>({identifier:y.identifier,operation:1,source:y.source}))),g}finally{for(const{task:g,manifest:y}of t)if(!b.URI.isUri(g.source)){const k=new d.ExtensionIdentifierWithVersion(g.identifier,y.version).key();this.installingExtensions.delete(k)||this.logService.warn("Installation task is not found in the cache",k)}}}async joinAllSettled(r){const o=[],n=[],t=await Promise.allSettled(r);for(const s of t)s.status==="fulfilled"?o.push(s.value):n.push(s.reason);if(n.length)throw m(n);return o}async getAllDepsAndPackExtensionsToInstall(r,o,n,t){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const a=[r,...s.map(y=>y.identifier)],u=[],g=async(y,k)=>{const O=k.extensionDependencies||[],M=[...O];if(k.extensionPack){const W=n?s.find(q=>(0,d.areSameExtensions)(q.identifier,y)):void 0;for(const q of k.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(L=>(0,d.areSameExtensions)({id:L},{id:q}))||M.every(L=>!(0,d.areSameExtensions)({id:L},{id:q}))&&M.push(q)}if(M.length){const W=[...a,...u.map(L=>L.gallery.identifier)],q=M.filter(L=>W.every($=>!(0,d.areSameExtensions)($,{id:L})));if(q.length){const L=await this.galleryService.query({names:q,pageSize:M.length},R.CancellationToken.None);for(const $ of L.firstPage){if(W.find(B=>(0,d.areSameExtensions)(B,$.identifier)))continue;const _=O.some(B=>(0,d.areSameExtensions)({id:B},$.identifier));let F;try{F=await this.checkAndGetCompatibleVersion($,!0,t)}catch(B){if(B instanceof C.ExtensionManagementError&&B.code===C.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!_){this.logService.info("Skipping the packed extension as it cannot be installed",$.identifier.id);continue}else throw B}u.push({gallery:F.extension,manifest:F.manifest}),await g(F.extension.identifier,k)}}}};return await g(r,o),s=await this.getInstalled(),u.filter(y=>!s.some(k=>(0,d.areSameExtensions)(k.identifier,y.gallery.identifier)))}async checkAndGetCompatibleVersion(r,o,n){if(await this.isMalicious(r))throw new C.ExtensionManagementError(I.localize(3,null,r.identifier.id),C.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(r)){const a=await this.getTargetPlatform();throw new C.ExtensionManagementError(I.localize(4,null,r.identifier.id,this.productService.nameLong,(0,C.TargetPlatformToString)(a)),C.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const t=await this.getCompatibleVersion(r,o,n);if(t){if(n&&r.hasPreReleaseVersion&&!t.properties.isPreReleaseVersion)throw new C.ExtensionManagementError(I.localize(5,null,r.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new C.ExtensionManagementError(I.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.Incompatible);const s=await this.galleryService.getManifest(t,R.CancellationToken.None);if(s===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);if(s.version!==t.version)throw new C.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);return{extension:t,manifest:s}}async getCompatibleVersion(r,o,n){const t=await this.getTargetPlatform();let s=null;return o&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==n&&(s=await this.galleryService.getCompatibleExtension(r.identifier,n,t)),!s&&await this.galleryService.isExtensionCompatible(r,n,t)&&(s=r),!s&&o&&(s=await this.galleryService.getCompatibleExtension(r,n,t)),s}async isMalicious(r){const o=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(o).has(r.identifier.id)}async unininstallExtension(r,o){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const t=(g,y)=>{const k=this.createUninstallExtensionTask(g,y);return this.uninstallingExtensions.set(k.extension.identifier.id.toLowerCase(),k),this.logService.info("Uninstalling extension:",g.identifier.id),this._onUninstallExtension.fire(g.identifier),k},s=(g,y)=>{y?this.logService.error("Failed to uninstall extension:",g.identifier.id,y.message):this.logService.info("Successfully uninstalled extension:",g.identifier.id),f(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(g),void 0,y),this._onDidUninstallExtension.fire({identifier:g.identifier,error:y?.code})},a=[],u=[];try{a.push(t(r,{}));const g=await this.getInstalled(1);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const y=this.getAllPackExtensionsToUninstall(r,g);for(const k of y)this.uninstallingExtensions.has(k.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",k.identifier.id):a.push(t(k,{}))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(a.map(y=>y.extension),g,r),await this.joinAllSettled(a.map(async y=>{try{if(await y.run(),await this.joinAllSettled(this.participants.map(k=>k.postUninstall(y.extension,o,R.CancellationToken.None))),y.extension.identifier.uuid)try{await this.galleryService.reportStatistic(y.extension.manifest.publisher,y.extension.manifest.name,y.extension.manifest.version,"uninstall")}catch(k){}s(y.extension)}catch(k){const O=k instanceof C.ExtensionManagementError?k:new C.ExtensionManagementError((0,T.getErrorMessage)(k),C.ExtensionManagementErrorCode.Internal);throw s(y.extension,O),O}finally{u.push(y)}}))}catch(g){const y=g instanceof C.ExtensionManagementError?g:new C.ExtensionManagementError((0,T.getErrorMessage)(g),C.ExtensionManagementErrorCode.Internal);for(const k of a){try{k.cancel()}catch(O){}u.includes(k)||s(k.extension,y)}throw y}finally{for(const g of a)this.uninstallingExtensions.delete(g.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",g.extension.identifier.id)}}checkForDependents(r,o,n){for(const t of r){const s=this.getDependents(t,o);if(s.length){const a=s.filter(u=>!r.some(g=>(0,d.areSameExtensions)(g.identifier,u.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(t,a,n))}}}getDependentsErrorMessage(r,o,n){return n===r?o.length===1?I.localize(7,null,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(8,null,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(9,null,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?I.localize(10,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(11,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(12,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(r,o,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const t=r.manifest.extensionPack?r.manifest.extensionPack:[];if(t.length){const s=o.filter(u=>!u.isBuiltin&&t.some(g=>(0,d.areSameExtensions)({id:g},u.identifier))),a=[];for(const u of s)a.push(...this.getAllPackExtensionsToUninstall(u,o,n));return[...s,...a]}return[]}getDependents(r,o){return o.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(t=>(0,d.areSameExtensions)({id:t},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const o=await this.findGalleryExtensionById(r.identifier.uuid);return o||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${r.length} reported extensions from service`),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};v=de([G(0,C.IExtensionGalleryService),G(1,E.ITelemetryService),G(2,p.ILogService),G(3,h.IProductService)],v),e.AbstractExtensionManagementService=v;function m(l){const r=Array.isArray(l)?l:[l];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,n)=>new Error(`${o.message}${o.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=m;function w(l){if(l instanceof C.ExtensionManagementError)return l;const r=new C.ExtensionManagementError(l.message,C.ExtensionManagementErrorCode.Internal);return r.stack=l.stack,r}function f(l,r,o,n,t){const s=t?t instanceof C.ExtensionManagementError?t.code:C.ExtensionManagementErrorCode.Internal:void 0;l.publicLogError(r,{...o,success:!t,duration:n,errorcode:s})}e.reportTelemetry=f;class c{constructor(){this.barrier=new A.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,A.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,A.createCancelablePromise)(r=>new Promise((o,n)=>{const t=r.onCancellationRequested(()=>{t.dispose(),n((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=c}),define(te[203],ne([0,1,17,5,66,3,10,4,32,7,132,11,30,193,80,14,8,60,26,43,23,22]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",o="extensionTips/lastPromptedMediumImpExeTime";let n=class extends p.ExtensionTipsService{constructor(s,a,u,g,y,k,O,M,W,q){super(O,M,W,q);this.environmentService=s,this.telemetryService=a,this.extensionManagementService=u,this.storageService=g,this.nativeHostService=y,this.extensionRecommendationNotificationService=k,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,M.exeBasedExtensionTips&&(0,R.forEach)(M.exeBasedExtensionTips,({key:L,value:$})=>{const _=[],F=[],B=[];(0,R.forEach)($.recommendations,({key:Z,value:H})=>{H.important?$.important?_.push({extensionId:Z,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):F.push({extensionId:Z,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):B.push({extensionId:Z,extensionName:H.name,isExtensionPack:!!H.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:_}),F.length&&this.mediumImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:F}),B.length&&this.allOtherExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:B})}),(0,A.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...a]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(a,u)}groupImportantTipsByExe(s,a){const u=new Map;s.forEach(M=>u.set(M.extensionId.toLowerCase(),M));const{installed:g,uninstalled:y}=this.groupByInstalled([...u.keys()],a);for(const M of g){const W=u.get(M);W&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:M,exeName:W.exeName})}for(const M of y){const W=u.get(M);W&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:M,exeName:W.exeName})}const k=this.getPromptedExecutableTips(),O=new Map;for(const M of y){const W=u.get(M);if(W&&(!k[W.exeName]||!k[W.exeName].includes(W.extensionId))){let q=O.get(W.exeName);q||(q=[],O.set(W.exeName,q)),q.push(W)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,a]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(a).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(a[0].exeName,a);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":const g=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const y=this._register((0,A.disposableTimeout)(()=>{y.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),a=Date.now()-s,u=7*24*60*60*1e3;if(a<u){const k=this._register((0,A.disposableTimeout)(()=>{k.dispose(),this.promptMediumImportanceExeBasedTip()},u-a));return}const[g,y]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(y).then(k=>{switch(k){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(y[0].exeName,y);const O=this._register((0,A.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const M=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(M(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const W=this._register((0,A.disposableTimeout)(()=>{W.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(s){const a=s.map(({extensionId:g})=>g.toLowerCase()),u=(0,I.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,u,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(o,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(o,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,a){const u=this.getPromptedExecutableTips();u[s]=a.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(r,JSON.stringify(u),0,0)}groupByInstalled(s,a){const u=[],g=[],y=a.reduce((k,O)=>(k.add(O.identifier.id.toLowerCase()),k),new Set);return s.forEach(k=>{y.has(k.toLowerCase())?u.push(k):g.push(k)}),{installed:u,uninstalled:g}}async getValidExecutableBasedExtensionTips(s){const a=[],u=new Map;for(const g of s.keys()){const y=s.get(g);if(!y||!(0,D.isNonEmptyArray)(y.recommendations))continue;const k=[];P.isWindows?y.windowsPath&&k.push(y.windowsPath.replace("%USERPROFILE%",S.env.USERPROFILE).replace("%ProgramFiles(x86)%",S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",S.env.ProgramFiles).replace("%APPDATA%",S.env.APPDATA).replace("%WINDIR%",S.env.WINDIR)):(k.push((0,i.join)("/usr/local/bin",g)),k.push((0,i.join)("/usr/bin",g)),k.push((0,i.join)(this.environmentService.userHome.fsPath,g)));for(const O of k){let M=u.get(O);if(M===void 0&&(M=await this.fileService.exists(b.URI.file(O)),u.set(O,M)),M)for(const{extensionId:W,extensionName:q,isExtensionPack:L}of y.recommendations)a.push({extensionId:W,extensionName:q,isExtensionPack:L,exeName:g,exeFriendlyName:y.exeFriendlyName,windowsPath:y.windowsPath})}}return a}};n=de([G(0,C.INativeEnvironmentService),G(1,l.ITelemetryService),G(2,d.IExtensionManagementService),G(3,c.IStorageService),G(4,m.INativeHostService),G(5,h.IExtensionRecommendationNotificationService),G(6,E.IFileService),G(7,w.IProductService),G(8,f.IRequestService),G(9,v.ILogService)],n),e.ExtensionTipsService=n}),define(te[92],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,i){throw new Error(`Event not found: ${i}`)}call(T,i,{eventName:P,data:S}){return this.appenders.forEach(b=>b.log(P,S)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class A{constructor(T){this.channel=T}log(T,i){return this.channel.call("log",{eventName:T,data:i}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(te[44],ne([0,1,28,15,21,22]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class i{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,w){return Promise.resolve(void 0)}publicLog2(m,w){return this.publicLog(m,w)}publicLogError(m,w){return Promise.resolve(void 0)}publicLogError2(m,w){return this.publicLogError(m,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=i,e.NullTelemetryService=new i;class P{async publicLog(m,w,f){}async publicLogError(m,w,f){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(v,m){return m.onDidChangeConfiguration(w=>{w.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=S;function b(v,m){return!(m.disableTelemetry||!v.enableTelemetry)}e.supportsTelemetry=b;function I(v){const m=v.getValue(T.TELEMETRY_SETTING_ID),w=v.getValue("telemetry.enableCrashReporter");if(v.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function C(v){const m=Object.create(null),w=Object.create(null),f=Object.create(null);p(v,f);for(let c in f){c=c.length>150?c.substr(c.length-149):c;const l=f[c];typeof l=="number"?w[c]=l:typeof l=="boolean"?w[c]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${l.length}`),m[c]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(m[c]=l)}return{properties:m,measurements:w}}e.validateTelemetryData=C;function d(v){if(!v)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{v.indexOf(`${f}+`)===0&&(m=f)}),m}e.cleanRemoteAuthority=d;function p(v,m,w=0,f){if(!!v)for(let c of Object.getOwnPropertyNames(v)){const l=v[c],r=f?f+c:c;Array.isArray(l)?m[r]=(0,D.safeStringify)(l):l instanceof Date?m[r]=l.toISOString():(0,A.isObject)(l)?w<2?p(l,m,w+1,r+"."):m[r]=(0,D.safeStringify)(l):m[r]=l}}function h(v){if(!v)return[];const m=[];return E(m,"",v),m}function E(v,m,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(f=>E(v,m?`${m}.${f}`:f,w[f])):v.push(m)}}),define(te[204],ne([0,1,44,150]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class R{constructor(){}setSharedProperty(S,b){}postEvent(S,b){}}class T{constructor(S,b,I,C,d){this.getMachineId=S,this.configurationService=b,this.productService=I,this.telemetry=C,this.keyValueStorage=d,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,D.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(E=>setTimeout(E,h))}get experimentsEnabled(){return!0}async getTreatment(S){await this.overrideInitDelay;const b=this.configurationService.getValue("experiments.override."+S);if(b!==void 0)return b;if(!this.tasClient||!this.experimentsEnabled)return;let I;const C=await this.tasClient;return this.networkInitialized?I=C.getTreatmentVariable("vscode",S):I=await C.getTreatmentVariableAsync("vscode",S,!0),I=C.getTreatmentVariable("vscode",S),I}async setupTASClient(){const S=this.productService.quality==="stable"?A.TargetPopulation.Public:A.TargetPopulation.Insiders,b=await this.getMachineId(),I=new A.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,b,S),C=this.productService.tasConfig,d=new(await new Promise((p,h)=>{J(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:A.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:C.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:C.assignmentContextTelemetryPropertyName,telemetryEventName:C.telemetryEventName,endpoint:C.endpoint,refetchInterval:A.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=T;class i extends T{constructor(S,b,I){super(()=>Promise.resolve(S),b,I,new R)}}e.AssignmentService=i}),define(te[205],ne([0,1,17,27,9,28,4,32,15,7,21,11,30,35,76,14,8,26,43,46,23,22,44]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const o=i.isWeb?"web":(0,d.getTargetPlatform)(i.platform,P.arch);var n;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished"})(n||(n={}));function t(...V){return String(V.reduce((X,se)=>X|se,0))}var s;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class k{constructor(X=y){this.state=X}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(X,se=this.state.pageSize){return new k({...this.state,pageNumber:X,pageSize:se})}withFilter(X,...se){const oe=[...this.state.criteria,...se.length?se.map(le=>({filterType:X,value:le})):[{filterType:X}]];return new k({...this.state,criteria:oe})}withSortBy(X){return new k({...this.state,sortBy:X})}withSortOrder(X){return new k({...this.state,sortOrder:X})}withFlags(...X){return new k({...this.state,flags:X.reduce((se,oe)=>se|oe,0)})}withAssetTypes(...X){return new k({...this.state,assetTypes:X})}get raw(){const{criteria:X,pageNumber:se,pageSize:oe,sortBy:le,sortOrder:he,flags:be,assetTypes:Ce}=this.state;return{filters:[{criteria:X,pageNumber:se,pageSize:oe,sortBy:le,sortOrder:he}],assetTypes:Ce,flags:be}}get searchText(){const X=this.state.criteria.filter(se=>se.filterType===s.SearchText)[0];return X&&X.value?X.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(X=>String(X.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(V,X){const se=(V||[]).filter(oe=>oe.statisticName===X)[0];return se?se.value:0}function M(V){const X="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(oe=>oe.assetType.indexOf(X)===0).reduce((oe,le)=>{const he=$(V,le.assetType);return he&&oe.push([le.assetType.substring(X.length),he]),oe},[])}function W(V){if(V.properties){const X=V.properties.filter(le=>le.key===a.Repository),se=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),oe=X.filter(le=>se.test(le.value))[0];return oe?{uri:oe.value,fallbackUri:oe.value}:null}return $(V,a.Repository)}function q(V){return{uri:`${V.fallbackAssetUri}/${a.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${a.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function L(V){const X=$(V,a.Icon);if(X)return X;const se=d.DefaultIconPath;return{uri:se,fallbackUri:se}}function $(V,X){return V.files.filter(oe=>oe.assetType===X)[0]?{uri:`${V.assetUri}/${X}`,fallbackUri:`${V.fallbackAssetUri}/${X}`}:null}function _(V,X){const se=V.properties?V.properties.filter(le=>le.key===X):[],oe=se.length>0&&se[0].value;return oe?oe.split(",").map(le=>(0,p.adoptToGalleryExtensionId)(le)):[]}function F(V){const X=V.properties?V.properties.filter(se=>se.key===u.Engine):[];return X.length>0&&X[0].value||""}function B(V){const X=V.properties?V.properties.filter(se=>se.key===u.PreRelease):[];return X.length>0&&X[0].value==="true"}function Z(V){const X=V.properties?V.properties.filter(oe=>oe.key===u.LocalizedLanguages):[],se=X.length>0&&X[0].value||"";return se?se.split(","):[]}function H(V){return V.indexOf("preview")!==-1}function j(V){return V.targetPlatform?(0,d.toTargetPlatform)(V.targetPlatform):"undefined"}function Q(V){const X=(0,D.distinct)(V.versions.map(j)),se=!!V.tags?.includes(d.WEB_EXTENSION_TAG),oe=X.indexOf("web");return se?oe===-1&&X.push("web"):oe!==-1&&X.splice(oe,1),X}function U(V,X){const se=(0,d.getFallbackTargetPlarforms)(X);for(let oe=0;oe<V.length;oe++){const le=V[oe];if(le.version===V[oe-1]?.version){let he=oe;const be=j(le);if(be===X)for(;he>0&&V[he-1].version===le.version;)he--;else if(se.includes(be))for(;he>0&&V[he-1].version===le.version&&j(V[he-1])!==X;)he--;he!==oe&&(V.splice(oe,1),V.splice(he,0,le))}}return V}e.sortExtensionVersions=U;function N(V,X,se,oe){const le=V.versions[0],he={manifest:$(X,a.Manifest),readme:$(X,a.Details),changelog:$(X,a.Changelog),license:$(X,a.License),repository:W(X),download:q(X),icon:L(X),coreTranslations:M(X)};return{identifier:{id:(0,p.getGalleryExtensionId)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:X.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,publisherDomain:V.publisher.domain?{link:V.publisher.domain,verified:!!V.publisher.isDomainVerified}:void 0,description:V.shortDescription||"",installCount:O(V.statistics,"install"),rating:O(V.statistics,"averagerating"),ratingCount:O(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:se,assets:he,properties:{dependencies:_(X,u.Dependency),extensionPack:_(X,u.ExtensionPack),engine:F(X),localizedLanguages:Z(X),targetPlatform:j(X),isPreReleaseVersion:B(X)},hasPreReleaseVersion:B(le),preview:H(V.flags),telemetryData:oe}}let z=class{constructor(X,se,oe,le,he,be,Ce,we){this.requestService=se,this.logService=oe,this.environmentService=le,this.telemetryService=he,this.fileService=be,this.productService=Ce,this.configurationService=we;const ve=Ce.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=ee(Ce.version,Ce,this.environmentService,this.configurationService,this.fileService,X)}api(X=""){return`${this.extensionsGalleryUrl}${X}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(X,se,oe){const le=(0,S.isBoolean)(se)?se:!1,he=(0,S.isBoolean)(se)?oe:se;let be=new k().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,X.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...X.map(({id:ve})=>ve.toLowerCase()));X.every(ve=>!ve.version)&&(be=be.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:Ce}=await this.queryGallery(be,o,A.CancellationToken.None),we=Ce.map(ve=>{const De=(0,p.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName);return{rawGalleryExtension:ve,version:X.find(Se=>(0,p.areSameExtensions)(Se,{id:De}))?.version}});return this.converToGalleryExtensions(we,le,o,()=>{},he)}async getCompatibleExtension(X,se,oe){const le=(0,d.isIExtensionIdentifier)(X)?null:X;if(le){if((0,d.isNotWebExtensionInWebTargetPlatform)(le.allTargetPlatforms,oe))return null;if(await this.isExtensionCompatible(le,se,oe))return le}const{id:he,uuid:be}=le?le.identifier:X;let Ce=new k().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");be?Ce=Ce.withFilter(s.ExtensionId,be):Ce=Ce.withFilter(s.ExtensionName,he);const{galleryExtensions:we}=await this.queryGallery(Ce,oe,A.CancellationToken.None),[ve]=we;if(!ve||!ve.versions.length)return null;const De=Q(ve);if((0,d.isNotWebExtensionInWebTargetPlatform)(De,oe))return null;for(let Se of ve.versions){if(!F(Se)){const Ie=await this.getEngine(Se);Se={...Se,properties:[...Se.properties||[],{key:u.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(Se,se,De,oe))return N(ve,Se,De)}return null}async isExtensionCompatible(X,se,oe){if(!(0,d.isTargetPlatformCompatible)(X.properties.targetPlatform,X.allTargetPlatforms,oe)||!se&&X.properties.isPreReleaseVersion)return!1;let le=X.properties.engine;if(!le){const he=await this.getManifest(X,A.CancellationToken.None);if(!he)throw new Error("Manifest was not found");le=he.engines.vscode}return(0,h.isEngineValid)(le,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(X,se,oe,le){if(!(0,d.isTargetPlatformCompatible)(j(X),oe,le)||!se&&B(X))return!1;const he=await this.getEngine(X);return(0,h.isEngineValid)(he,this.productService.version,this.productService.date)}async query(X,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let oe=X.text||"";const le=(0,T.getOrDefault)(X,Se=>Se.pageSize,50);let he=new k().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,le).withFilter(s.Target,"Microsoft.VisualStudio.Code");oe?(oe=oe.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Se,Ie,Me)=>(he=he.withFilter(s.Category,Me||Ie),"")),oe=oe.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Se,Ie,Me)=>(he=he.withFilter(s.Tag,Me||Ie),"")),oe=oe.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),oe=oe.trim(),oe&&(oe=oe.length<200?oe:oe.substring(0,200),he=he.withFilter(s.SearchText,oe)),he=he.withSortBy(0)):X.ids?he=he.withFilter(s.ExtensionId,...X.ids):X.names?he=he.withFilter(s.ExtensionName,...X.names):he=he.withSortBy(4),typeof X.sortBy=="number"&&(he=he.withSortBy(X.sortBy)),typeof X.sortOrder=="number"&&(he=he.withSortOrder(X.sortOrder));const{galleryExtensions:be,total:Ce}=await this.queryGallery(he,o,se),we=Se=>({index:(he.pageNumber-1)*he.pageSize+Se,querySource:X.source}),ve=await this.converToGalleryExtensions(be.map(Se=>({rawGalleryExtension:Se})),!!X.includePreRelease,o,we,se),De=async(Se,Ie)=>{if(Ie.isCancellationRequested)throw(0,R.canceled)();const Me=he.withPage(Se+1),{galleryExtensions:je}=await this.queryGallery(Me,o,Ie);return await this.converToGalleryExtensions(je.map(Ne=>({rawGalleryExtension:Ne})),!!X.includePreRelease,o,we,se)};return{firstPage:ve,total:Ce,pageSize:he.pageSize,getPage:De}}async converToGalleryExtensions(X,se,oe,le,he){const be=(ve,De)=>{const Se=Q(ve);let Ie=ve.versions[0];return Ie=ve.versions.find(Me=>Me.version===Ie.version&&(0,d.isTargetPlatformCompatible)(j(Me),Se,oe))||Ie,!se&&B(Ie)&&(Ie=ve.versions.find(Me=>Me.version!==Ie.version&&!B(Me))||Ie),N(ve,Ie,Se,le(De))},Ce=[],we=new Map;for(let ve=0;ve<X.length;ve++){const{rawGalleryExtension:De,version:Se}=X[ve];if(Se){const Ie=De.versions.find(Me=>Me.version===Se);Ie&&Ce.push([ve,N(De,Ie,Q(De))])}else{const Ie=be(De,ve);Ie.properties.isPreReleaseVersion&&!se?we.set(Ie.identifier.uuid,ve):Ce.push([ve,Ie])}}if(we.size){const ve=new k().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,we.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...we.keys()),{galleryExtensions:De}=await this.queryGallery(ve,oe,he);if(De.length!==we.size)throw new Error("Not all extensions with latest versions are returned");for(const Se of De){const Ie=we.get(Se.extensionId),Me=be(Se,Ie);Ce.push([Ie,Me])}}return Ce.sort((ve,De)=>ve[0]-De[0]).map(([,ve])=>ve)}async queryGallery(X,se,oe){if(!this.isEnabled())throw new Error("No extension gallery service configured.");X=X.withFlags(X.flags,n.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,t(n.Unpublished));const le=await this.commonHeadersPromise,he=JSON.stringify(X.raw),be={...le,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},Ce=new Date().getTime();let we,ve,De=0;try{if(we=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:be},oe),we.res.statusCode&&we.res.statusCode>=400&&we.res.statusCode<500)return{galleryExtensions:[],total:De};const Se=await(0,w.asJson)(we);if(Se){const Ie=Se.results[0],Me=Ie.extensions;Me.forEach(Ne=>U(Ne.versions,se));const je=Ie.resultMetadata&&Ie.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return De=je&&je.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Me,total:De}}return{galleryExtensions:[],total:De}}catch(Se){throw ve=Se,Se}finally{this.telemetryService.publicLog2("galleryService:query",{...X.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-Ce,success:!!we&&(0,w.isSuccess)(we),responseBodySize:we?.res.headers["Content-Length"],statusCode:we?String(we.res.statusCode):void 0,errorCode:ve?(0,R.isPromiseCanceledError)(ve)?"canceled":(0,R.getErrorMessage)(ve).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(De)})}}async reportStatistic(X,se,oe,le){if(!this.isEnabled())return;const he=i.isWeb?this.api(`/itemName/${X}.${se}/version/${oe}/statType/${le==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${X}/extensions/${se}/${oe}/stats?statType=${le}`),be=i.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:be};try{await this.requestService.request({type:"POST",url:he,headers:we},A.CancellationToken.None)}catch(ve){}}async download(X,se,oe){this.logService.trace("ExtensionGalleryService#download",X.identifier.id);const le=(0,p.getGalleryExtensionTelemetryData)(X),he=new Date().getTime(),be=De=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...le,duration:De}),Ce=oe===1?"install":oe===2?"update":"",we=Ce?{uri:`${X.assets.download.uri}${b.URI.parse(X.assets.download.uri).query?"&":"?"}${Ce}=true`,fallbackUri:`${X.assets.download.fallbackUri}${b.URI.parse(X.assets.download.fallbackUri).query?"&":"?"}${Ce}=true`}:X.assets.download,ve=await this.getAsset(we);await this.fileService.writeFile(se,ve.stream),be(new Date().getTime()-he)}async getReadme(X,se){if(X.assets.readme){const oe=await this.getAsset(X.assets.readme,{},se);return await(0,w.asText)(oe)||""}return""}async getManifest(X,se){if(X.assets.manifest){const oe=await this.getAsset(X.assets.manifest,{},se),le=await(0,w.asText)(oe);return le?JSON.parse(le):null}return null}async getManifestFromRawExtensionVersion(X,se){const oe=$(X,a.Manifest);if(!oe)throw new Error("Manifest was not found");const le={"Accept-Encoding":"gzip"},he=await this.getAsset(oe,{headers:le});return await(0,w.asJson)(he)}async getCoreTranslation(X,se){const oe=X.assets.coreTranslations.filter(le=>le[0]===se.toUpperCase())[0];if(oe){const le=await this.getAsset(oe[1]),he=await(0,w.asText)(le);return he?JSON.parse(he):null}return null}async getChangelog(X,se){if(X.assets.changelog){const oe=await this.getAsset(X.assets.changelog,{},se);return await(0,w.asText)(oe)||""}return""}async getAllCompatibleVersions(X,se,oe){let le=new k().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");X.identifier.uuid?le=le.withFilter(s.ExtensionId,X.identifier.uuid):le=le.withFilter(s.ExtensionName,X.identifier.id);const{galleryExtensions:he}=await this.queryGallery(le,oe,A.CancellationToken.None);if(!he.length)return[];const be=Q(he[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(be,oe))return[];const Ce=[];for(const we of he[0].versions)try{Ce[Ce.length-1]?.version!==we.version&&await this.isRawExtensionVersionCompatible(we,se,be,oe)&&Ce.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:B(we)})}catch(ve){}return Ce}async getAsset(X,se={},oe=A.CancellationToken.None){const le=await this.commonHeadersPromise,he={type:"GET"},be={...le,...se.headers||{}};se={...se,...he,headers:be};const Ce=X.uri,we=X.fallbackUri,ve={...se,url:Ce};try{const De=await this.requestService.request(ve,oe);if(De.res.statusCode===200)return De;const Se=await(0,w.asText)(De);throw new Error(`Expected 200, got back ${De.res.statusCode} instead.

${Se}`)}catch(De){if((0,R.isPromiseCanceledError)(De))throw De;const Se=(0,R.getErrorMessage)(De);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Ce,message:Se});const Ie={...se,url:we};return this.requestService.request(Ie,oe)}}async getEngine(X){let se=F(X);if(!se){const oe=await this.getManifestFromRawExtensionVersion(X,A.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");se=oe.engines.vscode}return se}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const X=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},A.CancellationToken.None);if(X.res.statusCode!==200)throw new Error("Could not get extensions report.");const se=await(0,w.asJson)(X),oe=new Map;if(se)for(const le of se.malicious){const he=oe.get(le)||{id:{id:le},malicious:!0,slow:!1};he.malicious=!0,oe.set(le,he)}return[...oe.values()]}};z=de([G(1,w.IRequestService),G(2,v.ILogService),G(3,C.IEnvironmentService),G(4,l.ITelemetryService),G(5,E.IFileService),G(6,m.IProductService),G(7,I.IConfigurationService)],z);let x=class extends z{constructor(X,se,oe,le,he,be,Ce,we){super(X,se,oe,le,he,be,Ce,we)}};x=de([G(0,c.IStorageService),G(1,w.IRequestService),G(2,v.ILogService),G(3,C.IEnvironmentService),G(4,l.ITelemetryService),G(5,E.IFileService),G(6,m.IProductService),G(7,I.IConfigurationService)],x),e.ExtensionGalleryService=x;let K=class extends z{constructor(X,se,oe,le,he,be,Ce){super(void 0,X,se,oe,le,he,be,Ce)}};K=de([G(0,w.IRequestService),G(1,v.ILogService),G(2,C.IEnvironmentService),G(3,l.ITelemetryService),G(4,E.IFileService),G(5,m.IProductService),G(6,I.IConfigurationService)],K),e.ExtensionGalleryServiceWithNoStorageService=K;async function ee(V,X,se,oe,le,he){const be={"X-Market-Client-Id":`VSCode ${V}`,"User-Agent":`VSCode ${V}`},Ce=await(0,f.getServiceMachineId)(se,le,he);return(0,r.supportsTelemetry)(X,se)&&(0,r.getTelemetryLevel)(oe)===3&&(be["X-Market-User-Id"]=Ce),be}e.resolveMarketplaceHeaders=ee}),define(te[93],ne([0,1,2,11,8,44]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let i=class extends D.Disposable{constructor(S,b,I=""){super();this.prefix=I;const C=S.getLogger(b.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(S.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(S,b){this.logger.trace(`${this.prefix}telemetry/${S}`,(0,T.validateTelemetryData)(b))}};i=de([G(0,R.ILoggerService),G(1,A.IEnvironmentService)],i),e.TelemetryLogAppender=i}),define(te[94],ne([0,1,2,28,4,25,142,21,42,86,37,22,44]),function(J,e,D,A,R,T,i,P,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(v,m){this._configurationService=m,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const f=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let m=v.sessionID,w=v["common.machineId"],f=v["common.firstSessionDate"],c=v["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:f,msftInternal:c}}dispose(){this._disposables.dispose()}_log(v,m,w,f){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(c=>{w=(0,A.mixin)(w,c),w=(0,A.mixin)(w,this._experimentProperties),w=(0,A.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,f)}),this._appenders.forEach(l=>l.log(v,w))},c=>{console.error(c)})}publicLog(v,m,w){return this._log(v,3,m,w)}publicLog2(v,m,w){return this.publicLog(v,m,w)}publicLogError(v,m){return this.sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}_anonymizeFilePaths(v){let m=v;const w=[];for(let r of this._cleanupPatterns)for(;;){const o=r.exec(v);if(!o)break;w.push([o.index,r.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const r=c.exec(v);if(!r)break;!f.test(r[0])&&w.every(([o,n])=>r.index<o||r.index>=n)&&(m+=v.substring(l,r.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}return l<v.length&&(m+=v.substr(l)),m}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const m=v.toLowerCase(),w=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":v}_cleanupInfo(v,m){let w=v;m&&(w=this._anonymizeFilePaths(w));for(let f of this._cleanupPatterns)w=w.replace(f,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=de([G(1,P.IConfigurationService)],p),e.TelemetryService=p;function h(){const E=(0,i.localize)(0,null,b.default.nameLong),v=b.default.privacyStatementUrl?(0,i.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,i.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=R.isWeb?"":(0,i.localize)(3,null),w=(0,i.localize)(4,null),f=(0,i.localize)(5,null),c=(0,i.localize)(6,null),l=(0,i.localize)(7,null),r=`
|       | ${w} | ${f} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,i.localize)(8,null);return`
${E} ${v} ${m}

&nbsp;

${l}
${r}

&nbsp;

${o}
`}I.Registry.as(S.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,i.localize)(10,null),(0,i.localize)(11,null),(0,i.localize)(12,null),(0,i.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(S.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,i.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,i.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,i.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[206],ne([0,1,9,28,44]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(P,S){const b=await new Promise((C,d)=>{J(["applicationinsights"],C,d)});let I;return b.defaultClient?(I=new b.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(b.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=b.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl=S?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class i{constructor(S,b,I,C,d){this._eventPrefix=S,this._defaultData=b,this.testCollector=C,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(b=>{S(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(S,b){!this._aiClient||(b=(0,A.mixin)(b,this._defaultData),b=(0,R.validateTelemetryData)(b),this.testCollector&&(b.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+S,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=i}),define(te[207],ne([0,1,16,52,21,11,8,22,92,93,94]),function(J,e,D,A,R,T,i,P,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(p,h,E,v){this.configurationService=p,this.telemetryService=h,this.loggerService=E,this.environmentService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:E}=await this.telemetryService.getTelemetryInfo(),v=Object.create(null);v["common.vscodemachineid"]=h,v["common.vscodesessionid"]=E;const m=[p.id,JSON.stringify(v),p.aiKey],f=new A.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new S.TelemetryAppenderClient(f),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new I.TelemetryService({appenders:c,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,E){await(await this.getCustomTelemetryService(p)).publicLog(h,E)}async publicLogError(p,h,E){await(await this.getCustomTelemetryService(p)).publicLogError(h,E)}};C=de([G(0,R.IConfigurationService),G(1,P.ITelemetryService),G(2,i.ILoggerService),G(3,T.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(te[208],ne([0,1,5,27,3,2,8]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(b,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((I,C)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,I),this._onCreateRequest.fire({requestId:d,...b});const p=new A.CancellationTokenSource;(0,D.timeout)(this._timeout,p.token).then(()=>C(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,T.toDisposable)(()=>p.cancel())])})}acceptReply(b,I){const C=this._pendingRequests.get(b);C?(this._pendingRequests.delete(b),(0,T.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),C(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=de([G(1,i.ILogService)],P),e.RequestStore=P}),define(te[95],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var A;(function(v){v.Shell="terminal.integrated.shell.",v.ShellArgs="terminal.integrated.shellArgs.",v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(A=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(v){v.ShellLinux="terminal.integrated.shell.linux",v.ShellMacOs="terminal.integrated.shell.osx",v.ShellWindows="terminal.integrated.shell.windows",v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationShellLinux="terminal.integrated.automationShell.linux",v.AutomationShellMacOs="terminal.integrated.automationShell.osx",v.AutomationShellWindows="terminal.integrated.automationShell.windows",v.AutomationProfileLinux="terminal.integrated.automationProfile.linux",v.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",v.AutomationProfileWindows="terminal.integrated.automationProfile.windows",v.ShellArgsLinux="terminal.integrated.shellArgs.linux",v.ShellArgsMacOs="terminal.integrated.shellArgs.osx",v.ShellArgsWindows="terminal.integrated.shellArgs.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.TerminalTitleSeparator="terminal.integrated.tabs.separator",v.TerminalTitle="terminal.integrated.tabs.title",v.TerminalDescription="terminal.integrated.tabs.description",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoEnabled="terminal.integrated.localEchoEnabled",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",v.CustomGlyphs="terminal.integrated.customGlyphs",v.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover",v.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var i;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence",v[v.Config=3]="Config"})(i=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.Log="log",v.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var S;(function(v){v.Cwd="cwd",v.InitialCwd="initialCwd",v.FixedDimensions="fixedDimensions",v.Title="title",v.ShellType="shellType",v.HasChildProcesses="hasChildProcesses",v.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",v.OverrideDimensions="overrideDimensions"})(S=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(v){v[v.Panel=1]="Panel",v[v.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(v){v.TerminalView="view",v.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(v){v.CwdDetection="cwdDetection"})(d=e.ProcessCapability||(e.ProcessCapability={}));var p;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var E;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(E=e.ProfileSource||(e.ProfileSource={}))}),define(te[209],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[210],ne([0,1,33,28,10,4,32,15,20]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let d=0;return C&&C.length===4&&(d=parseInt(C[3])),d}e.getWindowsBuildNumber=b;async function I(C,d,p,h=i.env,E=S.Promises.exists){if(R.isAbsolute(C))return await E(C)?C:void 0;if(d===void 0&&(d=i.cwd()),R.dirname(C)!=="."){const f=R.join(d,C);return await E(f)?f:void 0}const m=(0,A.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,P.isString)(m)&&(p=m.split(R.delimiter)),p===void 0||p.length===0){const f=R.join(d,C);return await E(f)?f:void 0}for(let f of p){let c;if(R.isAbsolute(f)?c=R.join(f,C):c=R.join(d,f,C),await E(c))return c;if(T.isWindows){let l=c+".com";if(await E(l)||(l=c+".exe",await E(l)))return l}}const w=R.join(d,C);return await E(w)?w:void 0}e.findExecutable=I}),define(te[211],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[96],ne([0,1,49,3,2,6,37,211]),function(J,e,D,A,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(v){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function b(v){return{id:v}}e.themeColorFromId=b;var I;(function(v){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||S.isThemeColor(n.color))}v.isThemeIcon=m;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const t=w.exec(n);if(!t)return;let[,s]=t;return{id:s}}v.fromString=f;function c(n,t){let s=n.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),t&&(s=`${s}~${t}`),{id:s}}v.modify=c;function l(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}v.getModifier=l;function r(n,t){return n.id===t.id&&n.color?.id===t.color?.id}v.isEqual=r;function o(n,t){return{id:n.id,color:t?b(t):void 0}}v.asThemeIcon=o,v.asClassNameArray=D.CSSIcon.asClassNameArray,v.asClassName=D.CSSIcon.asClassName,v.asCSSSelector=D.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(v){switch(v){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,R.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new d;i.Registry.add(e.Extensions.ThemingContribution,p);function h(v){return p.onColorThemeChange(v)}e.registerThemingParticipant=h;class E extends R.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let f=this.theme.getColor(m);return f&&w&&(f=w(f,this.theme)),f?f.toString():null}}e.Themable=E}),define(te[212],ne([0,1,49,7,96]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(C,d){const p=C.map(h=>({name:h.profileName,description:i(h)}));return d&&p.push(...d.map(h=>({name:h.title,description:P(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=T;function i(C){let d=`$(${R.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?d+=`
- args: "${C.args}"`:d+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(d+=`
- overrideName: ${C.overrideName}`),C.color&&(d+=`
- color: ${C.color}`),C.env&&(d+=`
- env: ${JSON.stringify(C.env)}`),d}function P(C){return`$(${R.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function S(C,d){if(!C&&!d)return!0;if(typeof C=="string"&&typeof d=="string")return C===d;if(Array.isArray(C)&&Array.isArray(d)){if(C.length!==d.length)return!1;for(let p=0;p<C.length;p++)if(C[p]!==d[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function b(C,d){if(!C&&!d)return!0;if(!C||!d)return!1;if(R.ThemeIcon.isThemeIcon(C)&&R.ThemeIcon.isThemeIcon(d))return C.id===d.id&&C.color===d.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const p=C,h=d;if((A.URI.isUri(p.light)||I(p.light))&&(A.URI.isUri(p.dark)||I(p.dark))&&(A.URI.isUri(h.light)||I(h.light))&&(A.URI.isUri(h.dark)||I(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(A.URI.isUri(C)&&A.URI.isUri(d)||I(C)||I(d)){const p=C,h=d;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=b;function I(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=I}),define(te[213],ne([0,1,49,143,42,37,212]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,A.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,A.localize)(1,null),type:"boolean"},icon:{description:(0,A.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,A.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,A.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,A.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b=(0,A.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,A.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),C=(0,A.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,A.localize)(9,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,A.localize)(10,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,A.localize)(11,null,"`#terminal.integrated.automationProfile.windows#`"),E={id:"terminal",order:100,title:(0,A.localize)(12,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(13,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(14,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(15,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(16,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,A.localize)(17,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,A.localize)(18,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},S]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(19,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(22,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(23,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(24,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,A.localize)(25,null)}},{type:"string",markdownDescription:(0,A.localize)(26,null)}],default:[],markdownDeprecationMessage:C},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(27,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,A.localize)(28,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(29,null),type:"string"},id:{description:(0,A.localize)(30,null),type:"string"},title:{description:(0,A.localize)(31,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(32,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(33,null),type:"string"},id:{description:(0,A.localize)(34,null),type:"string"},title:{description:(0,A.localize)(35,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(36,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(37,null),type:"string"},id:{description:(0,A.localize)(38,null),type:"string"},title:{description:(0,A.localize)(39,null),type:"string"},...P}},{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,A.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,A.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,A.localize)(42,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,A.localize)(43,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,A.localize)(44,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function v(){T.Registry.as(R.Extensions.Configuration).registerConfiguration(E),w()}e.registerTerminalPlatformConfiguration=v;let m;function w(f,c){const l=T.Registry.as(R.Extensions.Configuration);let r;f&&(r=(0,i.createProfileSchemaEnums)(f?.profiles,c));const o=m;m={id:"terminal",order:100,title:(0,A.localize)(45,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(46,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?r?.values:void 0,markdownEnumDescriptions:f?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(47,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?r?.values:void 0,markdownEnumDescriptions:f?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(48,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?r?.values:void 0,markdownEnumDescriptions:f?.os===1?r?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[m],remove:o?[o]:[]})}e.registerTerminalDefaultProfileConfiguration=w}),define(te[214],ne([0,1,45,49,10,4,20,70,210,96]),function(J,e,D,A,R,T,i,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,C=!0;function d(o,n,t,s,a=process.env,u,g,y,k){return u=u||{existsFile:i.SymlinkSupport.existsFile,readFile:i.Promises.readFile},T.isWindows?p(t,u,a,g,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),k,y):c(u,g,t,o&&typeof o=="object"?{...o}:s.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),k,y,a)}e.detectAvailableProfiles=d;async function p(o,n,t,s,a,u,g,y,k){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),M=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let W=!1;(0,S.getWindowsBuildNumber)()>=16299&&(W=!0),await v(y);const q=new Map;o&&(q.set("PowerShell",{source:"PowerShell",icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),q.set("Windows PowerShell",{path:`${M}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),q.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),q.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),q.set("Command Prompt",{path:`${M}\\cmd.exe`,icon:A.Codicon.terminalCmd,isAutoDetected:!0})),l(u,q);const L=await h(q.entries(),g,n,t,s,k);if(o||!o&&a)try{const $=await w(`${M}\\${W?"wsl":"bash"}.exe`,g);for(const _ of $)(!u||!(_.profileName in u))&&L.push(_)}catch($){C&&(s?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return L}async function h(o,n,t,s=process.env,a,u){const g=[];for(const[y,k]of o){if(k===null)continue;let O,M,W;if("source"in k){const $=I?.get(k.source);if(!$)continue;O=$.paths,M=k.args||$.args,k.icon?W=E(k.icon):$.icon&&(W=$.icon)}else O=Array.isArray(k.path)?k.path:[k.path],M=T.isWindows||Array.isArray(k.args)?k.args:void 0,W=E(k.icon)||void 0;const q=await u?.(O)||O.slice(),L=await r(y,n,q,t,s,M,k.env,k.overrideName,k.isAutoDetected,a);L?(L.isAutoDetected=k.isAutoDetected,L.icon=W,L.color=k.color,g.push(L)):a?.trace("profile not validated",y,O)}return g}function E(o){return typeof o=="string"?{id:o}:o}async function v(o){I&&!o||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:o||await m(),icon:b.ThemeIcon.asThemeIcon(A.Codicon.terminalPowershell)}))}async function m(){const o=[];for await(const n of(0,P.enumeratePowerShellInstallations)())o.push(n.exePath);return o}async function w(o,n){const t=[],s=await new Promise((g,y)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(k,O)=>{if(k)return y("Problem occurred when getting wsl distros");g(O)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),u=s.split(a).filter(g=>g.trim().length>0&&g!=="");for(const g of u){if(g===""||g.startsWith("docker-desktop"))continue;const y=`${g} (WSL)`,k={profileName:y,path:o,args:["-d",`${g}`],isDefault:y===n,icon:f(g)};t.push(k)}return t}function f(o){return o.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(A.Codicon.terminalUbuntu):o.includes("Debian")?b.ThemeIcon.asThemeIcon(A.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(A.Codicon.terminalLinux)}async function c(o,n,t,s,a,u,g,y){const k=new Map;if(t){const O=(await o.readFile("/etc/shells")).toString(),M=u||O.split(`
`).filter(q=>q.trim().indexOf("#")!==0&&q.trim().length>0),W=new Map;for(const q of M){let L=(0,R.basename)(q),$=W.get(L)||0;$++,$>1&&(L=`${L} (${$})`),W.set(L,$),k.set(L,{path:q,isAutoDetected:!0})}}return l(s,k),await h(k.entries(),a,o,y,n,g)}function l(o,n){if(!!o)for(const[t,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?n.delete(t):n.set(t,s)}async function r(o,n,t,s,a,u,g,y,k,O){if(t.length===0)return Promise.resolve(void 0);const M=t.shift();if(M==="")return r(o,n,t,s,a,u,g,y,k);const W={profileName:o,path:M,args:u,env:g,overrideName:y,isAutoDetected:k,isDefault:o===n};if((0,R.basename)(M)===M){const L=a.PATH?a.PATH.split(R.delimiter):void 0;return await(0,S.findExecutable)(M,void 0,L,void 0,s.existsFile)?W:r(o,n,t,s,a,u)}return await s.existsFile((0,R.normalize)(M))?W:r(o,n,t,s,a,u,g,y,k)}}),define(te[215],ne([0,1,3,2,16,4,34,52,21,11,75,165,8,85,22,208,95,213,214]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let c=0,l=class extends A.Disposable{constructor(o,n,t,s,a){super();this._reconnectConstants=o,this._configurationService=n,this._environmentService=t,this._logService=s,this._telemetryService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,A.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new E.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,C.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(o){return this._logService.error("ptyHost was unable to resolve shell environment",o),{}}}_startPtyHost(){const o={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?o.debugBrk=n.port:!n.break&&n.port&&(o.debug=n.port));const t=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,o);this._onPtyHostStart.fire(),i.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(g=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(g.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}, giving up`))}));const a=t.getChannel(v.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const u=i.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(g=>this._onProcessData.fire(g))),this._register(u.onProcessReady(g=>this._onProcessReady.fire(g))),this._register(u.onProcessExit(g=>this._onProcessExit.fire(g))),this._register(u.onDidChangeProperty(g=>this._onDidChangeProperty.fire(g))),this._register(u.onProcessReplay(g=>this._onProcessReplay.fire(g))),this._register(u.onProcessOrphanQuestion(g=>this._onProcessOrphanQuestion.fire(g))),this._register(u.onDidRequestDetach(g=>this._onDidRequestDetach.fire(g))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,n,t,s,a,u,g,y,k,O,M){const W=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),q=await this._proxy.createProcess(o,n,t,s,a,u,g,y,k,O,M);return clearTimeout(W),c=Math.max(c,q),q}updateTitle(o,n,t){return this._proxy.updateTitle(o,n,t)}updateIcon(o,n,t){return this._proxy.updateIcon(o,n,t)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,n){return this._proxy.shutdown(o,n)}input(o,n){return this._proxy.input(o,n)}processBinary(o,n){return this._proxy.processBinary(o,n)}resize(o,n,t){return this._proxy.resize(o,n,t)}acknowledgeDataEvent(o,n){return this._proxy.acknowledgeDataEvent(o,n)}setUnicodeVersion(o,n){return this._proxy.setUnicodeVersion(o,n)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,n,t,s=!1){const a=await this._shellEnv;return(0,w.detectAvailableProfiles)(n,t,s,this._configurationService,a,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,n){return this._proxy.requestDetachInstance(o,n)}async acceptDetachInstanceReply(o,n){return this._proxy.acceptDetachInstanceReply(o,n)}async serializeTerminalState(o){return this._proxy.serializeTerminalState(o)}async reviveTerminalProcesses(o){return this._proxy.reviveTerminalProcesses(o)}async refreshProperty(o,n){return this._proxy.refreshProperty(o,n)}async updateProperty(o,n,t){return this._proxy.updateProperty(o,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:n})}async acceptPtyHostResolvedVariables(o,n){this._resolveVariablesRequestStore.acceptReply(o,n)}};l=de([G(1,S.IConfigurationService),G(2,b.IEnvironmentService),G(3,d.ILogService),G(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(te[36],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(te[216],ne([0,1,3,2,7,11,35,14,8,36]),function(J,e,D,A,R,T,i,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends A.Disposable{constructor(d,p,h,E,v){super();this.extensionsManagementService=d,this.logService=E,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(w=>this.onInstallExtension(w))),this._register(d.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(d.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=R.URI.file(h.extensionsPath);this._register(p.watch(m)),this._register(D.Event.filter(p.onDidChangeFilesRaw,w=>w.changes.some(f=>this.doesChangeAffects(f,m)))(()=>this.onDidChange()))}doesChangeAffects(d,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),p)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const p of d)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(p=>!(0,i.areSameExtensions)(p,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,i.areSameExtensions)(p,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),p=d.filter(E=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,i.areSameExtensions)(v,E.identifier))?!1:E.installedTimestamp&&E.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",E.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",E.identifier.id),!1)),h=this.installedExtensions.filter(E=>this.installingExtensions.some(v=>(0,i.areSameExtensions)(v,E))?!1:d.every(v=>!(0,i.areSameExtensions)(v.identifier,E))?(this.logService.info("Detected extension removed from another source",E.id),!0):!1);this.installedExtensions=d.map(E=>E.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};I=de([G(1,P.IFileService),G(2,T.INativeEnvironmentService),G(3,S.ILogService),G(4,b.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(te[217],ne([0,1,36,77,14,18,103,3,2]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(d){this.uri=d,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let I=class{constructor(d){this._fileService=d,this._dispooables=new S.DisposableStore,this._limit=2**16;const p=new Map,h=E=>{let v=p.get(E.scheme);return v===void 0&&(v=d.hasProvider(E)&&!this._fileService.hasCapability(E,1024),p.set(E.scheme,v)),v};this._dispooables.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(E=>{p.delete(E.scheme)})),this.extUri=new T.ExtUri(h),this._canonicalUris=new i.SkipList((E,v)=>this.extUri.compare(E,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,T.normalizePath)(d));let p=this._canonicalUris.get(d);return p?p.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new b(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((h,E)=>h[1].touch<E[1].touch?1:h[1].touch>E[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(d[h][0],d[h][1].touch())}};I=de([G(0,R.IFileService)],I),e.UriIdentityService=I,(0,A.registerSingleton)(D.IUriIdentityService,I,!0)}),define(te[55],ne([0,1,39]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function A(i,P,S,b){const I=(0,D.setProperty)(i,P,S,b)[0];return I&&(i=i.substring(0,I.offset)+I.content+i.substring(I.offset+I.length)),i}e.edit=A;function R(i,P,S){let b=S;for(;b>=0;){if(i.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&i.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=R;function T(i,P,S){let b=S;for(;b>=0;)if(i.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&i.charAt(b)===P.charAt(1)))return b;return i.length-1}e.getLineEndOffset=T}),define(te[218],ne([0,1,28,61,15]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(d,p,h,E,v){const m=[],w=[],f=[];if(!p){const M=d.filter(({identifier:W})=>v.every(q=>q.toLowerCase()!==W.id.toLowerCase()));return{local:{added:m,removed:w,updated:f},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}d=d.map(I),p=p.map(I),h=h?h.map(I):null;const c=new Map,l=M=>{M.uuid&&c.set(M.id.toLowerCase(),M.uuid)};d.forEach(({identifier:M})=>l(M)),p.forEach(({identifier:M})=>l(M)),h&&h.forEach(({identifier:M})=>l(M));const r=M=>{const W=M.identifier.uuid||c.get(M.identifier.id.toLowerCase());return W?`uuid:${W}`:`id:${M.identifier.id.toLowerCase()}`},o=(M,W)=>(M.set(r(W),W),M),n=d.reduce(o,new Map),t=p.reduce(o,new Map),s=p.reduce((M,W)=>{const q=r(W);W=(0,D.deepClone)(W);const L=n.get(q);return L&&(L.installed&&(W.installed=!0),W.version||(W.version=L.version)),o(M,W)},new Map),a=h?h.reduce(o,new Map):null,u=E.reduce(o,new Map),g=v.reduce((M,W)=>{const q=c.get(W.toLowerCase());return M.add(q?`uuid:${q}`:`id:${W.toLowerCase()}`)},new Set),y=i(n,t,g);if(y.added.size>0||y.removed.size>0||y.updated.size>0){const M=i(a,n,g),W=i(a,t,g),q=(L,$)=>{const _=n.get(L);if(_){const F=t.get(L),B=$?F:_;return{...B,version:(F.version&&A.gt(F.version,_.version),_.version),state:P(_,F,a?.get(L)),preRelease:(0,R.isUndefined)(B.preRelease)?_.preRelease:B.preRelease}}};for(const L of W.removed.values()){const $=n.get(L);$&&w.push($.identifier)}for(const L of W.added.values())if(M.added.has(L)){if(y.updated.has(L)){const $=q(L,!0);$&&(f.push(C($,L)),s.set(L,$))}}else{const $=t.get(L);$.installed&&m.push(C($,L))}for(const L of W.updated.values()){const $=q(L,!0);$&&(f.push(C($,L)),s.set(L,$))}for(const L of M.added.values())W.added.has(L)||s.set(L,n.get(L));for(const L of M.updated.values())if(!W.removed.has(L)&&!W.updated.has(L)){const $=q(L,!1);$&&(s.get(L)?.installed&&($.installed=!0),s.set(L,$))}for(const L of M.removed.values())!u.has(L)&&!W.updated.has(L)&&a?.get(L)?.installed&&s.delete(L)}const k=[],O=i(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&s.forEach((M,W)=>k.push(C(M,W))),{local:{added:m,removed:w,updated:f},remote:k.length?{added:[...O.added].map(M=>s.get(M)),updated:[...O.updated].map(M=>s.get(M)),removed:[...O.removed].map(M=>t.get(M)),all:k}:null}}e.merge=T;function i(d,p,h,{checkInstalledProperty:E,checkVersionProperty:v}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=d?[...d.keys()].filter(r=>!h.has(r)):[],w=[...p.keys()].filter(r=>!h.has(r)),f=w.filter(r=>m.indexOf(r)===-1).reduce((r,o)=>(r.add(o),r),new Set),c=m.filter(r=>w.indexOf(r)===-1).reduce((r,o)=>(r.add(o),r),new Set),l=new Set;for(const r of m){if(c.has(r))continue;const o=d.get(r),n=p.get(r);(!n||o.disabled!==n.disabled||o.preRelease!==n.preRelease||!b(o.state,n.state)||v&&o.version!==n.version||E&&o.installed!==n.installed)&&l.add(r)}return{added:f,removed:c,updated:l}}function P(d,p,h){const E=d.state,v=p.state,m=h?.state;if(!p.version||E&&A.gt(d.version,p.version))return E;if(v&&A.gt(p.version,d.version)||!E)return v;if(!v)return E;const w=(0,D.deepClone)(E),f=m?S(m,v):{added:Object.keys(v).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},c=m?S(m,E):{added:Object.keys(E).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...f.added.values(),...f.updated.values()])w[l]=v[l];for(const l of f.removed.values())c.updated.has(l)||delete w[l];return w}function S(d,p){const h=Object.keys(d),E=Object.keys(p),v=E.filter(f=>h.indexOf(f)===-1).reduce((f,c)=>(f.add(c),f),new Set),m=h.filter(f=>E.indexOf(f)===-1).reduce((f,c)=>(f.add(c),f),new Set),w=new Set;for(const f of h){if(m.has(f))continue;const c=d[f],l=p[f];(0,D.equals)(c,l)||w.add(f)}return{added:v,removed:m,updated:w}}function b(d={},p={}){const{added:h,removed:E,updated:v}=S(d,p);return h.size===0&&E.size===0&&v.size===0}function I(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function C(d,p){const h={identifier:{id:d.identifier.id,uuid:p.startsWith("uuid:")?p.substring("uuid:".length):void 0},preRelease:!!d.preRelease};return d.version&&(h.version=d.version),d.disabled&&(h.disabled=!0),d.installed&&(h.installed=!0),d.state&&(h.state=d.state),h}}),define(te[97],ne([0,1,17,3,2,35,6,26,23]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,i.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let I=class it extends R.Disposable{constructor(d,p){super();this.storageService=d,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new A.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const p=b.exec(d);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const d=this.storageService.keys(0,1);for(const p of d){const h=it.fromKey(p);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=it.fromKey(d.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,p){this.storageService.store(it.toKey(d),JSON.stringify(p),0,1)}getKeysForSync(d){const p=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(it.toKey(d),0),E=h?JSON.parse(h):void 0;return E&&p?(0,D.distinct)([...E,...p]):E||p}};I=de([G(0,S.IStorageService),G(1,P.IProductService)],I),e.ExtensionsStorageSyncService=I}),define(te[98],ne([0,1,17,21,6]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,S){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),S&&b.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(P,S){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),S&&b.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(P){const S=P.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),I=[],C=[];if(Array.isArray(b))for(const d of b)d.startsWith("-")?C.push(d.substring(1)):I.push(d);return(0,D.distinct)([...S,...I].filter(d=>C.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};T=de([G(0,A.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[219],ne([0,1,17,31,28,160,55]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(c){return(0,A.parse)(c)||[]}e.parseKeybindings=P;async function S(c,l,r,o,n){const t=P(c),s=P(l),a=r?P(r):null,u=[...t,...s,...a||[]].map(F=>F.key),g=await n.resolveUserBindings(u);let y=I(t,s,a,g);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const k=d(t),O=d(s),M=a?d(a):null,W=h(k,O,g),q=M?h(M,k,g):{added:[...k.keys()].reduce((F,B)=>(F.add(B),F),new Set),removed:new Set,updated:new Set},L=M?h(M,O,g):{added:[...O.keys()].reduce((F,B)=>(F.add(B),F),new Set),removed:new Set,updated:new Set},$=b(W,q,L);let _=c;for(const F of $.removed.values())$.conflicts.has(F)||(_=w(_,F,o));for(const F of $.added.values()){if($.conflicts.has(F))continue;const B=O.get(F);if(B.some(Z=>Z.command!==`-${F}`&&y.conflicts.has(g[Z.key]))){$.conflicts.add(F);continue}_=m(_,B,o)}for(const F of $.updated.values()){if($.conflicts.has(F))continue;const B=O.get(F);if(B.some(Z=>Z.command!==`-${F}`&&y.conflicts.has(g[Z.key]))){$.conflicts.add(F);continue}_=f(_,F,B,o)}return{mergeContent:_,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=S;function b(c,l,r){const o=new Set,n=new Set,t=new Set,s=new Set;for(const a of l.removed.values())r.updated.has(a)&&s.add(a);for(const a of r.removed.values())s.has(a)||(l.updated.has(a)?s.add(a):n.add(a));for(const a of l.added.values())s.has(a)||r.added.has(a)&&c.updated.has(a)&&s.add(a);for(const a of r.added.values())s.has(a)||(l.added.has(a)?c.updated.has(a)&&s.add(a):o.add(a));for(const a of l.updated.values())s.has(a)||r.updated.has(a)&&c.updated.has(a)&&s.add(a);for(const a of r.updated.values())s.has(a)||(l.updated.has(a)?c.updated.has(a)&&s.add(a):t.add(a));return{added:o,removed:n,updated:t,conflicts:s}}function I(c,l,r,o){const n=new Set,t=C(c,o),s=C(l,o),a=r?C(r,o):null,u=p(t,s);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const g=a?p(a,t):{added:[...t.keys()].reduce((q,L)=>(q.add(L),q),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=a?p(a,s):{added:[...s.keys()].reduce((q,L)=>(q.add(L),q),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:k,removed:O,updated:M,conflicts:W}=b(u,g,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:k,removed:O,updated:M,conflicts:W}}function C(c,l){const r=new Map;for(const o of c){const n=l[o.key];let t=r.get(n);t||(t=[],r.set(n,t)),t.push(o)}return r}function d(c){const l=new Map;for(const r of c){const o=r.command[0]==="-"?r.command.substring(1):r.command;let n=l.get(o);n||(n=[],l.set(o,n)),n.push(r)}return l}function p(c,l){const r=[...c.keys()],o=[...l.keys()],n=o.filter(a=>r.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),t=r.filter(a=>o.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),s=new Set;for(const a of r){if(t.has(a))continue;const u=c.get(a).map(y=>({...y,key:a})),g=l.get(a).map(y=>({...y,key:a}));(0,D.equals)(u,g,(y,k)=>v(y,k))||s.add(a)}return{added:n,removed:t,updated:s}}function h(c,l,r){const o=[...c.keys()],n=[...l.keys()],t=n.filter(u=>o.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),s=o.filter(u=>n.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),a=new Set;for(const u of o){if(s.has(u))continue;const g=c.get(u).map(k=>({...k,key:r[k.key]})),y=l.get(u).map(k=>({...k,key:r[k.key]}));E(g,y)||a.add(u)}return{added:t,removed:s,updated:a}}function E(c,l){return!(!(0,D.equals)(c.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,o)=>v(r,o))||!(0,D.equals)(c.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,o)=>v(r,o)))}function v(c,l){if(c.command!==l.command||c.key!==l.key)return!1;const r=T.ContextKeyExpr.deserialize(c.when),o=T.ContextKeyExpr.deserialize(l.when);return!(r&&!o||!r&&o||r&&o&&!r.equals(o)||!R.equals(c.args,l.args))}function m(c,l,r){for(const o of l)c=i.edit(c,[-1],o,r);return c}function w(c,l,r){const o=P(c);for(let n=o.length-1;n>=0;n--)(o[n].command===l||o[n].command===`-${l}`)&&(c=i.edit(c,[n],void 0,r));return c}function f(c,l,r,o){const n=P(c),t=n.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=n.length-1;s>=0;s--)(n[s].command===l||n[s].command===`-${l}`)&&(c=i.edit(c,[s],void 0,o));for(let s=r.length-1;s>=0;s--)c=i.edit(c,[t],r[s],o);return c}}),define(te[220],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,i,P){const S={},b={},I=new Set;if(!i)return{local:{added:S,updated:b,removed:[...I.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=A(T,i);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:S,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=A(P,T),p=A(P,i),h={},E={},v=new Set,m=new Set;for(const w of d.removed.values())p.updated.has(w)?S[w]=i[w]:v.add(w);for(const w of p.removed.values())m.has(w)||(d.updated.has(w)?m.add(w):I.add(w));for(const w of d.updated.values())m.has(w)||(p.updated.has(w)?C.updated.has(w)&&m.add(w):E[w]=T[w]);for(const w of p.updated.values())m.has(w)||(d.updated.has(w)?C.updated.has(w)&&m.add(w):T[w]!==void 0&&(b[w]=i[w]));for(const w of d.added.values())m.has(w)||(p.added.has(w)?C.updated.has(w)&&m.add(w):h[w]=T[w]);for(const w of p.added.values())m.has(w)||(d.added.has(w)?C.updated.has(w)&&m.add(w):S[w]=i[w]);return{local:{added:S,removed:[...I.values()],updated:b},remote:{added:h,removed:[...v.values()],updated:E},conflicts:[...m.values()]}}e.merge=D;function A(T,i){const P=T?Object.keys(T):[],S=i?Object.keys(i):[],b=S.filter(d=>P.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),I=P.filter(d=>S.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),C=new Set;for(const d of P){if(I.has(d))continue;const p=T[d],h=i[d];p!==h&&C.add(d)}return{added:b,removed:I,updated:C}}function R(T,i){const{added:P,removed:S,updated:b}=A(T,i);return P.size===0&&S.size===0&&b.size===0}e.areSame=R}),define(te[24],ne([0,1,17,18,15,148,42,30,6,87,37]),function(J,e,D,A,R,T,i,P,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const a=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties();return Object.keys(a).filter(u=>!!a[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function d(){const a=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(a).filter(k=>!!a[k].ignoreSync),g=Object.keys(a).filter(k=>a[k].scope===2||a[k].scope===6),y=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...g,...y])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const a="vscode://schemas/ignoredSettings",u=I.Registry.as(i.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=I.Registry.as(b.Extensions.JSONContribution),y=()=>{const k=C(),O=d().filter(L=>L!==e.CONFIGURATION_SYNC_STORE_KEY),M=Object.keys(i.allSettings.properties).filter(L=>O.indexOf(L)===-1),W=O.filter(L=>k.indexOf(L)===-1),q={items:{type:"string",enum:[...M,...W.map(L=>`-${L}`)]}};g.registerSchema(a,q)};return u.onDidUpdateConfiguration(()=>y())}e.registerConfiguration=p;function h(a){return a&&(0,R.isObject)(a)&&(0,R.isString)(a.id)&&(0,R.isArray)(a.scopes)}e.isAuthenticationProvider=h;var E;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Extensions="extensions",a.GlobalState="globalState"})(E=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function v(a,u,g){return g.joinPath(u.userDataSyncHome,a,`lastSync${a}.json`)}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(a){const u={};return u[e.HEADER_EXECUTION_ID]=a,u}e.createSyncHeaders=m;var w;(function(a){a.Unauthorized="Unauthorized",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.RequestProtocolNotSupported="RequestProtocolNotSupported",a.RequestPathNotEscaped="RequestPathNotEscaped",a.RequestHeadersNotObject="RequestHeadersNotObject",a.NoRef="NoRef",a.EmptyResponse="EmptyResponse",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.UnresolvedConflicts="UnresolvedConflicts",a.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(u,g,y,k){super(u);this.code=g,this.resource=y,this.operationId=k,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class c extends f{constructor(u,g,y,k,O){super(u,y,void 0,O);this.url=g,this.serverCode=k}}e.UserDataSyncStoreError=c;class l extends f{constructor(u,g){super(u,g)}}e.UserDataAutoSyncError=l,function(a){function u(g){if(g instanceof a)return g;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(y&&y[1]){const k=y[2]==="unknown"?void 0:y[2],O=y[3]==="unknown"?void 0:y[3];return new a(g.message,y[1],k,O)}return new a(g.message,"Unknown")}a.toUserDataSyncError=u}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var o;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var n;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(a){return`sync.enable.${a}`}e.getEnablementKey=t,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(a,u){if(a.scheme!==e.USER_DATA_SYNC_SCHEME)return a=a.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,A.isEqualOrParent)(a,(0,A.joinPath)(u.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(te[47],ne([0,1,17,5,19,27,3,31,2,25,15,7,144,21,11,14,8,46,23,22,36,24]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=r;let o=class extends S.Disposable{constructor(u,g,y,k,O,M,W,q,L,$,_){super();this.resource=u,this.fileService=g,this.environmentService=y,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=M,this.userDataSyncResourceEnablementService=W,this.telemetryService=q,this.logService=L,this.configurationService=$,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new A.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new i.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=_.extUri,this.syncFolder=this.extUri.joinPath(y.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(u,y,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(y,g,k)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const g=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(g)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?(await this.doGenerateSyncResourcePreview(u,u,!0,this.getUserDataSyncConfiguration(),T.CancellationToken.None)).resourcePreviews.some(({remoteChange:y})=>y!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const g=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),g==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,g={}){await this._sync(u,!0,this.getUserDataSyncConfiguration(),g)}async preview(u,g,y={}){return this._sync(u,!1,g,y)}async apply(u,g={}){try{this.syncHeaders={...g};const y=await this.doApply(u);return this.setStatus(y),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,g,y,k){try{if(this.syncHeaders={...k},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const M=await this.getLastSyncUserData(),W=await this.getLatestRemoteUserData(u,M);return O=await this.performSync(W,M,g,y),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(u){const g=await this.resolveContent(u);if(!g)return!1;const y=this.parseSyncData(g);if(!y)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const k=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,k),M=await this.isRemoteDataFromCurrentMachine(O),W=await this.generateSyncPreview({ref:O.ref,syncData:y},k,M,this.getUserDataSyncConfiguration(),T.CancellationToken.None),q=[];for(const L of W){const $=await this.getAcceptResult(L,L.remoteResource,void 0,T.CancellationToken.None),{remoteChange:_}=await this.getAcceptResult(L,L.previewResource,L.remoteContent,T.CancellationToken.None);q.push([L,{...$,remoteChange:_!==0?_:2}])}await this.applyResult(O,k,q,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(u){const g=await this.currentMachineIdPromise;return!!u.syncData?.machineId&&u.syncData.machineId===g}async getLatestRemoteUserData(u,g){if(g){const y=u&&u.latest?u.latest[this.resource]:void 0;if(g.ref===y||y===void 0&&g.syncData===null)return g}return this.getRemoteUserData(g)}async performSync(u,g,y,k){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,u.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(u,g,y,k)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,g,y,k);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),g=await this.getLastSyncUserData(),this.performSync(u,g,y,k)}throw O}}async doSync(u,g,y,k){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,A.createCancelablePromise)(M=>this.doGenerateSyncResourcePreview(u,g,y,k,M)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:M})=>M==="conflict")?"hasConflicts":y?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(u){return await this.updateSyncResourcePreview(u,async g=>{const y=await this.getMergeResult(g,T.CancellationToken.None);await this.fileService.writeFile(g.previewResource,R.VSBuffer.fromString(y?.content||""));const k=y&&!y.hasConflicts?await this.getAcceptResult(g,g.previewResource,void 0,T.CancellationToken.None):void 0;return g.acceptResult=k,g.mergeState=y.hasConflicts?"conflict":k?"accepted":"preview",g.localChange=k?k.localChange:y.localChange,g.remoteChange=k?k.remoteChange:y.remoteChange,g}),this.syncPreviewPromise}async accept(u,g){return await this.updateSyncResourcePreview(u,async y=>{const k=await this.getAcceptResult(y,u,g,T.CancellationToken.None);return y.acceptResult=k,y.mergeState="accepted",y.localChange=k.localChange,y.remoteChange=k.remoteChange,y}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async g=>{const y=await this.getMergeResult(g,T.CancellationToken.None);return await this.fileService.writeFile(g.previewResource,R.VSBuffer.fromString(y.content||"")),g.acceptResult=void 0,g.mergeState="preview",g.localChange=y.localChange,g.remoteChange=y.remoteChange,g}),this.syncPreviewPromise}async updateSyncResourcePreview(u,g){if(!this.syncPreviewPromise)return;let y=await this.syncPreviewPromise;const k=y.resourcePreviews.findIndex(({localResource:O,remoteResource:M,previewResource:W})=>this.extUri.isEqual(O,u)||this.extUri.isEqual(M,u)||this.extUri.isEqual(W,u));k!==-1&&(this.syncPreviewPromise=(0,A.createCancelablePromise)(async O=>{const M=[...y.resourcePreviews];return M[k]=await g(M[k]),{...y,resourcePreviews:M}}),y=await this.syncPreviewPromise,this.updateConflicts(y.resourcePreviews),y.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(u){if(!this.syncPreviewPromise)return"idle";const g=await this.syncPreviewPromise;return g.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":g.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.applyResult(g.remoteUserData,g.lastSyncUserData,g.resourcePreviews.map(y=>[y,y.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(u){}}updateConflicts(u){const g=u.filter(({mergeState:y})=>y==="conflict");(0,D.equals)(this._conflicts,g,(y,k)=>this.extUri.isEqual(y.previewResource,k.previewResource))||(this._conflicts=g,this._onDidChangeConflicts.fire(g))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:g,ref:y})=>({created:g,uri:this.toRemoteBackupResource(y)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:g,ref:y})=>({created:g,uri:this.toLocalBackupResource(y)}))}toRemoteBackupResource(u){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const g=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(g))){const{content:y}=await this.getUserData(g);if(y)return this.parseSyncData(y)?.machineId}}async resolveContent(u){const g=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(g))){const{content:y}=await this.getUserData(g);return y}return this.extUri.isEqual(u,this.toLocalBackupResource(g))?this.userDataSyncBackupStoreService.resolveContent(this.resource,g):null}async resolvePreviewContent(u){const g=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(g)for(const y of g.resourcePreviews){if(this.extUri.isEqual(y.acceptedResource,u))return y.acceptResult?y.acceptResult.content:null;if(this.extUri.isEqual(y.remoteResource,u))return y.remoteContent;if(this.extUri.isEqual(y.localResource,u))return y.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(u){}}async doGenerateSyncResourcePreview(u,g,y,k,O){const M=await this.isRemoteDataFromCurrentMachine(u),W=await this.generateSyncPreview(u,g,M,k,O),q=[];for(const L of W){const $=L.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(L.localChange===0&&L.remoteChange===0)q.push({...L,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const _=y?await this.getMergeResult(L,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(L.previewResource,R.VSBuffer.fromString(_?.content||""));const F=_&&!_.hasConflicts?await this.getAcceptResult(L,L.previewResource,void 0,O):void 0;q.push({...L,acceptResult:F,mergeState:_?.hasConflicts?"conflict":F?"accepted":"preview",localChange:F?F.localChange:_?_.localChange:L.localChange,remoteChange:F?F.remoteChange:_?_.remoteChange:L.remoteChange})}}return{remoteUserData:u,lastSyncUserData:g,resourcePreviews:q,isLastSyncFromCurrentMachine:M}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),g=JSON.parse(u.value.toString()),y=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=g.version&&y&&g.version!==y,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${g.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;const k=g;if(k.content===null)return{ref:g.ref,syncData:null};const O=JSON.parse(k.content);if(r(O))return{...g,syncData:O,content:void 0}}catch(u){u instanceof E.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,g={}){if(g.ref||g.content||g.version)throw new Error("Cannot have core properties as additional");const y=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),k={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:y,...g};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(k)))}async getRemoteUserData(u){const{ref:g,content:y}=await this.getUserData(u);let k=null;return y!==null&&(k=this.parseSyncData(y)),{ref:g,syncData:k}}parseSyncData(u){try{const g=JSON.parse(u);if(r(g))return g}catch(g){this.logService.error(g)}throw new l.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(u){if((0,I.isString)(u)){const g=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:g}}else{const g=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,g,this.syncHeaders)}}async updateRemoteUserData(u,g){const y=await this.currentMachineIdPromise,k={version:this.version,machineId:y,content:u};return g=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(k),g,this.syncHeaders),{ref:g,syncData:k}}async backupLocal(u){const g={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(g))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};o=de([G(1,E.IFileService),G(2,h.IEnvironmentService),G(3,w.IStorageService),G(4,l.IUserDataSyncStoreService),G(5,l.IUserDataSyncBackupStoreService),G(6,l.IUserDataSyncResourceEnablementService),G(7,f.ITelemetryService),G(8,l.IUserDataSyncLogService),G(9,p.IConfigurationService),G(10,c.IUriIdentityService)],o),e.AbstractSynchroniser=o;let n=class extends o{constructor(u,g,y,k,O,M,W,q,L,$,_,F){super(g,y,k,O,M,W,q,L,$,_,F);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(B=>this.onFileChanges(B)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(u){return null}}async updateLocalFileContent(u,g,y){try{g?await this.writeFileContent(u,g,y):await this.fileService.createFile(this.file,R.VSBuffer.fromString(u),{overwrite:y})}catch(k){throw k instanceof E.FileOperationError&&k.fileOperationResult===1||k instanceof E.FileOperationError&&k.fileOperationResult===3?new l.UserDataSyncError(k.message,"LocalPreconditionFailed"):k}}async writeFileContent(u,g,y){await this.fileService.writeFile(this.file,R.VSBuffer.fromString(u),y?void 0:g)}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};n=de([G(2,E.IFileService),G(3,h.IEnvironmentService),G(4,w.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncResourceEnablementService),G(8,f.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,p.IConfigurationService),G(11,c.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(u,g,y,k,O,M,W,q,L,$,_,F,B){super(u,g,y,k,O,M,W,q,L,$,F,B);this.userDataSyncUtilService=_,this._formattingOptions=void 0}hasErrors(u){const g=[];return(0,P.parse)(u,g,{allowEmptyContent:!0,allowTrailingComma:!0}),g.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([G(2,E.IFileService),G(3,h.IEnvironmentService),G(4,w.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncResourceEnablementService),G(8,f.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,l.IUserDataSyncUtilService),G(11,p.IConfigurationService),G(12,c.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(u,g,y,k,O){this.resource=u,this.environmentService=g,this.logService=y,this.fileService=k,this.extUri=O.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,g,this.extUri)}async initialize({ref:u,content:g}){if(!g){this.logService.info("Remote content does not exist.",this.resource);return}const y=this.parseSyncData(g);if(!!y)try{await this.doInitialize({ref:u,syncData:y})}catch(k){this.logService.error(k)}}parseSyncData(u){try{const g=JSON.parse(u);if(r(g))return g}catch(g){this.logService.error(g)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,g={}){const y={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,...g};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(y)))}};s=de([G(1,h.IEnvironmentService),G(2,v.ILogService),G(3,E.IFileService),G(4,c.IUriIdentityService)],s),e.AbstractInitializer=s}),define(te[221],ne([0,1,5,27,9,3,39,48,25,7,21,11,30,35,14,8,23,22,36,47,218,97,98,24]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c,l,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function n(g,y){const k=JSON.parse(g.content);if(g.version===1||g.version===2){const O=(await y.getInstalled(0)).filter(M=>M.isBuiltin);for(const M of k)g.version===1&&(M.enabled===!1&&(M.disabled=!0),delete M.enabled),g.version===2&&O.every(W=>!(0,p.areSameExtensions)(W.identifier,M.identifier))&&(M.installed=!0)}return k}function t(g,y,k){const O=k.get((0,p.getExtensionId)(g,y),0)||"{}";return JSON.parse(O)}e.getExtensionStorageState=t;function s(g,y,k,O){O.store((0,p.getExtensionId)(g,y),JSON.stringify(k),0,1)}e.storeExtensionStorageState=s;let a=class mt extends f.AbstractSynchroniser{constructor(y,k,O,M,W,q,L,$,_,F,B,Z,H,j,Q){super("extensions",k,y,O,M,W,Z,H,_,B,Q);this.storageService=O,this.extensionManagementService=q,this.extensionEnablementService=L,this.ignoredExtensionsManagementService=$,this.extensionGalleryService=F,this.extensionsStorageSyncService=j,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,U=>U.some(({local:N})=>!!N)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,U=>!U.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(y,k){const O=y.syncData?await n(y.syncData,this.extensionManagementService):null,M=k?.skippedExtensions||[],W=k?.syncData?await n(k.syncData,this.extensionManagementService):null,q=await this.extensionManagementService.getInstalled(void 0,!0),L=this.getLocalExtensions(q),$=this.ignoredExtensionsManagementService.getIgnoredExtensions(q);O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:_,remote:F}=(0,c.merge)(L,O,W,M,$),B={local:_,remote:F,content:this.getPreviewContent(L,_.added,_.updated,_.removed),localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:F!==null?2:0};return[{skippedExtensions:M,localResource:this.localResource,localContent:this.format(L),localExtensions:L,remoteResource:this.remoteResource,remoteContent:O?this.format(O):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(y,k,O,M){const W=[...k,...O],q=new Set,L=$=>{q.add($.id.toLowerCase()),$.uuid&&q.add($.uuid)};W.forEach(({identifier:$})=>L($)),M.forEach(L);for(const $ of y)q.has($.identifier.id.toLowerCase())||$.identifier.uuid&&q.has($.identifier.uuid)||W.push($);return this.format(W)}async getMergeResult(y,k){return{...y.previewResult,hasConflicts:!1}}async getAcceptResult(y,k,O,M){if(this.extUri.isEqual(k,this.localResource))return this.acceptLocal(y);if(this.extUri.isEqual(k,this.remoteResource))return this.acceptRemote(y);if(this.extUri.isEqual(k,this.previewResource))return y.previewResult;throw new Error(`Invalid Resource: ${k.toString()}`)}async acceptLocal(y){const k=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),M=(0,c.merge)(y.localExtensions,null,null,y.skippedExtensions,O),{local:W,remote:q}=M;return{content:y.localContent,local:W,remote:q,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:q!==null?2:0}}async acceptRemote(y){const k=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),M=y.remoteContent?JSON.parse(y.remoteContent):null;if(M!==null){const W=(0,c.merge)(y.localExtensions,M,y.localExtensions,[],O),{local:q,remote:L}=W;return{content:y.remoteContent,local:q,remote:L,localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:y.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(y,k,O,M){let{skippedExtensions:W,localExtensions:q}=O[0][0],{local:L,remote:$,localChange:_,remoteChange:F}=O[0][1];if(_===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),_!==0&&(await this.backupLocal(JSON.stringify(q)),W=await this.updateLocalExtensions(L.added,L.removed,L.updated,W)),$){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const B=JSON.stringify($.all);y=await this.updateRemoteUserData(B,M?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${$.added.length?` Added: ${JSON.stringify($.added.map(Z=>Z.identifier.id))}.`:""}${$.updated.length?` Updated: ${JSON.stringify($.updated.map(Z=>Z.identifier.id))}.`:""}${$.removed.length?` Removed: ${JSON.stringify($.removed.map(Z=>Z.identifier.id))}.`:""}`)}k?.ref!==y.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(y,{skippedExtensions:W}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${W.length?` Skipped: ${JSON.stringify(W.map(B=>B.identifier.id))}.`:""}`))}async getAssociatedResources({uri:y}){return[{resource:this.extUri.joinPath(y,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(y){if(this.extUri.isEqual(y,mt.EXTENSIONS_DATA_URI)){const O=await this.extensionManagementService.getInstalled(),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(O),W=this.getLocalExtensions(O).filter(q=>!M.some(L=>(0,p.areSameExtensions)({id:L},q.identifier)));return this.format(W)}if(this.extUri.isEqual(this.remoteResource,y)||this.extUri.isEqual(this.localResource,y)||this.extUri.isEqual(this.acceptedResource,y))return this.resolvePreviewContent(y);let k=await super.resolveContent(y);if(k)return k;if(k=await super.resolveContent(this.extUri.dirname(y)),k){const O=this.parseSyncData(k);if(O)switch(this.extUri.basename(y)){case"extensions.json":return this.format(this.parseExtensions(O))}}return null}format(y){y.sort((M,W)=>!M.identifier.uuid&&W.identifier.uuid?-1:M.identifier.uuid&&!W.identifier.uuid?1:(0,S.compare)(M.identifier.id,W.identifier.id));const k=JSON.stringify(y),O=(0,P.format)(k,void 0,{});return(0,i.applyEdits)(k,O)}async hasLocalData(){try{const y=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(y).some(O=>O.installed||O.disabled))return!0}catch(y){}return!1}async updateLocalExtensions(y,k,O,M){const W=[],q=[],L=await this.extensionManagementService.getInstalled();if(k.length){const _=L.filter(({identifier:F,isBuiltin:B})=>!B&&k.some(Z=>(0,p.areSameExtensions)(F,Z)));await D.Promises.settled(_.map(async F=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,F.identifier.id),await this.extensionManagementService.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,F.identifier.id),W.push(F.identifier)}))}(y.length||O.length)&&await D.Promises.settled([...y,...O].map(async _=>{const F=L.find(Z=>(0,p.areSameExtensions)(Z.identifier,_.identifier));if(F&&F.isBuiltin){_.state&&F.manifest.version===_.version&&this.updateExtensionState(_.state,F.manifest.publisher,F.manifest.name,F.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,_.identifier))!==!!_.disabled&&(_.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,_.identifier.id),await this.extensionEnablementService.disableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,_.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,_.identifier.id),await this.extensionEnablementService.enableExtension(_.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,_.identifier.id))),W.push(_.identifier);return}const B=(await this.extensionGalleryService.getExtensions([_.identifier],!!_.preRelease,A.CancellationToken.None))[0];if(_.state&&(F?F.manifest.version===_.version:!!B)){const Z=F?F.manifest.publisher:B.publisher,H=F?F.manifest.name:B.name;this.updateExtensionState(_.state,Z,H,F?.manifest.version)}if(B)try{this.extensionEnablementService.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,_.identifier))!==!!_.disabled&&(_.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,_.identifier.id,B.version),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,_.identifier.id,B.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,_.identifier.id,B.version),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,_.identifier.id,B.version))),(!F||F.preRelease!==_.preRelease)&&(await this.extensionManagementService.canInstall(B)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,_.identifier.id,B.version),await this.extensionManagementService.installFromGallery(B,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:_.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,_.identifier.id,B.version),W.push(B.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),q.push(_)))}catch(Z){q.push(_),Z instanceof d.ExtensionManagementError&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatiblePreRelease,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(Z.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):(this.logService.error(Z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,B.displayName||B.identifier.id))}else q.push(_),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,_.identifier.id)}));const $=[];for(const _ of M)W.some(F=>(0,p.areSameExtensions)(F,_.identifier))||$.push(_);for(const _ of q)$.some(F=>(0,p.areSameExtensions)(F.identifier,_.identifier))||$.push(_);return $}updateExtensionState(y,k,O,M){const W=t(k,O,this.storageService),q=M?this.extensionsStorageSyncService.getKeysForSync({id:(0,p.getGalleryExtensionId)(k,O),version:M}):void 0;q?q.forEach(L=>{W[L]=y[L]}):Object.keys(y).forEach(L=>W[L]=y[L]),s(k,O,W,this.storageService)}parseExtensions(y){return JSON.parse(y.content)}getLocalExtensions(y){const k=this.extensionEnablementService.getDisabledExtensions();return y.map(({identifier:O,isBuiltin:M,manifest:W,preRelease:q})=>{const L={identifier:O,version:W.version,preRelease:q};k.some($=>(0,p.areSameExtensions)($,O))&&(L.disabled=!0),M||(L.installed=!0);try{const $=this.extensionsStorageSyncService.getKeysForSync({id:O.id,version:W.version});if($){const _=t(W.publisher,W.name,this.storageService);L.state=Object.keys(_).reduce((F,B)=>($.includes(B)&&(F[B]=_[B]),F),{})}}catch($){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)($))}return L})}};a.EXTENSIONS_DATA_URI=b.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),a=de([G(0,C.IEnvironmentService),G(1,h.IFileService),G(2,v.IStorageService),G(3,o.IUserDataSyncStoreService),G(4,o.IUserDataSyncBackupStoreService),G(5,d.IExtensionManagementService),G(6,d.IGlobalExtensionEnablementService),G(7,r.IIgnoredExtensionsManagementService),G(8,o.IUserDataSyncLogService),G(9,d.IExtensionGalleryService),G(10,I.IConfigurationService),G(11,o.IUserDataSyncResourceEnablementService),G(12,m.ITelemetryService),G(13,l.IExtensionsStorageSyncService),G(14,w.IUriIdentityService)],a),e.ExtensionsSynchroniser=a;let u=class extends f.AbstractInitializer{constructor(y,k,O,M,W,q){super("extensions",M,W,O,q);this.extensionManagementService=y,this.ignoredExtensionsManagementService=k}async parseExtensions(y){return y.syncData?await n(y.syncData,this.extensionManagementService):null}generatePreview(y,k){const O=[],M=[],W=[];for(const q of y){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(q.identifier.id))continue;const L=k.find($=>(0,p.areSameExtensions)($.identifier,q.identifier));L?(O.push(L),q.disabled&&W.push(q.identifier)):q.installed&&(M.push(q.identifier),q.disabled&&W.push(q.identifier))}return{installedExtensions:O,newExtensions:M,disabledExtensions:W,remoteExtensions:y}}};u=de([G(0,d.IExtensionManagementService),G(1,r.IIgnoredExtensionsManagementService),G(2,h.IFileService),G(3,C.IEnvironmentService),G(4,E.ILogService),G(5,w.IUriIdentityService)],u),e.AbstractExtensionsInitializer=u}),define(te[222],ne([0,1,28,24]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,S,b,I,C){if(!S)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const d=T(P,S);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=b?T(b,S):{added:Object.keys(S).reduce((w,f)=>(w.add(f),w),new Set),removed:new Set,updated:new Set},h=b?T(b,P):{added:Object.keys(P).reduce((w,f)=>(w.add(f),w),new Set),removed:new Set,updated:new Set},E={added:{},removed:[],updated:{}},v=D.deepClone(S),m=!b;for(const w of h.added.values())w!==A.SYNC_SERVICE_URL_TYPE&&m&&p.added.has(w)||(v[w]=P[w]);for(const w of h.updated.values())v[w]=P[w];for(const w of h.removed.values())I.unregistered.includes(w)||delete v[w];for(const w of p.added.values()){const f=S[w];if(I.machine.includes(w)){C.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(w))continue;const c=P[w];c&&c.value===f.value||w===A.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(w)||(c?E.updated[w]=f:E.added[w]=f)}for(const w of p.updated.values()){const f=S[w];if(I.machine.includes(w)){C.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const c=P[w];c&&c.value===f.value||(E.updated[w]=f)}for(const w of p.removed.values()){if(I.machine.includes(w)){C.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||E.removed.push(w)}return{local:E,remote:i(v,S)?null:v}}e.merge=R;function T(P,S){const b=Object.keys(P),I=Object.keys(S),C=I.filter(h=>b.indexOf(h)===-1).reduce((h,E)=>(h.add(E),h),new Set),d=b.filter(h=>I.indexOf(h)===-1).reduce((h,E)=>(h.add(E),h),new Set),p=new Set;for(const h of b){if(d.has(h))continue;const E=P[h],v=S[h];D.equals(E,v)||p.add(h)}return{added:C,removed:d,updated:p}}function i(P,S){const{added:b,removed:I,updated:C}=T(P,S);return b.size===0&&I.size===0&&C.size===0}}),define(te[223],ne([0,1,19,9,3,31,39,48,4,7,29,21,11,14,8,46,23,22,36,47,55,222,24]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const o="globalState.argv.",n=["locale"];function t(y){const k=y.storage?Object.keys(y.storage).sort():[],O={};k.forEach(q=>O[q]=y.storage[q]),y.storage=O;const M=JSON.stringify(y),W=(0,P.format)(M,void 0,{});return(0,i.applyEdits)(M,W)}const s=1;let a=class vt extends f.AbstractSynchroniser{constructor(k,O,M,W,q,L,$,_,F,B){super("globalState",k,q,F,O,M,L,$,W,_,B);this.storageService=F,this.version=s,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(k.onDidFilesChange,Z=>Z.contains(this.environmentService.argvResource)),R.Event.filter(F.onDidChangeValue,Z=>Z.scope===0&&Z.target!==void 0?Z.target===0:F.keys(0,0).includes(Z.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(k,O,M){const W=k.syncData?JSON.parse(k.syncData.content):null;O=O===null&&M?k:O;const q=O&&O.syncData?JSON.parse(O.syncData.content):null,L=await this.getLocalGlobalState();W?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(q),{local:_,remote:F}=(0,l.merge)(L.storage,W?W.storage:null,q?q.storage:null,$,this.logService),B={content:null,local:_,remote:F,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:F!==null?2:0};return[{localResource:this.localResource,localContent:t(L),localUserData:L,remoteResource:this.remoteResource,remoteContent:W?t(W):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async getMergeResult(k,O){return{...k.previewResult,hasConflicts:!1}}async getAcceptResult(k,O,M,W){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(k);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(k);if(this.extUri.isEqual(O,this.previewResource))return k.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(k){return{content:k.localContent,local:{added:{},removed:[],updated:{}},remote:k.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(k){if(k.remoteContent!==null){const O=JSON.parse(k.remoteContent),{local:M,remote:W}=(0,l.merge)(k.localUserData.storage,O.storage,null,k.storageKeys,this.logService);return{content:k.remoteContent,local:M,remote:W,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:k.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(k,O,M,W){let{localUserData:q}=M[0][0],{local:L,remote:$,localChange:_,remoteChange:F}=M[0][1];if(_===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),_!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(q)),await this.writeLocalGlobalState(L),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),F!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const B=JSON.stringify({storage:$});k=await this.updateRemoteUserData(B,W?null:k.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}O?.ref!==k.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(k),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:k}){return[{resource:this.extUri.joinPath(k,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(k){if(this.extUri.isEqual(k,vt.GLOBAL_STATE_DATA_URI)){const M=await this.getLocalGlobalState();return t(M)}if(this.extUri.isEqual(this.remoteResource,k)||this.extUri.isEqual(this.localResource,k)||this.extUri.isEqual(this.acceptedResource,k))return this.resolvePreviewContent(k);let O=await super.resolveContent(k);if(O)return O;if(O=await super.resolveContent(this.extUri.dirname(k)),O){const M=this.parseSyncData(O);if(M)switch(this.extUri.basename(k)){case"globalState.json":return t(JSON.parse(M.content))}}return null}async hasLocalData(){try{const{storage:k}=await this.getLocalGlobalState();if(Object.keys(k).length>1||k[`${o}.locale`]?.value!=="en")return!0}catch(k){}return!1}async getLocalGlobalState(){const k={},O=await this.getLocalArgvContent(),M=(0,T.parse)(O);for(const W of n)M[W]!==void 0&&(k[`${o}${W}`]={version:1,value:M[W]});for(const W of this.storageService.keys(0,0)){const q=this.storageService.get(W,0);q&&(k[W]={version:1,value:q})}return{storage:k}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const k=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),k.value.toString()}catch(k){this.logService.debug((0,A.getErrorMessage)(k))}return"{}"}async writeLocalGlobalState({added:k,removed:O,updated:M}){const W={},q={},L=(_,F)=>{for(const B of _){if(B.startsWith(o)){W[B.substring(o.length)]=F?F[B].value:void 0;continue}if(F){const Z=F[B];Z.value!==String(this.storageService.get(B,0))&&(q[B]=Z.value)}else this.storageService.get(B,0)!==void 0&&(q[B]=void 0)}};if(L(Object.keys(k),k),L(Object.keys(M),M),L(O),Object.keys(W).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(W),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(q).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const _ of Object.keys(q))this.storageService.store(_,q[_],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(q))}}async updateArgv(k){const O=await this.getLocalArgvContent();let M=O;for(const W of Object.keys(k))M=(0,c.edit)(M,[W],k[W],{});O!==M&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(M)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(k){const O=this.storageService.keys(0,0),M=this.storageService.keys(0,1),W=[...O,...M],q=k?.storage?Object.keys(k.storage).filter(L=>!L.startsWith(o)&&!W.includes(L)&&this.storageService.get(L,0)!==void 0):[];if(!S.isWeb){const L=[...r.ALL_SYNC_RESOURCES.map($=>(0,r.getEnablementKey)($)),r.SYNC_SERVICE_URL_TYPE];q.push(...L),M.push(...L)}return{user:O,machine:M,unregistered:q}}};a.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=de([G(0,p.IFileService),G(1,r.IUserDataSyncStoreService),G(2,r.IUserDataSyncBackupStoreService),G(3,r.IUserDataSyncLogService),G(4,d.IEnvironmentService),G(5,r.IUserDataSyncResourceEnablementService),G(6,m.ITelemetryService),G(7,C.IConfigurationService),G(8,v.IStorageService),G(9,w.IUriIdentityService)],a),e.GlobalStateSynchroniser=a;let u=class extends f.AbstractInitializer{constructor(k,O,M,W,q){super("globalState",M,W,O,q);this.storageService=k}async doInitialize(k){const O=k.syncData?JSON.parse(k.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},W={};for(const q of Object.keys(O.storage))q.startsWith(o)?M[q.substring(o.length)]=O.storage[q].value:this.storageService.get(q,0)===void 0&&(W[q]=O.storage[q].value);if(Object.keys(M).length){let q="{}";try{q=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(L){}for(const L of Object.keys(M))q=(0,c.edit)(q,[L],M[L],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(q))}if(Object.keys(W).length)for(const q of Object.keys(W))this.storageService.store(q,W[q],0,0)}};u=de([G(0,v.IStorageService),G(1,p.IFileService),G(2,d.IEnvironmentService),G(3,r.IUserDataSyncLogService),G(4,w.IUriIdentityService)],u),e.GlobalStateInitializer=u;let g=class{constructor(k,O,M,W,q){this.userDataSyncStoreClient=k,this.storageService=O,this.environmentService=M,this.fileService=W,this.logService=q}getSyncStoreType(k){return this.parseGlobalState(k)?.storage[r.SYNC_SERVICE_URL_TYPE]?.value}async sync(k){const O=(0,r.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(k,O)}catch(M){if(M instanceof r.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(k,O)}throw M}}async doSync(k,O){const M=await this.userDataSyncStoreClient.read("globalState",null,O),W=this.parseGlobalState(M)||{storage:{}};W.storage[r.SYNC_SERVICE_URL_TYPE]={value:k,version:s};const q=await(0,E.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),L={version:s,machineId:q,content:t(W)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(L),M.ref,O)}parseGlobalState({content:k}){if(!k)return null;const O=JSON.parse(k);if((0,f.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};g=de([G(1,v.IStorageService),G(2,d.IEnvironmentService),G(3,p.IFileService),G(4,h.ILogService)],g),e.UserDataSyncStoreTypeSynchronizer=g}),define(te[224],ne([0,1,17,19,3,31,4,15,145,21,11,14,23,22,36,47,219,24]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,o){try{const n=JSON.parse(l);if(!r)return(0,P.isUndefined)(n.all)?null:n.all;switch(i.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return o.error(n),null}}e.getKeybindingsContentFromSyncContent=w;let f=class extends E.AbstractJsonFileSynchroniser{constructor(r,o,n,t,s,a,u,g,y,k,O){super(u.keybindingsResource,"keybindings",a,u,g,r,o,s,k,n,y,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(t.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,o,n,t){const s=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;o=o===null&&n?r:o;const a=o?this.getKeybindingsContentFromLastSyncUserData(o):null,u=await this.getLocalFileContent(),g=await this.getFormattingOptions();let y=null,k=!1,O=!1,M=!1;if(s){let q=u?u.value.toString():"[]";if(q=q||"[]",this.hasErrors(q))throw new m.UserDataSyncError((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const L=await(0,v.merge)(q,s,a,g,this.userDataSyncUtilService);L.hasChanges&&(y=L.mergeContent,M=L.hasConflicts,k=M||L.mergeContent!==q,O=M||L.mergeContent!==s)}}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),y=u.value.toString(),O=!0);const W={content:y,localChange:k?u?2:1:0,remoteChange:O?2:0,hasConflicts:M};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:W.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:W.remoteChange,previewResource:this.previewResource,previewResult:W,acceptedResource:this.acceptedResource}]}async getMergeResult(r,o){return r.previewResult}async getAcceptResult(r,o,n,t){if(this.extUri.isEqual(o,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(r,o,n,t){const{fileContent:s}=n[0][0];let{content:a,localChange:u,remoteChange:g}=n[0][1];if(u===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a)))throw new m.UserDataSyncError((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(a||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),g!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const y=this.toSyncContent(a||"[]",r.syncData?.content);r=await this.updateRemoteUserData(y,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(y){}o?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const o=(0,T.parse)(r.value.toString());if((0,D.isNonEmptyArray)(o))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const o=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:o}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let o=await super.resolveContent(r);if(o)return o;if(o=await super.resolveContent(this.extUri.dirname(r)),o){const n=this.parseSyncData(o);if(n)switch(this.extUri.basename(r)){case"keybindings.json":return w(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,o){let n={};try{n=JSON.parse(o||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=r,i.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=de([G(0,m.IUserDataSyncStoreService),G(1,m.IUserDataSyncBackupStoreService),G(2,m.IUserDataSyncLogService),G(3,b.IConfigurationService),G(4,m.IUserDataSyncResourceEnablementService),G(5,C.IFileService),G(6,I.IEnvironmentService),G(7,d.IStorageService),G(8,m.IUserDataSyncUtilService),G(9,p.ITelemetryService),G(10,h.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let c=class extends E.AbstractInitializer{constructor(r,o,n,t){super("keybindings",o,n,r,t)}async doInitialize(r){const o=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!o){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,A.VSBuffer.fromString(o)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),o=(0,T.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(o)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(o){return this.logService.error(o),null}}};c=de([G(0,C.IFileService),G(1,I.IEnvironmentService),G(2,m.IUserDataSyncLogService),G(3,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(te[225],ne([0,1,17,31,39,48,28,55,24]),function(J,e,D,A,R,T,i,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(a,u,g){let y=[];g?y=C(g):y=I(u);const k=[],O=[...(0,S.getDisallowedIgnoredSettings)()];if(Array.isArray(y))for(const M of y)M.startsWith("-")?O.push(M.substring(1)):k.push(M);return(0,D.distinct)([...a,...k].filter(M=>O.indexOf(M)===-1))}e.getIgnoredSettings=b;function I(a){let u=a.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=a.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:a.getValue("settingsSync.ignoredSettings")||[]}function C(a){const u=(0,A.parse)(a);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function d(a,u,g,y){if(g.length){const k=s(u),O=(0,A.parse)(u),M=(0,A.parse)(a),W=[];for(const q of g){const L=O[q],$=M[q];L===void 0?a=P.edit(a,[q],void 0,y):$!==void 0?a=P.edit(a,[q],L,y):W.push(l(q,k))}W.sort((q,L)=>q.startOffset-L.startOffset),W.forEach(q=>a=m(q.setting.key,u,a,y))}return a}e.updateIgnoredSettings=d;function p(a,u,g,y,k,O){const M=d(a,u,y,O),W=g!==M,q=g!==u;if(!W&&!q)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(W&&!q)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(q&&!W)return{conflictsSettings:[],localContent:d(u,a,y,O),remoteContent:null,hasConflicts:!1};if(g===null&&E(a)){const V=h(a,u,y)?null:d(u,a,y,O);return{conflictsSettings:[],localContent:V,remoteContent:null,hasConflicts:!1}}let L=a,$=u;const _=(0,A.parse)(a),F=(0,A.parse)(u),B=g?(0,A.parse)(g):null,Z=y.reduce((V,X)=>(V.add(X),V),new Set),H=v(_,F,Z),j=v(B,_,Z),Q=v(B,F,Z),U=new Map,N=new Set,z=V=>{N.add(V);const X=k.filter(({key:se})=>se===V)[0];X?(L=P.edit(L,[V],X.value,O),$=P.edit($,[V],X.value,O)):U.set(V,{key:V,localValue:_[V],remoteValue:F[V]})};for(const V of j.removed.values())Q.updated.has(V)?z(V):$=P.edit($,[V],void 0,O);for(const V of Q.removed.values())N.has(V)||(j.updated.has(V)?z(V):L=P.edit(L,[V],void 0,O));for(const V of j.updated.values())N.has(V)||(Q.updated.has(V)?H.updated.has(V)&&z(V):$=P.edit($,[V],_[V],O));for(const V of Q.updated.values())N.has(V)||(j.updated.has(V)?H.updated.has(V)&&z(V):L=P.edit(L,[V],F[V],O));for(const V of j.added.values())N.has(V)||(Q.added.has(V)?H.updated.has(V)&&z(V):$=m(V,L,$,O));for(const V of Q.added.values())N.has(V)||(j.added.has(V)?H.updated.has(V)&&z(V):L=m(V,$,L,O));const x=U.size>0||!h(L,$,y),K=x||!h(L,a,[]),ee=x||!h($,u,[]);return{localContent:K?L:null,remoteContent:ee?$:null,conflictsSettings:[...U.values()],hasConflicts:x}}e.merge=p;function h(a,u,g){if(a===u)return!0;const y=(0,A.parse)(a),k=(0,A.parse)(u),O=g.reduce((q,L)=>(q.add(L),q),new Set),M=s(a).filter(q=>!(q.setting&&O.has(q.setting.key))),W=s(u).filter(q=>!(q.setting&&O.has(q.setting.key)));if(M.length!==W.length)return!1;for(let q=0;q<M.length;q++){const L=M[q],$=W[q];if(L.setting&&$.setting){if(L.setting.key!==$.setting.key||!i.equals(y[L.setting.key],k[L.setting.key]))return!1}else if(!L.setting&&!$.setting){if(L.value!==$.value)return!1}else return!1}return!0}e.areSame=h;function E(a){return a?s(a).length===0:!0}e.isEmpty=E;function v(a,u,g){const y=a?Object.keys(a).filter(q=>!g.has(q)):[],k=Object.keys(u).filter(q=>!g.has(q)),O=k.filter(q=>y.indexOf(q)===-1).reduce((q,L)=>(q.add(L),q),new Set),M=y.filter(q=>k.indexOf(q)===-1).reduce((q,L)=>(q.add(L),q),new Set),W=new Set;if(a)for(const q of y){if(M.has(q))continue;const L=a[q],$=u[q];i.equals(L,$)||W.add(q)}return{added:O,removed:M,updated:W}}function m(a,u,g,y){const k=(0,A.parse)(u),O=s(u),M=s(g),W=w(a,O,M);return f(g,a,k[a],W,M,y)}e.addSetting=m;function w(a,u,g){const y=u.findIndex(O=>O.setting?.key===a),k=u[y-1];if(k){if(k.setting){const M=l(k.setting.key,g);if(M)return{index:g.indexOf(M),insertAfter:!0}}else{const M=r(y,u);if(M){const W=l(M.setting.key,g);if(W){const q=o(g.indexOf(W),g),L=n(u,M,u[y]);if(q){const $=n(g,W,q),_=t(L,$);return _?{index:g.indexOf(_),insertAfter:!0}:{index:g.indexOf(q),insertAfter:!1}}else{const $=n(g,W,g[g.length-1]),_=t(L,$);return _?{index:g.indexOf(_),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const O=u[y+1];if(O)if(O.setting){const M=l(O.setting.key,g);if(M)return{index:g.indexOf(M),insertAfter:!1}}else{const M=o(y,u);if(M){const W=l(M.setting.key,g);if(W){const q=r(g.indexOf(W),g),L=n(u,u[y],M);if(q){const $=n(g,q,W),_=t(L.reverse(),$.reverse());return _?{index:g.indexOf(_),insertAfter:!1}:{index:g.indexOf(q),insertAfter:!0}}else{const $=n(g,g[0],W),_=t(L.reverse(),$.reverse());return _?{index:g.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function f(a,u,g,y,k,O){let M;return y.index===-1?M=(0,R.setProperty)(a,[u],g,O):M=c(a,u,g,y,k,O).map(W=>(0,R.withFormatting)(a,W,O)[0]),(0,R.applyEdits)(a,M)}function c(a,u,g,y,k,O){const M=`${JSON.stringify(u)}: ${JSON.stringify(g)}`,W=(0,T.getEOL)(O,a),q=k[y.index];if(y.insertAfter){const L=[];if(q.setting)L.push({offset:q.endOffset,length:0,content:","+M});else{const $=o(y.index,k),_=r(y.index,k),F=_?.setting?.commaOffset;_&&F===void 0&&L.push({offset:_.endOffset,length:0,content:","});const B=F!==void 0&&F>q.endOffset;L.push({offset:B?F+1:q.endOffset,length:0,content:$?W+M+",":W+M})}return L}else{if(q.setting)return[{offset:q.startOffset,length:0,content:M+","}];const L=(k[y.index-1]&&!k[y.index-1].setting?W:"")+M+(o(y.index,k)?",":"")+W;return[{offset:q.startOffset,length:0,content:L}]}}function l(a,u){return u.filter(g=>g.setting?.key===a)[0]}function r(a,u){for(let g=a-1;g>=0;g--)if(u[g].setting)return u[g]}function o(a,u){for(let g=a+1;g<u.length;g++)if(u[g].setting)return u[g]}function n(a,u,g){const y=a.indexOf(u),k=a.indexOf(g);return a.filter((O,M)=>y<M&&M<k)}function t(a,u){if(a.length&&u.length){let g=0;for(;g<u.length&&g<a.length;g++)if(a[g].value!==u[g].value)return u[g-1];return u[g-1]}}function s(a){const u=[];let g=-1,y,k;const O={onObjectBegin:M=>{g++},onObjectProperty:(M,W,q)=>{g===0&&(y=W,k=M)},onObjectEnd:(M,W)=>{g--,g===0&&u.push({startOffset:y,endOffset:M+W,value:a.substring(y,M+W),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(M,W)=>{g++},onArrayEnd:(M,W)=>{g--,g===0&&u.push({startOffset:y,endOffset:M+W,value:a.substring(y,M+W),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(M,W,q)=>{g===0&&u.push({startOffset:y,endOffset:W+q,value:a.substring(y,W+q),setting:{key:k,commaOffset:void 0}})},onSeparator:(M,W,q)=>{if(g===0&&M===","){let L=u.length-1;for(;L>=0&&!u[L].setting;L--);const $=u[L];$&&u.splice(L,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:W}})}},onComment:(M,W)=>{g===0&&u.push({startOffset:M,endOffset:M+W,value:a.substring(M,M+W)})}};return(0,A.visit)(a,O),u}}),define(te[226],ne([0,1,19,3,39,146,21,88,84,11,30,14,23,22,36,47,55,225,24]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function c(n){const t=JSON.parse(n);return f(t)?t:{settings:n}}e.parseSettingsSyncContent=c;let l=class extends E.AbstractJsonFileSynchroniser{constructor(t,s,a,u,g,y,k,O,M,W,q,L,$){super(s.settingsResource,"settings",t,s,a,u,g,M,W,y,k,O,$);this.extensionManagementService=q,this.userConfigurationFileService=L,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const s=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(t,s),u=this.getSettingsSyncContent(a),g=new P.ConfigurationModelParser(w.USER_DATA_SYNC_CONFIGURATION_SCOPE);return u?.settings&&g.parse(u.settings),g.configurationModel.getValue(w.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,s,a){const u=await this.getLocalFileContent(),g=await this.getFormattingOptions(),y=this.getSettingsSyncContent(t);s=s===null&&a?t:s;const k=s?this.getSettingsSyncContent(s):null,O=await this.getIgnoredSettings();let M=null,W=!1,q=!1,L=!1;if(y){let _=u?u.value.toString().trim():"{}";_=_||"{}",this.validateContent(_),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const F=(0,m.merge)(_,y.settings,k?k.settings:null,O,[],g);M=F.localContent||F.remoteContent,W=F.localContent!==null,q=F.remoteContent!==null,L=F.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),M=u.value.toString(),q=!0);const $={content:M,localChange:W?2:0,remoteChange:q?2:0,hasConflicts:L};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:y?y.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async getMergeResult(t,s){const a=await this.getFormattingOptions(),u=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,m.updateIgnoredSettings)(t.previewResult.content,"{}",u,a):null}}async getAcceptResult(t,s,a,u){const g=await this.getFormattingOptions(),y=await this.getIgnoredSettings();if(this.extUri.isEqual(s,this.localResource))return{content:t.fileContent?(0,m.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",y,g):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,m.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",y,g):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return a===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:a!==null?(0,m.updateIgnoredSettings)(a,t.fileContent?t.fileContent.value.toString():"{}",y,g):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(t,s,a,u){const{fileContent:g}=a[0][0];let{content:y,localChange:k,remoteChange:O}=a[0][1];if(k===0&&O===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),y=y?y.trim():"{}",y=y||"{}",this.validateContent(y),k!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),g&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(g.value.toString()))),await this.updateLocalFileContent(y,g,u),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),O!==0){const M=await this.getFormattingOptions(),W=this.getSettingsSyncContent(t),q=await this.getIgnoredSettings(y);y=(0,m.updateIgnoredSettings)(y,W?W.settings:"{}",q,M),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(y)),u?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(M){}s?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const s=await this.getFormattingOptions(),a=(0,v.edit)(t.value.toString(),[w.CONFIGURATION_SYNC_STORE_KEY],void 0,s);return!(0,m.isEmpty)(a)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:s}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let s=await super.resolveContent(t);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(t)),s){const a=this.parseSyncData(s);if(a){const u=this.parseSettingsSyncContent(a.content);if(u)switch(this.extUri.basename(t)){case"settings.json":return u.settings}}}return null}async resolvePreviewContent(t){let s=await super.resolvePreviewContent(t);if(s){const a=await this.getFormattingOptions(),u=await this.getIgnoredSettings();s=(0,m.updateIgnoredSettings)(s,"{}",u,a)}return s}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return c(t)}catch(s){this.logService.error(s)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const a=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,u=>u.some(({local:g})=>!!g)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,u=>!u.error))(()=>{a.dispose(),this._defaultIgnoredSettings=void 0})}const s=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(s,this.configurationService,t)}async writeFileContent(t,s,a){await this.userConfigurationFileService.write(D.VSBuffer.fromString(t),a?void 0:{etag:s.etag,mtime:s.mtime})}validateContent(t){if(this.hasErrors(t))throw new w.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const s=JSON.parse(t.value.toString());if(!o(s))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const a=this.parseSettingsSyncContent(s.content);if(!a||!a.settings)return;let u=a.settings;const g=await this.getFormattingOptions();for(const y in s)if(["version","content","machineId"].indexOf(y)===-1&&s[y]!==void 0){const k=(0,R.setProperty)(u,[y],s[y],g);k.length&&(u=(0,R.applyEdits)(u,k))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(u))}catch(t){}}};l=de([G(0,C.IFileService),G(1,b.IEnvironmentService),G(2,d.IStorageService),G(3,w.IUserDataSyncStoreService),G(4,w.IUserDataSyncBackupStoreService),G(5,w.IUserDataSyncLogService),G(6,w.IUserDataSyncUtilService),G(7,i.IConfigurationService),G(8,w.IUserDataSyncResourceEnablementService),G(9,p.ITelemetryService),G(10,I.IExtensionManagementService),G(11,S.IUserConfigurationFileService),G(12,h.IUriIdentityService)],l),e.SettingsSynchroniser=l;let r=class extends E.AbstractInitializer{constructor(t,s,a,u){super("settings",s,a,t,u)}async doInitialize(t){const s=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!s){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(s.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return c(t)}catch(s){this.logService.error(s)}return null}};r=de([G(0,C.IFileService),G(1,b.IEnvironmentService),G(2,w.IUserDataSyncLogService),G(3,h.IUriIdentityService)],r),e.SettingsInitializer=r;function o(n){return!!(n&&n.version!==void 0&&typeof n.version=="number"&&n.content!==void 0&&typeof n.content=="string"&&n.machineId!==void 0&&typeof n.machineId=="string")}}),define(te[227],ne([0,1,19,3,28,21,11,14,23,22,36,47,220,24]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends C.AbstractSynchroniser{constructor(m,w,f,c,l,r,o,n,t,s){super("snippets",w,m,f,c,l,n,t,r,o,s);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(A.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,f){const c=await this.getSnippetsFileContents(),l=this.toSnippetsContents(c),r=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&f?m:w;const o=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,d.merge)(l,r,o);return this.getResourcePreviews(n,c,r||{})}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,f,c){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return f===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:f,localChange:f===null?m.fileContent!==null?3:0:2,remoteChange:f===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,f,c){const l=f.map(([r,o])=>({...r,acceptResult:o}));l.every(({localChange:r,remoteChange:o})=>r===0&&o===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,c)),l.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(l,m,c)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch(o){}}getResourcePreviews(m,w,f){const c=new Map;for(const l of Object.keys(m.local.added)){const r={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};c.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const r={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const r={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const r={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:f[l]?2:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!c.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const f=this.parseSyncData(w);if(f){const c=this.parseSnippets(f),l=[];for(const r of Object.keys(c)){const o=this.extUri.joinPath(m,r),n=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(n);l.push({resource:o,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const f=this.parseSyncData(w);if(f)return this.parseSnippets(f)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch(m){}return!1}async updateLocalBackup(m){const w={};for(const f of m)f.fileContent&&(w[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:f,acceptResult:c,localResource:l,remoteResource:r,localChange:o}of m)if(o!==0){const n=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,n);o===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):o===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,D.VSBuffer.fromString(c.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,D.VSBuffer.fromString(c.content),w?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,w,f){const c=w.syncData?this.parseSnippets(w.syncData):{},l=(0,R.deepClone)(c);for(const{acceptResult:r,localResource:o,remoteResource:n,remoteChange:t}of m)if(t!==0){const s=o?this.extUri.basename(o):this.extUri.basename(n);t===3?delete l[s]:l[s]=r.content}return(0,d.areSame)(c,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),f?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const f of Object.keys(m))w[f]=m[f].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof P.FileOperationError&&f.fileOperationResult===1)return m;throw f}for(const f of w.children||[]){const c=f.resource,l=this.extUri.extname(c);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,c),o=await this.fileService.readFile(c);m[r]=o}}return m}};h=de([G(0,i.IEnvironmentService),G(1,P.IFileService),G(2,S.IStorageService),G(3,p.IUserDataSyncStoreService),G(4,p.IUserDataSyncBackupStoreService),G(5,p.IUserDataSyncLogService),G(6,T.IConfigurationService),G(7,p.IUserDataSyncResourceEnablementService),G(8,b.ITelemetryService),G(9,I.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let E=class extends C.AbstractInitializer{constructor(m,w,f,c){super("snippets",w,f,m,c)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(w)){const l=w[c];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,c);await this.fileService.createFile(r,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};E=de([G(0,P.IFileService),G(1,i.IEnvironmentService),G(2,p.IUserDataSyncLogService),G(3,I.IUriIdentityService)],E),e.SnippetsInitializer=E}),define(te[63],ne([0,1,3,2,6,24]),function(J,e,D,A,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let i=class extends A.Disposable{constructor(S,b){super();this.userDataSyncStoreService=S,this.logService=b,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};i=de([G(0,T.IUserDataSyncStoreService),G(1,T.IUserDataSyncLogService)],i),e.UserDataSyncAccountService=i}),define(te[228],ne([0,1,5,19,58,2,18,21,11,14,24]),function(J,e,D,A,R,T,i,P,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends T.Disposable{constructor(p,h,E,v){super();this.environmentService=p,this.fileService=h,this.configurationService=E,this.logService=v,I.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(p){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,p),E=await this.fileService.resolve(h);return E.children?E.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(p,h){if(!h){const E=await this.getAllRefs(p);E.length&&(h=E[E.length-1].ref)}if(h){const E=(0,i.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(E)).value.toString()}return null}async backup(p,h){const E=(0,i.joinPath)(this.environmentService.userDataSyncHome,p),v=(0,i.joinPath)(E,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(v,A.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(p)}catch(m){}}async cleanUpBackup(p){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch(v){return}const E=await this.fileService.resolve(h);if(E.children){const v=E.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=v.filter(c=>Date.now()-this.getCreationTime(c)>m);const f=v.length-w.length;f<10&&(w=w.slice(10-f)),await D.Promises.settled(w.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(E){this.logService.error(E)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};C=de([G(0,S.IEnvironmentService),G(1,b.IFileService),G(2,P.IConfigurationService),G(3,I.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(te[229],ne([0,1,2,7]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(d){this.service=d}listen(d,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class T{constructor(d){this.service=d}listen(d,p){throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(A.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class i{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=i;class P{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class S{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class b{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class I extends D.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:A.URI.revive(d.url),type:d.type,defaultUrl:A.URI.revive(d.defaultUrl),insidersUrl:A.URI.revive(d.insidersUrl),stableUrl:A.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(te[230],ne([0,1,11,8]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends A.AbstractLogger{constructor(i,P){super();this.logger=this._register(i.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(i,...P){this.logger.trace(i,...P)}debug(i,...P){this.logger.debug(i,...P)}info(i,...P){this.logger.info(i,...P)}warn(i,...P){this.logger.warn(i,...P)}error(i,...P){this.logger.error(i,...P)}critical(i,...P){this.logger.critical(i,...P)}flush(){this.logger.flush()}};R=de([G(0,A.ILoggerService),G(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(te[64],ne([0,1,3,2,4,25,149,11,14,6,26,46,23,24]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let E=class et extends A.Disposable{constructor(m,w,f,c,l,r){super();this.storageService=f,this.userDataSyncStoreService=c,this.logService=l,this.productService=r,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(m,w,f)}async getMachines(m){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(c=>({...c,isCurrent:c.id===w}))}async addCurrentMachine(m){const w=await this.currentMachineIdPromise,f=await this.readMachinesData(m);f.machines.some(({id:c})=>c===w)||(f.machines.push({id:w,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(m){const w=await this.currentMachineIdPromise,f=await this.readMachinesData(m),c=f.machines.filter(({id:l})=>l!==w);c.length!==f.machines.length&&(f.machines=c,await this.writeMachinesData(f))}async renameMachine(m,w,f){const c=await this.currentMachineIdPromise,l=await this.readMachinesData(f),r=l.machines.find(({id:o})=>o===m);r&&(r.name=w,await this.writeMachinesData(l),l.machines.some(({id:o})=>o===c)&&this.storageService.store(h,w,0,1))}async setEnablement(m,w){const f=await this.readMachinesData(),c=f.machines.find(({id:l})=>l===m);c&&(c.disabled=w?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(m){const w=this.storageService.get(h,0);if(w)return w;const f=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,c=new RegExp(`${(0,T.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let l=0;for(const r of m){const o=c.exec(r.name),n=o?parseInt(o[1]):0;l=n>l?n:l}return`${f} #${l+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const w=this.parse(this.userData);if(w.version!==et.VERSION)throw new Error((0,i.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(m){const w=JSON.stringify(m),f=await this.userDataSyncStoreService.write(et.RESOURCE,w,this.userData?.ref||null);this.userData={ref:f,content:w},this._onDidChange.fire()}async readUserData(m){if(this.userData){const w=m&&m.latest?m.latest[et.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(w){this.logService.error(w)}return{version:et.VERSION,machines:[]}}};E.VERSION=1,E.RESOURCE="machines",E=de([G(0,P.IEnvironmentService),G(1,S.IFileService),G(2,d.IStorageService),G(3,p.IUserDataSyncStoreService),G(4,p.IUserDataSyncLogService),G(5,I.IProductService)],E),e.UserDataSyncMachinesService=E}),define(te[99],ne([0,1,5,58,38,9,3,2,4,18,7,147,11,26,23,22,24,63,64]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const f="sync.enable",c="sync.disableMachineEventually",l="sync.sessionId",r="sync.storeUrl",o="sync.productQuality";let n=class extends P.Disposable{constructor(u,g,y){super();this.storageService=u,this.environmentService=g,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new i.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(k=>this.onDidStorageChange(k)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(f,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(f,u,0,1)}onDidStorageChange(u){if(u.scope===0&&f===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=de([G(0,h.IStorageService),G(1,d.IEnvironmentService),G(2,v.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let t=class extends P.Disposable{constructor(u,g,y,k,O,M,W,q,L,$,_){super();this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=y,this.userDataSyncResourceEnablementService=k,this.userDataSyncService=O,this.logService=M,this.userDataSyncAccountService=W,this.telemetryService=q,this.userDataSyncMachinesService=L,this.storageService=$,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=_,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(g.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,g.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(W.onDidChangeAccount(()=>this.updateAutoSync())),this._register(y.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(i.Event.debounce(O.onDidChangeLocal,(F,B)=>F?[...F,B]:[B],1e3)(F=>this.triggerSync(F,!1,!1))),this._register(i.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(r,0);return u?I.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(r,u.toString(),0,1):this.storageService.remove(r,0)}get productQuality(){return this.storageService.get(o,0)}set productQuality(u){u?this.storageService.store(o,u,0,1):this.storageService.remove(o,0)}updateAutoSync(){const{enabled:u,message:g}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(y=>this.onDidFinishSync(y))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(g&&this.logService.info(g),this.autoSync.clear()):g&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(g))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,g,y){try{this.userDataSyncAccountService.account&&!y&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(k){if(g)this.logService.error(k),this.updateEnablement(!1);else throw k}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(f,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const g=v.UserDataSyncError.toUserDataSyncError(u);g instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:g.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),g.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):g.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):g.code==="LocalTooManyRequests"||g.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):g.code==="UpgradeRequired"||g.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):g.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with newer version than of client. Requires client upgrade.`)):g.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with older version than of client. Requires server reset.`)):g.code==="ServiceChanged"||g.code==="DefaultServiceChanged"?S.isWeb&&g.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(g),this.successiveFailures++),this._onError.fire(g)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(u,g,y){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(g&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",y)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};t=de([G(0,p.IProductService),G(1,v.IUserDataSyncStoreManagementService),G(2,v.IUserDataSyncStoreService),G(3,v.IUserDataSyncResourceEnablementService),G(4,v.IUserDataSyncService),G(5,v.IUserDataSyncLogService),G(6,m.IUserDataSyncAccountService),G(7,E.ITelemetryService),G(8,w.IUserDataSyncMachinesService),G(9,h.IStorageService),G(10,v.IUserDataAutoSyncEnablementService)],t),e.UserDataAutoSyncService=t;class s extends P.Disposable{constructor(u,g,y,k,O,M,W,q){super();this.lastSyncUrl=u,this.interval=g,this.userDataSyncStoreManagementService=y,this.userDataSyncStoreService=k,this.userDataSyncService=O,this.userDataSyncMachinesService=M,this.logService=W,this.storageService=q,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new i.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new i.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(u,g){const y=(0,D.createCancelablePromise)(async k=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,T.isPromiseCanceledError)(O))return}return this.doSync(u,g,k)});return this.syncPromise=y,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),g=this.userDataSyncStoreManagementService.userDataSyncStore;return!!g&&!!u&&(!(0,b.isEqual)(g.defaultUrl,u.defaultUrl)||!(0,b.isEqual)(g.insidersUrl,u.insidersUrl)||!(0,b.isEqual)(g.stableUrl,u.stableUrl))}async doSync(u,g,y){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let k;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,g),y.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const O=this.storageService.get(l,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const M=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(y.isCancellationRequested)return;const W=M.find(q=>q.isCurrent);if(W?.disabled)throw new v.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(q){throw new v.UserDataAutoSyncError((0,R.toErrorMessage)(q),q instanceof v.UserDataSyncError?q.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(l,this.manifest.session,0,1),y.isCancellationRequested)return;W||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),k=O}this._onDidFinishSync.fire(k)}register(u){return super._register(u)}}s.INTERVAL_SYNCING="Interval"}),define(te[231],ne([0,1,3,2,4,23,22,24]),function(J,e,D,A,R,T,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends A.Disposable{constructor(I,C){super();this.storageService=I,this.telemetryService=C,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(I.onDidChangeValue(d=>this.onDidStorageChange(d)))}isResourceEnabled(I){return this.storageService.getBoolean((0,P.getEnablementKey)(I),0,!0)}setResourceEnablement(I,C){if(this.isResourceEnabled(I)!==C){const d=(0,P.getEnablementKey)(I);this.telemetryService.publicLog2(d,{enabled:C}),this.storeResourceEnablement(d,C)}}getResourceSyncStateVersion(I){}storeResourceEnablement(I,C){this.storageService.store(I,C,0,R.isWeb?0:1)}onDidStorageChange(I){if(I.scope===0){const C=P.ALL_SYNC_RESOURCES.filter(d=>(0,P.getEnablementKey)(d)===I.key)[0];if(C){this._onDidChangeResourceEnablement.fire([C,this.isResourceEnabled(C)]);return}}}};S=de([G(0,T.IStorageService),G(1,i.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(te[232],ne([0,1,17,5,38,9,3,2,18,29,21,6,23,22,221,223,224,226,227,24]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let l=class extends P.Disposable{constructor(t,s,a,u,g,y,k){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=s,this.instantiationService=a,this.configurationService=u,this.logService=g,this.telemetryService=y,this.storageService=k,this._status="uninitialized",this._onDidChangeStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new i.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new i.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new i.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new i.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(v.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(w.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(E.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeLocal,()=>O.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,s){await this.checkEnablement();const a=(0,b.generateUuid)();try{const k=(0,f.createSyncHeaders)(a);s&&(k["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,k)}catch(k){const O=f.UserDataSyncError.toUserDataSyncError(k);throw this.reportUserDataSyncError(O,a),O}let u=!1;const g=this;let y;return{manifest:t,run(){if(u)throw new Error("Can run a task only once");return y=(0,A.createCancelablePromise)(k=>g.sync(t,a,k)),y.finally(()=>y=void 0)},async stop(){if(y&&y.cancel(),g.status!=="idle")return g.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,b.generateUuid)(),s=(0,f.createSyncHeaders)(t);let a;try{a=await this.userDataSyncStoreService.manifest(null,s)}catch(u){const g=f.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(g,t),g}return new r(t,a,s,this.synchronisers,this.configurationService,this.logService)}async sync(t,s,a){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),a.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const g=(0,f.createSyncHeaders)(s);for(const y of this.synchronisers){if(a.isCancellationRequested)return;try{await y.sync(t,g)}catch(k){let O=!1;if(k instanceof f.UserDataSyncError)switch(k.code){case"TooLarge":k=new f.UserDataSyncError(k.message,k.code,y.resource),O=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":O=!0;break}const M=f.UserDataSyncError.toUserDataSyncError(k);if(this.reportUserDataSyncError(M,s),O)throw M;this.logService.error(k),this.logService.error(`${y.resource}: ${(0,R.toErrorMessage)(k)}`),this._syncErrors.push([y.resource,M])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(g){const y=f.UserDataSyncError.toUserDataSyncError(g);throw this.reportUserDataSyncError(y,s),y}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(s){this.logService.error(s)}}async replace(t){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(t))return}async accept(t,s,a,u){await this.checkEnablement();const g=this.getSynchroniser(t);await g.accept(s,a),u&&await g.apply(!1,(0,f.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(t){for(const s of this.synchronisers){const a=await s.resolveContent(t);if(a)return a}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,s){return this.getSynchroniser(t).getAssociatedResources(s)}getMachineId(t,s){return this.getSynchroniser(t).getMachineId(s)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of t)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(s){this.logService.error(`${t.resource}: ${(0,R.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const s=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,D.equals)(this._conflicts,t,([s,a],[u,g])=>s===s&&(0,D.equals)(a,g,(y,k)=>(0,S.isEqual)(y.previewResource,k.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,s){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof f.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof f.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(o)])}getSynchroniser(t){return this.synchronisers.find(s=>s.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=de([G(0,f.IUserDataSyncStoreService),G(1,f.IUserDataSyncStoreManagementService),G(2,C.IInstantiationService),G(3,I.IConfigurationService),G(4,f.IUserDataSyncLogService),G(5,p.ITelemetryService),G(6,d.IStorageService)],l),e.UserDataSyncService=l;class r extends P.Disposable{constructor(t,s,a,u,g,y){super();this.id=t,this.manifest=s,this.syncHeaders=a,this.synchronisers=u,this.configurationService=g,this.logService=y,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new i.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,A.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,s){try{return await this.performAction(t,a=>a.accept(t,s))}catch(a){throw this.logService.error(a),a}}async merge(t){try{return t?await this.performAction(t,s=>s.merge(t)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(t){try{return await this.performAction(t,s=>s.discard(t))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,s]of this.previews)for(const a of s.resourcePreviews)a.mergeState==="conflict"&&t.push(a.previewResource);for(const s of t)await this.discard(s);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[s,a]of this.previews){this.synchronizingResources.push([s,a.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(y=>y.resource===s);for(const y of a.resourcePreviews)(y.localChange!==0||y.remoteChange!==0)&&y.mergeState==="preview"&&await u.merge(y.previewResource);const g=await u.apply(!1,this.syncHeaders);g&&t.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,s]of this.previews){this.synchronizingResources.push([t,s.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(u=>u.resource===t);for(const u of s.resourcePreviews)await a.accept(u.remoteResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,s]of this.previews){this.synchronizingResources.push([t,s.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(u=>u.resource===t);for(const u of s.resourcePreviews)await a.accept(u.localResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(s){(0,T.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(t,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const a=this.previews.findIndex(([,q])=>q.resourcePreviews.some(({localResource:L,previewResource:$,remoteResource:_})=>(0,S.isEqual)(t,L)||(0,S.isEqual)(t,$)||(0,S.isEqual)(t,_)));if(a===-1)return this.previews;const[u,g]=this.previews[a],y=g.resourcePreviews.find(({localResource:q,remoteResource:L,previewResource:$})=>(0,S.isEqual)(q,t)||(0,S.isEqual)(L,t)||(0,S.isEqual)($,t));if(!y)return this.previews;let k=this.synchronizingResources.find(q=>q[0]===u);k||(k=[u,[]],this.synchronizingResources.push(k)),k[1].some(q=>(0,S.isEqual)(q,y.localResource))||(k[1].push(y.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const O=this.synchronisers.find(q=>q.resource===this.previews[a][0]),M=await s(O);M?this.previews.splice(a,1,this.toSyncResourcePreview(O.resource,M)):this.previews.splice(a,1);const W=this.synchronizingResources.findIndex(q=>q[0]===u);return this.synchronizingResources[W][1].splice(k[1].findIndex(q=>(0,S.isEqual)(q,y.localResource)),1),k[1].length||(this.synchronizingResources.splice(W,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[s,a]of this.previews){this.synchronizingResources.push([s,a.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(y=>y.resource===s);let g=a;for(const y of a.resourcePreviews)(y.localChange!==0||y.remoteChange!==0)&&y.mergeState==="preview"&&(g=await u.merge(y.previewResource));g&&t.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const s=[],a=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(t.isCancellationRequested)return[];const g=await u.preview(this.manifest,a,this.syncHeaders);g&&s.push(this.toSyncResourcePreview(u.resource,g))}return s}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE),s=await this.synchronisers.find(a=>a instanceof m.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...s}}toSyncResourcePreview(t,s){return[t,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function o(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(te[233],ne([0,1,3,2,15,7,24]),function(J,e,D,A,R,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(C,d){this.service=C,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(C,d,p){try{return await this._call(C,d,p)}catch(h){throw this.logService.error(h),h}}async _call(C,d,p){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],T.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:T.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),E=p[0],v=this.getManualSyncTask(E);switch(p=p.slice(1),h){case"preview":return v.preview();case"accept":return v.accept(T.URI.revive(p[0]),p[1]);case"merge":return v.merge(T.URI.revive(p[0]));case"discard":return v.discard(T.URI.revive(p[0]));case"discardConflicts":return v.discardConflicts();case"apply":return v.apply();case"pull":return v.pull();case"push":return v.push();case"stop":return v.stop();case"_getStatus":return v.status;case"dispose":return this.disposeManualSyncTask(v)}}throw new Error("Invalid call")}getManualSyncTask(C){const d=this.manualSyncTasks.get(this.createKey(C));if(!d)throw new Error(`Manual sync taks not found: ${C}`);return d.manualSyncTask}async createManualSyncTask(){const C=new A.DisposableStore,d=C.add(await this.service.createManualSyncTask());return C.add(d.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:p}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:C}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(C){C.dispose();const d=this.createKey(C.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=P;class S extends A.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,p,h){return C.call(d,p,h).then(null,E=>{throw i.UserDataSyncError.toUserDataSyncError(E)})},listen(d,p){return C.listen(d,p)}},this.channel.call("_getInitialData").then(([d,p,h])=>{this.updateStatus(d),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(E=>this.updateStatus(E))),this._register(this.channel.listen("onDidChangeLastSyncTime")(E=>this.updateLastSyncTime(E)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([p,h])=>[p,i.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:d,status:p}=await this.channel.call("createManualSyncTask"),h=this,E=new b(C,d,p,{async call(v,m,w){return h.channel.call(`manualSync/${v}`,[C,...(0,R.isArray)(m)?m:[m]],w)},listen(v,m){return D.Event.map(D.Event.filter(h.channel.listen(`manualSync/${v}`,m),w=>!E.isDiposed()&&w.manualSyncTaskId===C),w=>w.data)}});return E}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,d,p,h){return this.channel.call("accept",[C,d,p,h])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:p,uri:h})=>({created:p,uri:T.URI.revive(h)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:p,uri:h})=>({created:p,uri:T.URI.revive(h)}))}async getAssociatedResources(C,d){return(await this.channel.call("getAssociatedResources",[C,d])).map(({resource:h,comparableResource:E})=>({resource:T.URI.revive(h),comparableResource:T.URI.revive(E)}))}async getMachineId(C,d){return this.channel.call("getMachineId",[C,d])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([d,p])=>[d,p.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=S;class b extends A.Disposable{constructor(C,d,p,h){super();this.id=C,this.manifest=d,this._disposed=!1,this._status=p;const E=this;this.channel={async call(v,m,w){try{const f=await h.call(v,m,w);return E.isDiposed()||(E._status=await h.call("_getStatus")),f}catch(f){throw i.UserDataSyncError.toUserDataSyncError(f)}},listen(v,m){return h.listen(v,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,d){const p=await this.channel.call("accept",[C,d]);return this.deserializePreviews(p)}async merge(C){const d=await this.channel.call("merge",[C]);return this.deserializePreviews(d)}async discard(C){const d=await this.channel.call("discard",[C]);return this.deserializePreviews(d)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([d,p])=>[d,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource),acceptedResource:T.URI.revive(h.acceptedResource)}))}])}}}),define(te[234],ne([0,1,5,27,9,3,2,109,4,18,15,7,29,21,11,14,26,43,46,23,24]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",o="sync.user-session-id",n="sync.machine-session-id",t=100,s=1e3*60*5;let a=class extends i.Disposable{constructor(M,W,q){super();this.productService=M,this.configurationService=W,this.storageService=q,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(q.onDidChangeValue,L=>L.key===c.SYNC_SERVICE_URL_TYPE&&L.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(M){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,M,0,S.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(M,W){M=S.isWeb&&M?.web?{...M,...M.web}:M;const q={...M||{},...W||{}};if(q&&(0,I.isString)(q.url)&&(0,I.isObject)(q.authenticationProviders)&&Object.keys(q.authenticationProviders).every(L=>(0,I.isArray)(q.authenticationProviders[L].scopes))){const L=q,$=!!L.canSwitch&&!W?.url,_=L.url===L.insidersUrl?"insiders":"stable",F=($?this.userDataSyncStoreType:void 0)||_,B=W?.url||(F==="insiders"?L.insidersUrl:F==="stable"?L.stableUrl:L.url);return{url:C.URI.parse(B),type:F,defaultType:_,defaultUrl:C.URI.parse(L.url),stableUrl:C.URI.parse(L.stableUrl),insidersUrl:C.URI.parse(L.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(L.authenticationProviders).reduce((Z,H)=>(Z.push({id:H,scopes:L.authenticationProviders[H].scopes}),Z),[])}}}};a=de([G(0,v.IProductService),G(1,p.IConfigurationService),G(2,f.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let u=class extends a{constructor(M,W,q){super(M,W,q);const L=this.storageService.get(l,0);L&&(this.previousConfigurationSyncStore=JSON.parse(L));const $=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(l,JSON.stringify($),0,1):this.storageService.remove(l,0)}async switch(M){M!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=M,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=de([G(0,v.IProductService),G(1,p.IConfigurationService),G(2,f.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let g=class extends i.Disposable{constructor(M,W,q,L,$,_,F){super();this.requestService=q,this.logService=L,this.storageService=F,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(M),this.commonHeadersPromise=(0,w.getServiceMachineId)($,_,F).then(B=>{const Z={"X-Client-Name":`${W.applicationName}${S.isWeb?"-web":""}`,"X-Client-Version":W.version};return W.commit&&(Z["X-Client-Commit"]=W.commit),Z}),this.session=new k(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,i.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(M,W){this.authToken={token:M,type:W}}updateUserDataSyncStoreUrl(M){this.userDataSyncStoreUrl=M?(0,b.joinPath)(M,"v1"):void 0}initDonotMakeRequestsUntil(){const M=this.storageService.getNumber(r,0);M&&Date.now()<M&&this.setDonotMakeRequestsUntil(new Date(M))}setDonotMakeRequestsUntil(M){this._donotMakeRequestsUntil?.getTime()!==M?.getTime()&&(this._donotMakeRequestsUntil=M,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(W=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),W).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,W=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M),q={},L=await this.request(W.toString(),{type:"GET",headers:q},[],A.CancellationToken.None);return(await(0,m.asJson)(L)||[]).map(({url:_,created:F})=>({ref:(0,b.relativePath)(W,W.with({path:_})),created:F*1e3}))}async resolveContent(M,W){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M,W).toString(),L={};L["Cache-Control"]="no-cache";const $=await this.request(q,{type:"GET",headers:L},[],A.CancellationToken.None);return await(0,m.asText)($)}async delete(M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M).toString(),q={};await this.request(W,{type:"DELETE",headers:q},[],A.CancellationToken.None)}async read(M,W,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M,"latest").toString();q={...q},q["Cache-Control"]="no-cache",W&&(q["If-None-Match"]=W.ref);const $=await this.request(L,{type:"GET",headers:q},[304],A.CancellationToken.None);let _=null;if($.res.statusCode===304&&(_=W),_===null){const F=$.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",L,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const B=await(0,m.asText)($);if(!B&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",L,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);_={ref:F,content:B}}return _}async write(M,W,q,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",M).toString();L={...L},L["Content-Type"]=P.Mimes.text,q&&(L["If-Match"]=q);const _=await this.request($,{type:"POST",data:W,headers:L},[],A.CancellationToken.None),F=_.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",_.res.statusCode,_.res.headers[c.HEADER_OPERATION_ID]);return F}async manifest(M,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();W={...W},W["Content-Type"]="application/json",M&&(W["If-None-Match"]=M.ref);const L=await this.request(q,{type:"GET",headers:W},[304],A.CancellationToken.None);let $=null;if(L.res.statusCode===304&&($=M),!$){const F=L.res.headers.etag;if(!F)throw new c.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",L.res.statusCode,L.res.headers[c.HEADER_OPERATION_ID]);const B=await(0,m.asText)(L);if(!B&&L.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",q,"EmptyResponse",L.res.statusCode,L.res.headers[c.HEADER_OPERATION_ID]);B&&($={...JSON.parse(B),ref:F})}const _=this.storageService.get(o,0);return _&&$&&_!==$.session&&this.clearSession(),$===null&&_&&this.clearSession(),$&&this.storageService.store(o,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),W={"Content-Type":P.Mimes.text};await this.request(M,{type:"DELETE",headers:W},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(o,0),this.storageService.remove(n,0)}async request(M,W,q,L){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",M,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${W.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;W.headers={...W.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(W.headers),this.logService.trace("Sending request to server",{url:M,type:W.type,headers:{...W.headers,authorization:void 0}});let _;try{_=await this.session.request(M,W,L)}catch(H){if(!(H instanceof c.UserDataSyncStoreError)){let j="RequestFailed";const Q=(0,R.getErrorMessage)(H).toLowerCase();Q.includes("xhr timeout")?j="RequestTimeout":Q.includes("protocol")&&Q.includes("not supported")?j="RequestProtocolNotSupported":Q.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Q.includes("headers must be an object")?j="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(H)&&(j="RequestCanceled"),H=new c.UserDataSyncStoreError(`Connection refused for the request '${M}'.`,M,j,void 0,void 0)}throw this.logService.info("Request failed",M),H}const F=_.res.headers[c.HEADER_OPERATION_ID],B={url:M,status:_.res.statusCode,"execution-id":W.headers[c.HEADER_EXECUTION_ID],"operation-id":F},Z=(0,m.isSuccess)(_)||_.res.statusCode&&q.indexOf(_.res.statusCode)!==-1;if(Z?this.logService.trace("Request succeeded",B):this.logService.info("Request failed",B),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${M}' failed because of Unauthorized (401).`,M,"Unauthorized",_.res.statusCode,F);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new c.UserDataSyncStoreError(`${W.type} request '${M}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,M,"Conflict",_.res.statusCode,F);if(_.res.statusCode===410)throw new c.UserDataSyncStoreError(`${W.type} request '${M}' failed because the requested resource is not longer available (410).`,M,"Gone",_.res.statusCode,F);if(_.res.statusCode===412)throw new c.UserDataSyncStoreError(`${W.type} request '${M}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,M,"PreconditionFailed",_.res.statusCode,F);if(_.res.statusCode===413)throw new c.UserDataSyncStoreError(`${W.type} request '${M}' failed because of too large payload (413).`,M,"TooLarge",_.res.statusCode,F);if(_.res.statusCode===426)throw new c.UserDataSyncStoreError(`${W.type} request '${M}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,M,"UpgradeRequired",_.res.statusCode,F);if(_.res.statusCode===429){const H=_.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new c.UserDataSyncStoreError(`${W.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",_.res.statusCode,F)):new c.UserDataSyncStoreError(`${W.type} request '${M}' failed because of too many requests (429).`,M,"RemoteTooManyRequests",_.res.statusCode,F)}if(!Z)throw new c.UserDataSyncStoreError("Server returned "+_.res.statusCode,M,"Unknown",_.res.statusCode,F);return _}addSessionHeaders(M){let W=this.storageService.get(n,0);W===void 0&&(W=(0,d.generateUuid)(),this.storageService.store(n,W,0,1)),M["X-Machine-Session-Id"]=W;const q=this.storageService.get(o,0);q!==void 0&&(M["X-User-Session-Id"]=q)}};g=de([G(1,v.IProductService),G(2,m.IRequestService),G(3,c.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,E.IFileService),G(6,f.IStorageService)],g),e.UserDataSyncStoreClient=g;let y=class extends g{constructor(M,W,q,L,$,_,F){super(M.userDataSyncStore?.url,W,q,L,$,_,F);this._register(M.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(M.userDataSyncStore?.url)))}};y=de([G(0,c.IUserDataSyncStoreManagementService),G(1,v.IProductService),G(2,m.IRequestService),G(3,c.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,E.IFileService),G(6,f.IStorageService)],y),e.UserDataSyncStoreService=y;class k{constructor(M,W,q,L){this.limit=M,this.interval=W,this.requestService=q,this.logService=L,this.requests=[],this.startTime=void 0}request(M,W,q){if(this.isExpired()&&this.reset(),W.url=M,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,M,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(M),this.requestService.request(W,q)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=k}),define(te[235],ne([0,1,3,60,26,23,22,99,24,63,64]),function(J,e,D,A,R,T,i,P,S,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(p,h,E,v,m,w,f,c,l,r,o,n){super(p,h,E,v,m,f,c,l,r,o,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(w.onDidFocusWindow,()=>"windowFocus"),D.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(t,s)=>t?[...t,s]:[s],1e3)(t=>this.triggerSync(t,!0,!1)))}};C=de([G(0,R.IProductService),G(1,S.IUserDataSyncStoreManagementService),G(2,S.IUserDataSyncStoreService),G(3,S.IUserDataSyncResourceEnablementService),G(4,S.IUserDataSyncService),G(5,A.INativeHostService),G(6,S.IUserDataSyncLogService),G(7,b.IUserDataSyncAccountService),G(8,i.ITelemetryService),G(9,I.IUserDataSyncMachinesService),G(10,T.IStorageService),G(11,S.IUserDataAutoSyncEnablementService)],C),e.UserDataAutoSyncService=C}),define(te[236],ne([0,1,5,3,2]),function(J,e,D,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:S,getActiveWindowId:b}){super();this.disposables=this._register(new R.DisposableStore),A.Event.latch(A.Event.any(P,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>b()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch(C){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[65],ne([0,1,51,5,10,15,20,125,248,249]),function(J,e,D,A,R,T,i,P,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,o){let n=o.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=o}}e.ExtractError=I;function C(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(o=>r&o).reduce((o,n)=>o+n,r&61440)}function d(l){if(l instanceof I)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new I(r,l)}function p(l,r,o,n,t,s){const a=R.dirname(r),u=R.join(n,a);if(!u.startsWith(n))return Promise.reject(new Error(P.localize(0,null,r)));const g=R.join(n,r);let y;return s.onCancellationRequested(()=>{y&&y.destroy()}),Promise.resolve(i.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((k,O)=>{if(!s.isCancellationRequested)try{y=(0,D.createWriteStream)(g,{mode:o}),y.once("close",()=>k()),y.once("error",O),l.once("error",O),l.pipe(y)}catch(M){O(M)}}))}function h(l,r,o,n){let t=(0,A.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((a,u)=>{const g=new A.Sequencer,y=k=>{k.isCancellationRequested||(s++,l.readEntry())};l.once("error",u),l.once("close",()=>t.then(()=>{n.isCancellationRequested||l.entryCount===s?a():u(new I("Incomplete",new Error(P.localize(1,null,s,l.entryCount))))},u)),l.readEntry(),l.on("entry",k=>{if(n.isCancellationRequested)return;if(!o.sourcePathRegex.test(k.fileName)){y(n);return}const O=k.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(O)){const q=R.join(r,O);t=(0,A.createCancelablePromise)(L=>i.Promises.mkdir(q,{recursive:!0}).then(()=>y(L)).then(void 0,u));return}const M=v(l,k),W=C(k);t=(0,A.createCancelablePromise)(q=>g.queue(()=>M.then(L=>p(L,O,W,r,o,q).then(()=>y(q)))).then(null,u))})})}function E(l,r=!1){return new Promise((o,n)=>{(0,S.open)(l,r?{lazyEntries:!0}:void 0,(t,s)=>{t?n(d(t)):o((0,T.assertIsDefined)(s))})})}function v(l,r){return new Promise((o,n)=>{l.openReadStream(r,(t,s)=>{t?n(d(t)):o((0,T.assertIsDefined)(s))})})}function m(l,r){return new Promise((o,n)=>{const t=new b.ZipFile;r.forEach(a=>{a.contents?t.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&t.addFile(a.localPath,a.path)}),t.end();const s=(0,D.createWriteStream)(l);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>o(l))})}e.zip=m;function w(l,r,o={},n){const t=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=E(l,!0);return o.overwrite&&(s=s.then(a=>i.Promises.rm(r).then(()=>a))),s.then(a=>h(a,r,{sourcePathRegex:t},n))}e.extract=w;function f(l,r){return E(l).then(o=>new Promise((n,t)=>{o.on("entry",s=>{s.fileName===r&&v(o,s).then(a=>n(a),a=>t(a))}),o.once("close",()=>t(new Error(P.localize(2,null,r))))}))}function c(l,r){return f(l,r).then(o=>new Promise((n,t)=>{const s=[];o.once("error",t),o.on("data",a=>s.push(a)),o.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=c}),define(te[237],ne([0,1,65,134]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,D.buffer)(T,"extension/package.json").then(i=>{try{return JSON.parse(i.toString("utf8"))}catch(P){throw new Error((0,A.localize)(0,null))}})}e.getManifest=R}),define(te[238],ne([0,1,17,5,9,2,16,10,4,18,61,7,29,20,65,135,11,30,35,156,14,8,26]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let o=class extends T.Disposable{constructor(t,s,a,u,g){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=a,this.environmentService=u,this.productService=g,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new A.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal))));try{const a=await Promise.all(s);return(0,D.flatten)(a)}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,a]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return a=a.filter(u=>!s[new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(a=(0,w.groupByExtension)(a,g=>g.identifier).map(g=>g.sort((y,k)=>I.rcompare(y.manifest.version,k.manifest.version))[0])),this.logService.trace("Scanned user extensions:",a.length),a}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,a,u){const g=t.key(),y=P.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),k=P.join(this.extensionsPath,g);try{await p.Promises.rm(k)}catch(M){try{await p.Promises.rm(k)}catch(W){}throw new m.ExtensionManagementError((0,E.localize)(0,null,k,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,y,u);let O=await this.scanExtension(C.URI.file(y),1);if(!O)throw new Error((0,E.localize)(1,null,y));await this.storeMetadata(O,{...a,installedTimestamp:Date.now()});try{await this.rename(t,y,k,Date.now()+2*60*1e3),this.logService.info("Renamed to",k)}catch(M){try{await p.Promises.rm(y)}catch(W){}if(M.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(M)}. Deleted from extracted location`,y),M}try{O=await this.scanExtension(C.URI.file(k),1)}catch(M){}if(O)return O;throw new Error((0,E.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const a=P.join(t.location.fsPath,"package.json"),u=await p.Promises.readFile(a,"utf8"),{manifest:g}=await this.parseManifest(u);return g.__metadata=s,await p.Promises.writeFile(a,JSON.stringify(g,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(a=>new w.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version));await this.withUninstalledExtensions(a=>{s.forEach(u=>a[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const a=(await this.scanExtensions(1)).find(u=>new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let a={};if(s)try{a=JSON.parse(s)}catch(u){}return t&&(t(a),Object.keys(a).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await p.Promises.rm(this.uninstalledPath)),a})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await p.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,a,u){this.logService.trace(`Started extracting the extension from ${s} to ${a}`);try{await p.Promises.rm(a)}catch(g){throw new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,a,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${a}:`,t.id)}catch(g){try{await p.Promises.rm(a)}catch(k){}let y=m.ExtensionManagementErrorCode.Extract;throw g instanceof h.ExtractError&&(g.type==="CorruptZip"?y=m.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(y=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(g.message,y)}}async rename(t,s,a,u){try{await p.Promises.rename(s,a)}catch(g){if(S.isWindows&&g&&g.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${s} to ${a} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,a,u);throw new m.ExtensionManagementError(g.message||(0,E.localize)(3,null,s,a),g.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[a,u]=await Promise.all([t,s]);return[...a,...u]}async scanExtensionsInDir(t,s){const a=new A.Limiter(10),u=await this.fileService.resolve(C.URI.file(t));return u.children?(await Promise.all(u.children.filter(y=>y.isDirectory).map(y=>a.queue(async()=>s===1&&(0,b.basename)(y.resource).indexOf(".")===0?null:this.scanExtension(y.resource,s))))).filter(y=>y&&y.identifier):[]}async scanExtension(t,s){try{const a=await this.fileService.resolve(t);if(a.children){const{manifest:u,metadata:g}=await this.readManifest(t.fsPath),y=a.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,k=a.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,O={id:(0,w.getGalleryExtensionId)(u.publisher,u.name)},M={type:s,identifier:O,manifest:u,location:t,readmeUrl:y,changelogUrl:k,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(M,g),M}}catch(a){s!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(a=>t.some(u=>(0,w.areSameExtensions)(a.identifier,{id:u})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),a=new Set;for(const y of s)t[new w.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]||a.add(y.identifier.id.toLowerCase());const u=(0,w.groupByExtension)(s,y=>y.identifier);await A.Promises.settled(u.map(async y=>{const k=y.sort((O,M)=>I.rcompare(O.manifest.version,M.manifest.version))[0];a.has(k.identifier.id.toLowerCase())||await this.beforeRemovingExtension(k)}));const g=s.filter(y=>t[new w.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]);await A.Promises.settled(g.map(y=>this.removeUninstalledExtension(y)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],a=(0,w.groupByExtension)(t,u=>u.identifier);s.push(...(0,D.flatten)(a.map(u=>u.sort((g,y)=>I.rcompare(g.manifest.version,y.manifest.version)).slice(1)))),await A.Promises.settled(s.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((a,u)=>new Error(`${a.message}${a.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(i.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[p.Promises.readFile(P.join(t,"package.json"),"utf8").then(y=>this.parseManifest(y)),p.Promises.readFile(P.join(t,"package.nls.json"),"utf8").then(void 0,y=>y.code!=="ENOENT"?Promise.reject(y):"{}").then(y=>JSON.parse(y))],[{manifest:a,metadata:u},g]=await Promise.all(s);return{manifest:(0,f.localizeManifest)(a,g),metadata:u}}parseManifest(t){return new Promise((s,a)=>{try{const u=JSON.parse(t),g=u.__metadata||null;s({manifest:u,metadata:g})}catch(u){a(new Error((0,E.localize)(4,null)))}})}};o=de([G(1,c.IFileService),G(2,l.ILogService),G(3,v.INativeEnvironmentService),G(4,r.IProductService)],o),e.ExtensionsScanner=o}),define(te[239],ne([0,1,38,9,16,10,4,32,18,61,7,29,20,65,133,79,11,202,30,35,186,175,237,187,238,216,76,14,6,8,26,22,36]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c,l,r,o,n,t,s,a,u,g,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let M=class extends m.AbstractExtensionManagementService{constructor(F,B,Z,H,j,Q,U,N,z){super(F,B,Z,N);this.environmentService=H,this.downloadService=j,this.fileService=U;const x=this._register(Q.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(Q.createInstance(n.ExtensionsScanner,ee=>x.postUninstall(ee))),this.manifestCache=this._register(new o.ExtensionsManifestCache(H,this)),this.extensionsDownloader=this._register(Q.createInstance(c.ExtensionsDownloader));const K=this._register(new t.ExtensionsWatcher(this,U,H,Z,z));this._register(K.onDidChangeExtensionsByAnotherSource(({added:ee,removed:V})=>{ee.length&&this._onDidInstallExtensions.fire(ee.map(X=>({identifier:X.identifier,operation:0,local:X}))),V.forEach(X=>this._onDidUninstallExtension.fire({identifier:X}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const F=await this.isAlpineLinux(),B=(0,w.getTargetPlatform)(F?"alpine":i.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",B),B})()),this._targetPlatformPromise}async isAlpineLinux(){if(!i.isLinux)return!1;let F;try{F=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch(B){try{F=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(Z){this.logService.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(Z))}}return!!F&&(F.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const B=await this.collectFiles(F),Z=await(0,p.zip)((0,S.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,B);return I.URI.file(Z)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const B=await this.downloadVsix(F),Z=T.resolve(B.fsPath);return(0,r.getManifest)(Z)}getInstalled(F=null){return this.extensionsScanner.scanExtensions(F)}async install(F,B={}){this.logService.trace("ExtensionManagementService#install",F.toString());const Z=await this.downloadVsix(F),H=await(0,r.getManifest)(T.resolve(Z.fsPath));if(H.engines&&H.engines.vscode&&!(0,s.isEngineValid)(H.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,f.getGalleryExtensionId)(H.publisher,H.name),this.productService.version));return this.installExtension(H,Z,B)}async updateMetadata(F,B){return this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id),F=await this.extensionsScanner.saveMetadataForLocalExtension(F,{...F.manifest.__metadata||{},...B}),this.manifestCache.invalidate(),F}async updateExtensionScope(F,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",F.identifier.id),F=await this.extensionsScanner.saveMetadataForLocalExtension(F,{...F.manifest.__metadata||{},isMachineScoped:B}),this.manifestCache.invalidate(),F}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(F){if(F.scheme===R.Schemas.file)return F;const B=(0,S.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(F,B),B}createInstallExtensionTask(F,B,Z){return I.URI.isUri(B)?new L(F,B,Z,this.galleryService,this.extensionsScanner,this.logService):new q(B,Z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(F,B){return new $(F,B,this.extensionsScanner)}async collectFiles(F){const B=async H=>{let j=await d.Promises.readdir(H);j=j.map(N=>T.join(H,N));const Q=await Promise.all(j.map(N=>d.Promises.stat(N)));let U=Promise.resolve([]);return Q.forEach((N,z)=>{const x=j[z];N.isFile()&&(U=U.then(K=>[...K,x])),N.isDirectory()&&(U=U.then(K=>B(x).then(ee=>[...K,...ee])))}),U};return(await B(F.location.fsPath)).map(H=>({path:`extension/${T.relative(F.location.fsPath,H)}`,localPath:H}))}};M=de([G(0,w.IExtensionGalleryService),G(1,k.ITelemetryService),G(2,g.ILogService),G(3,v.INativeEnvironmentService),G(4,E.IDownloadService),G(5,u.IInstantiationService),G(6,a.IFileService),G(7,y.IProductService),G(8,O.IUriIdentityService)],M),e.ExtensionManagementService=M;class W extends m.AbstractExtensionTask{constructor(F,B,Z,H){super();this.identifier=F,this.source=B,this.extensionsScanner=Z,this.logService=H,this._operation=1}get operation(){return this._operation}async installExtension(F,B){try{const Z=await this.unsetUninstalledAndGetLocal(F.identifierWithVersion);if(Z)return F.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Z,{...Z.manifest.__metadata||{},...F.metadata}):Z}catch(Z){throw i.isMacintosh?new w.ExtensionManagementError(h.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(h.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(F,B)}async unsetUninstalledAndGetLocal(F){if(!await this.isUninstalled(F))return null;this.logService.trace("Removing the extension from uninstalled list:",F.id);const Z=await this.extensionsScanner.setInstalled(F);return this.logService.info("Removed the extension from uninstalled list:",F.id),Z}async isUninstalled(F){return!!(await this.extensionsScanner.getUninstalledExtensions())[F.key()]}async extract({zipPath:F,identifierWithVersion:B,metadata:Z},H){let j=await this.extensionsScanner.extractUserExtension(B,F,Z,H);return this.logService.info("Extracting completed.",B.id),j}}class q extends W{constructor(F,B,Z,H,j){super(F.identifier,F,H,j);this.gallery=F,this.options=B,this.extensionsDownloader=Z}async doRun(F){const Z=(await this.extensionsScanner.scanExtensions(null)).find(j=>(0,f.areSameExtensions)(j.identifier,this.gallery.identifier));Z&&(this._operation=2);const H=await this.downloadInstallableExtension(this.gallery,this._operation);H.metadata.isMachineScoped=this.options.isMachineScoped||Z?.isMachineScoped,H.metadata.isBuiltin=this.options.isBuiltin||Z?.isBuiltin,H.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,H.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:Z?.preRelease;try{const j=await this.installExtension(H,F);return Z&&b.neq(Z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Z),j}catch(j){throw await this.deleteDownloadedVSIX(H.zipPath),j}}async deleteDownloadedVSIX(F){try{await this.extensionsDownloader.delete(I.URI.file(F))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",F.toString(),(0,A.getErrorMessage)(B))}}async downloadInstallableExtension(F,B){const Z={id:F.identifier.uuid,publisherId:F.publisherId,publisherDisplayName:F.publisherDisplayName};let H;try{this.logService.trace("Started downloading extension:",F.identifier.id),H=(await this.extensionsDownloader.downloadExtension(F,B)).fsPath,this.logService.info("Downloaded extension:",F.identifier.id,H)}catch(j){throw new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Download)}try{const j=await(0,r.getManifest)(H);return{zipPath:H,identifierWithVersion:new f.ExtensionIdentifierWithVersion(F.identifier,j.version),metadata:Z}}catch(j){throw await this.deleteDownloadedVSIX(H),new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Invalid)}}}class L extends W{constructor(F,B,Z,H,j,Q){super({id:(0,f.getGalleryExtensionId)(F.publisher,F.name)},B,j,Q);this.manifest=F,this.location=B,this.options=Z,this.galleryService=H}async doRun(F){const B=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),H=(await this.extensionsScanner.scanExtensions(1)).find(Q=>(0,f.areSameExtensions)(this.identifier,Q.identifier)),j=await this.getMetadata(this.identifier.id,F);if(j.isMachineScoped=this.options.isMachineScoped||H?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||H?.isBuiltin,H)if(this._operation=2,B.equals(new f.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version)))try{await this.extensionsScanner.removeExtension(H,"existing")}catch(Q){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(H.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(H);else{const Q=await this.unsetUninstalledAndGetLocal(B);if(Q)try{await this.extensionsScanner.removeExtension(Q,"existing")}catch(U){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:B,metadata:j},F)}async getMetadata(F,B){try{const Z=(await this.galleryService.query({names:[F],pageSize:1},B)).firstPage[0];if(Z)return{id:Z.identifier.uuid,publisherDisplayName:Z.publisherDisplayName,publisherId:Z.publisherId}}catch(Z){}return{}}}class $ extends m.AbstractExtensionTask{constructor(F,B,Z){super();this.extension=F,this.options=B,this.extensionsScanner=Z}async doRun(F){const B=[],Z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const H=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);B.push(...Z.filter(j=>H.equals(new f.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else B.push(...Z.filter(H=>(0,f.areSameExtensions)(H.identifier,this.extension.identifier)));if(!B.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const H of B)try{F.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(H)}catch(j){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(j)))}}}}),define(te[240],ne([0,1,81,57,33,19,9,3,2,10,4,29,34,71,250]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{constructor(u){this.socket=u,this._errorListener=g=>{if(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const g=y=>u(T.VSBuffer.wrap(y));return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(u){const g=y=>{u({type:0,hadError:y,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}}end(){this.socket.end()}drain(){return new Promise((u,g)=>{if(this.socket.bufferSize===0){u();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),u()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=E;var v;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var m;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(m||(m={}));class w extends S.Disposable{constructor(u,g,y,k){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=g,this._recordInflateBytes=k,g?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),y&&(this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):T.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let g=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.length-4),this._isEnded||this._write(T.VSBuffer.wrap(g),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,g){let y=2;u.byteLength<126?y+=0:u.byteLength<2**16?y+=2:y+=8;const k=T.VSBuffer.alloc(y);if(g?k.writeUInt8(194,0):k.writeUInt8(130,0),u.byteLength<126)k.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){k.writeUInt8(126,1);let O=1;k.writeUInt8(u.byteLength>>>8&255,++O),k.writeUInt8(u.byteLength>>>0&255,++O)}else{k.writeUInt8(127,1);let O=1;k.writeUInt8(0,++O),k.writeUInt8(0,++O),k.writeUInt8(0,++O),k.writeUInt8(0,++O),k.writeUInt8(u.byteLength>>>24&255,++O),k.writeUInt8(u.byteLength>>>16&255,++O),k.writeUInt8(u.byteLength>>>8&255,++O),k.writeUInt8(u.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=k.byteLength+u.byteLength,this.socket.write(T.VSBuffer.concat([k,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),y=g.readUInt8(0),k=(y&128)>>>7,O=(y&64)>>>6,M=g.readUInt8(1),W=(M&128)>>>7,q=M&127;this._state.state=2,this._state.readLen=2+(W?4:0)+(q===126?2:0)+(q===127?8:0),this._state.fin=k,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(k),this._state.mask=0}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),y=g.readUInt8(1),k=(y&128)>>>7;let O=y&127,M=1;O===126?O=g.readUInt8(++M)*2**8+g.readUInt8(++M):O===127&&(O=g.readUInt8(++M)*0+g.readUInt8(++M)*0+g.readUInt8(++M)*0+g.readUInt8(++M)*0+g.readUInt8(++M)*2**24+g.readUInt8(++M)*2**16+g.readUInt8(++M)*2**8+g.readUInt8(++M));let W=0;k&&(W=g.readUInt8(++M)*2**24+g.readUInt8(++M)*2**16+g.readUInt8(++M)*2**8+g.readUInt8(++M)),this._state.state=3,this._state.readLen=O,this._state.mask=W}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);f(g,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(g.buffer)),this._zlibInflate.write(g.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const y=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=y.length,this._onData.fire(T.VSBuffer.wrap(y))})):(this._totalIncomingDataBytes+=g.byteLength,this._onData.fire(g))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=w;function f(a,u){if(u===0)return;let g=a.byteLength>>>2;for(let q=0;q<g;q++){const L=a.readUInt32BE(q*4);a.writeUInt32BE(L^u,q*4)}let y=g*4,k=a.byteLength-y;const O=u>>>24&255,M=u>>>16&255,W=u>>>8&255;k>=1&&a.writeUInt8(a.readUInt8(y)^O,y),k>=2&&a.writeUInt8(a.readUInt8(y+1)^M,y+1),k>=3&&a.writeUInt8(a.readUInt8(y+2)^W,y+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function l(){const a=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):u=(0,b.join)((0,R.tmpdir)(),`vscode-ipc-${a}.sock`),o(u),u}e.createRandomIPCHandle=l;function r(a,u,g){const y=(0,D.createHash)("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${g}-${u}-sock`;let k;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?k=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${g}-${u}.sock`):k=(0,b.join)(a,`${g}-${u}.sock`),o(k),k}e.createStaticIPCHandle=r;function o(a){const u=c[I.platform];typeof u=="number"&&a.length>=u&&console.warn(`WARNING: IPC handle "${a}" is longer than ${u} chars, try a shorter --user-data-dir`)}class n extends d.IPCServer{constructor(u){super(n.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const g=P.Event.fromNodeEventEmitter(u,"connection");return P.Event.map(g,y=>({protocol:new p.Protocol(new E(y)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(y,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function t(a){return new Promise((u,g)=>{const y=(0,A.createServer)();y.on("error",g),y.listen(a,()=>{y.removeListener("error",g),u(new n(y))})})}e.serve=t;function s(a,u){return new Promise((g,y)=>{const k=(0,A.createConnection)(a,()=>{k.removeListener("error",y),g(p.Client.fromSocket(new E(k),u))});k.once("error",y)})}e.connect=s}),define(te[241],ne([0,1,57,240]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,T,i,P){const S=I=>P(I,void 0),b=D.createConnection({host:R,port:T},()=>{b.removeListener("error",S);const I=Buffer.alloc(16);for(let h=0;h<16;h++)I[h]=Math.round(Math.random()*256);const C=I.toString("base64");let d=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${T}/?${i}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${C}`];b.write(d.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",p),P(void 0,new A.NodeSocket(b)))};b.on("data",p)});b.once("error",S)}}}),define(te[242],ne([0,1,57,115,241,5,2,21,8,26,184,62,91]),function(J,e,D,A,R,T,i,P,S,b,I,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(w,f,c,l,r){let o;for(let n=3;n&&(o&&o.dispose(),o=await new h(w,f,c,l,r).waitForReady(),!(r&&A.BROWSER_RESTRICTED_PORTS[r]||!A.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));n--);return o}class h extends i.Disposable{constructor(f,c,l,r,o){super();this.defaultTunnelHost=c,this.suggestedLocalPort=o,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let f=await(0,A.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(f){f.pause();const c=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),r=l.getSocket().socket,o=l.readEntireBuffer();l.dispose(),o.byteLength>0&&f.write(o.buffer),f.on("end",()=>{this._socketsDispose.delete(f.localAddress),r.end()}),f.on("close",()=>r.end()),f.on("error",()=>{this._socketsDispose.delete(f.localAddress),r.destroy()}),r.on("end",()=>f.end()),r.on("close",()=>f.end()),r.on("error",()=>{f.destroy()}),f.pipe(r),r.pipe(f),this._socketsDispose.set(f.localAddress,()=>{f.end(),r.end()})}}let E=class extends C.AbstractTunnelService{constructor(f,c,l,r,o){super(c);this.socketFactory=f,this.signService=l,this.productService=r,this.configurationService=o}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,c,l,r,o,n,t){const s=this.getTunnelFromMap(c,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,l,r,o,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${l} on local port ${r}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},u=p(a,this.defaultTunnelHost,c,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,l,u),u}}};E=de([G(1,S.ILogService),G(2,d.ISignService),G(3,b.IProductService),G(4,P.IConfigurationService)],E),e.BaseTunnelService=E;let v=class extends E{constructor(f,c,l,r){super(R.nodeSocketFactory,f,c,l,r)}};v=de([G(0,S.ILogService),G(1,d.ISignService),G(2,b.IProductService),G(3,P.IConfigurationService)],v),e.TunnelService=v;let m=class extends i.Disposable{constructor(f,c,l,r){super();this.logService=f,this.productService=c,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(f,c,l,r,o,n,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${o}.`),!this._tunnelServices.has(f)){const a=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(f,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(c,l,r,o,n,t,s)}};m=de([G(0,S.ILogService),G(1,b.IProductService),G(2,d.ISignService),G(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[251],ne([0,1,72,33,38,9,2,16,18,7,34,119,180,161,181,172,173,174,159,163,21,182,78,201,79,192,11,154,197,205,30,162,203,239,80,157,14,177,179,53,6,169,83,170,171,59,188,8,85,60,86,26,191,43,23,199,200,22,92,93,94,44,206,207,95,209,215,97,98,99,24,63,228,229,230,64,231,232,233,234,235,236,91,196,62,242,189,190,90,195,84,204,36,217]),function(J,e,D,A,R,T,i,P,S,b,I,C,d,p,h,E,v,m,w,f,c,l,r,o,n,t,s,a,u,g,y,k,O,M,W,q,L,$,_,F,B,Z,H,j,Q,U,N,z,x,K,ee,V,X,se,oe,le,he,be,Ce,we,ve,De,Se,Ie,Me,je,Ne,We,ie,ae,ce,ye,Pe,_e,Te,Fe,Ae,Ue,Y,re,ue,fe,pe,ge,Ee,Re,ke,Le,$e,Ye,He,Ct,It,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Rt extends i.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Oe="vscode:electron-main->shared-process=disposeWorker",qe=(Ge,ze)=>this.onDisposeWorker(ze);D.ipcRenderer.on(Oe,qe),this._register((0,i.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,qe)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ce.registerConfiguration)(),me.invokeFunction(Oe=>{const qe=Oe.get(z.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(qe)}),this._register((0,i.combinedDisposable)(me.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(h.LanguagePackCachedDataCleaner),me.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(v.LogsDataCleaner),me.createInstance(E.LocalizationsUpdater),me.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const me=new H.ServiceCollection,Oe={_serviceBrand:void 0,...ee.default};me.set(V.IProductService,Oe);const qe=new I.StaticRouter(xe=>xe==="main"),Ge=new j.MessagePortMainProcessService(this.server,qe);me.set(Q.IMainProcessService,Ge);const ze=new a.NativeEnvironmentService(this.configuration.args,Oe);me.set(s.INativeEnvironmentService,ze);const rt=new x.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Qe=new x.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ge.getChannel("logger"));me.set(z.ILoggerService,Qe);const at=this._register(new z.MultiplexLogService([this._register(new z.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,S.joinPath)(b.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new x.FollowerLogService(rt,at));me.set(z.ILogService,Je),this.sharedProcessWorkerService=new Ye.SharedProcessWorkerService(Je,Oe,ze),me.set($e.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Xe=this._register(new $.FileService(Je));me.set(L.IFileService,Xe);const ct=this._register(new _.DiskFileSystemProvider(Je));Xe.registerProvider(P.Schemas.file,ct);const Be=this._register(new l.ConfigurationService(ze.settingsResource,Xe));me.set(c.IConfigurationService,Be);const tt=new le.NativeStorageService(void 0,Ge,ze);me.set(oe.IStorageService,tt),this._register((0,i.toDisposable)(()=>tt.flush())),await Promise.all([Be.initialize(),tt.initialize()]),me.set(He.IUserConfigurationFileService,I.ProxyChannel.toService(Ge.getChannel(He.UserConfigurationFileServiceId))),me.set(It.IUriIdentityService,new Pt.UriIdentityService(Xe)),me.set(se.IRequestService,new F.SyncDescriptor(X.RequestService)),me.set(w.IChecksumService,new F.SyncDescriptor(f.ChecksumService));const st=I.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});me.set(K.INativeHostService,st),me.set(n.IDownloadService,new F.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(st)),ut=new I.StaticRouter(xe=>lt.getActiveClientId().then(dt=>xe===dt));me.set(W.IExtensionRecommendationNotificationService,new q.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Ct.AssignmentService(this.configuration.machineId,Be,Oe);let nt;const Ze=[];if((0,De.supportsTelemetry)(Oe,ze)){const xe=new we.TelemetryLogAppender(Qe,ze);Ze.push(xe);const{appRoot:dt,extensionsPath:Tt,installSourcePath:Lt}=ze;if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=await ht.getTreatment("telemetryMigration")??!1,ft=Oe.quality!=="stable";if(ft&&ot){const wt=new Se.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ot,!0);this._register((0,i.toDisposable)(()=>wt.flush())),Ze.push(wt)}const St=new Se.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,i.toDisposable)(()=>St.flush())),Ze.push(St)}nt=new ve.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Xe,(0,A.release)(),(0,A.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,Lt),sendErrorTelemetry:!0,piiPaths:[dt,Tt]},Be)}else{nt=De.NullTelemetryService;const xe=De.NullAppender;Ze.push(xe)}this.server.registerChannel("telemetryAppender",new Ce.TelemetryAppenderChannel(Ze)),me.set(be.ITelemetryService,nt);const kt=new Ie.CustomEndpointTelemetryService(Be,nt,Qe,ze);me.set(be.ICustomEndpointTelemetryService,kt),me.set(y.IExtensionManagementService,new F.SyncDescriptor(M.ExtensionManagementService)),me.set(y.IExtensionGalleryService,new F.SyncDescriptor(g.ExtensionGalleryService)),me.set(y.IExtensionTipsService,new F.SyncDescriptor(O.ExtensionTipsService)),me.set(U.ILocalizationsService,new F.SyncDescriptor(N.LocalizationsService)),me.set(r.IDiagnosticsService,new F.SyncDescriptor(o.DiagnosticsService)),me.set(ye.IUserDataSyncAccountService,new F.SyncDescriptor(ye.UserDataSyncAccountService)),me.set(ce.IUserDataSyncLogService,new F.SyncDescriptor(Te.UserDataSyncLogService)),me.set(ce.IUserDataSyncUtilService,new _e.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",xe=>xe.ctx!=="main"))),me.set(y.IGlobalExtensionEnablementService,new F.SyncDescriptor(u.GlobalExtensionEnablementService)),me.set(ie.IIgnoredExtensionsManagementService,new F.SyncDescriptor(ie.IgnoredExtensionsManagementService)),me.set(We.IExtensionsStorageSyncService,new F.SyncDescriptor(We.ExtensionsStorageSyncService)),me.set(ce.IUserDataSyncStoreManagementService,new F.SyncDescriptor(re.UserDataSyncStoreManagementService)),me.set(ce.IUserDataSyncStoreService,new F.SyncDescriptor(re.UserDataSyncStoreService)),me.set(Fe.IUserDataSyncMachinesService,new F.SyncDescriptor(Fe.UserDataSyncMachinesService)),me.set(ce.IUserDataSyncBackupStoreService,new F.SyncDescriptor(Pe.UserDataSyncBackupStoreService)),me.set(ce.IUserDataAutoSyncEnablementService,new F.SyncDescriptor(ae.UserDataAutoSyncEnablementService)),me.set(ce.IUserDataSyncResourceEnablementService,new F.SyncDescriptor(Ae.UserDataSyncResourceEnablementService)),me.set(ce.IUserDataSyncService,new F.SyncDescriptor(Ue.UserDataSyncService));const yt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Be.getValue("terminal.integrated.persistentSessionScrollback")??100},Be,ze,Je,nt);return await yt.initialize(),me.set(je.ILocalPtyService,this._register(yt)),me.set(pe.ISignService,new F.SyncDescriptor(ge.SignService)),me.set(Ee.ISharedTunnelsService,new F.SyncDescriptor(Re.SharedTunnelsService)),me.set(ke.ISharedProcessTunnelService,new F.SyncDescriptor(Le.SharedProcessTunnelService)),new Z.InstantiationService(me)}initChannels(me){const Oe=new k.ExtensionManagementChannel(me.get(y.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const qe=I.ProxyChannel.fromService(me.get(U.ILocalizationsService));this.server.registerChannel("localizations",qe);const Ge=I.ProxyChannel.fromService(me.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const ze=new k.ExtensionTipsChannel(me.get(y.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=I.ProxyChannel.fromService(me.get(w.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=new _e.UserDataSyncMachinesServiceChannel(me.get(Fe.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Qe);const at=I.ProxyChannel.fromService(me.get(be.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Je=new _e.UserDataSyncAccountServiceChannel(me.get(ye.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const Xe=new _e.UserDataSyncStoreManagementServiceChannel(me.get(ce.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Xe);const ct=new Y.UserDataSyncChannel(me.get(ce.IUserDataSyncService),me.get(z.ILogService));this.server.registerChannel("userDataSync",ct);const Be=this._register(me.get(B.IInstantiationService).createInstance(ue.UserDataAutoSyncService)),tt=new _e.UserDataAutoSyncChannel(Be);this.server.registerChannel("userDataAutoSync",tt);const st=me.get(je.ILocalPtyService),lt=I.ProxyChannel.fromService(st);this.server.registerChannel(Me.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(me.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=I.ProxyChannel.fromService(me.get($e.ISharedProcessWorkerService));this.server.registerChannel($e.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Oe=>{(0,T.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Oe=>{const qe=(0,R.toErrorMessage)(Oe,!0);!qe||me.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Dt(pt){const me=new Rt(pt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Dt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1e473b624f088fc05269891170a8ffa1c84a35a6/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
